/* DeviceItem.c generated by valac 0.56.13, the Vala compiler
 * generated from DeviceItem.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Sean Davis <sean@bluesabre.org>
 */

#include "sound.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	DEVICE_ITEM_0_PROPERTY,
	DEVICE_ITEM_ROW_PROPERTY,
	DEVICE_ITEM_DISPLAY_NAME_PROPERTY,
	DEVICE_ITEM_ICON_NAME_PROPERTY,
	DEVICE_ITEM_IS_PRIORITY_PROPERTY,
	DEVICE_ITEM_IS_DEFAULT_PROPERTY,
	DEVICE_ITEM_NUM_PROPERTIES
};
static GParamSpec* device_item_properties[DEVICE_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DEVICE_ITEM_ACTIVATED_SIGNAL,
	DEVICE_ITEM_NUM_SIGNALS
};
static guint device_item_signals[DEVICE_ITEM_NUM_SIGNALS] = {0};

struct _DeviceItemPrivate {
	GtkRadioButton* radio_button;
	GtkListBoxRow* _row;
	gchar* _display_name;
	gchar* _icon_name;
	gboolean _is_priority;
	gboolean _is_default;
};

static gint DeviceItem_private_offset;
static gpointer device_item_parent_class = NULL;

static GObject * device_item_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _device_item___lambda52_ (DeviceItem* self);
static void __device_item___lambda52__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                          gpointer self);
static void device_item_finalize (GObject * obj);
static GType device_item_get_type_once (void);
static void _vala_device_item_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_device_item_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
device_item_get_instance_private (DeviceItem* self)
{
	return G_STRUCT_MEMBER_P (self, DeviceItem_private_offset);
}

DeviceItem*
device_item_construct (GType object_type,
                       const gchar* display_name,
                       gboolean is_default,
                       gboolean is_priority,
                       const gchar* icon_name,
                       GtkListBoxRow* row)
{
	DeviceItem * self = NULL;
#line 34 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (display_name != NULL, NULL);
#line 34 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 35 "../src/Widgets/DeviceItem.vala"
	self = (DeviceItem*) g_object_new (object_type, "display-name", display_name, "is-default", is_default, "is-priority", is_priority, "icon-name", icon_name, "row", row, NULL);
#line 34 "../src/Widgets/DeviceItem.vala"
	return self;
#line 107 "DeviceItem.c"
}

DeviceItem*
device_item_new (const gchar* display_name,
                 gboolean is_default,
                 gboolean is_priority,
                 const gchar* icon_name,
                 GtkListBoxRow* row)
{
#line 34 "../src/Widgets/DeviceItem.vala"
	return device_item_construct (TYPE_DEVICE_ITEM, display_name, is_default, is_priority, icon_name, row);
#line 119 "DeviceItem.c"
}

void
device_item_set_default (DeviceItem* self)
{
	GtkRadioButton* _tmp0_;
#line 81 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 82 "../src/Widgets/DeviceItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 83 "../src/Widgets/DeviceItem.vala"
	device_item_set_is_priority (self, TRUE);
#line 84 "../src/Widgets/DeviceItem.vala"
	device_item_update_visible (self, TRUE);
#line 136 "DeviceItem.c"
}

void
device_item_update_visible (DeviceItem* self,
                            gboolean is_default)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 87 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = self->priv->_is_priority;
#line 88 "../src/Widgets/DeviceItem.vala"
	if (_tmp1_) {
#line 88 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = TRUE;
#line 153 "DeviceItem.c"
	} else {
#line 88 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = is_default;
#line 157 "DeviceItem.c"
	}
#line 88 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_visible ((GtkWidget*) self, _tmp0_);
#line 161 "DeviceItem.c"
}

GtkListBoxRow*
device_item_get_row (DeviceItem* self)
{
	GtkListBoxRow* result;
	GtkListBoxRow* _tmp0_;
#line 28 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_row;
#line 28 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/DeviceItem.vala"
	return result;
#line 177 "DeviceItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/Widgets/DeviceItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 185 "DeviceItem.c"
}

static void
device_item_set_row (DeviceItem* self,
                     GtkListBoxRow* value)
{
	GtkListBoxRow* old_value;
#line 28 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/DeviceItem.vala"
	old_value = device_item_get_row (self);
#line 28 "../src/Widgets/DeviceItem.vala"
	if (old_value != value) {
#line 199 "DeviceItem.c"
		GtkListBoxRow* _tmp0_;
#line 28 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Widgets/DeviceItem.vala"
		_g_object_unref0 (self->priv->_row);
#line 28 "../src/Widgets/DeviceItem.vala"
		self->priv->_row = _tmp0_;
#line 28 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, device_item_properties[DEVICE_ITEM_ROW_PROPERTY]);
#line 209 "DeviceItem.c"
	}
}

const gchar*
device_item_get_display_name (DeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_display_name;
#line 29 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 29 "../src/Widgets/DeviceItem.vala"
	return result;
#line 226 "DeviceItem.c"
}

static void
device_item_set_display_name (DeviceItem* self,
                              const gchar* value)
{
	gchar* old_value;
#line 29 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Widgets/DeviceItem.vala"
	old_value = device_item_get_display_name (self);
#line 29 "../src/Widgets/DeviceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 240 "DeviceItem.c"
		gchar* _tmp0_;
#line 29 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/Widgets/DeviceItem.vala"
		_g_free0 (self->priv->_display_name);
#line 29 "../src/Widgets/DeviceItem.vala"
		self->priv->_display_name = _tmp0_;
#line 29 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, device_item_properties[DEVICE_ITEM_DISPLAY_NAME_PROPERTY]);
#line 250 "DeviceItem.c"
	}
}

const gchar*
device_item_get_icon_name (DeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_icon_name;
#line 30 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/DeviceItem.vala"
	return result;
#line 267 "DeviceItem.c"
}

static void
device_item_set_icon_name (DeviceItem* self,
                           const gchar* value)
{
	gchar* old_value;
#line 30 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/DeviceItem.vala"
	old_value = device_item_get_icon_name (self);
#line 30 "../src/Widgets/DeviceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 281 "DeviceItem.c"
		gchar* _tmp0_;
#line 30 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Widgets/DeviceItem.vala"
		_g_free0 (self->priv->_icon_name);
#line 30 "../src/Widgets/DeviceItem.vala"
		self->priv->_icon_name = _tmp0_;
#line 30 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, device_item_properties[DEVICE_ITEM_ICON_NAME_PROPERTY]);
#line 291 "DeviceItem.c"
	}
}

gboolean
device_item_get_is_priority (DeviceItem* self)
{
	gboolean result;
#line 31 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/Widgets/DeviceItem.vala"
	result = self->priv->_is_priority;
#line 31 "../src/Widgets/DeviceItem.vala"
	return result;
#line 305 "DeviceItem.c"
}

void
device_item_set_is_priority (DeviceItem* self,
                             gboolean value)
{
	gboolean old_value;
#line 31 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/DeviceItem.vala"
	old_value = device_item_get_is_priority (self);
#line 31 "../src/Widgets/DeviceItem.vala"
	if (old_value != value) {
#line 31 "../src/Widgets/DeviceItem.vala"
		self->priv->_is_priority = value;
#line 31 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, device_item_properties[DEVICE_ITEM_IS_PRIORITY_PROPERTY]);
#line 323 "DeviceItem.c"
	}
}

gboolean
device_item_get_is_default (DeviceItem* self)
{
	gboolean result;
#line 32 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/Widgets/DeviceItem.vala"
	result = self->priv->_is_default;
#line 32 "../src/Widgets/DeviceItem.vala"
	return result;
#line 337 "DeviceItem.c"
}

static void
device_item_set_is_default (DeviceItem* self,
                            gboolean value)
{
	gboolean old_value;
#line 32 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Widgets/DeviceItem.vala"
	old_value = device_item_get_is_default (self);
#line 32 "../src/Widgets/DeviceItem.vala"
	if (old_value != value) {
#line 32 "../src/Widgets/DeviceItem.vala"
		self->priv->_is_default = value;
#line 32 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, device_item_properties[DEVICE_ITEM_IS_DEFAULT_PROPERTY]);
#line 355 "DeviceItem.c"
	}
}

static void
_device_item___lambda52_ (DeviceItem* self)
{
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkRadioButton* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 72 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 72 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 72 "../src/Widgets/DeviceItem.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/Widgets/DeviceItem.vala"
	if (_tmp2_) {
#line 73 "../src/Widgets/DeviceItem.vala"
		g_signal_emit (self, device_item_signals[DEVICE_ITEM_ACTIVATED_SIGNAL], 0);
#line 378 "DeviceItem.c"
	}
#line 75 "../src/Widgets/DeviceItem.vala"
	_tmp3_ = self->priv->radio_button;
#line 75 "../src/Widgets/DeviceItem.vala"
	_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
#line 75 "../src/Widgets/DeviceItem.vala"
	_tmp5_ = _tmp4_;
#line 75 "../src/Widgets/DeviceItem.vala"
	device_item_update_visible (self, _tmp5_);
#line 388 "DeviceItem.c"
}

static void
__device_item___lambda52__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                     gpointer self)
{
#line 71 "../src/Widgets/DeviceItem.vala"
	_device_item___lambda52_ ((DeviceItem*) self);
#line 397 "DeviceItem.c"
}

static GObject *
device_item_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DeviceItem * self;
	GtkLabel* label = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_ = NULL;
	gboolean _tmp2_;
	GtkRadioButton* _tmp3_ = NULL;
	GtkRadioButton* _tmp4_;
	GtkLabel* _tmp5_;
	GtkListBoxRow* _tmp6_;
	GtkImage* img_type = NULL;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkImage* _tmp16_ = NULL;
	GtkImage* _tmp17_;
	GtkBox* box = NULL;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkRadioButton* _tmp20_;
	GtkBox* _tmp21_;
	GtkImage* _tmp22_;
	GtkBox* _tmp23_;
	GtkRadioButton* _tmp24_;
	gboolean _tmp25_;
#line 42 "../src/Widgets/DeviceItem.vala"
	parent_class = G_OBJECT_CLASS (device_item_parent_class);
#line 42 "../src/Widgets/DeviceItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../src/Widgets/DeviceItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE_ITEM, DeviceItem);
#line 43 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_display_name;
#line 43 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 43 "../src/Widgets/DeviceItem.vala"
	gtk_label_set_ellipsize (_tmp1_, PANGO_ELLIPSIZE_MIDDLE);
#line 43 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp1_);
#line 43 "../src/Widgets/DeviceItem.vala"
	label = _tmp1_;
#line 46 "../src/Widgets/DeviceItem.vala"
	_tmp2_ = self->priv->_is_default;
#line 46 "../src/Widgets/DeviceItem.vala"
	_tmp3_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 46 "../src/Widgets/DeviceItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, _tmp2_);
#line 46 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 46 "../src/Widgets/DeviceItem.vala"
	g_object_set ((GtkButton*) _tmp3_, "xalign", (gfloat) 0, NULL);
#line 46 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp3_);
#line 46 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 46 "../src/Widgets/DeviceItem.vala"
	self->priv->radio_button = _tmp3_;
#line 51 "../src/Widgets/DeviceItem.vala"
	_tmp4_ = self->priv->radio_button;
#line 51 "../src/Widgets/DeviceItem.vala"
	_tmp5_ = label;
#line 51 "../src/Widgets/DeviceItem.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 53 "../src/Widgets/DeviceItem.vala"
	_tmp6_ = self->priv->_row;
#line 53 "../src/Widgets/DeviceItem.vala"
	if (_tmp6_ != NULL) {
#line 473 "DeviceItem.c"
		DeviceItem* item = NULL;
		GtkListBoxRow* _tmp7_;
		DeviceItem* _tmp8_;
		GtkRadioButton* _tmp9_;
		DeviceItem* _tmp10_;
		GtkRadioButton* _tmp11_;
		GSList* _tmp12_;
#line 54 "../src/Widgets/DeviceItem.vala"
		_tmp7_ = self->priv->_row;
#line 54 "../src/Widgets/DeviceItem.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DEVICE_ITEM, DeviceItem));
#line 54 "../src/Widgets/DeviceItem.vala"
		item = _tmp8_;
#line 55 "../src/Widgets/DeviceItem.vala"
		_tmp9_ = self->priv->radio_button;
#line 55 "../src/Widgets/DeviceItem.vala"
		_tmp10_ = item;
#line 55 "../src/Widgets/DeviceItem.vala"
		_tmp11_ = _tmp10_->priv->radio_button;
#line 55 "../src/Widgets/DeviceItem.vala"
		_tmp12_ = gtk_radio_button_get_group (_tmp11_);
#line 55 "../src/Widgets/DeviceItem.vala"
		gtk_radio_button_set_group (_tmp9_, _tmp12_);
#line 53 "../src/Widgets/DeviceItem.vala"
		_g_object_unref0 (item);
#line 499 "DeviceItem.c"
	}
#line 58 "../src/Widgets/DeviceItem.vala"
	_tmp13_ = self->priv->_icon_name;
#line 58 "../src/Widgets/DeviceItem.vala"
	_tmp14_ = g_strconcat (_tmp13_, "-symbolic", NULL);
#line 58 "../src/Widgets/DeviceItem.vala"
	_tmp15_ = _tmp14_;
#line 58 "../src/Widgets/DeviceItem.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp15_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 58 "../src/Widgets/DeviceItem.vala"
	g_object_set (_tmp16_, "use-fallback", TRUE, NULL);
#line 58 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp16_);
#line 58 "../src/Widgets/DeviceItem.vala"
	_tmp17_ = _tmp16_;
#line 58 "../src/Widgets/DeviceItem.vala"
	_g_free0 (_tmp15_);
#line 58 "../src/Widgets/DeviceItem.vala"
	img_type = _tmp17_;
#line 62 "../src/Widgets/DeviceItem.vala"
	_tmp18_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 8);
#line 62 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp18_);
#line 62 "../src/Widgets/DeviceItem.vala"
	box = _tmp18_;
#line 63 "../src/Widgets/DeviceItem.vala"
	_tmp19_ = box;
#line 63 "../src/Widgets/DeviceItem.vala"
	_tmp20_ = self->priv->radio_button;
#line 63 "../src/Widgets/DeviceItem.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 64 "../src/Widgets/DeviceItem.vala"
	_tmp21_ = box;
#line 64 "../src/Widgets/DeviceItem.vala"
	_tmp22_ = img_type;
#line 64 "../src/Widgets/DeviceItem.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 66 "../src/Widgets/DeviceItem.vala"
	_tmp23_ = box;
#line 66 "../src/Widgets/DeviceItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp23_);
#line 67 "../src/Widgets/DeviceItem.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 68 "../src/Widgets/DeviceItem.vala"
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, FALSE);
#line 69 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) self, TRUE);
#line 71 "../src/Widgets/DeviceItem.vala"
	_tmp24_ = self->priv->radio_button;
#line 71 "../src/Widgets/DeviceItem.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp24_, "toggled", (GCallback) __device_item___lambda52__gtk_toggle_button_toggled, self, 0);
#line 78 "../src/Widgets/DeviceItem.vala"
	_tmp25_ = self->priv->_is_default;
#line 78 "../src/Widgets/DeviceItem.vala"
	device_item_update_visible (self, _tmp25_);
#line 42 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (box);
#line 42 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (img_type);
#line 42 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (label);
#line 42 "../src/Widgets/DeviceItem.vala"
	return obj;
#line 563 "DeviceItem.c"
}

static void
device_item_base_init (DeviceItemClass * klass)
{
#line 39 "../src/Widgets/DeviceItem.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), GTK_STYLE_CLASS_MENUITEM);
#line 571 "DeviceItem.c"
}

static void
device_item_class_init (DeviceItemClass * klass,
                        gpointer klass_data)
{
#line 23 "../src/Widgets/DeviceItem.vala"
	device_item_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/DeviceItem.vala"
	g_type_class_adjust_private_offset (klass, &DeviceItem_private_offset);
#line 23 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_device_item_get_property;
#line 23 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_device_item_set_property;
#line 23 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->constructor = device_item_constructor;
#line 23 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->finalize = device_item_finalize;
#line 23 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ITEM_ROW_PROPERTY, device_item_properties[DEVICE_ITEM_ROW_PROPERTY] = g_param_spec_object ("row", "row", "row", gtk_list_box_row_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ITEM_DISPLAY_NAME_PROPERTY, device_item_properties[DEVICE_ITEM_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ITEM_ICON_NAME_PROPERTY, device_item_properties[DEVICE_ITEM_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ITEM_IS_PRIORITY_PROPERTY, device_item_properties[DEVICE_ITEM_IS_PRIORITY_PROPERTY] = g_param_spec_boolean ("is-priority", "is-priority", "is-priority", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ITEM_IS_DEFAULT_PROPERTY, device_item_properties[DEVICE_ITEM_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Widgets/DeviceItem.vala"
	device_item_signals[DEVICE_ITEM_ACTIVATED_SIGNAL] = g_signal_new ("activated", TYPE_DEVICE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 602 "DeviceItem.c"
}

static void
device_item_instance_init (DeviceItem * self,
                           gpointer klass)
{
#line 23 "../src/Widgets/DeviceItem.vala"
	self->priv = device_item_get_instance_private (self);
#line 611 "DeviceItem.c"
}

static void
device_item_finalize (GObject * obj)
{
	DeviceItem * self;
#line 23 "../src/Widgets/DeviceItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE_ITEM, DeviceItem);
#line 26 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 28 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->_row);
#line 29 "../src/Widgets/DeviceItem.vala"
	_g_free0 (self->priv->_display_name);
#line 30 "../src/Widgets/DeviceItem.vala"
	_g_free0 (self->priv->_icon_name);
#line 23 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (device_item_parent_class)->finalize (obj);
#line 630 "DeviceItem.c"
}

static GType
device_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeviceItemClass), (GBaseInitFunc) device_item_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DeviceItem), 0, (GInstanceInitFunc) device_item_instance_init, NULL };
	GType device_item_type_id;
	device_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DeviceItem", &g_define_type_info, 0);
	DeviceItem_private_offset = g_type_add_instance_private (device_item_type_id, sizeof (DeviceItemPrivate));
	return device_item_type_id;
}

GType
device_item_get_type (void)
{
	static volatile gsize device_item_type_id__once = 0;
	if (g_once_init_enter (&device_item_type_id__once)) {
		GType device_item_type_id;
		device_item_type_id = device_item_get_type_once ();
		g_once_init_leave (&device_item_type_id__once, device_item_type_id);
	}
	return device_item_type_id__once;
}

static void
_vala_device_item_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	DeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE_ITEM, DeviceItem);
#line 23 "../src/Widgets/DeviceItem.vala"
	switch (property_id) {
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_ROW_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		g_value_set_object (value, device_item_get_row (self));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_DISPLAY_NAME_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		g_value_set_string (value, device_item_get_display_name (self));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_ICON_NAME_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		g_value_set_string (value, device_item_get_icon_name (self));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_IS_PRIORITY_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		g_value_set_boolean (value, device_item_get_is_priority (self));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_IS_DEFAULT_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		g_value_set_boolean (value, device_item_get_is_default (self));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 695 "DeviceItem.c"
		default:
#line 23 "../src/Widgets/DeviceItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 701 "DeviceItem.c"
	}
}

static void
_vala_device_item_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	DeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE_ITEM, DeviceItem);
#line 23 "../src/Widgets/DeviceItem.vala"
	switch (property_id) {
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_ROW_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		device_item_set_row (self, g_value_get_object (value));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_DISPLAY_NAME_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		device_item_set_display_name (self, g_value_get_string (value));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_ICON_NAME_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		device_item_set_icon_name (self, g_value_get_string (value));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_IS_PRIORITY_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		device_item_set_is_priority (self, g_value_get_boolean (value));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 23 "../src/Widgets/DeviceItem.vala"
		case DEVICE_ITEM_IS_DEFAULT_PROPERTY:
#line 23 "../src/Widgets/DeviceItem.vala"
		device_item_set_is_default (self, g_value_get_boolean (value));
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 745 "DeviceItem.c"
		default:
#line 23 "../src/Widgets/DeviceItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/DeviceItem.vala"
		break;
#line 751 "DeviceItem.c"
	}
}

