/* DeviceManagerWidget.c generated by valac 0.56.13, the Vala compiler
 * generated from DeviceManagerWidget.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Sean Davis <sean@bluesabre.org>
 */

#include "sound.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib-object.h>

enum  {
	SOUND_WIDGETS_DEVICE_MANAGER_WIDGET_0_PROPERTY,
	SOUND_WIDGETS_DEVICE_MANAGER_WIDGET_NUM_PROPERTIES
};
static GParamSpec* sound_widgets_device_manager_widget_properties[SOUND_WIDGETS_DEVICE_MANAGER_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _SoundWidgetsDeviceManagerWidgetPrivate {
	GtkListBox* device_list;
	GtkScrolledWindow* scrolled_box;
	SoundPulseAudioManager* pam;
};

struct _Block4Data {
	int _ref_count_;
	SoundWidgetsDeviceManagerWidget* self;
	DeviceItem* device_item;
	SoundDevice* device;
};

static gint SoundWidgetsDeviceManagerWidget_private_offset;
static gpointer sound_widgets_device_manager_widget_parent_class = NULL;

static void sound_widgets_device_manager_widget_add_device (SoundWidgetsDeviceManagerWidget* self,
                                                     SoundDevice* device);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda53_ (Block4Data* _data4_);
static void sound_widgets_device_manager_widget_update_preferred_devices (SoundWidgetsDeviceManagerWidget* self,
                                                                   SoundDevice* device);
static void ___lambda53__device_item_activated (DeviceItem* _sender,
                                         gpointer self);
static void __lambda54_ (Block4Data* _data4_);
static void sound_widgets_device_manager_widget_update_showable (SoundWidgetsDeviceManagerWidget* self);
static void ___lambda54__sound_device_removed (SoundDevice* _sender,
                                        gpointer self);
static void __lambda55_ (Block4Data* _data4_);
static void ___lambda55__sound_device_defaulted (SoundDevice* _sender,
                                          gpointer self);
static guint sound_widgets_device_manager_widget_n_visible_items (SoundWidgetsDeviceManagerWidget* self);
static void sound_widgets_device_manager_widget_default_output_changed (SoundWidgetsDeviceManagerWidget* self);
static void sound_widgets_device_manager_widget_default_input_changed (SoundWidgetsDeviceManagerWidget* self);
static GObject * sound_widgets_device_manager_widget_constructor (GType type,
                                                           guint n_construct_properties,
                                                           GObjectConstructParam * construct_properties);
static void _sound_widgets_device_manager_widget_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                                           SoundDevice* dev,
                                                                                           gpointer self);
static void _sound_widgets_device_manager_widget_default_output_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self);
static void _sound_widgets_device_manager_widget_default_input_changed_g_object_notify (GObject* _sender,
                                                                                 GParamSpec* pspec,
                                                                                 gpointer self);
static void sound_widgets_device_manager_widget_finalize (GObject * obj);
static GType sound_widgets_device_manager_widget_get_type_once (void);

static inline gpointer
sound_widgets_device_manager_widget_get_instance_private (SoundWidgetsDeviceManagerWidget* self)
{
	return G_STRUCT_MEMBER_P (self, SoundWidgetsDeviceManagerWidget_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 109 "DeviceManagerWidget.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	return _data4_;
#line 119 "DeviceManagerWidget.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 129 "DeviceManagerWidget.c"
		SoundWidgetsDeviceManagerWidget* self;
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
		self = _data4_->self;
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
		_g_object_unref0 (_data4_->device_item);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
		_g_object_unref0 (_data4_->device);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
		_g_object_unref0 (self);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
		g_slice_free (Block4Data, _data4_);
#line 141 "DeviceManagerWidget.c"
	}
}

static void
__lambda53_ (Block4Data* _data4_)
{
	SoundWidgetsDeviceManagerWidget* self;
	SoundPulseAudioManager* _tmp0_;
#line 70 "../src/Widgets/DeviceManagerWidget.vala"
	self = _data4_->self;
#line 71 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = self->priv->pam;
#line 71 "../src/Widgets/DeviceManagerWidget.vala"
	sound_pulse_audio_manager_set_default_device (_tmp0_, _data4_->device, NULL, NULL);
#line 72 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_update_preferred_devices (self, _data4_->device);
#line 158 "DeviceManagerWidget.c"
}

static void
___lambda53__device_item_activated (DeviceItem* _sender,
                                    gpointer self)
{
#line 70 "../src/Widgets/DeviceManagerWidget.vala"
	__lambda53_ (self);
#line 167 "DeviceManagerWidget.c"
}

static void
__lambda54_ (Block4Data* _data4_)
{
	SoundWidgetsDeviceManagerWidget* self;
	GtkListBox* _tmp0_;
	DeviceItem* _tmp1_;
	GtkListBox* _tmp2_;
#line 75 "../src/Widgets/DeviceManagerWidget.vala"
	self = _data4_->self;
#line 76 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = self->priv->device_list;
#line 76 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp1_ = _data4_->device_item;
#line 76 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) _tmp1_);
#line 77 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp2_ = self->priv->device_list;
#line 77 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 78 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_update_showable (self);
#line 191 "DeviceManagerWidget.c"
}

static void
___lambda54__sound_device_removed (SoundDevice* _sender,
                                   gpointer self)
{
#line 75 "../src/Widgets/DeviceManagerWidget.vala"
	__lambda54_ (self);
#line 200 "DeviceManagerWidget.c"
}

static void
__lambda55_ (Block4Data* _data4_)
{
	SoundWidgetsDeviceManagerWidget* self;
	DeviceItem* _tmp0_;
#line 81 "../src/Widgets/DeviceManagerWidget.vala"
	self = _data4_->self;
#line 82 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = _data4_->device_item;
#line 82 "../src/Widgets/DeviceManagerWidget.vala"
	device_item_set_default (_tmp0_);
#line 83 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_update_preferred_devices (self, _data4_->device);
#line 84 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_update_showable (self);
#line 218 "DeviceManagerWidget.c"
}

static void
___lambda55__sound_device_defaulted (SoundDevice* _sender,
                                     gpointer self)
{
#line 81 "../src/Widgets/DeviceManagerWidget.vala"
	__lambda55_ (self);
#line 227 "DeviceManagerWidget.c"
}

static void
sound_widgets_device_manager_widget_add_device (SoundWidgetsDeviceManagerWidget* self,
                                                SoundDevice* device)
{
	Block4Data* _data4_;
	SoundDevice* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp9_;
	GtkListBoxRow* _tmp10_;
	GtkListBoxRow* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GtkListBoxRow* _tmp20_;
	DeviceItem* _tmp21_;
	GtkListBox* _tmp22_;
	DeviceItem* _tmp23_;
	DeviceItem* _tmp24_;
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (device != NULL);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_data4_->_ref_count_ = 1;
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_data4_->self = g_object_ref (self);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_g_object_unref0 (_data4_->device);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_data4_->device = _tmp0_;
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp3_ = sound_device_get_input (_data4_->device);
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp4_ = _tmp3_;
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
	if (_tmp4_ != self->is_input_manager) {
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp2_ = TRUE;
#line 281 "DeviceManagerWidget.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp5_ = sound_device_get_port_name (_data4_->device);
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp6_ = _tmp5_;
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp2_ = g_strcmp0 (_tmp6_, "analog-output") == 0;
#line 291 "DeviceManagerWidget.c"
	}
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
	if (_tmp2_) {
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp1_ = TRUE;
#line 297 "DeviceManagerWidget.c"
	} else {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp7_ = sound_device_get_port_name (_data4_->device);
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp8_ = _tmp7_;
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp1_ = g_strcmp0 (_tmp8_, "analog-input") == 0;
#line 307 "DeviceManagerWidget.c"
	}
#line 58 "../src/Widgets/DeviceManagerWidget.vala"
	if (_tmp1_) {
#line 59 "../src/Widgets/DeviceManagerWidget.vala"
		block4_data_unref (_data4_);
#line 59 "../src/Widgets/DeviceManagerWidget.vala"
		_data4_ = NULL;
#line 59 "../src/Widgets/DeviceManagerWidget.vala"
		return;
#line 317 "DeviceManagerWidget.c"
	}
#line 62 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp9_ = self->priv->device_list;
#line 62 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp10_ = gtk_list_box_get_row_at_index (_tmp9_, 0);
#line 62 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 62 "../src/Widgets/DeviceManagerWidget.vala"
	row = _tmp11_;
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp12_ = sound_device_get_display_name (_data4_->device);
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp13_ = _tmp12_;
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp14_ = sound_device_get_is_default (_data4_->device);
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp15_ = _tmp14_;
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp16_ = sound_device_get_is_priority (_data4_->device);
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp17_ = _tmp16_;
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp18_ = sound_device_get_icon_name (_data4_->device);
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp19_ = _tmp18_;
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp20_ = row;
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp21_ = device_item_new (_tmp13_, _tmp15_, _tmp17_, _tmp19_, _tmp20_);
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	g_object_ref_sink (_tmp21_);
#line 63 "../src/Widgets/DeviceManagerWidget.vala"
	_data4_->device_item = _tmp21_;
#line 68 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp22_ = self->priv->device_list;
#line 68 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp23_ = _data4_->device_item;
#line 68 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 70 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp24_ = _data4_->device_item;
#line 70 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_connect_data (_tmp24_, "activated", (GCallback) ___lambda53__device_item_activated, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 75 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_connect_data (_data4_->device, "removed", (GCallback) ___lambda54__sound_device_removed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 81 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_connect_data (_data4_->device, "defaulted", (GCallback) ___lambda55__sound_device_defaulted, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 87 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_update_showable (self);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_g_object_unref0 (row);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	block4_data_unref (_data4_);
#line 56 "../src/Widgets/DeviceManagerWidget.vala"
	_data4_ = NULL;
#line 373 "DeviceManagerWidget.c"
}

/**
     * Preferred devices are stored as:
     * {
     *   device_a: last_used_unix_timestamp,
     *   device_b: last_used_unix_timestamp
     * }
     * If a device hasn't been selected in 7 days, it is removed from preferred devices.
     * Device selection happens when the user selects the device, and when the plugin
     * is initialized.
     */
static void
sound_widgets_device_manager_widget_update_preferred_devices (SoundWidgetsDeviceManagerWidget* self,
                                                              SoundDevice* device)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GVariant* preferred_devices = NULL;
	GSettings* _tmp4_;
	GVariant* _tmp5_;
	gint32 now = 0;
	gint32 preferred_expiry = 0;
	GVariantBuilder* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GVariant* dictionary = NULL;
	GVariantBuilder* _tmp29_;
	GVariant* _tmp30_;
	GSettings* _tmp31_;
#line 100 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (device != NULL);
#line 101 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = g_variant_type_new ("a{si}");
#line 101 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp1_ = _tmp0_;
#line 101 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 101 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp3_ = _tmp2_;
#line 101 "../src/Widgets/DeviceManagerWidget.vala"
	_g_variant_type_free0 (_tmp1_);
#line 101 "../src/Widgets/DeviceManagerWidget.vala"
	builder = _tmp3_;
#line 102 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp4_ = sound_indicator_settings;
#line 102 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp5_ = g_settings_get_value (_tmp4_, "preferred-devices");
#line 102 "../src/Widgets/DeviceManagerWidget.vala"
	preferred_devices = _tmp5_;
#line 103 "../src/Widgets/DeviceManagerWidget.vala"
	now = (gint32) (g_get_real_time () / 1000000);
#line 104 "../src/Widgets/DeviceManagerWidget.vala"
	preferred_expiry = now - (86400 * 7);
#line 106 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp6_ = builder;
#line 106 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp7_ = sound_device_get_id (device);
#line 106 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp8_ = _tmp7_;
#line 106 "../src/Widgets/DeviceManagerWidget.vala"
	g_variant_builder_add (_tmp6_, "{si}", _tmp8_, now, NULL);
#line 441 "DeviceManagerWidget.c"
	{
		GVariantIter* _dev_it = NULL;
		GVariant* _tmp9_;
		GVariantIter* _tmp10_;
		GVariant* dev = NULL;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp9_ = preferred_devices;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp10_ = g_variant_iter_new (_tmp9_);
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
		_dev_it = _tmp10_;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
		while (TRUE) {
#line 455 "DeviceManagerWidget.c"
			GVariantIter* _tmp11_;
			GVariant* _tmp12_;
			GVariant* _tmp13_;
			gchar* name = NULL;
			GVariant* _tmp14_;
			GVariant* _tmp15_;
			GVariant* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gint32 last_used = 0;
			GVariant* _tmp20_;
			GVariant* _tmp21_;
			GVariant* _tmp22_;
			gint32 _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			GVariantBuilder* _tmp27_;
			const gchar* _tmp28_;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp11_ = _dev_it;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp12_ = g_variant_iter_next_value (_tmp11_);
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			_g_variant_unref0 (dev);
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			dev = _tmp12_;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp13_ = dev;
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			if (!(_tmp13_ != NULL)) {
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
				break;
#line 490 "DeviceManagerWidget.c"
			}
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp14_ = dev;
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp15_ = g_variant_get_child_value (_tmp14_, (gsize) 0);
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp16_ = _tmp15_;
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp17_ = g_variant_get_string (_tmp16_, NULL);
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp19_ = _tmp18_;
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			_g_variant_unref0 (_tmp16_);
#line 108 "../src/Widgets/DeviceManagerWidget.vala"
			name = _tmp19_;
#line 109 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp20_ = dev;
#line 109 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp21_ = g_variant_get_child_value (_tmp20_, (gsize) 1);
#line 109 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp22_ = _tmp21_;
#line 109 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp23_ = g_variant_get_int32 (_tmp22_);
#line 109 "../src/Widgets/DeviceManagerWidget.vala"
			_g_variant_unref0 (_tmp22_);
#line 109 "../src/Widgets/DeviceManagerWidget.vala"
			last_used = _tmp23_;
#line 110 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp24_ = name;
#line 110 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp25_ = sound_device_get_id (device);
#line 110 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp26_ = _tmp25_;
#line 110 "../src/Widgets/DeviceManagerWidget.vala"
			if (g_strcmp0 (_tmp24_, _tmp26_) == 0) {
#line 111 "../src/Widgets/DeviceManagerWidget.vala"
				_g_free0 (name);
#line 111 "../src/Widgets/DeviceManagerWidget.vala"
				continue;
#line 532 "DeviceManagerWidget.c"
			}
#line 113 "../src/Widgets/DeviceManagerWidget.vala"
			if (last_used < preferred_expiry) {
#line 114 "../src/Widgets/DeviceManagerWidget.vala"
				_g_free0 (name);
#line 114 "../src/Widgets/DeviceManagerWidget.vala"
				continue;
#line 540 "DeviceManagerWidget.c"
			}
#line 116 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp27_ = builder;
#line 116 "../src/Widgets/DeviceManagerWidget.vala"
			_tmp28_ = name;
#line 116 "../src/Widgets/DeviceManagerWidget.vala"
			g_variant_builder_add (_tmp27_, "{si}", _tmp28_, last_used, NULL);
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
			_g_free0 (name);
#line 550 "DeviceManagerWidget.c"
		}
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
		_g_variant_unref0 (dev);
#line 107 "../src/Widgets/DeviceManagerWidget.vala"
		_g_variant_iter_free0 (_dev_it);
#line 556 "DeviceManagerWidget.c"
	}
#line 118 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp29_ = builder;
#line 118 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp30_ = g_variant_builder_end (_tmp29_);
#line 118 "../src/Widgets/DeviceManagerWidget.vala"
	g_variant_ref_sink (_tmp30_);
#line 118 "../src/Widgets/DeviceManagerWidget.vala"
	dictionary = _tmp30_;
#line 120 "../src/Widgets/DeviceManagerWidget.vala"
	sound_device_set_is_priority (device, TRUE);
#line 121 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp31_ = sound_indicator_settings;
#line 121 "../src/Widgets/DeviceManagerWidget.vala"
	g_settings_set_value (_tmp31_, "preferred-devices", dictionary);
#line 100 "../src/Widgets/DeviceManagerWidget.vala"
	_g_variant_unref0 (dictionary);
#line 100 "../src/Widgets/DeviceManagerWidget.vala"
	_g_variant_unref0 (preferred_devices);
#line 100 "../src/Widgets/DeviceManagerWidget.vala"
	_g_variant_builder_unref0 (builder);
#line 578 "DeviceManagerWidget.c"
}

static guint
sound_widgets_device_manager_widget_n_visible_items (SoundWidgetsDeviceManagerWidget* self)
{
	guint n = 0U;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	guint result;
#line 124 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 125 "../src/Widgets/DeviceManagerWidget.vala"
	n = (guint) 0;
#line 126 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = self->priv->device_list;
#line 126 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 596 "DeviceManagerWidget.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 126 "../src/Widgets/DeviceManagerWidget.vala"
		device_collection = _tmp1_;
#line 126 "../src/Widgets/DeviceManagerWidget.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 604 "DeviceManagerWidget.c"
			GtkWidget* device = NULL;
#line 126 "../src/Widgets/DeviceManagerWidget.vala"
			device = (GtkWidget*) device_it->data;
#line 608 "DeviceManagerWidget.c"
			{
				GtkWidget* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
#line 127 "../src/Widgets/DeviceManagerWidget.vala"
				_tmp2_ = device;
#line 127 "../src/Widgets/DeviceManagerWidget.vala"
				_tmp3_ = gtk_widget_get_visible (_tmp2_);
#line 127 "../src/Widgets/DeviceManagerWidget.vala"
				_tmp4_ = _tmp3_;
#line 127 "../src/Widgets/DeviceManagerWidget.vala"
				if (_tmp4_) {
#line 621 "DeviceManagerWidget.c"
					guint _tmp5_;
#line 128 "../src/Widgets/DeviceManagerWidget.vala"
					_tmp5_ = n;
#line 128 "../src/Widgets/DeviceManagerWidget.vala"
					n = _tmp5_ + 1;
#line 627 "DeviceManagerWidget.c"
				}
			}
		}
#line 126 "../src/Widgets/DeviceManagerWidget.vala"
		(device_collection == NULL) ? NULL : (device_collection = (g_list_free (device_collection), NULL));
#line 633 "DeviceManagerWidget.c"
	}
#line 131 "../src/Widgets/DeviceManagerWidget.vala"
	result = n;
#line 131 "../src/Widgets/DeviceManagerWidget.vala"
	return result;
#line 639 "DeviceManagerWidget.c"
}

static void
sound_widgets_device_manager_widget_update_showable (SoundWidgetsDeviceManagerWidget* self)
{
#line 134 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/Widgets/DeviceManagerWidget.vala"
	if (sound_widgets_device_manager_widget_n_visible_items (self) <= ((guint) 1)) {
#line 649 "DeviceManagerWidget.c"
		GtkScrolledWindow* _tmp0_;
#line 136 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp0_ = self->priv->scrolled_box;
#line 136 "../src/Widgets/DeviceManagerWidget.vala"
		gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 655 "DeviceManagerWidget.c"
	} else {
		GtkScrolledWindow* _tmp1_;
#line 138 "../src/Widgets/DeviceManagerWidget.vala"
		_tmp1_ = self->priv->scrolled_box;
#line 138 "../src/Widgets/DeviceManagerWidget.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 662 "DeviceManagerWidget.c"
	}
}

static void
sound_widgets_device_manager_widget_default_output_changed (SoundWidgetsDeviceManagerWidget* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
#line 142 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = self->priv->pam;
#line 143 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp1_ = sound_pulse_audio_manager_get_default_output (_tmp0_);
#line 143 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_emit_by_name (_tmp2_, "defaulted");
#line 682 "DeviceManagerWidget.c"
}

static void
sound_widgets_device_manager_widget_default_input_changed (SoundWidgetsDeviceManagerWidget* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
#line 146 "../src/Widgets/DeviceManagerWidget.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = self->priv->pam;
#line 147 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp1_ = sound_pulse_audio_manager_get_default_input (_tmp0_);
#line 147 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp2_ = _tmp1_;
#line 147 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_emit_by_name (_tmp2_, "defaulted");
#line 701 "DeviceManagerWidget.c"
}

SoundWidgetsDeviceManagerWidget*
sound_widgets_device_manager_widget_construct (GType object_type)
{
	SoundWidgetsDeviceManagerWidget * self = NULL;
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	self = (SoundWidgetsDeviceManagerWidget*) g_object_new (object_type, NULL);
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	return self;
#line 712 "DeviceManagerWidget.c"
}

SoundWidgetsDeviceManagerWidget*
sound_widgets_device_manager_widget_new (void)
{
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	return sound_widgets_device_manager_widget_construct (SOUND_WIDGETS_TYPE_DEVICE_MANAGER_WIDGET);
#line 720 "DeviceManagerWidget.c"
}

static void
_sound_widgets_device_manager_widget_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                                      SoundDevice* dev,
                                                                                      gpointer self)
{
#line 32 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_add_device ((SoundWidgetsDeviceManagerWidget*) self, dev);
#line 730 "DeviceManagerWidget.c"
}

static void
_sound_widgets_device_manager_widget_default_output_changed_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self)
{
#line 33 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_default_output_changed ((SoundWidgetsDeviceManagerWidget*) self);
#line 740 "DeviceManagerWidget.c"
}

static void
_sound_widgets_device_manager_widget_default_input_changed_g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self)
{
#line 34 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_default_input_changed ((SoundWidgetsDeviceManagerWidget*) self);
#line 750 "DeviceManagerWidget.c"
}

static GObject *
sound_widgets_device_manager_widget_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundWidgetsDeviceManagerWidget * self;
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp1_;
	SoundPulseAudioManager* _tmp2_;
	SoundPulseAudioManager* _tmp3_;
	SoundPulseAudioManager* _tmp4_;
	GtkListBox* _tmp5_ = NULL;
	GtkScrolledWindow* _tmp6_ = NULL;
	GtkScrolledWindow* _tmp7_;
	GtkListBox* _tmp8_;
	GtkScrolledWindow* _tmp9_;
#line 30 "../src/Widgets/DeviceManagerWidget.vala"
	parent_class = G_OBJECT_CLASS (sound_widgets_device_manager_widget_parent_class);
#line 30 "../src/Widgets/DeviceManagerWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/Widgets/DeviceManagerWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_DEVICE_MANAGER_WIDGET, SoundWidgetsDeviceManagerWidget);
#line 31 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp0_ = sound_pulse_audio_manager_get_default ();
#line 31 "../src/Widgets/DeviceManagerWidget.vala"
	self->priv->pam = _tmp0_;
#line 32 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp1_ = self->priv->pam;
#line 32 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_connect_object (_tmp1_, "new-device", (GCallback) _sound_widgets_device_manager_widget_add_device_sound_pulse_audio_manager_new_device, self, 0);
#line 33 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp2_ = self->priv->pam;
#line 33 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::default-output", (GCallback) _sound_widgets_device_manager_widget_default_output_changed_g_object_notify, self, 0);
#line 34 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp3_ = self->priv->pam;
#line 34 "../src/Widgets/DeviceManagerWidget.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::default-input", (GCallback) _sound_widgets_device_manager_widget_default_input_changed_g_object_notify, self, 0);
#line 35 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp4_ = self->priv->pam;
#line 35 "../src/Widgets/DeviceManagerWidget.vala"
	sound_pulse_audio_manager_start (_tmp4_);
#line 37 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp5_ = (GtkListBox*) gtk_list_box_new ();
#line 37 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_list_box_set_activate_on_single_click (_tmp5_, TRUE);
#line 37 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 37 "../src/Widgets/DeviceManagerWidget.vala"
	g_object_ref_sink (_tmp5_);
#line 37 "../src/Widgets/DeviceManagerWidget.vala"
	_g_object_unref0 (self->priv->device_list);
#line 37 "../src/Widgets/DeviceManagerWidget.vala"
	self->priv->device_list = _tmp5_;
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp6_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	g_object_set (_tmp6_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp6_, TRUE);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_scrolled_window_set_max_content_height (_tmp6_, 256);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, TRUE);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp6_, 3);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	g_object_ref_sink (_tmp6_);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	_g_object_unref0 (self->priv->scrolled_box);
#line 42 "../src/Widgets/DeviceManagerWidget.vala"
	self->priv->scrolled_box = _tmp6_;
#line 49 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp7_ = self->priv->scrolled_box;
#line 49 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp8_ = self->priv->device_list;
#line 49 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 51 "../src/Widgets/DeviceManagerWidget.vala"
	_tmp9_ = self->priv->scrolled_box;
#line 51 "../src/Widgets/DeviceManagerWidget.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
#line 53 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_update_showable (self);
#line 30 "../src/Widgets/DeviceManagerWidget.vala"
	return obj;
#line 841 "DeviceManagerWidget.c"
}

static void
sound_widgets_device_manager_widget_class_init (SoundWidgetsDeviceManagerWidgetClass * klass,
                                                gpointer klass_data)
{
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	sound_widgets_device_manager_widget_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	g_type_class_adjust_private_offset (klass, &SoundWidgetsDeviceManagerWidget_private_offset);
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_widgets_device_manager_widget_constructor;
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_widgets_device_manager_widget_finalize;
#line 856 "DeviceManagerWidget.c"
}

static void
sound_widgets_device_manager_widget_instance_init (SoundWidgetsDeviceManagerWidget * self,
                                                   gpointer klass)
{
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	self->priv = sound_widgets_device_manager_widget_get_instance_private (self);
#line 865 "DeviceManagerWidget.c"
}

static void
sound_widgets_device_manager_widget_finalize (GObject * obj)
{
	SoundWidgetsDeviceManagerWidget * self;
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_DEVICE_MANAGER_WIDGET, SoundWidgetsDeviceManagerWidget);
#line 24 "../src/Widgets/DeviceManagerWidget.vala"
	_g_object_unref0 (self->priv->device_list);
#line 25 "../src/Widgets/DeviceManagerWidget.vala"
	_g_object_unref0 (self->priv->scrolled_box);
#line 23 "../src/Widgets/DeviceManagerWidget.vala"
	G_OBJECT_CLASS (sound_widgets_device_manager_widget_parent_class)->finalize (obj);
#line 880 "DeviceManagerWidget.c"
}

static GType
sound_widgets_device_manager_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundWidgetsDeviceManagerWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_widgets_device_manager_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundWidgetsDeviceManagerWidget), 0, (GInstanceInitFunc) sound_widgets_device_manager_widget_instance_init, NULL };
	GType sound_widgets_device_manager_widget_type_id;
	sound_widgets_device_manager_widget_type_id = g_type_register_static (gtk_box_get_type (), "SoundWidgetsDeviceManagerWidget", &g_define_type_info, 0);
	SoundWidgetsDeviceManagerWidget_private_offset = g_type_add_instance_private (sound_widgets_device_manager_widget_type_id, sizeof (SoundWidgetsDeviceManagerWidgetPrivate));
	return sound_widgets_device_manager_widget_type_id;
}

GType
sound_widgets_device_manager_widget_get_type (void)
{
	static volatile gsize sound_widgets_device_manager_widget_type_id__once = 0;
	if (g_once_init_enter (&sound_widgets_device_manager_widget_type_id__once)) {
		GType sound_widgets_device_manager_widget_type_id;
		sound_widgets_device_manager_widget_type_id = sound_widgets_device_manager_widget_get_type_once ();
		g_once_init_leave (&sound_widgets_device_manager_widget_type_id__once, sound_widgets_device_manager_widget_type_id);
	}
	return sound_widgets_device_manager_widget_type_id__once;
}

