/* PlayerRow.c generated by valac 0.56.13, the Vala compiler
 * generated from PlayerRow.vala, do not modify */

/*
 * Copyright 2014 Ikey Doherty <ikey.doherty@gmail.com>
 *           2016-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include "sound.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gio/gdesktopappinfo.h>
#include <pango/pango.h>

#define ICON_SIZE 48
#define SOUND_WIDGETS_PLAYER_ROW_NOT_PLAYING _ ("Not playing")

enum  {
	SOUND_WIDGETS_PLAYER_ROW_0_PROPERTY,
	SOUND_WIDGETS_PLAYER_ROW_APP_INFO_PROPERTY,
	SOUND_WIDGETS_PLAYER_ROW_CLIENT_PROPERTY,
	SOUND_WIDGETS_PLAYER_ROW_NUM_PROPERTIES
};
static GParamSpec* sound_widgets_player_row_properties[SOUND_WIDGETS_PLAYER_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _SoundWidgetsPlayerRowLoadRemoteArtData SoundWidgetsPlayerRowLoadRemoteArtData;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
enum  {
	SOUND_WIDGETS_PLAYER_ROW_CLOSE_SIGNAL,
	SOUND_WIDGETS_PLAYER_ROW_NUM_SIGNALS
};
static guint sound_widgets_player_row_signals[SOUND_WIDGETS_PLAYER_ROW_NUM_SIGNALS] = {0};

struct _SoundWidgetsPlayerRowPrivate {
	GtkImage* background;
	GtkImage* mask;
	GtkLabel* title_label;
	GtkLabel* artist_label;
	GtkButton* prev_btn;
	GtkButton* play_btn;
	GtkButton* next_btn;
	GIcon* app_icon;
	GCancellable* load_remote_art_cancel;
	gboolean launched_by_indicator;
	gchar* app_name;
	gchar* last_art_url;
	GAppInfo* ainfo;
	SoundServicesMprisClient* client_;
	SoundServicesMediaPlayer* mp_client;
};

struct _SoundWidgetsPlayerRowLoadRemoteArtData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundWidgetsPlayerRow* self;
	gchar* uri;
	gint scale;
	GtkStyleContext* _tmp0_;
	GFile* file;
	GFile* _tmp1_;
	GInputStream* stream;
	GFile* _tmp2_;
	GCancellable* _tmp3_;
	GFileInputStream* _tmp4_;
	GdkPixbuf* pixbuf;
	GInputStream* _tmp5_;
	GCancellable* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	GtkImage* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GtkImage* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GIcon* _tmp18_;
	GtkImage* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GError* _inner_error0_;
};

static gint SoundWidgetsPlayerRow_private_offset;
static gpointer sound_widgets_player_row_parent_class = NULL;
static GtkCssProvider* sound_widgets_player_row_provider;
static GtkCssProvider* sound_widgets_player_row_provider = NULL;

static void sound_widgets_player_row_update_controls (SoundWidgetsPlayerRow* self);
static void sound_widgets_player_row_update_art (SoundWidgetsPlayerRow* self,
                                          const gchar* uri);
static void sound_widgets_player_row_connect_to_client (SoundWidgetsPlayerRow* self);
static void __lambda15_ (SoundWidgetsPlayerRow* self,
                  const gchar* i,
                  GHashTable* p,
                  gchar** inv,
                  gint inv_length1);
static void ___lambda16_ (SoundWidgetsPlayerRow* self,
                   const gchar* k,
                   GVariant* v);
static gboolean ___lambda17_ (SoundWidgetsPlayerRow* self);
static gboolean ____lambda17__gsource_func (gpointer self);
static gboolean ____lambda18_ (SoundWidgetsPlayerRow* self);
static void sound_widgets_player_row_update_play_status (SoundWidgetsPlayerRow* self);
static gboolean _____lambda18__gsource_func (gpointer self);
static gboolean _____lambda19_ (SoundWidgetsPlayerRow* self);
static gboolean ______lambda19__gsource_func (gpointer self);
static void ____lambda16__gh_func (gconstpointer key,
                            gconstpointer value,
                            gpointer self);
static void ___lambda15__sound_services_dbus_prop_iface_properties_changed (SoundServicesDbusPropIface* _sender,
                                                                     const gchar* iface,
                                                                     GHashTable* changed,
                                                                     gchar** invalid,
                                                                     gint invalid_length1,
                                                                     gpointer self);
static gboolean sound_widgets_player_row_raise_player (SoundWidgetsPlayerRow* self,
                                                GdkEventButton* event);
static void* _____lambda21_ (SoundWidgetsPlayerRow* self);
static gpointer ______lambda21__gthread_func (gpointer self);
static GdkPixbuf* sound_widgets_player_row_mask_pixbuf (GdkPixbuf* pixbuf,
                                                 gint scale);
static void sound_widgets_player_row_load_remote_art (SoundWidgetsPlayerRow* self,
                                               const gchar* uri,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void sound_widgets_player_row_load_remote_art_finish (SoundWidgetsPlayerRow* self,
                                                      GAsyncResult* _res_);
static void sound_widgets_player_row_load_remote_art_data_free (gpointer _data);
static gboolean sound_widgets_player_row_load_remote_art_co (SoundWidgetsPlayerRowLoadRemoteArtData* _data_);
static void sound_widgets_player_row_load_remote_art_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static gboolean _sound_widgets_player_row_client_____lambda20_ (SoundWidgetsPlayerRow* self);
static gboolean __sound_widgets_player_row_client_____lambda20__gsource_func (gpointer self);
static GObject * sound_widgets_player_row_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static gboolean _sound_widgets_player_row_raise_player_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static void _sound_widgets_player_row___lambda22_ (SoundWidgetsPlayerRow* self);
static gboolean __lambda23_ (SoundWidgetsPlayerRow* self);
static void* ___lambda24_ (SoundWidgetsPlayerRow* self);
static gpointer ____lambda24__gthread_func (gpointer self);
static gboolean ___lambda23__gsource_func (gpointer self);
static void __sound_widgets_player_row___lambda22__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _sound_widgets_player_row___lambda25_ (SoundWidgetsPlayerRow* self);
static gboolean __lambda26_ (SoundWidgetsPlayerRow* self);
static void* ___lambda27_ (SoundWidgetsPlayerRow* self);
static gpointer ____lambda27__gthread_func (gpointer self);
static gboolean ___lambda26__gsource_func (gpointer self);
static void __sound_widgets_player_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _sound_widgets_player_row___lambda28_ (SoundWidgetsPlayerRow* self);
static gboolean __lambda29_ (SoundWidgetsPlayerRow* self);
static void* ___lambda30_ (SoundWidgetsPlayerRow* self);
static gpointer ____lambda30__gthread_func (gpointer self);
static gboolean ___lambda29__gsource_func (gpointer self);
static void __sound_widgets_player_row___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void sound_widgets_player_row_finalize (GObject * obj);
static GType sound_widgets_player_row_get_type_once (void);
static void _vala_sound_widgets_player_row_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_sound_widgets_player_row_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
sound_widgets_player_row_get_instance_private (SoundWidgetsPlayerRow* self)
{
	return G_STRUCT_MEMBER_P (self, SoundWidgetsPlayerRow_private_offset);
}

/**
     * Create a new PlayerRow
     *
     * @param client The underlying MprisClient instance to use
     */
SoundWidgetsPlayerRow*
sound_widgets_player_row_construct (GType object_type,
                                    SoundServicesMprisClient* mpris_client)
{
	SoundWidgetsPlayerRow * self = NULL;
#line 124 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (mpris_client != NULL, NULL);
#line 125 "../src/Widgets/PlayerRow.vala"
	self = (SoundWidgetsPlayerRow*) g_object_new (object_type, "client", mpris_client, NULL);
#line 124 "../src/Widgets/PlayerRow.vala"
	return self;
#line 238 "PlayerRow.c"
}

SoundWidgetsPlayerRow*
sound_widgets_player_row_new (SoundServicesMprisClient* mpris_client)
{
#line 124 "../src/Widgets/PlayerRow.vala"
	return sound_widgets_player_row_construct (SOUND_WIDGETS_TYPE_PLAYER_ROW, mpris_client);
#line 246 "PlayerRow.c"
}

/**
     * Create a new PlayerRow for bluetooth controls
     *
     * @param client The underlying MediaPlayer instance to use
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 134 "../src/Widgets/PlayerRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 259 "PlayerRow.c"
}

SoundWidgetsPlayerRow*
sound_widgets_player_row_construct_bluetooth (GType object_type,
                                              SoundServicesMediaPlayer* media_player_client,
                                              const gchar* name,
                                              const gchar* icon)
{
	SoundWidgetsPlayerRow * self = NULL;
	SoundServicesMediaPlayer* _tmp0_;
	GThemedIcon* _tmp1_;
	GtkImage* _tmp2_;
	GIcon* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
#line 133 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (media_player_client != NULL, NULL);
#line 133 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 133 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 133 "../src/Widgets/PlayerRow.vala"
	self = (SoundWidgetsPlayerRow*) g_object_new (object_type, NULL);
#line 134 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = _g_object_ref0 (media_player_client);
#line 134 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->mp_client);
#line 134 "../src/Widgets/PlayerRow.vala"
	self->priv->mp_client = _tmp0_;
#line 136 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (icon);
#line 136 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->app_icon);
#line 136 "../src/Widgets/PlayerRow.vala"
	self->priv->app_icon = (GIcon*) _tmp1_;
#line 137 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = self->priv->background;
#line 137 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = self->priv->app_icon;
#line 137 "../src/Widgets/PlayerRow.vala"
	gtk_image_set_from_gicon (_tmp2_, _tmp3_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 138 "../src/Widgets/PlayerRow.vala"
	_tmp4_ = self->priv->title_label;
#line 138 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_label (_tmp4_, name);
#line 139 "../src/Widgets/PlayerRow.vala"
	_tmp5_ = self->priv->artist_label;
#line 139 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_label (_tmp5_, SOUND_WIDGETS_PLAYER_ROW_NOT_PLAYING);
#line 141 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_update_controls (self);
#line 133 "../src/Widgets/PlayerRow.vala"
	return self;
#line 313 "PlayerRow.c"
}

SoundWidgetsPlayerRow*
sound_widgets_player_row_new_bluetooth (SoundServicesMediaPlayer* media_player_client,
                                        const gchar* name,
                                        const gchar* icon)
{
#line 133 "../src/Widgets/PlayerRow.vala"
	return sound_widgets_player_row_construct_bluetooth (SOUND_WIDGETS_TYPE_PLAYER_ROW, media_player_client, name, icon);
#line 323 "PlayerRow.c"
}

/**
     * Create a new PlayerRow for the default player
     *
     * @param info The AppInfo of the default music player
     */
SoundWidgetsPlayerRow*
sound_widgets_player_row_construct_default (GType object_type,
                                            GAppInfo* info)
{
	SoundWidgetsPlayerRow * self = NULL;
	gchar** title_info = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint title_info_length1;
	gint _title_info_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GtkLabel* _tmp19_;
	const gchar* _tmp20_;
	GtkLabel* _tmp21_;
#line 149 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 150 "../src/Widgets/PlayerRow.vala"
	self = (SoundWidgetsPlayerRow*) g_object_new (object_type, "app-info", info, "client", NULL, NULL);
#line 155 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = sound_indicator_settings;
#line 155 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "last-title-info");
#line 155 "../src/Widgets/PlayerRow.vala"
	title_info = _tmp2_;
#line 155 "../src/Widgets/PlayerRow.vala"
	title_info_length1 = _vala_array_length (_tmp1_);
#line 155 "../src/Widgets/PlayerRow.vala"
	_title_info_size_ = title_info_length1;
#line 156 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = title_info;
#line 156 "../src/Widgets/PlayerRow.vala"
	_tmp3__length1 = title_info_length1;
#line 156 "../src/Widgets/PlayerRow.vala"
	if (_tmp3__length1 == 4) {
#line 367 "PlayerRow.c"
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		GAppInfo* _tmp6_;
		GAppInfo* _tmp7_;
		const gchar* _tmp8_;
#line 157 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = title_info;
#line 157 "../src/Widgets/PlayerRow.vala"
		_tmp4__length1 = title_info_length1;
#line 157 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = _tmp4_[0];
#line 157 "../src/Widgets/PlayerRow.vala"
		_tmp6_ = sound_widgets_player_row_get_app_info (self);
#line 157 "../src/Widgets/PlayerRow.vala"
		_tmp7_ = _tmp6_;
#line 157 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = g_app_info_get_id (_tmp7_);
#line 157 "../src/Widgets/PlayerRow.vala"
		if (g_strcmp0 (_tmp5_, _tmp8_) == 0) {
#line 388 "PlayerRow.c"
			GtkLabel* _tmp9_;
			gchar** _tmp10_;
			gint _tmp10__length1;
			const gchar* _tmp11_;
			GtkLabel* _tmp12_;
			gchar** _tmp13_;
			gint _tmp13__length1;
			const gchar* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			const gchar* _tmp16_;
#line 158 "../src/Widgets/PlayerRow.vala"
			_tmp9_ = self->priv->title_label;
#line 158 "../src/Widgets/PlayerRow.vala"
			_tmp10_ = title_info;
#line 158 "../src/Widgets/PlayerRow.vala"
			_tmp10__length1 = title_info_length1;
#line 158 "../src/Widgets/PlayerRow.vala"
			_tmp11_ = _tmp10_[1];
#line 158 "../src/Widgets/PlayerRow.vala"
			gtk_label_set_label (_tmp9_, _tmp11_);
#line 159 "../src/Widgets/PlayerRow.vala"
			_tmp12_ = self->priv->artist_label;
#line 159 "../src/Widgets/PlayerRow.vala"
			_tmp13_ = title_info;
#line 159 "../src/Widgets/PlayerRow.vala"
			_tmp13__length1 = title_info_length1;
#line 159 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = _tmp13_[2];
#line 159 "../src/Widgets/PlayerRow.vala"
			gtk_label_set_label (_tmp12_, _tmp14_);
#line 160 "../src/Widgets/PlayerRow.vala"
			_tmp15_ = title_info;
#line 160 "../src/Widgets/PlayerRow.vala"
			_tmp15__length1 = title_info_length1;
#line 160 "../src/Widgets/PlayerRow.vala"
			_tmp16_ = _tmp15_[3];
#line 160 "../src/Widgets/PlayerRow.vala"
			if (g_strcmp0 (_tmp16_, "") != 0) {
#line 428 "PlayerRow.c"
				gchar** _tmp17_;
				gint _tmp17__length1;
				const gchar* _tmp18_;
#line 161 "../src/Widgets/PlayerRow.vala"
				_tmp17_ = title_info;
#line 161 "../src/Widgets/PlayerRow.vala"
				_tmp17__length1 = title_info_length1;
#line 161 "../src/Widgets/PlayerRow.vala"
				_tmp18_ = _tmp17_[3];
#line 161 "../src/Widgets/PlayerRow.vala"
				sound_widgets_player_row_update_art (self, _tmp18_);
#line 440 "PlayerRow.c"
			}
#line 164 "../src/Widgets/PlayerRow.vala"
			title_info = (_vala_array_free (title_info, title_info_length1, (GDestroyNotify) g_free), NULL);
#line 164 "../src/Widgets/PlayerRow.vala"
			return self;
#line 446 "PlayerRow.c"
		}
	}
#line 168 "../src/Widgets/PlayerRow.vala"
	_tmp19_ = self->priv->title_label;
#line 168 "../src/Widgets/PlayerRow.vala"
	_tmp20_ = self->priv->app_name;
#line 168 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_label (_tmp19_, _tmp20_);
#line 169 "../src/Widgets/PlayerRow.vala"
	_tmp21_ = self->priv->artist_label;
#line 169 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_label (_tmp21_, SOUND_WIDGETS_PLAYER_ROW_NOT_PLAYING);
#line 149 "../src/Widgets/PlayerRow.vala"
	title_info = (_vala_array_free (title_info, title_info_length1, (GDestroyNotify) g_free), NULL);
#line 149 "../src/Widgets/PlayerRow.vala"
	return self;
#line 463 "PlayerRow.c"
}

SoundWidgetsPlayerRow*
sound_widgets_player_row_new_default (GAppInfo* info)
{
#line 149 "../src/Widgets/PlayerRow.vala"
	return sound_widgets_player_row_construct_default (SOUND_WIDGETS_TYPE_PLAYER_ROW, info);
#line 471 "PlayerRow.c"
}

static gboolean
___lambda17_ (SoundWidgetsPlayerRow* self)
{
	gboolean result;
#line 391 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_update_from_meta (self);
#line 392 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 392 "../src/Widgets/PlayerRow.vala"
	return result;
#line 484 "PlayerRow.c"
}

static gboolean
____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda17_ ((SoundWidgetsPlayerRow*) self);
#line 390 "../src/Widgets/PlayerRow.vala"
	return result;
#line 494 "PlayerRow.c"
}

static gboolean
____lambda18_ (SoundWidgetsPlayerRow* self)
{
	gboolean result;
#line 396 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_update_play_status (self);
#line 397 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 397 "../src/Widgets/PlayerRow.vala"
	return result;
#line 507 "PlayerRow.c"
}

static gboolean
_____lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda18_ ((SoundWidgetsPlayerRow*) self);
#line 395 "../src/Widgets/PlayerRow.vala"
	return result;
#line 517 "PlayerRow.c"
}

static gboolean
_____lambda19_ (SoundWidgetsPlayerRow* self)
{
	gboolean result;
#line 401 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_update_controls (self);
#line 402 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 402 "../src/Widgets/PlayerRow.vala"
	return result;
#line 530 "PlayerRow.c"
}

static gboolean
______lambda19__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda19_ ((SoundWidgetsPlayerRow*) self);
#line 400 "../src/Widgets/PlayerRow.vala"
	return result;
#line 540 "PlayerRow.c"
}

static void
___lambda16_ (SoundWidgetsPlayerRow* self,
              const gchar* k,
              GVariant* v)
{
#line 388 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (k != NULL);
#line 388 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (v != NULL);
#line 389 "../src/Widgets/PlayerRow.vala"
	if (g_strcmp0 (k, "Metadata") == 0) {
#line 390 "../src/Widgets/PlayerRow.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda17__gsource_func, g_object_ref (self), g_object_unref);
#line 556 "PlayerRow.c"
	} else {
#line 394 "../src/Widgets/PlayerRow.vala"
		if (g_strcmp0 (k, "PlaybackStatus") == 0) {
#line 395 "../src/Widgets/PlayerRow.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda18__gsource_func, g_object_ref (self), g_object_unref);
#line 562 "PlayerRow.c"
		} else {
			gboolean _tmp0_ = FALSE;
#line 399 "../src/Widgets/PlayerRow.vala"
			if (g_strcmp0 (k, "CanGoNext") == 0) {
#line 399 "../src/Widgets/PlayerRow.vala"
				_tmp0_ = TRUE;
#line 569 "PlayerRow.c"
			} else {
#line 399 "../src/Widgets/PlayerRow.vala"
				_tmp0_ = g_strcmp0 (k, "CanGoPrevious") == 0;
#line 573 "PlayerRow.c"
			}
#line 399 "../src/Widgets/PlayerRow.vala"
			if (_tmp0_) {
#line 400 "../src/Widgets/PlayerRow.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda19__gsource_func, g_object_ref (self), g_object_unref);
#line 579 "PlayerRow.c"
			}
		}
	}
}

static void
____lambda16__gh_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
#line 388 "../src/Widgets/PlayerRow.vala"
	___lambda16_ ((SoundWidgetsPlayerRow*) self, (const gchar*) key, (GVariant*) value);
#line 592 "PlayerRow.c"
}

static void
__lambda15_ (SoundWidgetsPlayerRow* self,
             const gchar* i,
             GHashTable* p,
             gchar** inv,
             gint inv_length1)
{
#line 385 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (i != NULL);
#line 385 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (p != NULL);
#line 386 "../src/Widgets/PlayerRow.vala"
	if (g_strcmp0 (i, "org.mpris.MediaPlayer2.Player") == 0) {
#line 388 "../src/Widgets/PlayerRow.vala"
		g_hash_table_foreach (p, ____lambda16__gh_func, self);
#line 610 "PlayerRow.c"
	}
}

static void
___lambda15__sound_services_dbus_prop_iface_properties_changed (SoundServicesDbusPropIface* _sender,
                                                                const gchar* iface,
                                                                GHashTable* changed,
                                                                gchar** invalid,
                                                                gint invalid_length1,
                                                                gpointer self)
{
#line 385 "../src/Widgets/PlayerRow.vala"
	__lambda15_ ((SoundWidgetsPlayerRow*) self, iface, changed, invalid, invalid_length1);
#line 624 "PlayerRow.c"
}

static void
sound_widgets_player_row_connect_to_client (SoundWidgetsPlayerRow* self)
{
	SoundServicesMprisClient* _tmp0_;
	SoundServicesMprisClient* _tmp1_;
	SoundServicesDbusPropIface* _tmp2_;
	SoundServicesDbusPropIface* _tmp3_;
#line 384 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 385 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = sound_widgets_player_row_get_client (self);
#line 385 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = _tmp0_;
#line 385 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = sound_services_mpris_client_get_prop (_tmp1_);
#line 385 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = _tmp2_;
#line 385 "../src/Widgets/PlayerRow.vala"
	g_signal_connect_object (_tmp3_, "properties-changed", (GCallback) ___lambda15__sound_services_dbus_prop_iface_properties_changed, self, 0);
#line 646 "PlayerRow.c"
}

static void*
_____lambda21_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
	{
		SoundServicesMprisClient* _tmp0_;
		SoundServicesMprisClient* _tmp1_;
		SoundServicesPlayerIface* _tmp2_;
		SoundServicesPlayerIface* _tmp3_;
#line 424 "../src/Widgets/PlayerRow.vala"
		_tmp0_ = sound_widgets_player_row_get_client (self);
#line 424 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = _tmp0_;
#line 424 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = sound_services_mpris_client_get_player (_tmp1_);
#line 424 "../src/Widgets/PlayerRow.vala"
		_tmp3_ = _tmp2_;
#line 424 "../src/Widgets/PlayerRow.vala"
		sound_services_mpris_iface_raise ((SoundServicesMprisIface*) _tmp3_, &_inner_error0_);
#line 424 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 671 "PlayerRow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 423 "../src/Widgets/PlayerRow.vala"
		e = _inner_error0_;
#line 423 "../src/Widgets/PlayerRow.vala"
		_inner_error0_ = NULL;
#line 426 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = e;
#line 426 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = _tmp4_->message;
#line 426 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:426: Raising the player probably failed (faulty MPRIS i" \
"nterface): %s", _tmp5_);
#line 423 "../src/Widgets/PlayerRow.vala"
		_g_error_free0 (e);
#line 693 "PlayerRow.c"
	}
	__finally0:
#line 423 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 423 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 423 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 423 "../src/Widgets/PlayerRow.vala"
		return NULL;
#line 704 "PlayerRow.c"
	}
#line 428 "../src/Widgets/PlayerRow.vala"
	result = NULL;
#line 428 "../src/Widgets/PlayerRow.vala"
	return result;
#line 710 "PlayerRow.c"
}

static gpointer
______lambda21__gthread_func (gpointer self)
{
	gpointer result;
	result = _____lambda21_ ((SoundWidgetsPlayerRow*) self);
#line 422 "../src/Widgets/PlayerRow.vala"
	g_object_unref (self);
#line 422 "../src/Widgets/PlayerRow.vala"
	return result;
#line 722 "PlayerRow.c"
}

static gboolean
sound_widgets_player_row_raise_player (SoundWidgetsPlayerRow* self,
                                       GdkEventButton* event)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 410 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 410 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 735 "PlayerRow.c"
	{
		gboolean _tmp0_ = FALSE;
		SoundServicesMprisClient* _tmp1_;
		SoundServicesMprisClient* _tmp2_;
#line 412 "../src/Widgets/PlayerRow.vala"
		g_signal_emit (self, sound_widgets_player_row_signals[SOUND_WIDGETS_PLAYER_ROW_CLOSE_SIGNAL], 0);
#line 413 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = sound_widgets_player_row_get_client (self);
#line 413 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = _tmp1_;
#line 413 "../src/Widgets/PlayerRow.vala"
		if (_tmp2_ != NULL) {
#line 748 "PlayerRow.c"
			SoundServicesMprisClient* _tmp3_;
			SoundServicesMprisClient* _tmp4_;
			SoundServicesPlayerIface* _tmp5_;
			SoundServicesPlayerIface* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp3_ = sound_widgets_player_row_get_client (self);
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp4_ = _tmp3_;
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp5_ = sound_services_mpris_client_get_player (_tmp4_);
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp6_ = _tmp5_;
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp7_ = sound_services_mpris_iface_get_can_raise ((SoundServicesMprisIface*) _tmp6_);
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp8_ = _tmp7_;
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp0_ = _tmp8_;
#line 769 "PlayerRow.c"
		} else {
#line 413 "../src/Widgets/PlayerRow.vala"
			_tmp0_ = FALSE;
#line 773 "PlayerRow.c"
		}
#line 413 "../src/Widgets/PlayerRow.vala"
		if (_tmp0_) {
#line 414 "../src/Widgets/PlayerRow.vala"
			if (!g_thread_supported ()) {
#line 415 "../src/Widgets/PlayerRow.vala"
				g_warning ("PlayerRow.vala:415: Threading is not supported. DBus timeout could be " \
"blocking UI");
#line 781 "PlayerRow.c"
				{
					SoundServicesMprisClient* _tmp9_;
					SoundServicesMprisClient* _tmp10_;
					SoundServicesPlayerIface* _tmp11_;
					SoundServicesPlayerIface* _tmp12_;
#line 417 "../src/Widgets/PlayerRow.vala"
					_tmp9_ = sound_widgets_player_row_get_client (self);
#line 417 "../src/Widgets/PlayerRow.vala"
					_tmp10_ = _tmp9_;
#line 417 "../src/Widgets/PlayerRow.vala"
					_tmp11_ = sound_services_mpris_client_get_player (_tmp10_);
#line 417 "../src/Widgets/PlayerRow.vala"
					_tmp12_ = _tmp11_;
#line 417 "../src/Widgets/PlayerRow.vala"
					sound_services_mpris_iface_raise ((SoundServicesMprisIface*) _tmp12_, &_inner_error0_);
#line 417 "../src/Widgets/PlayerRow.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 799 "PlayerRow.c"
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp13_;
					const gchar* _tmp14_;
#line 416 "../src/Widgets/PlayerRow.vala"
					e = _inner_error0_;
#line 416 "../src/Widgets/PlayerRow.vala"
					_inner_error0_ = NULL;
#line 419 "../src/Widgets/PlayerRow.vala"
					_tmp13_ = e;
#line 419 "../src/Widgets/PlayerRow.vala"
					_tmp14_ = _tmp13_->message;
#line 419 "../src/Widgets/PlayerRow.vala"
					g_warning ("PlayerRow.vala:419: Raising the player probably failed (faulty MPRIS i" \
"nterface): %s", _tmp14_);
#line 416 "../src/Widgets/PlayerRow.vala"
					_g_error_free0 (e);
#line 821 "PlayerRow.c"
				}
				__finally1:
#line 416 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 826 "PlayerRow.c"
					goto __catch0_g_error;
				}
			} else {
				GThread* _tmp15_;
				GThread* _tmp16_;
#line 422 "../src/Widgets/PlayerRow.vala"
				_tmp15_ = g_thread_new ("wingpanel_indicator_sound_dbus_backward_thread", ______lambda21__gthread_func, g_object_ref (self));
#line 422 "../src/Widgets/PlayerRow.vala"
				_tmp16_ = _tmp15_;
#line 422 "../src/Widgets/PlayerRow.vala"
				_g_thread_unref0 (_tmp16_);
#line 838 "PlayerRow.c"
			}
		} else {
			GAppInfo* _tmp17_;
			GAppInfo* _tmp18_;
#line 431 "../src/Widgets/PlayerRow.vala"
			_tmp17_ = sound_widgets_player_row_get_app_info (self);
#line 431 "../src/Widgets/PlayerRow.vala"
			_tmp18_ = _tmp17_;
#line 431 "../src/Widgets/PlayerRow.vala"
			if (_tmp18_ != NULL) {
#line 849 "PlayerRow.c"
				GAppInfo* _tmp19_;
				GAppInfo* _tmp20_;
#line 432 "../src/Widgets/PlayerRow.vala"
				_tmp19_ = sound_widgets_player_row_get_app_info (self);
#line 432 "../src/Widgets/PlayerRow.vala"
				_tmp20_ = _tmp19_;
#line 432 "../src/Widgets/PlayerRow.vala"
				g_app_info_launch (_tmp20_, NULL, NULL, &_inner_error0_);
#line 432 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 860 "PlayerRow.c"
					goto __catch0_g_error;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 411 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 435 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:435: Could not launch player");
#line 873 "PlayerRow.c"
	}
	__finally0:
#line 411 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 878 "PlayerRow.c"
		gboolean _tmp21_ = FALSE;
#line 411 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 411 "../src/Widgets/PlayerRow.vala"
		return _tmp21_;
#line 886 "PlayerRow.c"
	}
#line 438 "../src/Widgets/PlayerRow.vala"
	result = GDK_EVENT_STOP;
#line 438 "../src/Widgets/PlayerRow.vala"
	return result;
#line 892 "PlayerRow.c"
}

/**
     * Update play status based on player requirements
     */
static void
sound_widgets_player_row_update_play_status (SoundWidgetsPlayerRow* self)
{
	SoundServicesMprisClient* _tmp0_;
	SoundServicesMprisClient* _tmp1_;
	SoundServicesPlayerIface* _tmp2_;
	SoundServicesPlayerIface* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp14_ = FALSE;
	SoundServicesMprisClient* _tmp15_;
	SoundServicesMprisClient* _tmp16_;
	SoundServicesPlayerIface* _tmp17_;
	SoundServicesPlayerIface* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gboolean _tmp22_;
#line 444 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = sound_widgets_player_row_get_client (self);
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = _tmp0_;
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = sound_services_mpris_client_get_player (_tmp1_);
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = _tmp2_;
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp4_ = sound_services_player_iface_get_playback_status (_tmp3_);
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp5_ = _tmp4_;
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp6_ = _tmp5_;
#line 445 "../src/Widgets/PlayerRow.vala"
	_tmp7_ = g_strcmp0 (_tmp6_, "Playing") == 0;
#line 445 "../src/Widgets/PlayerRow.vala"
	_g_free0 (_tmp6_);
#line 445 "../src/Widgets/PlayerRow.vala"
	if (_tmp7_) {
#line 940 "PlayerRow.c"
		GtkButton* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
#line 446 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = self->priv->play_btn;
#line 446 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = gtk_button_get_image (_tmp8_);
#line 446 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = _tmp9_;
#line 446 "../src/Widgets/PlayerRow.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_image_get_type (), GtkImage), "icon-name", "media-playback-pause-symbolic", NULL);
#line 952 "PlayerRow.c"
	} else {
		GtkButton* _tmp11_;
		GtkWidget* _tmp12_;
		GtkWidget* _tmp13_;
#line 448 "../src/Widgets/PlayerRow.vala"
		_tmp11_ = self->priv->play_btn;
#line 448 "../src/Widgets/PlayerRow.vala"
		_tmp12_ = gtk_button_get_image (_tmp11_);
#line 448 "../src/Widgets/PlayerRow.vala"
		_tmp13_ = _tmp12_;
#line 448 "../src/Widgets/PlayerRow.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_image_get_type (), GtkImage), "icon-name", "media-playback-start-symbolic", NULL);
#line 965 "PlayerRow.c"
	}
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp15_ = sound_widgets_player_row_get_client (self);
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp16_ = _tmp15_;
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp17_ = sound_services_mpris_client_get_player (_tmp16_);
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp18_ = _tmp17_;
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp19_ = sound_services_player_iface_get_playback_status (_tmp18_);
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp20_ = _tmp19_;
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp21_ = _tmp20_;
#line 456 "../src/Widgets/PlayerRow.vala"
	_tmp22_ = g_strcmp0 (_tmp21_, "Stopped") == 0;
#line 456 "../src/Widgets/PlayerRow.vala"
	_g_free0 (_tmp21_);
#line 456 "../src/Widgets/PlayerRow.vala"
	if (_tmp22_) {
#line 987 "PlayerRow.c"
		GAppInfo* _tmp23_;
		GAppInfo* _tmp24_;
#line 456 "../src/Widgets/PlayerRow.vala"
		_tmp23_ = sound_widgets_player_row_get_app_info (self);
#line 456 "../src/Widgets/PlayerRow.vala"
		_tmp24_ = _tmp23_;
#line 456 "../src/Widgets/PlayerRow.vala"
		_tmp14_ = _tmp24_ == NULL;
#line 996 "PlayerRow.c"
	} else {
#line 456 "../src/Widgets/PlayerRow.vala"
		_tmp14_ = FALSE;
#line 1000 "PlayerRow.c"
	}
#line 456 "../src/Widgets/PlayerRow.vala"
	if (_tmp14_) {
#line 457 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) self, TRUE);
#line 458 "../src/Widgets/PlayerRow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 1008 "PlayerRow.c"
	} else {
#line 460 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) self, FALSE);
#line 461 "../src/Widgets/PlayerRow.vala"
		gtk_widget_show ((GtkWidget*) self);
#line 1014 "PlayerRow.c"
	}
}

/**
     * Update prev/next sensitivity based on player requirements
     */
static void
sound_widgets_player_row_update_controls (SoundWidgetsPlayerRow* self)
{
	SoundServicesMediaPlayer* _tmp0_;
#line 468 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = self->priv->mp_client;
#line 469 "../src/Widgets/PlayerRow.vala"
	if (_tmp0_ == NULL) {
#line 1031 "PlayerRow.c"
		GtkButton* _tmp1_;
		SoundServicesMprisClient* _tmp2_;
		SoundServicesMprisClient* _tmp3_;
		SoundServicesPlayerIface* _tmp4_;
		SoundServicesPlayerIface* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		GtkButton* _tmp8_;
		SoundServicesMprisClient* _tmp9_;
		SoundServicesMprisClient* _tmp10_;
		SoundServicesPlayerIface* _tmp11_;
		SoundServicesPlayerIface* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = self->priv->prev_btn;
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = sound_widgets_player_row_get_client (self);
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp3_ = _tmp2_;
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = sound_services_mpris_client_get_player (_tmp3_);
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = _tmp4_;
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp6_ = sound_services_player_iface_get_can_go_previous (_tmp5_);
#line 470 "../src/Widgets/PlayerRow.vala"
		_tmp7_ = _tmp6_;
#line 470 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, _tmp7_);
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = self->priv->next_btn;
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = sound_widgets_player_row_get_client (self);
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = _tmp9_;
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp11_ = sound_services_mpris_client_get_player (_tmp10_);
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp12_ = _tmp11_;
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp13_ = sound_services_player_iface_get_can_go_next (_tmp12_);
#line 471 "../src/Widgets/PlayerRow.vala"
		_tmp14_ = _tmp13_;
#line 471 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, _tmp14_);
#line 1078 "PlayerRow.c"
	} else {
		GtkButton* _tmp15_;
		GtkButton* _tmp16_;
#line 473 "../src/Widgets/PlayerRow.vala"
		_tmp15_ = self->priv->prev_btn;
#line 473 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, TRUE);
#line 474 "../src/Widgets/PlayerRow.vala"
		_tmp16_ = self->priv->next_btn;
#line 474 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
#line 1090 "PlayerRow.c"
	}
}

/**
     * Utility, handle updating the album art
     */
static void
sound_widgets_player_row_update_art (SoundWidgetsPlayerRow* self,
                                     const gchar* uri)
{
	gint scale = 0;
	GtkStyleContext* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 481 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (uri != NULL);
#line 482 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 482 "../src/Widgets/PlayerRow.vala"
	scale = gtk_style_context_get_scale (_tmp0_);
#line 483 "../src/Widgets/PlayerRow.vala"
	if (!g_str_has_prefix (uri, "file://")) {
#line 483 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = !g_str_has_prefix (uri, "http");
#line 1117 "PlayerRow.c"
	} else {
#line 483 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = FALSE;
#line 1121 "PlayerRow.c"
	}
#line 483 "../src/Widgets/PlayerRow.vala"
	if (_tmp1_) {
#line 1125 "PlayerRow.c"
		GtkImage* _tmp2_;
		GIcon* _tmp3_;
		GtkImage* _tmp4_;
		GtkStyleContext* _tmp5_;
		GtkImage* _tmp6_;
		GtkImage* _tmp7_;
#line 484 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = self->priv->background;
#line 484 "../src/Widgets/PlayerRow.vala"
		_tmp3_ = self->priv->app_icon;
#line 484 "../src/Widgets/PlayerRow.vala"
		g_object_set (_tmp2_, "gicon", _tmp3_, NULL);
#line 485 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = self->priv->background;
#line 485 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 485 "../src/Widgets/PlayerRow.vala"
		gtk_style_context_set_scale (_tmp5_, scale);
#line 486 "../src/Widgets/PlayerRow.vala"
		_tmp6_ = self->priv->mask;
#line 486 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, TRUE);
#line 487 "../src/Widgets/PlayerRow.vala"
		_tmp7_ = self->priv->mask;
#line 487 "../src/Widgets/PlayerRow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp7_);
#line 488 "../src/Widgets/PlayerRow.vala"
		return;
#line 1154 "PlayerRow.c"
	}
#line 491 "../src/Widgets/PlayerRow.vala"
	if (g_str_has_prefix (uri, "file://")) {
#line 1158 "PlayerRow.c"
		gchar* fname = NULL;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = _tmp8_ = g_strsplit (uri, "file://", 0);
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = _tmp9_;
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp10__length1 = _vala_array_length (_tmp8_);
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp11_ = _tmp10_[1];
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp13_ = _tmp12_;
#line 492 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 492 "../src/Widgets/PlayerRow.vala"
		fname = _tmp13_;
#line 1183 "PlayerRow.c"
		{
			GdkPixbuf* pbuf = NULL;
			const gchar* _tmp14_;
			GdkPixbuf* _tmp15_;
			GtkImage* _tmp16_;
			GdkPixbuf* _tmp17_;
			GdkPixbuf* _tmp18_;
			GdkPixbuf* _tmp19_;
			GtkImage* _tmp20_;
			GtkStyleContext* _tmp21_;
			GtkImage* _tmp22_;
			GtkImage* _tmp23_;
#line 494 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = fname;
#line 494 "../src/Widgets/PlayerRow.vala"
			_tmp15_ = gdk_pixbuf_new_from_file_at_size (_tmp14_, ICON_SIZE * scale, ICON_SIZE * scale, &_inner_error0_);
#line 494 "../src/Widgets/PlayerRow.vala"
			pbuf = _tmp15_;
#line 494 "../src/Widgets/PlayerRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1204 "PlayerRow.c"
				goto __catch0_g_error;
			}
#line 495 "../src/Widgets/PlayerRow.vala"
			_tmp16_ = self->priv->background;
#line 495 "../src/Widgets/PlayerRow.vala"
			_tmp17_ = pbuf;
#line 495 "../src/Widgets/PlayerRow.vala"
			_tmp18_ = sound_widgets_player_row_mask_pixbuf (_tmp17_, scale);
#line 495 "../src/Widgets/PlayerRow.vala"
			_tmp19_ = _tmp18_;
#line 495 "../src/Widgets/PlayerRow.vala"
			g_object_set (_tmp16_, "gicon", (GIcon*) _tmp19_, NULL);
#line 495 "../src/Widgets/PlayerRow.vala"
			_g_object_unref0 (_tmp19_);
#line 496 "../src/Widgets/PlayerRow.vala"
			_tmp20_ = self->priv->background;
#line 496 "../src/Widgets/PlayerRow.vala"
			_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
#line 496 "../src/Widgets/PlayerRow.vala"
			gtk_style_context_set_scale (_tmp21_, 1);
#line 497 "../src/Widgets/PlayerRow.vala"
			_tmp22_ = self->priv->mask;
#line 497 "../src/Widgets/PlayerRow.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp22_, FALSE);
#line 498 "../src/Widgets/PlayerRow.vala"
			_tmp23_ = self->priv->mask;
#line 498 "../src/Widgets/PlayerRow.vala"
			gtk_widget_show ((GtkWidget*) _tmp23_);
#line 493 "../src/Widgets/PlayerRow.vala"
			_g_object_unref0 (pbuf);
#line 1235 "PlayerRow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 493 "../src/Widgets/PlayerRow.vala"
			e = _inner_error0_;
#line 493 "../src/Widgets/PlayerRow.vala"
			_inner_error0_ = NULL;
#line 500 "../src/Widgets/PlayerRow.vala"
			_tmp24_ = e;
#line 500 "../src/Widgets/PlayerRow.vala"
			_tmp25_ = _tmp24_->message;
#line 500 "../src/Widgets/PlayerRow.vala"
			g_warning ("PlayerRow.vala:500: %s", _tmp25_);
#line 493 "../src/Widgets/PlayerRow.vala"
			_g_error_free0 (e);
#line 1255 "PlayerRow.c"
		}
		__finally0:
#line 493 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 493 "../src/Widgets/PlayerRow.vala"
			_g_free0 (fname);
#line 493 "../src/Widgets/PlayerRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 493 "../src/Widgets/PlayerRow.vala"
			g_clear_error (&_inner_error0_);
#line 493 "../src/Widgets/PlayerRow.vala"
			return;
#line 1268 "PlayerRow.c"
		}
#line 491 "../src/Widgets/PlayerRow.vala"
		_g_free0 (fname);
#line 1272 "PlayerRow.c"
	} else {
		GCancellable* _tmp26_;
		GCancellable* _tmp27_;
#line 504 "../src/Widgets/PlayerRow.vala"
		_tmp26_ = self->priv->load_remote_art_cancel;
#line 504 "../src/Widgets/PlayerRow.vala"
		g_cancellable_cancel (_tmp26_);
#line 505 "../src/Widgets/PlayerRow.vala"
		_tmp27_ = self->priv->load_remote_art_cancel;
#line 505 "../src/Widgets/PlayerRow.vala"
		g_cancellable_reset (_tmp27_);
#line 506 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_load_remote_art (self, uri, NULL, NULL);
#line 1286 "PlayerRow.c"
	}
}

static void
sound_widgets_player_row_load_remote_art_data_free (gpointer _data)
{
	SoundWidgetsPlayerRowLoadRemoteArtData* _data_;
	_data_ = _data;
#line 27 "../src/Widgets/PlayerRow.vala"
	_g_free0 (_data_->uri);
#line 27 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/Widgets/PlayerRow.vala"
	g_slice_free (SoundWidgetsPlayerRowLoadRemoteArtData, _data_);
#line 1301 "PlayerRow.c"
}

static void
sound_widgets_player_row_load_remote_art (SoundWidgetsPlayerRow* self,
                                          const gchar* uri,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	SoundWidgetsPlayerRowLoadRemoteArtData* _data_;
	SoundWidgetsPlayerRow* _tmp0_;
	gchar* _tmp1_;
#line 27 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (uri != NULL);
#line 27 "../src/Widgets/PlayerRow.vala"
	_data_ = g_slice_new0 (SoundWidgetsPlayerRowLoadRemoteArtData);
#line 27 "../src/Widgets/PlayerRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/Widgets/PlayerRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_widgets_player_row_load_remote_art_data_free);
#line 27 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/Widgets/PlayerRow.vala"
	_data_->self = _tmp0_;
#line 27 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = g_strdup (uri);
#line 27 "../src/Widgets/PlayerRow.vala"
	_g_free0 (_data_->uri);
#line 27 "../src/Widgets/PlayerRow.vala"
	_data_->uri = _tmp1_;
#line 27 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_load_remote_art_co (_data_);
#line 1335 "PlayerRow.c"
}

static void
sound_widgets_player_row_load_remote_art_finish (SoundWidgetsPlayerRow* self,
                                                 GAsyncResult* _res_)
{
	SoundWidgetsPlayerRowLoadRemoteArtData* _data_;
#line 27 "../src/Widgets/PlayerRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1345 "PlayerRow.c"
}

static void
sound_widgets_player_row_load_remote_art_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	SoundWidgetsPlayerRowLoadRemoteArtData* _data_;
#line 514 "../src/Widgets/PlayerRow.vala"
	_data_ = _user_data_;
#line 514 "../src/Widgets/PlayerRow.vala"
	_data_->_source_object_ = source_object;
#line 514 "../src/Widgets/PlayerRow.vala"
	_data_->_res_ = _res_;
#line 514 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_load_remote_art_co (_data_);
#line 1362 "PlayerRow.c"
}

static gboolean
sound_widgets_player_row_load_remote_art_co (SoundWidgetsPlayerRowLoadRemoteArtData* _data_)
{
#line 510 "../src/Widgets/PlayerRow.vala"
	switch (_data_->_state_) {
#line 510 "../src/Widgets/PlayerRow.vala"
		case 0:
#line 1372 "PlayerRow.c"
		goto _state_0;
#line 510 "../src/Widgets/PlayerRow.vala"
		case 1:
#line 1376 "PlayerRow.c"
		goto _state_1;
#line 510 "../src/Widgets/PlayerRow.vala"
		case 2:
#line 1380 "PlayerRow.c"
		goto _state_2;
		default:
#line 510 "../src/Widgets/PlayerRow.vala"
		g_assert_not_reached ();
#line 1385 "PlayerRow.c"
	}
	_state_0:
#line 511 "../src/Widgets/PlayerRow.vala"
	_data_->_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) _data_->self);
#line 511 "../src/Widgets/PlayerRow.vala"
	_data_->scale = gtk_style_context_get_scale (_data_->_tmp0_);
#line 512 "../src/Widgets/PlayerRow.vala"
	_data_->_tmp1_ = g_file_new_for_uri (_data_->uri);
#line 512 "../src/Widgets/PlayerRow.vala"
	_data_->file = _data_->_tmp1_;
#line 1396 "PlayerRow.c"
	{
#line 514 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp2_ = _data_->file;
#line 514 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp3_ = _data_->self->priv->load_remote_art_cancel;
#line 514 "../src/Widgets/PlayerRow.vala"
		_data_->_state_ = 1;
#line 514 "../src/Widgets/PlayerRow.vala"
		g_file_read_async (_data_->_tmp2_, G_PRIORITY_DEFAULT, _data_->_tmp3_, sound_widgets_player_row_load_remote_art_ready, _data_);
#line 514 "../src/Widgets/PlayerRow.vala"
		return FALSE;
#line 1408 "PlayerRow.c"
		_state_1:
#line 514 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp4_ = g_file_read_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 514 "../src/Widgets/PlayerRow.vala"
		_data_->stream = (GInputStream*) _data_->_tmp4_;
#line 514 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1416 "PlayerRow.c"
			goto __catch0_g_error;
		}
#line 515 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp5_ = _data_->stream;
#line 515 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp6_ = _data_->self->priv->load_remote_art_cancel;
#line 515 "../src/Widgets/PlayerRow.vala"
		_data_->_state_ = 2;
#line 515 "../src/Widgets/PlayerRow.vala"
		gdk_pixbuf_new_from_stream_async (_data_->_tmp5_, _data_->_tmp6_, sound_widgets_player_row_load_remote_art_ready, _data_);
#line 515 "../src/Widgets/PlayerRow.vala"
		return FALSE;
#line 1429 "PlayerRow.c"
		_state_2:
#line 515 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp7_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
#line 515 "../src/Widgets/PlayerRow.vala"
		_data_->pixbuf = _data_->_tmp7_;
#line 515 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 515 "../src/Widgets/PlayerRow.vala"
			_g_object_unref0 (_data_->stream);
#line 1439 "PlayerRow.c"
			goto __catch0_g_error;
		}
#line 516 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp8_ = _data_->pixbuf;
#line 516 "../src/Widgets/PlayerRow.vala"
		if (_data_->_tmp8_ != NULL) {
#line 517 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp9_ = _data_->self->priv->background;
#line 517 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp10_ = _data_->pixbuf;
#line 517 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp11_ = sound_widgets_player_row_mask_pixbuf (_data_->_tmp10_, _data_->scale);
#line 517 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 517 "../src/Widgets/PlayerRow.vala"
			g_object_set (_data_->_tmp9_, "gicon", (GIcon*) _data_->_tmp12_, NULL);
#line 517 "../src/Widgets/PlayerRow.vala"
			_g_object_unref0 (_data_->_tmp12_);
#line 518 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp13_ = _data_->self->priv->background;
#line 518 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _data_->_tmp13_);
#line 518 "../src/Widgets/PlayerRow.vala"
			gtk_style_context_set_scale (_data_->_tmp14_, 1);
#line 519 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp15_ = _data_->self->priv->mask;
#line 519 "../src/Widgets/PlayerRow.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _data_->_tmp15_, FALSE);
#line 520 "../src/Widgets/PlayerRow.vala"
			_data_->_tmp16_ = _data_->self->priv->mask;
#line 520 "../src/Widgets/PlayerRow.vala"
			gtk_widget_show ((GtkWidget*) _data_->_tmp16_);
#line 1472 "PlayerRow.c"
		}
#line 513 "../src/Widgets/PlayerRow.vala"
		_g_object_unref0 (_data_->pixbuf);
#line 513 "../src/Widgets/PlayerRow.vala"
		_g_object_unref0 (_data_->stream);
#line 1478 "PlayerRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 513 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 523 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp17_ = _data_->self->priv->background;
#line 523 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp18_ = _data_->self->priv->app_icon;
#line 523 "../src/Widgets/PlayerRow.vala"
		g_object_set (_data_->_tmp17_, "gicon", _data_->_tmp18_, NULL);
#line 524 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp19_ = _data_->self->priv->background;
#line 524 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) _data_->_tmp19_);
#line 524 "../src/Widgets/PlayerRow.vala"
		gtk_style_context_set_scale (_data_->_tmp20_, _data_->scale);
#line 525 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp21_ = _data_->self->priv->mask;
#line 525 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _data_->_tmp21_, TRUE);
#line 526 "../src/Widgets/PlayerRow.vala"
		_data_->_tmp22_ = _data_->self->priv->mask;
#line 526 "../src/Widgets/PlayerRow.vala"
		gtk_widget_hide ((GtkWidget*) _data_->_tmp22_);
#line 1505 "PlayerRow.c"
	}
	__finally0:
#line 513 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 513 "../src/Widgets/PlayerRow.vala"
		_g_object_unref0 (_data_->file);
#line 513 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 513 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 513 "../src/Widgets/PlayerRow.vala"
		g_object_unref (_data_->_async_result);
#line 513 "../src/Widgets/PlayerRow.vala"
		return FALSE;
#line 1520 "PlayerRow.c"
	}
#line 510 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (_data_->file);
#line 510 "../src/Widgets/PlayerRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 510 "../src/Widgets/PlayerRow.vala"
	if (_data_->_state_ != 0) {
#line 510 "../src/Widgets/PlayerRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 510 "../src/Widgets/PlayerRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1532 "PlayerRow.c"
		}
	}
#line 510 "../src/Widgets/PlayerRow.vala"
	g_object_unref (_data_->_async_result);
#line 510 "../src/Widgets/PlayerRow.vala"
	return FALSE;
#line 1539 "PlayerRow.c"
}

/**
     * Update display info such as artist, the background image, etc.
     */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 1556 "PlayerRow.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1560 "PlayerRow.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1566 "PlayerRow.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1571 "PlayerRow.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1577 "PlayerRow.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1581 "PlayerRow.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1585 "PlayerRow.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1589 "PlayerRow.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1593 "PlayerRow.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1597 "PlayerRow.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1612 "PlayerRow.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 1621 "PlayerRow.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1628 "PlayerRow.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1634 "PlayerRow.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1642 "PlayerRow.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1646 "PlayerRow.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1652 "PlayerRow.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1657 "PlayerRow.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1663 "PlayerRow.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1667 "PlayerRow.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1671 "PlayerRow.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 1677 "PlayerRow.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1683 "PlayerRow.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1695 "PlayerRow.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1699 "PlayerRow.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1703 "PlayerRow.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 1708 "PlayerRow.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 1716 "PlayerRow.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1734 "PlayerRow.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1740 "PlayerRow.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1744 "PlayerRow.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1752 "PlayerRow.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1761 "PlayerRow.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1770 "PlayerRow.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1776 "PlayerRow.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1784 "PlayerRow.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1796 "PlayerRow.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1802 "PlayerRow.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1806 "PlayerRow.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1814 "PlayerRow.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1825 "PlayerRow.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1834 "PlayerRow.c"
	}
}

void
sound_widgets_player_row_update_from_meta (SoundWidgetsPlayerRow* self)
{
	GHashTable* metadata = NULL;
	SoundServicesMprisClient* _tmp0_;
	SoundServicesMprisClient* _tmp1_;
	SoundServicesPlayerIface* _tmp2_;
	SoundServicesPlayerIface* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	gchar* title = NULL;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GHashTable* _tmp24_;
	GtkLabel* _tmp37_;
	const gchar* _tmp38_;
	gboolean _tmp39_ = FALSE;
	GHashTable* _tmp40_;
#line 533 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 534 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = sound_widgets_player_row_get_client (self);
#line 534 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = _tmp0_;
#line 534 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = sound_services_mpris_client_get_player (_tmp1_);
#line 534 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = _tmp2_;
#line 534 "../src/Widgets/PlayerRow.vala"
	_tmp4_ = sound_services_player_iface_get_metadata (_tmp3_);
#line 534 "../src/Widgets/PlayerRow.vala"
	_tmp5_ = _tmp4_;
#line 534 "../src/Widgets/PlayerRow.vala"
	metadata = _tmp5_;
#line 535 "../src/Widgets/PlayerRow.vala"
	_tmp6_ = metadata;
#line 535 "../src/Widgets/PlayerRow.vala"
	if (g_hash_table_contains (_tmp6_, "mpris:artUrl")) {
#line 1877 "PlayerRow.c"
		gchar* url = NULL;
		GHashTable* _tmp7_;
		gconstpointer _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 536 "../src/Widgets/PlayerRow.vala"
		_tmp7_ = metadata;
#line 536 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = g_hash_table_lookup (_tmp7_, "mpris:artUrl");
#line 536 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = g_variant_get_string ((GVariant*) _tmp8_, NULL);
#line 536 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 536 "../src/Widgets/PlayerRow.vala"
		url = _tmp10_;
#line 537 "../src/Widgets/PlayerRow.vala"
		_tmp11_ = url;
#line 537 "../src/Widgets/PlayerRow.vala"
		_tmp12_ = self->priv->last_art_url;
#line 537 "../src/Widgets/PlayerRow.vala"
		if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
#line 1901 "PlayerRow.c"
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 538 "../src/Widgets/PlayerRow.vala"
			_tmp13_ = url;
#line 538 "../src/Widgets/PlayerRow.vala"
			sound_widgets_player_row_update_art (self, _tmp13_);
#line 539 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = url;
#line 539 "../src/Widgets/PlayerRow.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 539 "../src/Widgets/PlayerRow.vala"
			_g_free0 (self->priv->last_art_url);
#line 539 "../src/Widgets/PlayerRow.vala"
			self->priv->last_art_url = _tmp15_;
#line 1917 "PlayerRow.c"
		}
#line 535 "../src/Widgets/PlayerRow.vala"
		_g_free0 (url);
#line 1921 "PlayerRow.c"
	} else {
		gchar* _tmp16_;
		GtkImage* _tmp17_;
		GtkImage* _tmp18_;
		GIcon* _tmp19_;
		GtkImage* _tmp20_;
		GtkImage* _tmp21_;
#line 542 "../src/Widgets/PlayerRow.vala"
		_tmp16_ = g_strdup ("");
#line 542 "../src/Widgets/PlayerRow.vala"
		_g_free0 (self->priv->last_art_url);
#line 542 "../src/Widgets/PlayerRow.vala"
		self->priv->last_art_url = _tmp16_;
#line 543 "../src/Widgets/PlayerRow.vala"
		_tmp17_ = self->priv->background;
#line 543 "../src/Widgets/PlayerRow.vala"
		gtk_image_set_pixel_size (_tmp17_, ICON_SIZE);
#line 544 "../src/Widgets/PlayerRow.vala"
		_tmp18_ = self->priv->background;
#line 544 "../src/Widgets/PlayerRow.vala"
		_tmp19_ = self->priv->app_icon;
#line 544 "../src/Widgets/PlayerRow.vala"
		gtk_image_set_from_gicon (_tmp18_, _tmp19_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 545 "../src/Widgets/PlayerRow.vala"
		_tmp20_ = self->priv->mask;
#line 545 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp20_, TRUE);
#line 546 "../src/Widgets/PlayerRow.vala"
		_tmp21_ = self->priv->mask;
#line 546 "../src/Widgets/PlayerRow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp21_);
#line 1953 "PlayerRow.c"
	}
#line 550 "../src/Widgets/PlayerRow.vala"
	_tmp24_ = metadata;
#line 550 "../src/Widgets/PlayerRow.vala"
	if (g_hash_table_contains (_tmp24_, "xesam:title")) {
#line 1959 "PlayerRow.c"
		GHashTable* _tmp25_;
		gconstpointer _tmp26_;
		const GVariantType* _tmp27_;
#line 550 "../src/Widgets/PlayerRow.vala"
		_tmp25_ = metadata;
#line 550 "../src/Widgets/PlayerRow.vala"
		_tmp26_ = g_hash_table_lookup (_tmp25_, "xesam:title");
#line 550 "../src/Widgets/PlayerRow.vala"
		_tmp27_ = G_VARIANT_TYPE_STRING;
#line 550 "../src/Widgets/PlayerRow.vala"
		_tmp23_ = g_variant_is_of_type ((GVariant*) _tmp26_, _tmp27_);
#line 1971 "PlayerRow.c"
	} else {
#line 550 "../src/Widgets/PlayerRow.vala"
		_tmp23_ = FALSE;
#line 1975 "PlayerRow.c"
	}
#line 550 "../src/Widgets/PlayerRow.vala"
	if (_tmp23_) {
#line 1979 "PlayerRow.c"
		GHashTable* _tmp28_;
		gconstpointer _tmp29_;
		const gchar* _tmp30_;
#line 551 "../src/Widgets/PlayerRow.vala"
		_tmp28_ = metadata;
#line 551 "../src/Widgets/PlayerRow.vala"
		_tmp29_ = g_hash_table_lookup (_tmp28_, "xesam:title");
#line 551 "../src/Widgets/PlayerRow.vala"
		_tmp30_ = g_variant_get_string ((GVariant*) _tmp29_, NULL);
#line 551 "../src/Widgets/PlayerRow.vala"
		_tmp22_ = g_strcmp0 (_tmp30_, "") != 0;
#line 1991 "PlayerRow.c"
	} else {
#line 550 "../src/Widgets/PlayerRow.vala"
		_tmp22_ = FALSE;
#line 1995 "PlayerRow.c"
	}
#line 550 "../src/Widgets/PlayerRow.vala"
	if (_tmp22_) {
#line 1999 "PlayerRow.c"
		GHashTable* _tmp31_;
		gconstpointer _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
#line 552 "../src/Widgets/PlayerRow.vala"
		_tmp31_ = metadata;
#line 552 "../src/Widgets/PlayerRow.vala"
		_tmp32_ = g_hash_table_lookup (_tmp31_, "xesam:title");
#line 552 "../src/Widgets/PlayerRow.vala"
		_tmp33_ = g_variant_get_string ((GVariant*) _tmp32_, NULL);
#line 552 "../src/Widgets/PlayerRow.vala"
		_tmp34_ = g_strdup (_tmp33_);
#line 552 "../src/Widgets/PlayerRow.vala"
		_g_free0 (title);
#line 552 "../src/Widgets/PlayerRow.vala"
		title = _tmp34_;
#line 2016 "PlayerRow.c"
	} else {
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 554 "../src/Widgets/PlayerRow.vala"
		_tmp35_ = self->priv->app_name;
#line 554 "../src/Widgets/PlayerRow.vala"
		_tmp36_ = g_strdup (_tmp35_);
#line 554 "../src/Widgets/PlayerRow.vala"
		_g_free0 (title);
#line 554 "../src/Widgets/PlayerRow.vala"
		title = _tmp36_;
#line 2028 "PlayerRow.c"
	}
#line 557 "../src/Widgets/PlayerRow.vala"
	_tmp37_ = self->priv->title_label;
#line 557 "../src/Widgets/PlayerRow.vala"
	_tmp38_ = title;
#line 557 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_label (_tmp37_, _tmp38_);
#line 559 "../src/Widgets/PlayerRow.vala"
	_tmp40_ = metadata;
#line 559 "../src/Widgets/PlayerRow.vala"
	if (g_hash_table_contains (_tmp40_, "xesam:artist")) {
#line 2040 "PlayerRow.c"
		GHashTable* _tmp41_;
		gconstpointer _tmp42_;
		const GVariantType* _tmp43_;
#line 559 "../src/Widgets/PlayerRow.vala"
		_tmp41_ = metadata;
#line 559 "../src/Widgets/PlayerRow.vala"
		_tmp42_ = g_hash_table_lookup (_tmp41_, "xesam:artist");
#line 559 "../src/Widgets/PlayerRow.vala"
		_tmp43_ = G_VARIANT_TYPE_STRING_ARRAY;
#line 559 "../src/Widgets/PlayerRow.vala"
		_tmp39_ = g_variant_is_of_type ((GVariant*) _tmp42_, _tmp43_);
#line 2052 "PlayerRow.c"
	} else {
#line 559 "../src/Widgets/PlayerRow.vala"
		_tmp39_ = FALSE;
#line 2056 "PlayerRow.c"
	}
#line 559 "../src/Widgets/PlayerRow.vala"
	if (_tmp39_) {
#line 2060 "PlayerRow.c"
		const gchar** artists = NULL;
		GHashTable* _tmp44_;
		gconstpointer _tmp45_;
		gsize _tmp46_ = 0;
		const gchar** _tmp47_;
		gint artists_length1;
		gint _artists_size_;
		GtkLabel* _tmp48_;
		const gchar** _tmp49_;
		gint _tmp49__length1;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 560 "../src/Widgets/PlayerRow.vala"
		_tmp44_ = metadata;
#line 560 "../src/Widgets/PlayerRow.vala"
		_tmp45_ = g_hash_table_lookup (_tmp44_, "xesam:artist");
#line 560 "../src/Widgets/PlayerRow.vala"
		_tmp47_ = g_variant_get_strv ((GVariant*) _tmp45_, &_tmp46_);
#line 560 "../src/Widgets/PlayerRow.vala"
		artists = _tmp47_;
#line 560 "../src/Widgets/PlayerRow.vala"
		artists_length1 = _tmp46_;
#line 560 "../src/Widgets/PlayerRow.vala"
		_artists_size_ = artists_length1;
#line 561 "../src/Widgets/PlayerRow.vala"
		_tmp48_ = self->priv->artist_label;
#line 561 "../src/Widgets/PlayerRow.vala"
		_tmp49_ = artists;
#line 561 "../src/Widgets/PlayerRow.vala"
		_tmp49__length1 = artists_length1;
#line 561 "../src/Widgets/PlayerRow.vala"
		_tmp50_ = _vala_g_strjoinv (", ", _tmp49_, (gint) _tmp49__length1);
#line 561 "../src/Widgets/PlayerRow.vala"
		_tmp51_ = _tmp50_;
#line 561 "../src/Widgets/PlayerRow.vala"
		gtk_label_set_label (_tmp48_, _tmp51_);
#line 561 "../src/Widgets/PlayerRow.vala"
		_g_free0 (_tmp51_);
#line 559 "../src/Widgets/PlayerRow.vala"
		artists = (g_free (artists), NULL);
#line 2101 "PlayerRow.c"
	} else {
		SoundServicesMprisClient* _tmp52_;
		SoundServicesMprisClient* _tmp53_;
		SoundServicesPlayerIface* _tmp54_;
		SoundServicesPlayerIface* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gboolean _tmp59_;
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp52_ = sound_widgets_player_row_get_client (self);
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp53_ = _tmp52_;
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp54_ = sound_services_mpris_client_get_player (_tmp53_);
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp55_ = _tmp54_;
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp56_ = sound_services_player_iface_get_playback_status (_tmp55_);
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp57_ = _tmp56_;
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp58_ = _tmp57_;
#line 563 "../src/Widgets/PlayerRow.vala"
		_tmp59_ = g_strcmp0 (_tmp58_, "Playing") == 0;
#line 563 "../src/Widgets/PlayerRow.vala"
		_g_free0 (_tmp58_);
#line 563 "../src/Widgets/PlayerRow.vala"
		if (_tmp59_) {
#line 2131 "PlayerRow.c"
			GtkLabel* _tmp60_;
#line 564 "../src/Widgets/PlayerRow.vala"
			_tmp60_ = self->priv->artist_label;
#line 564 "../src/Widgets/PlayerRow.vala"
			gtk_label_set_label (_tmp60_, _ ("Unknown Artist"));
#line 2137 "PlayerRow.c"
		} else {
			GtkLabel* _tmp61_;
#line 566 "../src/Widgets/PlayerRow.vala"
			_tmp61_ = self->priv->artist_label;
#line 566 "../src/Widgets/PlayerRow.vala"
			gtk_label_set_label (_tmp61_, SOUND_WIDGETS_PLAYER_ROW_NOT_PLAYING);
#line 2144 "PlayerRow.c"
		}
	}
#line 533 "../src/Widgets/PlayerRow.vala"
	_g_free0 (title);
#line 533 "../src/Widgets/PlayerRow.vala"
	_g_hash_table_unref0 (metadata);
#line 2151 "PlayerRow.c"
}

static GdkPixbuf*
sound_widgets_player_row_mask_pixbuf (GdkPixbuf* pixbuf,
                                      gint scale)
{
	gint size = 0;
	gint mask_offset = 0;
	gint mask_size_offset = 0;
	gint mask_size = 0;
	gint offset_x = 0;
	gint offset_y = 0;
	GdkPixbuf* input = NULL;
	GdkPixbuf* _tmp0_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* cr = NULL;
	cairo_t* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* result;
#line 571 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 572 "../src/Widgets/PlayerRow.vala"
	size = ICON_SIZE * scale;
#line 573 "../src/Widgets/PlayerRow.vala"
	mask_offset = 4 * scale;
#line 574 "../src/Widgets/PlayerRow.vala"
	mask_size_offset = mask_offset * 2;
#line 575 "../src/Widgets/PlayerRow.vala"
	mask_size = ICON_SIZE * scale;
#line 576 "../src/Widgets/PlayerRow.vala"
	offset_x = mask_offset;
#line 577 "../src/Widgets/PlayerRow.vala"
	offset_y = mask_offset + scale;
#line 578 "../src/Widgets/PlayerRow.vala"
	size = size - mask_size_offset;
#line 580 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = gdk_pixbuf_scale_simple (pixbuf, size, size, GDK_INTERP_BILINEAR);
#line 580 "../src/Widgets/PlayerRow.vala"
	input = _tmp0_;
#line 581 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, mask_size, mask_size);
#line 581 "../src/Widgets/PlayerRow.vala"
	surface = _tmp1_;
#line 582 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = cairo_create (surface);
#line 582 "../src/Widgets/PlayerRow.vala"
	cr = _tmp2_;
#line 584 "../src/Widgets/PlayerRow.vala"
	granite_drawing_utilities_cairo_rounded_rectangle (cr, (gdouble) offset_x, (gdouble) offset_y, (gdouble) size, (gdouble) size, (gdouble) mask_offset);
#line 585 "../src/Widgets/PlayerRow.vala"
	cairo_clip (cr);
#line 587 "../src/Widgets/PlayerRow.vala"
	gdk_cairo_set_source_pixbuf (cr, input, (gdouble) offset_x, (gdouble) offset_y);
#line 588 "../src/Widgets/PlayerRow.vala"
	cairo_paint (cr);
#line 590 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = gdk_pixbuf_get_from_surface (surface, 0, 0, mask_size, mask_size);
#line 590 "../src/Widgets/PlayerRow.vala"
	result = _tmp3_;
#line 590 "../src/Widgets/PlayerRow.vala"
	_cairo_destroy0 (cr);
#line 590 "../src/Widgets/PlayerRow.vala"
	_cairo_surface_destroy0 (surface);
#line 590 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (input);
#line 590 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2220 "PlayerRow.c"
}

void
sound_widgets_player_row_update_play (SoundWidgetsPlayerRow* self,
                                      const gchar* playing,
                                      const gchar* title,
                                      const gchar* artist)
{
	gboolean _tmp9_ = FALSE;
#line 593 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 593 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (playing != NULL);
#line 593 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (title != NULL);
#line 593 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (artist != NULL);
#line 594 "../src/Widgets/PlayerRow.vala"
	if (g_strcmp0 (playing, "") != 0) {
#line 2240 "PlayerRow.c"
		const gchar* _tmp0_;
		GQuark _tmp2_ = 0U;
#line 595 "../src/Widgets/PlayerRow.vala"
		static GQuark _tmp1_label0 = 0;
#line 595 "../src/Widgets/PlayerRow.vala"
		_tmp0_ = playing;
#line 595 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 595 "../src/Widgets/PlayerRow.vala"
		if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("playing")))) {
#line 595 "../src/Widgets/PlayerRow.vala"
			switch (0) {
#line 2253 "PlayerRow.c"
				default:
				{
					GtkButton* _tmp3_;
					GtkWidget* _tmp4_;
					GtkWidget* _tmp5_;
#line 597 "../src/Widgets/PlayerRow.vala"
					_tmp3_ = self->priv->play_btn;
#line 597 "../src/Widgets/PlayerRow.vala"
					_tmp4_ = gtk_button_get_image (_tmp3_);
#line 597 "../src/Widgets/PlayerRow.vala"
					_tmp5_ = _tmp4_;
#line 597 "../src/Widgets/PlayerRow.vala"
					gtk_image_set_from_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_image_get_type (), GtkImage), "media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 601 "../src/Widgets/PlayerRow.vala"
					break;
#line 2269 "PlayerRow.c"
				}
			}
		} else {
#line 595 "../src/Widgets/PlayerRow.vala"
			switch (0) {
#line 2275 "PlayerRow.c"
				default:
				{
					GtkButton* _tmp6_;
					GtkWidget* _tmp7_;
					GtkWidget* _tmp8_;
#line 604 "../src/Widgets/PlayerRow.vala"
					_tmp6_ = self->priv->play_btn;
#line 604 "../src/Widgets/PlayerRow.vala"
					_tmp7_ = gtk_button_get_image (_tmp6_);
#line 604 "../src/Widgets/PlayerRow.vala"
					_tmp8_ = _tmp7_;
#line 604 "../src/Widgets/PlayerRow.vala"
					gtk_image_set_from_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_image_get_type (), GtkImage), "media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 608 "../src/Widgets/PlayerRow.vala"
					break;
#line 2291 "PlayerRow.c"
				}
			}
		}
	}
#line 612 "../src/Widgets/PlayerRow.vala"
	if (g_strcmp0 (title, "") != 0) {
#line 612 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = g_strcmp0 (artist, "") != 0;
#line 2300 "PlayerRow.c"
	} else {
#line 612 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = FALSE;
#line 2304 "PlayerRow.c"
	}
#line 612 "../src/Widgets/PlayerRow.vala"
	if (_tmp9_) {
#line 2308 "PlayerRow.c"
		GtkLabel* _tmp10_;
		GtkLabel* _tmp11_;
#line 613 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = self->priv->title_label;
#line 613 "../src/Widgets/PlayerRow.vala"
		gtk_label_set_label (_tmp10_, title);
#line 614 "../src/Widgets/PlayerRow.vala"
		_tmp11_ = self->priv->artist_label;
#line 614 "../src/Widgets/PlayerRow.vala"
		gtk_label_set_label (_tmp11_, artist);
#line 2319 "PlayerRow.c"
	}
}

GAppInfo*
sound_widgets_player_row_get_app_info (SoundWidgetsPlayerRow* self)
{
	GAppInfo* result;
	GAppInfo* _tmp0_;
#line 52 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = self->priv->ainfo;
#line 53 "../src/Widgets/PlayerRow.vala"
	result = _tmp0_;
#line 53 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2336 "PlayerRow.c"
}

void
sound_widgets_player_row_set_app_info (SoundWidgetsPlayerRow* self,
                                       GAppInfo* value)
{
	GAppInfo* _tmp0_;
	GAppInfo* _tmp1_;
#line 54 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 55 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->ainfo);
#line 55 "../src/Widgets/PlayerRow.vala"
	self->priv->ainfo = _tmp0_;
#line 56 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = self->priv->ainfo;
#line 56 "../src/Widgets/PlayerRow.vala"
	if (_tmp1_ != NULL) {
#line 2357 "PlayerRow.c"
		GAppInfo* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		GIcon* icon = NULL;
		GIcon* _tmp9_;
		GIcon* _tmp10_;
		GIcon* _tmp11_;
#line 57 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = self->priv->ainfo;
#line 57 "../src/Widgets/PlayerRow.vala"
		_tmp3_ = g_app_info_get_display_name (_tmp2_);
#line 57 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 57 "../src/Widgets/PlayerRow.vala"
		_g_free0 (self->priv->app_name);
#line 57 "../src/Widgets/PlayerRow.vala"
		self->priv->app_name = _tmp4_;
#line 58 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = self->priv->app_name;
#line 58 "../src/Widgets/PlayerRow.vala"
		if (g_strcmp0 (_tmp5_, "") == 0) {
#line 2380 "PlayerRow.c"
			GAppInfo* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
#line 59 "../src/Widgets/PlayerRow.vala"
			_tmp6_ = self->priv->ainfo;
#line 59 "../src/Widgets/PlayerRow.vala"
			_tmp7_ = g_app_info_get_name (_tmp6_);
#line 59 "../src/Widgets/PlayerRow.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 59 "../src/Widgets/PlayerRow.vala"
			_g_free0 (self->priv->app_name);
#line 59 "../src/Widgets/PlayerRow.vala"
			self->priv->app_name = _tmp8_;
#line 2394 "PlayerRow.c"
		}
#line 61 "../src/Widgets/PlayerRow.vala"
		_tmp9_ = g_app_info_get_icon (value);
#line 61 "../src/Widgets/PlayerRow.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 61 "../src/Widgets/PlayerRow.vala"
		icon = _tmp10_;
#line 62 "../src/Widgets/PlayerRow.vala"
		_tmp11_ = icon;
#line 62 "../src/Widgets/PlayerRow.vala"
		if (_tmp11_ != NULL) {
#line 2406 "PlayerRow.c"
			GIcon* _tmp12_;
			GIcon* _tmp13_;
			GtkImage* _tmp14_;
			GIcon* _tmp15_;
#line 63 "../src/Widgets/PlayerRow.vala"
			_tmp12_ = icon;
#line 63 "../src/Widgets/PlayerRow.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 63 "../src/Widgets/PlayerRow.vala"
			_g_object_unref0 (self->priv->app_icon);
#line 63 "../src/Widgets/PlayerRow.vala"
			self->priv->app_icon = _tmp13_;
#line 64 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = self->priv->background;
#line 64 "../src/Widgets/PlayerRow.vala"
			_tmp15_ = self->priv->app_icon;
#line 64 "../src/Widgets/PlayerRow.vala"
			gtk_image_set_from_gicon (_tmp14_, _tmp15_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 2425 "PlayerRow.c"
		}
#line 56 "../src/Widgets/PlayerRow.vala"
		_g_object_unref0 (icon);
#line 2429 "PlayerRow.c"
	}
#line 54 "../src/Widgets/PlayerRow.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_widgets_player_row_properties[SOUND_WIDGETS_PLAYER_ROW_APP_INFO_PROPERTY]);
#line 2433 "PlayerRow.c"
}

SoundServicesMprisClient*
sound_widgets_player_row_get_client (SoundWidgetsPlayerRow* self)
{
	SoundServicesMprisClient* result;
	SoundServicesMprisClient* _tmp0_;
#line 74 "../src/Widgets/PlayerRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = self->priv->client_;
#line 75 "../src/Widgets/PlayerRow.vala"
	result = _tmp0_;
#line 75 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2449 "PlayerRow.c"
}

static gboolean
_sound_widgets_player_row_client_____lambda20_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		SoundServicesMprisClient* _tmp0_;
		SoundServicesMprisClient* _tmp1_;
		SoundServicesPlayerIface* _tmp2_;
		SoundServicesPlayerIface* _tmp3_;
#line 92 "../src/Widgets/PlayerRow.vala"
		self->priv->launched_by_indicator = FALSE;
#line 93 "../src/Widgets/PlayerRow.vala"
		_tmp0_ = sound_widgets_player_row_get_client (self);
#line 93 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = _tmp0_;
#line 93 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = sound_services_mpris_client_get_player (_tmp1_);
#line 93 "../src/Widgets/PlayerRow.vala"
		_tmp3_ = _tmp2_;
#line 93 "../src/Widgets/PlayerRow.vala"
		sound_services_player_iface_play_pause (_tmp3_, &_inner_error0_);
#line 93 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2476 "PlayerRow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 91 "../src/Widgets/PlayerRow.vala"
		e = _inner_error0_;
#line 91 "../src/Widgets/PlayerRow.vala"
		_inner_error0_ = NULL;
#line 95 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = e;
#line 95 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = _tmp4_->message;
#line 95 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:95: Could not play/pause: %s", _tmp5_);
#line 91 "../src/Widgets/PlayerRow.vala"
		_g_error_free0 (e);
#line 2498 "PlayerRow.c"
	}
	__finally0:
#line 91 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2503 "PlayerRow.c"
		gboolean _tmp6_ = FALSE;
#line 91 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 91 "../src/Widgets/PlayerRow.vala"
		return _tmp6_;
#line 2511 "PlayerRow.c"
	}
#line 98 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 98 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2517 "PlayerRow.c"
}

static gboolean
__sound_widgets_player_row_client_____lambda20__gsource_func (gpointer self)
{
	gboolean result;
	result = _sound_widgets_player_row_client_____lambda20_ ((SoundWidgetsPlayerRow*) self);
#line 90 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2527 "PlayerRow.c"
}

void
sound_widgets_player_row_set_client (SoundWidgetsPlayerRow* self,
                                     SoundServicesMprisClient* value)
{
	SoundServicesMprisClient* _tmp0_;
#line 76 "../src/Widgets/PlayerRow.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 77 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->client_);
#line 77 "../src/Widgets/PlayerRow.vala"
	self->priv->client_ = _tmp0_;
#line 78 "../src/Widgets/PlayerRow.vala"
	if (value != NULL) {
#line 2545 "PlayerRow.c"
		gchar* desktop_entry = NULL;
		SoundServicesMprisClient* _tmp1_;
		SoundServicesMprisClient* _tmp2_;
		SoundServicesPlayerIface* _tmp3_;
		SoundServicesPlayerIface* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
#line 79 "../src/Widgets/PlayerRow.vala"
		_tmp1_ = sound_widgets_player_row_get_client (self);
#line 79 "../src/Widgets/PlayerRow.vala"
		_tmp2_ = _tmp1_;
#line 79 "../src/Widgets/PlayerRow.vala"
		_tmp3_ = sound_services_mpris_client_get_player (_tmp2_);
#line 79 "../src/Widgets/PlayerRow.vala"
		_tmp4_ = _tmp3_;
#line 79 "../src/Widgets/PlayerRow.vala"
		_tmp5_ = sound_services_mpris_iface_get_desktop_entry ((SoundServicesMprisIface*) _tmp4_);
#line 79 "../src/Widgets/PlayerRow.vala"
		_tmp6_ = _tmp5_;
#line 79 "../src/Widgets/PlayerRow.vala"
		desktop_entry = _tmp6_;
#line 80 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = desktop_entry;
#line 80 "../src/Widgets/PlayerRow.vala"
		if (_tmp8_ != NULL) {
#line 2573 "PlayerRow.c"
			const gchar* _tmp9_;
#line 80 "../src/Widgets/PlayerRow.vala"
			_tmp9_ = desktop_entry;
#line 80 "../src/Widgets/PlayerRow.vala"
			_tmp7_ = g_strcmp0 (_tmp9_, "") != 0;
#line 2579 "PlayerRow.c"
		} else {
#line 80 "../src/Widgets/PlayerRow.vala"
			_tmp7_ = FALSE;
#line 2583 "PlayerRow.c"
		}
#line 80 "../src/Widgets/PlayerRow.vala"
		if (_tmp7_) {
#line 2587 "PlayerRow.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GDesktopAppInfo* _tmp13_;
			GDesktopAppInfo* _tmp14_;
#line 81 "../src/Widgets/PlayerRow.vala"
			_tmp10_ = desktop_entry;
#line 81 "../src/Widgets/PlayerRow.vala"
			_tmp11_ = g_strdup_printf ("%s.desktop", _tmp10_);
#line 81 "../src/Widgets/PlayerRow.vala"
			_tmp12_ = _tmp11_;
#line 81 "../src/Widgets/PlayerRow.vala"
			_tmp13_ = g_desktop_app_info_new (_tmp12_);
#line 81 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = _tmp13_;
#line 81 "../src/Widgets/PlayerRow.vala"
			sound_widgets_player_row_set_app_info (self, (GAppInfo*) _tmp14_);
#line 81 "../src/Widgets/PlayerRow.vala"
			_g_object_unref0 (_tmp14_);
#line 81 "../src/Widgets/PlayerRow.vala"
			_g_free0 (_tmp12_);
#line 2609 "PlayerRow.c"
		}
#line 84 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_connect_to_client (self);
#line 85 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_update_play_status (self);
#line 86 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_update_from_meta (self);
#line 87 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_update_controls (self);
#line 89 "../src/Widgets/PlayerRow.vala"
		if (self->priv->launched_by_indicator) {
#line 90 "../src/Widgets/PlayerRow.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __sound_widgets_player_row_client_____lambda20__gsource_func, g_object_ref (self), g_object_unref);
#line 2623 "PlayerRow.c"
		}
#line 78 "../src/Widgets/PlayerRow.vala"
		_g_free0 (desktop_entry);
#line 2627 "PlayerRow.c"
	} else {
		GtkButton* _tmp15_;
		GtkWidget* _tmp16_;
		GtkWidget* _tmp17_;
		GtkButton* _tmp18_;
		GtkButton* _tmp19_;
		GSettings* _tmp20_;
		GAppInfo* _tmp21_;
		GAppInfo* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		GtkLabel* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		GtkLabel* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar** _tmp33_;
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 102 "../src/Widgets/PlayerRow.vala"
		_tmp15_ = self->priv->play_btn;
#line 102 "../src/Widgets/PlayerRow.vala"
		_tmp16_ = gtk_button_get_image (_tmp15_);
#line 102 "../src/Widgets/PlayerRow.vala"
		_tmp17_ = _tmp16_;
#line 102 "../src/Widgets/PlayerRow.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_image_get_type (), GtkImage), "icon-name", "media-playback-start-symbolic", NULL);
#line 103 "../src/Widgets/PlayerRow.vala"
		_tmp18_ = self->priv->prev_btn;
#line 103 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, FALSE);
#line 104 "../src/Widgets/PlayerRow.vala"
		_tmp19_ = self->priv->next_btn;
#line 104 "../src/Widgets/PlayerRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp20_ = sound_indicator_settings;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp21_ = sound_widgets_player_row_get_app_info (self);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp22_ = _tmp21_;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp23_ = g_app_info_get_id (_tmp22_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp25_ = self->priv->title_label;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp26_ = gtk_label_get_text (_tmp25_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp27_ = g_strdup (_tmp26_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp28_ = self->priv->artist_label;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp29_ = gtk_label_get_text (_tmp28_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp30_ = g_strdup (_tmp29_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp31_ = self->priv->last_art_url;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp32_ = g_strdup (_tmp31_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp33_ = g_new0 (gchar*, 4 + 1);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp33_[0] = _tmp24_;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp33_[1] = _tmp27_;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp33_[2] = _tmp30_;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp33_[3] = _tmp32_;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp34_ = _tmp33_;
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp34__length1 = 4;
#line 105 "../src/Widgets/PlayerRow.vala"
		g_settings_set_strv (_tmp20_, "last-title-info", _tmp34_);
#line 105 "../src/Widgets/PlayerRow.vala"
		_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 114 "../src/Widgets/PlayerRow.vala"
		_tmp35_ = g_strdup ("");
#line 114 "../src/Widgets/PlayerRow.vala"
		_g_free0 (self->mpris_name);
#line 114 "../src/Widgets/PlayerRow.vala"
		self->mpris_name = _tmp35_;
#line 2717 "PlayerRow.c"
	}
#line 76 "../src/Widgets/PlayerRow.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_widgets_player_row_properties[SOUND_WIDGETS_PLAYER_ROW_CLIENT_PROPERTY]);
#line 2721 "PlayerRow.c"
}

static gboolean
_sound_widgets_player_row_raise_player_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = sound_widgets_player_row_raise_player ((SoundWidgetsPlayerRow*) self, event);
#line 272 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2733 "PlayerRow.c"
}

static void*
___lambda24_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
	{
		SoundServicesMediaPlayer* _tmp0_;
#line 290 "../src/Widgets/PlayerRow.vala"
		_tmp0_ = self->priv->mp_client;
#line 290 "../src/Widgets/PlayerRow.vala"
		if (_tmp0_ == NULL) {
#line 2747 "PlayerRow.c"
			SoundServicesMprisClient* _tmp1_;
			SoundServicesMprisClient* _tmp2_;
			SoundServicesPlayerIface* _tmp3_;
			SoundServicesPlayerIface* _tmp4_;
#line 291 "../src/Widgets/PlayerRow.vala"
			_tmp1_ = sound_widgets_player_row_get_client (self);
#line 291 "../src/Widgets/PlayerRow.vala"
			_tmp2_ = _tmp1_;
#line 291 "../src/Widgets/PlayerRow.vala"
			_tmp3_ = sound_services_mpris_client_get_player (_tmp2_);
#line 291 "../src/Widgets/PlayerRow.vala"
			_tmp4_ = _tmp3_;
#line 291 "../src/Widgets/PlayerRow.vala"
			sound_services_player_iface_previous (_tmp4_, &_inner_error0_);
#line 291 "../src/Widgets/PlayerRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2764 "PlayerRow.c"
				goto __catch0_g_error;
			}
		} else {
			SoundServicesMediaPlayer* _tmp5_;
#line 292 "../src/Widgets/PlayerRow.vala"
			_tmp5_ = self->priv->mp_client;
#line 292 "../src/Widgets/PlayerRow.vala"
			if (_tmp5_ != NULL) {
#line 2773 "PlayerRow.c"
				SoundServicesMediaPlayer* _tmp6_;
#line 293 "../src/Widgets/PlayerRow.vala"
				_tmp6_ = self->priv->mp_client;
#line 293 "../src/Widgets/PlayerRow.vala"
				sound_services_media_player_previous (_tmp6_, &_inner_error0_);
#line 293 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2781 "PlayerRow.c"
					goto __catch0_g_error;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 289 "../src/Widgets/PlayerRow.vala"
		e = _inner_error0_;
#line 289 "../src/Widgets/PlayerRow.vala"
		_inner_error0_ = NULL;
#line 296 "../src/Widgets/PlayerRow.vala"
		_tmp7_ = e;
#line 296 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = _tmp7_->message;
#line 296 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:296: Going to previous track probably failed (faulty MP" \
"RIS interface): %s", _tmp8_);
#line 289 "../src/Widgets/PlayerRow.vala"
		_g_error_free0 (e);
#line 2805 "PlayerRow.c"
	}
	__finally0:
#line 289 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 289 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 289 "../src/Widgets/PlayerRow.vala"
		return NULL;
#line 2816 "PlayerRow.c"
	}
#line 299 "../src/Widgets/PlayerRow.vala"
	result = NULL;
#line 299 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2822 "PlayerRow.c"
}

static gpointer
____lambda24__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda24_ ((SoundWidgetsPlayerRow*) self);
#line 288 "../src/Widgets/PlayerRow.vala"
	g_object_unref (self);
#line 288 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2834 "PlayerRow.c"
}

static gboolean
__lambda23_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 276 "../src/Widgets/PlayerRow.vala"
	if (!g_thread_supported ()) {
#line 277 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:277: Threading is not supported. DBus timeout could be " \
"blocking UI");
#line 2846 "PlayerRow.c"
		{
			gboolean _tmp0_ = FALSE;
			SoundServicesMediaPlayer* _tmp1_;
#line 279 "../src/Widgets/PlayerRow.vala"
			_tmp1_ = self->priv->mp_client;
#line 279 "../src/Widgets/PlayerRow.vala"
			if (_tmp1_ == NULL) {
#line 2854 "PlayerRow.c"
				SoundServicesMprisClient* _tmp2_;
				SoundServicesMprisClient* _tmp3_;
				SoundServicesPlayerIface* _tmp4_;
				SoundServicesPlayerIface* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp2_ = sound_widgets_player_row_get_client (self);
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp3_ = _tmp2_;
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp4_ = sound_services_mpris_client_get_player (_tmp3_);
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp5_ = _tmp4_;
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp6_ = sound_services_player_iface_get_can_go_previous (_tmp5_);
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp7_ = _tmp6_;
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp0_ = _tmp7_;
#line 2875 "PlayerRow.c"
			} else {
#line 279 "../src/Widgets/PlayerRow.vala"
				_tmp0_ = FALSE;
#line 2879 "PlayerRow.c"
			}
#line 279 "../src/Widgets/PlayerRow.vala"
			if (_tmp0_) {
#line 2883 "PlayerRow.c"
				SoundServicesMprisClient* _tmp8_;
				SoundServicesMprisClient* _tmp9_;
				SoundServicesPlayerIface* _tmp10_;
				SoundServicesPlayerIface* _tmp11_;
#line 280 "../src/Widgets/PlayerRow.vala"
				_tmp8_ = sound_widgets_player_row_get_client (self);
#line 280 "../src/Widgets/PlayerRow.vala"
				_tmp9_ = _tmp8_;
#line 280 "../src/Widgets/PlayerRow.vala"
				_tmp10_ = sound_services_mpris_client_get_player (_tmp9_);
#line 280 "../src/Widgets/PlayerRow.vala"
				_tmp11_ = _tmp10_;
#line 280 "../src/Widgets/PlayerRow.vala"
				sound_services_player_iface_previous (_tmp11_, &_inner_error0_);
#line 280 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2900 "PlayerRow.c"
					goto __catch0_g_error;
				}
			} else {
				SoundServicesMediaPlayer* _tmp12_;
#line 281 "../src/Widgets/PlayerRow.vala"
				_tmp12_ = self->priv->mp_client;
#line 281 "../src/Widgets/PlayerRow.vala"
				if (_tmp12_ != NULL) {
#line 2909 "PlayerRow.c"
					SoundServicesMediaPlayer* _tmp13_;
#line 282 "../src/Widgets/PlayerRow.vala"
					_tmp13_ = self->priv->mp_client;
#line 282 "../src/Widgets/PlayerRow.vala"
					sound_services_media_player_previous (_tmp13_, &_inner_error0_);
#line 282 "../src/Widgets/PlayerRow.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2917 "PlayerRow.c"
						goto __catch0_g_error;
					}
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 278 "../src/Widgets/PlayerRow.vala"
			e = _inner_error0_;
#line 278 "../src/Widgets/PlayerRow.vala"
			_inner_error0_ = NULL;
#line 285 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = e;
#line 285 "../src/Widgets/PlayerRow.vala"
			_tmp15_ = _tmp14_->message;
#line 285 "../src/Widgets/PlayerRow.vala"
			g_warning ("PlayerRow.vala:285: Going to previous track probably failed (faulty MP" \
"RIS interface): %s", _tmp15_);
#line 278 "../src/Widgets/PlayerRow.vala"
			_g_error_free0 (e);
#line 2941 "PlayerRow.c"
		}
		__finally0:
#line 278 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2946 "PlayerRow.c"
			gboolean _tmp16_ = FALSE;
#line 278 "../src/Widgets/PlayerRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/Widgets/PlayerRow.vala"
			g_clear_error (&_inner_error0_);
#line 278 "../src/Widgets/PlayerRow.vala"
			return _tmp16_;
#line 2954 "PlayerRow.c"
		}
	} else {
		GThread* _tmp17_;
		GThread* _tmp18_;
#line 288 "../src/Widgets/PlayerRow.vala"
		_tmp17_ = g_thread_new ("wingpanel_indicator_sound_dbus_backward_thread", ____lambda24__gthread_func, g_object_ref (self));
#line 288 "../src/Widgets/PlayerRow.vala"
		_tmp18_ = _tmp17_;
#line 288 "../src/Widgets/PlayerRow.vala"
		_g_thread_unref0 (_tmp18_);
#line 2965 "PlayerRow.c"
	}
#line 303 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 303 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2971 "PlayerRow.c"
}

static gboolean
___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda23_ ((SoundWidgetsPlayerRow*) self);
#line 275 "../src/Widgets/PlayerRow.vala"
	return result;
#line 2981 "PlayerRow.c"
}

static void
_sound_widgets_player_row___lambda22_ (SoundWidgetsPlayerRow* self)
{
#line 275 "../src/Widgets/PlayerRow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda23__gsource_func, g_object_ref (self), g_object_unref);
#line 2989 "PlayerRow.c"
}

static void
__sound_widgets_player_row___lambda22__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 274 "../src/Widgets/PlayerRow.vala"
	_sound_widgets_player_row___lambda22_ ((SoundWidgetsPlayerRow*) self);
#line 2998 "PlayerRow.c"
}

static void*
___lambda27_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
	{
		SoundServicesMediaPlayer* _tmp0_;
#line 328 "../src/Widgets/PlayerRow.vala"
		_tmp0_ = self->priv->mp_client;
#line 328 "../src/Widgets/PlayerRow.vala"
		if (_tmp0_ == NULL) {
#line 3012 "PlayerRow.c"
			SoundServicesMprisClient* _tmp1_;
			SoundServicesMprisClient* _tmp2_;
			SoundServicesPlayerIface* _tmp3_;
			SoundServicesPlayerIface* _tmp4_;
#line 329 "../src/Widgets/PlayerRow.vala"
			_tmp1_ = sound_widgets_player_row_get_client (self);
#line 329 "../src/Widgets/PlayerRow.vala"
			_tmp2_ = _tmp1_;
#line 329 "../src/Widgets/PlayerRow.vala"
			_tmp3_ = sound_services_mpris_client_get_player (_tmp2_);
#line 329 "../src/Widgets/PlayerRow.vala"
			_tmp4_ = _tmp3_;
#line 329 "../src/Widgets/PlayerRow.vala"
			sound_services_player_iface_play_pause (_tmp4_, &_inner_error0_);
#line 329 "../src/Widgets/PlayerRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3029 "PlayerRow.c"
				goto __catch0_g_error;
			}
		} else {
			SoundServicesMediaPlayer* _tmp5_;
#line 330 "../src/Widgets/PlayerRow.vala"
			_tmp5_ = self->priv->mp_client;
#line 330 "../src/Widgets/PlayerRow.vala"
			if (_tmp5_ != NULL) {
#line 3038 "PlayerRow.c"
				SoundServicesMediaPlayer* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_;
#line 331 "../src/Widgets/PlayerRow.vala"
				_tmp6_ = self->priv->mp_client;
#line 331 "../src/Widgets/PlayerRow.vala"
				_tmp7_ = sound_services_media_player_get_status (_tmp6_);
#line 331 "../src/Widgets/PlayerRow.vala"
				_tmp8_ = _tmp7_;
#line 331 "../src/Widgets/PlayerRow.vala"
				_tmp9_ = _tmp8_;
#line 331 "../src/Widgets/PlayerRow.vala"
				_tmp10_ = g_strcmp0 (_tmp9_, "playing") == 0;
#line 331 "../src/Widgets/PlayerRow.vala"
				_g_free0 (_tmp9_);
#line 331 "../src/Widgets/PlayerRow.vala"
				if (_tmp10_) {
#line 3058 "PlayerRow.c"
					SoundServicesMediaPlayer* _tmp11_;
#line 332 "../src/Widgets/PlayerRow.vala"
					_tmp11_ = self->priv->mp_client;
#line 332 "../src/Widgets/PlayerRow.vala"
					sound_services_media_player_pause (_tmp11_, &_inner_error0_);
#line 332 "../src/Widgets/PlayerRow.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3066 "PlayerRow.c"
						goto __catch0_g_error;
					}
				} else {
					SoundServicesMediaPlayer* _tmp12_;
#line 334 "../src/Widgets/PlayerRow.vala"
					_tmp12_ = self->priv->mp_client;
#line 334 "../src/Widgets/PlayerRow.vala"
					sound_services_media_player_play (_tmp12_, &_inner_error0_);
#line 334 "../src/Widgets/PlayerRow.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3077 "PlayerRow.c"
						goto __catch0_g_error;
					}
				}
#line 336 "../src/Widgets/PlayerRow.vala"
				sound_widgets_player_row_update_play_status (self);
#line 3083 "PlayerRow.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 327 "../src/Widgets/PlayerRow.vala"
		e = _inner_error0_;
#line 327 "../src/Widgets/PlayerRow.vala"
		_inner_error0_ = NULL;
#line 339 "../src/Widgets/PlayerRow.vala"
		_tmp13_ = e;
#line 339 "../src/Widgets/PlayerRow.vala"
		_tmp14_ = _tmp13_->message;
#line 339 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:339: Playing/Pausing probably failed (faulty MPRIS inte" \
"rface): %s", _tmp14_);
#line 327 "../src/Widgets/PlayerRow.vala"
		_g_error_free0 (e);
#line 3105 "PlayerRow.c"
	}
	__finally0:
#line 327 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 327 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 327 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 327 "../src/Widgets/PlayerRow.vala"
		return NULL;
#line 3116 "PlayerRow.c"
	}
#line 342 "../src/Widgets/PlayerRow.vala"
	result = NULL;
#line 342 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3122 "PlayerRow.c"
}

static gpointer
____lambda27__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda27_ ((SoundWidgetsPlayerRow*) self);
#line 326 "../src/Widgets/PlayerRow.vala"
	g_object_unref (self);
#line 326 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3134 "PlayerRow.c"
}

static gboolean
__lambda26_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 309 "../src/Widgets/PlayerRow.vala"
	if (!g_thread_supported ()) {
#line 310 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:310: Threading is not supported. DBus timeout could be " \
"blocking UI");
#line 3146 "PlayerRow.c"
		{
			SoundServicesMediaPlayer* _tmp0_;
#line 312 "../src/Widgets/PlayerRow.vala"
			_tmp0_ = self->priv->mp_client;
#line 312 "../src/Widgets/PlayerRow.vala"
			if (_tmp0_ == NULL) {
#line 3153 "PlayerRow.c"
				SoundServicesMprisClient* _tmp1_;
				SoundServicesMprisClient* _tmp2_;
				SoundServicesPlayerIface* _tmp3_;
				SoundServicesPlayerIface* _tmp4_;
#line 313 "../src/Widgets/PlayerRow.vala"
				_tmp1_ = sound_widgets_player_row_get_client (self);
#line 313 "../src/Widgets/PlayerRow.vala"
				_tmp2_ = _tmp1_;
#line 313 "../src/Widgets/PlayerRow.vala"
				_tmp3_ = sound_services_mpris_client_get_player (_tmp2_);
#line 313 "../src/Widgets/PlayerRow.vala"
				_tmp4_ = _tmp3_;
#line 313 "../src/Widgets/PlayerRow.vala"
				sound_services_player_iface_play_pause (_tmp4_, &_inner_error0_);
#line 313 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3170 "PlayerRow.c"
					goto __catch0_g_error;
				}
			} else {
				SoundServicesMediaPlayer* _tmp5_;
#line 314 "../src/Widgets/PlayerRow.vala"
				_tmp5_ = self->priv->mp_client;
#line 314 "../src/Widgets/PlayerRow.vala"
				if (_tmp5_ != NULL) {
#line 3179 "PlayerRow.c"
					SoundServicesMediaPlayer* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gboolean _tmp10_;
#line 315 "../src/Widgets/PlayerRow.vala"
					_tmp6_ = self->priv->mp_client;
#line 315 "../src/Widgets/PlayerRow.vala"
					_tmp7_ = sound_services_media_player_get_status (_tmp6_);
#line 315 "../src/Widgets/PlayerRow.vala"
					_tmp8_ = _tmp7_;
#line 315 "../src/Widgets/PlayerRow.vala"
					_tmp9_ = _tmp8_;
#line 315 "../src/Widgets/PlayerRow.vala"
					_tmp10_ = g_strcmp0 (_tmp9_, "playing") == 0;
#line 315 "../src/Widgets/PlayerRow.vala"
					_g_free0 (_tmp9_);
#line 315 "../src/Widgets/PlayerRow.vala"
					if (_tmp10_) {
#line 3199 "PlayerRow.c"
						SoundServicesMediaPlayer* _tmp11_;
#line 316 "../src/Widgets/PlayerRow.vala"
						_tmp11_ = self->priv->mp_client;
#line 316 "../src/Widgets/PlayerRow.vala"
						sound_services_media_player_pause (_tmp11_, &_inner_error0_);
#line 316 "../src/Widgets/PlayerRow.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3207 "PlayerRow.c"
							goto __catch0_g_error;
						}
					} else {
						SoundServicesMediaPlayer* _tmp12_;
#line 318 "../src/Widgets/PlayerRow.vala"
						_tmp12_ = self->priv->mp_client;
#line 318 "../src/Widgets/PlayerRow.vala"
						sound_services_media_player_play (_tmp12_, &_inner_error0_);
#line 318 "../src/Widgets/PlayerRow.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3218 "PlayerRow.c"
							goto __catch0_g_error;
						}
					}
#line 320 "../src/Widgets/PlayerRow.vala"
					sound_widgets_player_row_update_play_status (self);
#line 3224 "PlayerRow.c"
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 311 "../src/Widgets/PlayerRow.vala"
			e = _inner_error0_;
#line 311 "../src/Widgets/PlayerRow.vala"
			_inner_error0_ = NULL;
#line 323 "../src/Widgets/PlayerRow.vala"
			_tmp13_ = e;
#line 323 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = _tmp13_->message;
#line 323 "../src/Widgets/PlayerRow.vala"
			g_warning ("PlayerRow.vala:323: Playing/Pausing probably failed (faulty MPRIS inte" \
"rface): %s", _tmp14_);
#line 311 "../src/Widgets/PlayerRow.vala"
			_g_error_free0 (e);
#line 3246 "PlayerRow.c"
		}
		__finally0:
#line 311 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3251 "PlayerRow.c"
			gboolean _tmp15_ = FALSE;
#line 311 "../src/Widgets/PlayerRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 311 "../src/Widgets/PlayerRow.vala"
			g_clear_error (&_inner_error0_);
#line 311 "../src/Widgets/PlayerRow.vala"
			return _tmp15_;
#line 3259 "PlayerRow.c"
		}
	} else {
		GThread* _tmp16_;
		GThread* _tmp17_;
#line 326 "../src/Widgets/PlayerRow.vala"
		_tmp16_ = g_thread_new ("wingpanel_indicator_sound_dbus_backward_thread", ____lambda27__gthread_func, g_object_ref (self));
#line 326 "../src/Widgets/PlayerRow.vala"
		_tmp17_ = _tmp16_;
#line 326 "../src/Widgets/PlayerRow.vala"
		_g_thread_unref0 (_tmp17_);
#line 3270 "PlayerRow.c"
	}
#line 346 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 346 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3276 "PlayerRow.c"
}

static gboolean
___lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda26_ ((SoundWidgetsPlayerRow*) self);
#line 308 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3286 "PlayerRow.c"
}

static void
_sound_widgets_player_row___lambda25_ (SoundWidgetsPlayerRow* self)
{
#line 308 "../src/Widgets/PlayerRow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda26__gsource_func, g_object_ref (self), g_object_unref);
#line 3294 "PlayerRow.c"
}

static void
__sound_widgets_player_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 307 "../src/Widgets/PlayerRow.vala"
	_sound_widgets_player_row___lambda25_ ((SoundWidgetsPlayerRow*) self);
#line 3303 "PlayerRow.c"
}

static void*
___lambda30_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
	{
		SoundServicesMediaPlayer* _tmp0_;
#line 366 "../src/Widgets/PlayerRow.vala"
		_tmp0_ = self->priv->mp_client;
#line 366 "../src/Widgets/PlayerRow.vala"
		if (_tmp0_ == NULL) {
#line 3317 "PlayerRow.c"
			SoundServicesMprisClient* _tmp1_;
			SoundServicesMprisClient* _tmp2_;
			SoundServicesPlayerIface* _tmp3_;
			SoundServicesPlayerIface* _tmp4_;
#line 367 "../src/Widgets/PlayerRow.vala"
			_tmp1_ = sound_widgets_player_row_get_client (self);
#line 367 "../src/Widgets/PlayerRow.vala"
			_tmp2_ = _tmp1_;
#line 367 "../src/Widgets/PlayerRow.vala"
			_tmp3_ = sound_services_mpris_client_get_player (_tmp2_);
#line 367 "../src/Widgets/PlayerRow.vala"
			_tmp4_ = _tmp3_;
#line 367 "../src/Widgets/PlayerRow.vala"
			sound_services_player_iface_next (_tmp4_, &_inner_error0_);
#line 367 "../src/Widgets/PlayerRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3334 "PlayerRow.c"
				goto __catch0_g_error;
			}
		} else {
			SoundServicesMediaPlayer* _tmp5_;
#line 368 "../src/Widgets/PlayerRow.vala"
			_tmp5_ = self->priv->mp_client;
#line 368 "../src/Widgets/PlayerRow.vala"
			if (_tmp5_ != NULL) {
#line 3343 "PlayerRow.c"
				SoundServicesMediaPlayer* _tmp6_;
#line 369 "../src/Widgets/PlayerRow.vala"
				_tmp6_ = self->priv->mp_client;
#line 369 "../src/Widgets/PlayerRow.vala"
				sound_services_media_player_next (_tmp6_, &_inner_error0_);
#line 369 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3351 "PlayerRow.c"
					goto __catch0_g_error;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 365 "../src/Widgets/PlayerRow.vala"
		e = _inner_error0_;
#line 365 "../src/Widgets/PlayerRow.vala"
		_inner_error0_ = NULL;
#line 372 "../src/Widgets/PlayerRow.vala"
		_tmp7_ = e;
#line 372 "../src/Widgets/PlayerRow.vala"
		_tmp8_ = _tmp7_->message;
#line 372 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:372: Going to next track probably failed (faulty MPRIS " \
"interface): %s", _tmp8_);
#line 365 "../src/Widgets/PlayerRow.vala"
		_g_error_free0 (e);
#line 3375 "PlayerRow.c"
	}
	__finally0:
#line 365 "../src/Widgets/PlayerRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 365 "../src/Widgets/PlayerRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 365 "../src/Widgets/PlayerRow.vala"
		g_clear_error (&_inner_error0_);
#line 365 "../src/Widgets/PlayerRow.vala"
		return NULL;
#line 3386 "PlayerRow.c"
	}
#line 375 "../src/Widgets/PlayerRow.vala"
	result = NULL;
#line 375 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3392 "PlayerRow.c"
}

static gpointer
____lambda30__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda30_ ((SoundWidgetsPlayerRow*) self);
#line 364 "../src/Widgets/PlayerRow.vala"
	g_object_unref (self);
#line 364 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3404 "PlayerRow.c"
}

static gboolean
__lambda29_ (SoundWidgetsPlayerRow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 352 "../src/Widgets/PlayerRow.vala"
	if (!g_thread_supported ()) {
#line 353 "../src/Widgets/PlayerRow.vala"
		g_warning ("PlayerRow.vala:353: Threading is not supported. DBus timeout could be " \
"blocking UI");
#line 3416 "PlayerRow.c"
		{
			gboolean _tmp0_ = FALSE;
			SoundServicesMediaPlayer* _tmp1_;
#line 355 "../src/Widgets/PlayerRow.vala"
			_tmp1_ = self->priv->mp_client;
#line 355 "../src/Widgets/PlayerRow.vala"
			if (_tmp1_ == NULL) {
#line 3424 "PlayerRow.c"
				SoundServicesMprisClient* _tmp2_;
				SoundServicesMprisClient* _tmp3_;
				SoundServicesPlayerIface* _tmp4_;
				SoundServicesPlayerIface* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp2_ = sound_widgets_player_row_get_client (self);
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp3_ = _tmp2_;
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp4_ = sound_services_mpris_client_get_player (_tmp3_);
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp5_ = _tmp4_;
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp6_ = sound_services_player_iface_get_can_go_next (_tmp5_);
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp7_ = _tmp6_;
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp0_ = _tmp7_;
#line 3445 "PlayerRow.c"
			} else {
#line 355 "../src/Widgets/PlayerRow.vala"
				_tmp0_ = FALSE;
#line 3449 "PlayerRow.c"
			}
#line 355 "../src/Widgets/PlayerRow.vala"
			if (_tmp0_) {
#line 3453 "PlayerRow.c"
				SoundServicesMprisClient* _tmp8_;
				SoundServicesMprisClient* _tmp9_;
				SoundServicesPlayerIface* _tmp10_;
				SoundServicesPlayerIface* _tmp11_;
#line 356 "../src/Widgets/PlayerRow.vala"
				_tmp8_ = sound_widgets_player_row_get_client (self);
#line 356 "../src/Widgets/PlayerRow.vala"
				_tmp9_ = _tmp8_;
#line 356 "../src/Widgets/PlayerRow.vala"
				_tmp10_ = sound_services_mpris_client_get_player (_tmp9_);
#line 356 "../src/Widgets/PlayerRow.vala"
				_tmp11_ = _tmp10_;
#line 356 "../src/Widgets/PlayerRow.vala"
				sound_services_player_iface_next (_tmp11_, &_inner_error0_);
#line 356 "../src/Widgets/PlayerRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3470 "PlayerRow.c"
					goto __catch0_g_error;
				}
			} else {
				SoundServicesMediaPlayer* _tmp12_;
#line 357 "../src/Widgets/PlayerRow.vala"
				_tmp12_ = self->priv->mp_client;
#line 357 "../src/Widgets/PlayerRow.vala"
				if (_tmp12_ != NULL) {
#line 3479 "PlayerRow.c"
					SoundServicesMediaPlayer* _tmp13_;
#line 358 "../src/Widgets/PlayerRow.vala"
					_tmp13_ = self->priv->mp_client;
#line 358 "../src/Widgets/PlayerRow.vala"
					sound_services_media_player_next (_tmp13_, &_inner_error0_);
#line 358 "../src/Widgets/PlayerRow.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3487 "PlayerRow.c"
						goto __catch0_g_error;
					}
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 354 "../src/Widgets/PlayerRow.vala"
			e = _inner_error0_;
#line 354 "../src/Widgets/PlayerRow.vala"
			_inner_error0_ = NULL;
#line 361 "../src/Widgets/PlayerRow.vala"
			_tmp14_ = e;
#line 361 "../src/Widgets/PlayerRow.vala"
			_tmp15_ = _tmp14_->message;
#line 361 "../src/Widgets/PlayerRow.vala"
			g_warning ("PlayerRow.vala:361: Going to next track probably failed (faulty MPRIS " \
"interface): %s", _tmp15_);
#line 354 "../src/Widgets/PlayerRow.vala"
			_g_error_free0 (e);
#line 3511 "PlayerRow.c"
		}
		__finally0:
#line 354 "../src/Widgets/PlayerRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3516 "PlayerRow.c"
			gboolean _tmp16_ = FALSE;
#line 354 "../src/Widgets/PlayerRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 354 "../src/Widgets/PlayerRow.vala"
			g_clear_error (&_inner_error0_);
#line 354 "../src/Widgets/PlayerRow.vala"
			return _tmp16_;
#line 3524 "PlayerRow.c"
		}
	} else {
		GThread* _tmp17_;
		GThread* _tmp18_;
#line 364 "../src/Widgets/PlayerRow.vala"
		_tmp17_ = g_thread_new ("wingpanel_indicator_sound_dbus_forward_thread", ____lambda30__gthread_func, g_object_ref (self));
#line 364 "../src/Widgets/PlayerRow.vala"
		_tmp18_ = _tmp17_;
#line 364 "../src/Widgets/PlayerRow.vala"
		_g_thread_unref0 (_tmp18_);
#line 3535 "PlayerRow.c"
	}
#line 379 "../src/Widgets/PlayerRow.vala"
	result = FALSE;
#line 379 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3541 "PlayerRow.c"
}

static gboolean
___lambda29__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda29_ ((SoundWidgetsPlayerRow*) self);
#line 351 "../src/Widgets/PlayerRow.vala"
	return result;
#line 3551 "PlayerRow.c"
}

static void
_sound_widgets_player_row___lambda28_ (SoundWidgetsPlayerRow* self)
{
#line 351 "../src/Widgets/PlayerRow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda29__gsource_func, g_object_ref (self), g_object_unref);
#line 3559 "PlayerRow.c"
}

static void
__sound_widgets_player_row___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 350 "../src/Widgets/PlayerRow.vala"
	_sound_widgets_player_row___lambda28_ ((SoundWidgetsPlayerRow*) self);
#line 3568 "PlayerRow.c"
}

static GObject *
sound_widgets_player_row_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundWidgetsPlayerRow * self;
	GThemedIcon* _tmp0_;
	GCancellable* _tmp1_;
	GtkImage* _tmp2_ = NULL;
	GtkImage* _tmp3_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_ = NULL;
	GtkOverlay* _tmp5_;
	GtkImage* _tmp6_;
	GtkOverlay* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* _tmp10_ = NULL;
	GtkLabel* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkGrid* titles = NULL;
	GtkGrid* _tmp15_ = NULL;
	GtkGrid* _tmp16_;
	GtkOverlay* _tmp17_;
	GtkGrid* _tmp18_;
	GtkLabel* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkEventBox* titles_events = NULL;
	GtkEventBox* _tmp22_ = NULL;
	GtkEventBox* _tmp23_;
	GtkGrid* _tmp24_;
	GtkButton* _tmp25_ = NULL;
	GtkButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkButton* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkCssProvider* _tmp30_;
	GtkButton* _tmp31_ = NULL;
	GtkButton* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkButton* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkCssProvider* _tmp36_;
	GtkButton* _tmp37_ = NULL;
	GtkButton* _tmp38_;
	GtkStyleContext* _tmp39_;
	GtkButton* _tmp40_;
	GtkStyleContext* _tmp41_;
	GtkCssProvider* _tmp42_;
	GtkEventBox* _tmp43_;
	GtkButton* _tmp44_;
	GtkButton* _tmp45_;
	GtkButton* _tmp46_;
	SoundServicesMprisClient* _tmp47_;
	SoundServicesMprisClient* _tmp48_;
	GtkEventBox* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* _tmp52_;
#line 177 "../src/Widgets/PlayerRow.vala"
	parent_class = G_OBJECT_CLASS (sound_widgets_player_row_parent_class);
#line 177 "../src/Widgets/PlayerRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 177 "../src/Widgets/PlayerRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_PLAYER_ROW, SoundWidgetsPlayerRow);
#line 178 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 178 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->app_icon);
#line 178 "../src/Widgets/PlayerRow.vala"
	self->priv->app_icon = (GIcon*) _tmp0_;
#line 180 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = g_cancellable_new ();
#line 180 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->load_remote_art_cancel);
#line 180 "../src/Widgets/PlayerRow.vala"
	self->priv->load_remote_art_cancel = _tmp1_;
#line 182 "../src/Widgets/PlayerRow.vala"
	_tmp2_ = (GtkImage*) gtk_image_new ();
#line 182 "../src/Widgets/PlayerRow.vala"
	gtk_image_set_pixel_size (_tmp2_, ICON_SIZE);
#line 182 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp2_);
#line 182 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->background);
#line 182 "../src/Widgets/PlayerRow.vala"
	self->priv->background = _tmp2_;
#line 186 "../src/Widgets/PlayerRow.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_resource ("/io/elementary/wingpanel/sound/image-mask.svg");
#line 186 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp3_, TRUE);
#line 186 "../src/Widgets/PlayerRow.vala"
	gtk_image_set_pixel_size (_tmp3_, 48);
#line 186 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp3_);
#line 186 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->mask);
#line 186 "../src/Widgets/PlayerRow.vala"
	self->priv->mask = _tmp3_;
#line 191 "../src/Widgets/PlayerRow.vala"
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
#line 191 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp4_, TRUE);
#line 191 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 2);
#line 191 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp4_, 4);
#line 191 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 4);
#line 191 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp4_);
#line 191 "../src/Widgets/PlayerRow.vala"
	overlay = _tmp4_;
#line 197 "../src/Widgets/PlayerRow.vala"
	_tmp5_ = overlay;
#line 197 "../src/Widgets/PlayerRow.vala"
	_tmp6_ = self->priv->background;
#line 197 "../src/Widgets/PlayerRow.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 198 "../src/Widgets/PlayerRow.vala"
	_tmp7_ = overlay;
#line 198 "../src/Widgets/PlayerRow.vala"
	_tmp8_ = self->priv->mask;
#line 198 "../src/Widgets/PlayerRow.vala"
	gtk_overlay_add_overlay (_tmp7_, (GtkWidget*) _tmp8_);
#line 200 "../src/Widgets/PlayerRow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 200 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_ellipsize (_tmp9_, PANGO_ELLIPSIZE_END);
#line 200 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_max_width_chars (_tmp9_, 16);
#line 200 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
#line 200 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_width_chars (_tmp9_, 16);
#line 200 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
#line 200 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp9_);
#line 200 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->title_label);
#line 200 "../src/Widgets/PlayerRow.vala"
	self->priv->title_label = _tmp9_;
#line 208 "../src/Widgets/PlayerRow.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
#line 208 "../src/Widgets/PlayerRow.vala"
	gtk_label_set_ellipsize (_tmp10_, PANGO_ELLIPSIZE_END);
#line 208 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 208 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 208 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp10_);
#line 208 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->artist_label);
#line 208 "../src/Widgets/PlayerRow.vala"
	self->priv->artist_label = _tmp10_;
#line 213 "../src/Widgets/PlayerRow.vala"
	_tmp11_ = self->priv->artist_label;
#line 213 "../src/Widgets/PlayerRow.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
#line 213 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_DIM_LABEL);
#line 214 "../src/Widgets/PlayerRow.vala"
	_tmp13_ = self->priv->artist_label;
#line 214 "../src/Widgets/PlayerRow.vala"
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 214 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_SMALL_LABEL);
#line 216 "../src/Widgets/PlayerRow.vala"
	_tmp15_ = (GtkGrid*) gtk_grid_new ();
#line 216 "../src/Widgets/PlayerRow.vala"
	gtk_grid_set_column_spacing (_tmp15_, 3);
#line 216 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp15_);
#line 216 "../src/Widgets/PlayerRow.vala"
	titles = _tmp15_;
#line 219 "../src/Widgets/PlayerRow.vala"
	_tmp16_ = titles;
#line 219 "../src/Widgets/PlayerRow.vala"
	_tmp17_ = overlay;
#line 219 "../src/Widgets/PlayerRow.vala"
	gtk_grid_attach (_tmp16_, (GtkWidget*) _tmp17_, 0, 0, 1, 2);
#line 220 "../src/Widgets/PlayerRow.vala"
	_tmp18_ = titles;
#line 220 "../src/Widgets/PlayerRow.vala"
	_tmp19_ = self->priv->title_label;
#line 220 "../src/Widgets/PlayerRow.vala"
	gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 1, 0, 1, 1);
#line 221 "../src/Widgets/PlayerRow.vala"
	_tmp20_ = titles;
#line 221 "../src/Widgets/PlayerRow.vala"
	_tmp21_ = self->priv->artist_label;
#line 221 "../src/Widgets/PlayerRow.vala"
	gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 1, 1, 1, 1);
#line 223 "../src/Widgets/PlayerRow.vala"
	_tmp22_ = (GtkEventBox*) gtk_event_box_new ();
#line 223 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp22_, TRUE);
#line 223 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp22_);
#line 223 "../src/Widgets/PlayerRow.vala"
	titles_events = _tmp22_;
#line 226 "../src/Widgets/PlayerRow.vala"
	_tmp23_ = titles_events;
#line 226 "../src/Widgets/PlayerRow.vala"
	_tmp24_ = titles;
#line 226 "../src/Widgets/PlayerRow.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 228 "../src/Widgets/PlayerRow.vala"
	_tmp25_ = (GtkButton*) gtk_button_new_from_icon_name ("media-skip-backward-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 228 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, FALSE);
#line 228 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
#line 228 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp25_);
#line 228 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->prev_btn);
#line 228 "../src/Widgets/PlayerRow.vala"
	self->priv->prev_btn = _tmp25_;
#line 235 "../src/Widgets/PlayerRow.vala"
	_tmp26_ = self->priv->prev_btn;
#line 235 "../src/Widgets/PlayerRow.vala"
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 235 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_class (_tmp27_, "circular");
#line 236 "../src/Widgets/PlayerRow.vala"
	_tmp28_ = self->priv->prev_btn;
#line 236 "../src/Widgets/PlayerRow.vala"
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
#line 236 "../src/Widgets/PlayerRow.vala"
	_tmp30_ = sound_widgets_player_row_provider;
#line 236 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_provider (_tmp29_, (GtkStyleProvider*) _tmp30_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 238 "../src/Widgets/PlayerRow.vala"
	_tmp31_ = (GtkButton*) gtk_button_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 238 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp31_, TRUE);
#line 238 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp31_, GTK_ALIGN_CENTER);
#line 238 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp31_);
#line 238 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->play_btn);
#line 238 "../src/Widgets/PlayerRow.vala"
	self->priv->play_btn = _tmp31_;
#line 245 "../src/Widgets/PlayerRow.vala"
	_tmp32_ = self->priv->play_btn;
#line 245 "../src/Widgets/PlayerRow.vala"
	_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 245 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_class (_tmp33_, "circular");
#line 246 "../src/Widgets/PlayerRow.vala"
	_tmp34_ = self->priv->play_btn;
#line 246 "../src/Widgets/PlayerRow.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 246 "../src/Widgets/PlayerRow.vala"
	_tmp36_ = sound_widgets_player_row_provider;
#line 246 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_provider (_tmp35_, (GtkStyleProvider*) _tmp36_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 248 "../src/Widgets/PlayerRow.vala"
	_tmp37_ = (GtkButton*) gtk_button_new_from_icon_name ("media-skip-forward-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 248 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp37_, FALSE);
#line 248 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
#line 248 "../src/Widgets/PlayerRow.vala"
	g_object_ref_sink (_tmp37_);
#line 248 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->next_btn);
#line 248 "../src/Widgets/PlayerRow.vala"
	self->priv->next_btn = _tmp37_;
#line 255 "../src/Widgets/PlayerRow.vala"
	_tmp38_ = self->priv->next_btn;
#line 255 "../src/Widgets/PlayerRow.vala"
	_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
#line 255 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_class (_tmp39_, "circular");
#line 256 "../src/Widgets/PlayerRow.vala"
	_tmp40_ = self->priv->next_btn;
#line 256 "../src/Widgets/PlayerRow.vala"
	_tmp41_ = gtk_widget_get_style_context ((GtkWidget*) _tmp40_);
#line 256 "../src/Widgets/PlayerRow.vala"
	_tmp42_ = sound_widgets_player_row_provider;
#line 256 "../src/Widgets/PlayerRow.vala"
	gtk_style_context_add_provider (_tmp41_, (GtkStyleProvider*) _tmp42_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 258 "../src/Widgets/PlayerRow.vala"
	gtk_box_set_spacing ((GtkBox*) self, 6);
#line 259 "../src/Widgets/PlayerRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 12);
#line 260 "../src/Widgets/PlayerRow.vala"
	_tmp43_ = titles_events;
#line 260 "../src/Widgets/PlayerRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp43_);
#line 261 "../src/Widgets/PlayerRow.vala"
	_tmp44_ = self->priv->prev_btn;
#line 261 "../src/Widgets/PlayerRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp44_);
#line 262 "../src/Widgets/PlayerRow.vala"
	_tmp45_ = self->priv->play_btn;
#line 262 "../src/Widgets/PlayerRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp45_);
#line 263 "../src/Widgets/PlayerRow.vala"
	_tmp46_ = self->priv->next_btn;
#line 263 "../src/Widgets/PlayerRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp46_);
#line 265 "../src/Widgets/PlayerRow.vala"
	_tmp47_ = sound_widgets_player_row_get_client (self);
#line 265 "../src/Widgets/PlayerRow.vala"
	_tmp48_ = _tmp47_;
#line 265 "../src/Widgets/PlayerRow.vala"
	if (_tmp48_ != NULL) {
#line 266 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_connect_to_client (self);
#line 267 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_update_play_status (self);
#line 268 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_update_from_meta (self);
#line 269 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_update_controls (self);
#line 3897 "PlayerRow.c"
	}
#line 272 "../src/Widgets/PlayerRow.vala"
	_tmp49_ = titles_events;
#line 272 "../src/Widgets/PlayerRow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp49_, "button-press-event", (GCallback) _sound_widgets_player_row_raise_player_gtk_widget_button_press_event, self, 0);
#line 274 "../src/Widgets/PlayerRow.vala"
	_tmp50_ = self->priv->prev_btn;
#line 274 "../src/Widgets/PlayerRow.vala"
	g_signal_connect_object (_tmp50_, "clicked", (GCallback) __sound_widgets_player_row___lambda22__gtk_button_clicked, self, 0);
#line 307 "../src/Widgets/PlayerRow.vala"
	_tmp51_ = self->priv->play_btn;
#line 307 "../src/Widgets/PlayerRow.vala"
	g_signal_connect_object (_tmp51_, "clicked", (GCallback) __sound_widgets_player_row___lambda25__gtk_button_clicked, self, 0);
#line 350 "../src/Widgets/PlayerRow.vala"
	_tmp52_ = self->priv->next_btn;
#line 350 "../src/Widgets/PlayerRow.vala"
	g_signal_connect_object (_tmp52_, "clicked", (GCallback) __sound_widgets_player_row___lambda28__gtk_button_clicked, self, 0);
#line 177 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (titles_events);
#line 177 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (titles);
#line 177 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (overlay);
#line 177 "../src/Widgets/PlayerRow.vala"
	return obj;
#line 3923 "PlayerRow.c"
}

static void
sound_widgets_player_row_class_init (SoundWidgetsPlayerRowClass * klass,
                                     gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 27 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Widgets/PlayerRow.vala"
	g_type_class_adjust_private_offset (klass, &SoundWidgetsPlayerRow_private_offset);
#line 27 "../src/Widgets/PlayerRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_widgets_player_row_get_property;
#line 27 "../src/Widgets/PlayerRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_widgets_player_row_set_property;
#line 27 "../src/Widgets/PlayerRow.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_widgets_player_row_constructor;
#line 27 "../src/Widgets/PlayerRow.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_widgets_player_row_finalize;
#line 27 "../src/Widgets/PlayerRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_PLAYER_ROW_APP_INFO_PROPERTY, sound_widgets_player_row_properties[SOUND_WIDGETS_PLAYER_ROW_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", g_app_info_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Widgets/PlayerRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_PLAYER_ROW_CLIENT_PROPERTY, sound_widgets_player_row_properties[SOUND_WIDGETS_PLAYER_ROW_CLIENT_PROPERTY] = g_param_spec_object ("client", "client", "client", SOUND_SERVICES_TYPE_MPRIS_CLIENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_signals[SOUND_WIDGETS_PLAYER_ROW_CLOSE_SIGNAL] = g_signal_new ("close", SOUND_WIDGETS_TYPE_PLAYER_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 173 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 173 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (sound_widgets_player_row_provider);
#line 173 "../src/Widgets/PlayerRow.vala"
	sound_widgets_player_row_provider = _tmp0_;
#line 174 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = sound_widgets_player_row_provider;
#line 174 "../src/Widgets/PlayerRow.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "io/elementary/wingpanel/sound/PlayerRow.css");
#line 3960 "PlayerRow.c"
}

static void
sound_widgets_player_row_instance_init (SoundWidgetsPlayerRow * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 27 "../src/Widgets/PlayerRow.vala"
	self->priv = sound_widgets_player_row_get_instance_private (self);
#line 33 "../src/Widgets/PlayerRow.vala"
	self->priv->background = NULL;
#line 43 "../src/Widgets/PlayerRow.vala"
	self->priv->launched_by_indicator = FALSE;
#line 44 "../src/Widgets/PlayerRow.vala"
	_tmp0_ = g_strdup (_ ("Music player"));
#line 44 "../src/Widgets/PlayerRow.vala"
	self->priv->app_name = _tmp0_;
#line 47 "../src/Widgets/PlayerRow.vala"
	_tmp1_ = g_strdup ("");
#line 47 "../src/Widgets/PlayerRow.vala"
	self->mpris_name = _tmp1_;
#line 70 "../src/Widgets/PlayerRow.vala"
	self->priv->client_ = NULL;
#line 71 "../src/Widgets/PlayerRow.vala"
	self->priv->mp_client = NULL;
#line 3987 "PlayerRow.c"
}

static void
sound_widgets_player_row_finalize (GObject * obj)
{
	SoundWidgetsPlayerRow * self;
#line 27 "../src/Widgets/PlayerRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_PLAYER_ROW, SoundWidgetsPlayerRow);
#line 33 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->background);
#line 34 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->mask);
#line 35 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->title_label);
#line 36 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->artist_label);
#line 37 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->prev_btn);
#line 38 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->play_btn);
#line 39 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->next_btn);
#line 40 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->app_icon);
#line 41 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->load_remote_art_cancel);
#line 44 "../src/Widgets/PlayerRow.vala"
	_g_free0 (self->priv->app_name);
#line 45 "../src/Widgets/PlayerRow.vala"
	_g_free0 (self->priv->last_art_url);
#line 47 "../src/Widgets/PlayerRow.vala"
	_g_free0 (self->mpris_name);
#line 49 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->ainfo);
#line 70 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->client_);
#line 71 "../src/Widgets/PlayerRow.vala"
	_g_object_unref0 (self->priv->mp_client);
#line 27 "../src/Widgets/PlayerRow.vala"
	G_OBJECT_CLASS (sound_widgets_player_row_parent_class)->finalize (obj);
#line 4028 "PlayerRow.c"
}

/**
 * A PlayerRow is simply used to control and display information in a two-way
 * fashion with an underlying MPRIS provider (MediaPlayer2)
 * It is "designed" to be self contained and added to a large UI, enabling multiple
 * MPRIS clients to be controlled with multiple widgets
 */
static GType
sound_widgets_player_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundWidgetsPlayerRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_widgets_player_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundWidgetsPlayerRow), 0, (GInstanceInitFunc) sound_widgets_player_row_instance_init, NULL };
	GType sound_widgets_player_row_type_id;
	sound_widgets_player_row_type_id = g_type_register_static (gtk_box_get_type (), "SoundWidgetsPlayerRow", &g_define_type_info, 0);
	SoundWidgetsPlayerRow_private_offset = g_type_add_instance_private (sound_widgets_player_row_type_id, sizeof (SoundWidgetsPlayerRowPrivate));
	return sound_widgets_player_row_type_id;
}

GType
sound_widgets_player_row_get_type (void)
{
	static volatile gsize sound_widgets_player_row_type_id__once = 0;
	if (g_once_init_enter (&sound_widgets_player_row_type_id__once)) {
		GType sound_widgets_player_row_type_id;
		sound_widgets_player_row_type_id = sound_widgets_player_row_get_type_once ();
		g_once_init_leave (&sound_widgets_player_row_type_id__once, sound_widgets_player_row_type_id);
	}
	return sound_widgets_player_row_type_id__once;
}

static void
_vala_sound_widgets_player_row_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	SoundWidgetsPlayerRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_WIDGETS_TYPE_PLAYER_ROW, SoundWidgetsPlayerRow);
#line 27 "../src/Widgets/PlayerRow.vala"
	switch (property_id) {
#line 27 "../src/Widgets/PlayerRow.vala"
		case SOUND_WIDGETS_PLAYER_ROW_APP_INFO_PROPERTY:
#line 27 "../src/Widgets/PlayerRow.vala"
		g_value_set_object (value, sound_widgets_player_row_get_app_info (self));
#line 27 "../src/Widgets/PlayerRow.vala"
		break;
#line 27 "../src/Widgets/PlayerRow.vala"
		case SOUND_WIDGETS_PLAYER_ROW_CLIENT_PROPERTY:
#line 27 "../src/Widgets/PlayerRow.vala"
		g_value_set_object (value, sound_widgets_player_row_get_client (self));
#line 27 "../src/Widgets/PlayerRow.vala"
		break;
#line 4081 "PlayerRow.c"
		default:
#line 27 "../src/Widgets/PlayerRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/PlayerRow.vala"
		break;
#line 4087 "PlayerRow.c"
	}
}

static void
_vala_sound_widgets_player_row_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	SoundWidgetsPlayerRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_WIDGETS_TYPE_PLAYER_ROW, SoundWidgetsPlayerRow);
#line 27 "../src/Widgets/PlayerRow.vala"
	switch (property_id) {
#line 27 "../src/Widgets/PlayerRow.vala"
		case SOUND_WIDGETS_PLAYER_ROW_APP_INFO_PROPERTY:
#line 27 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_set_app_info (self, g_value_get_object (value));
#line 27 "../src/Widgets/PlayerRow.vala"
		break;
#line 27 "../src/Widgets/PlayerRow.vala"
		case SOUND_WIDGETS_PLAYER_ROW_CLIENT_PROPERTY:
#line 27 "../src/Widgets/PlayerRow.vala"
		sound_widgets_player_row_set_client (self, g_value_get_object (value));
#line 27 "../src/Widgets/PlayerRow.vala"
		break;
#line 4113 "PlayerRow.c"
		default:
#line 27 "../src/Widgets/PlayerRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/PlayerRow.vala"
		break;
#line 4119 "PlayerRow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

