/* PulseAudioManager.c generated by valac 0.56.13, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2016-2018 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */

#include "sound.h"
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pulse/ext-stream-restore.h"

enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPulseAudioManagerSetDefaultDeviceData SoundPulseAudioManagerSetDefaultDeviceData;
typedef struct _Block5Data Block5Data;
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _SoundPulseAudioManagerSetCardProfileByIndexData SoundPulseAudioManagerSetCardProfileByIndexData;
typedef struct _Block6Data Block6Data;
typedef struct _SoundPulseAudioManagerWaitForUpdateData SoundPulseAudioManagerWaitForUpdateData;
typedef struct _Block7Data Block7Data;
typedef struct _SoundPulseAudioManagerSetSinkPortByNameData SoundPulseAudioManagerSetSinkPortByNameData;
typedef struct _Block8Data Block8Data;
typedef struct _SoundPulseAudioManagerSetSourcePortByNameData SoundPulseAudioManagerSetSourcePortByNameData;
typedef struct _Block9Data Block9Data;
typedef struct _SoundPulseAudioManagerSetDefaultSinkData SoundPulseAudioManagerSetDefaultSinkData;
typedef struct _Block10Data Block10Data;
typedef struct _SoundPulseAudioManagerSetDefaultSourceData SoundPulseAudioManagerSetDefaultSourceData;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManagerPrivate {
	pa_context* context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
};

struct _SoundPulseAudioManagerSetDefaultDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoundDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	SoundDevice* other_device;
	SoundDevice* _tmp10_;
	gchar* profile_name;
	SoundDevice* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	guint32 _tmp23_;
	guint32 _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gboolean _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	gboolean _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gboolean _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
};

struct _Block5Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetCardProfileByIndexData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	Block5Data* _data5_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block6Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gulong handler_id;
	SoundDevice* device;
	gchar* prop_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerWaitForUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	gchar* prop_name;
	Block6Data* _data6_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gulong _tmp3_;
};

struct _Block7Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSinkPortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	Block7Data* _data7_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block8Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSourcePortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	Block8Data* _data8_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block9Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSinkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	Block9Data* _data9_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block10Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSourceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	Block10Data* _data10_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	pa_context* _tmp0_;
	pa_proplist* props;
	pa_proplist* _tmp1_;
	pa_proplist* _tmp2_;
	pa_glib_mainloop* _tmp3_;
	pa_mainloop_api* _tmp4_;
	pa_proplist* _tmp5_;
	pa_context* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	const gchar* _tmp10_;
};

static gint SoundPulseAudioManager_private_offset;
static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;
static gboolean sound_pulse_audio_manager_debug_enabled;
static gboolean sound_pulse_audio_manager_debug_enabled = FALSE;

static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_);
static void sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                          guint32 card_index,
                                                          const gchar* profile_name,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                                 GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                const gchar* prop_name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                       GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                      const gchar* sink_name,
                                                      const gchar* port_name,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                             GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                        const gchar* source_name,
                                                        const gchar* port_name,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                               GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda46_ (Block5Data* _data5_,
                  pa_context* c,
                  gint success);
static void ___lambda46__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda47_ (Block6Data* _data6_,
                  GObject* s,
                  GParamSpec* p);
static void ___lambda47__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda48_ (Block7Data* _data7_,
                  pa_context* c,
                  gint success);
static void ___lambda48__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda49_ (Block8Data* _data8_,
                  pa_context* c,
                  gint success);
static void ___lambda49__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda50_ (Block9Data* _data9_,
                  pa_context* c,
                  gint success);
static void ___lambda50__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_source_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda51_ (Block10Data* _data10_,
                  pa_context* c,
                  gint success);
static void ___lambda51__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* context,
                                                     pa_server_info* server);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* sink,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_card_info* card,
                                                   gint eol);
static void _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                      pa_card_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                       GeeHashMap* devices,
                                                       guint32 card_index);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* source,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
static void _vala_array_add1 (pa_card_port_info** * array,
                       gint* length,
                       gint* size,
                       pa_card_port_info* value);
static gchar* sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                                pa_card_port_info* port);
static GeeArrayList* sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                                         pa_card_port_info* port);
static void sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                                GeeHashMap* devices,
                                                pa_card_info* card,
                                                pa_card_port_info** relevant_ports,
                                                gint relevant_ports_length1);
static pa_card_profile_info2** _vala_array_dup1 (pa_card_profile_info2** self,
                                          gssize length);
static gint __lambda45_ (SoundPulseAudioManager* self,
                  pa_card_profile_info2* a,
                  pa_card_profile_info2* b);
static gint ___lambda45__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void __lambda44_ (SoundPulseAudioManager* self,
                  pa_context* c,
                  gint success);
static void ___lambda44__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static GType sound_pulse_audio_manager_get_type_once (void);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_pulse_audio_manager_get_instance_private (SoundPulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPulseAudioManager_private_offset);
}

SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
	SoundPulseAudioManager* result;
#line 34 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = sound_pulse_audio_manager_pam;
#line 34 "../src/Services/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 604 "PulseAudioManager.c"
		SoundPulseAudioManager* _tmp1_;
#line 35 "../src/Services/PulseAudioManager.vala"
		_tmp1_ = sound_pulse_audio_manager_new ();
#line 35 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (sound_pulse_audio_manager_pam);
#line 35 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_pam = _tmp1_;
#line 612 "PulseAudioManager.c"
	}
#line 38 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = sound_pulse_audio_manager_pam;
#line 38 "../src/Services/PulseAudioManager.vala"
	result = _tmp2_;
#line 38 "../src/Services/PulseAudioManager.vala"
	return result;
#line 620 "PulseAudioManager.c"
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
#line 54 "../src/Services/PulseAudioManager.vala"
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
#line 54 "../src/Services/PulseAudioManager.vala"
	return self;
#line 631 "PulseAudioManager.c"
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
#line 54 "../src/Services/PulseAudioManager.vala"
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
#line 639 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
#line 70 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 649 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultDeviceData, _data_);
#line 663 "PulseAudioManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/Services/PulseAudioManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 671 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultDeviceData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_device_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->device = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_device_co (_data_);
#line 705 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 715 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
#line 94 "../src/Services/PulseAudioManager.vala"
	_data_ = _user_data_;
#line 94 "../src/Services/PulseAudioManager.vala"
	_data_->_source_object_ = source_object;
#line 94 "../src/Services/PulseAudioManager.vala"
	_data_->_res_ = _res_;
#line 94 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_device_co (_data_);
#line 732 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_)
{
#line 74 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 74 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 742 "PulseAudioManager.c"
		goto _state_0;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 746 "PulseAudioManager.c"
		goto _state_1;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 2:
#line 750 "PulseAudioManager.c"
		goto _state_2;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 3:
#line 754 "PulseAudioManager.c"
		goto _state_3;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 4:
#line 758 "PulseAudioManager.c"
		goto _state_4;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 5:
#line 762 "PulseAudioManager.c"
		goto _state_5;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 6:
#line 766 "PulseAudioManager.c"
		goto _state_6;
#line 74 "../src/Services/PulseAudioManager.vala"
		case 7:
#line 770 "PulseAudioManager.c"
		goto _state_7;
		default:
#line 74 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 775 "PulseAudioManager.c"
	}
	_state_0:
#line 75 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:75: \n");
#line 76 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = sound_device_get_id (_data_->device);
#line 76 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 76 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:76: set_default_device: %s", _data_->_tmp1_);
#line 77 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp3_ = sound_device_get_input (_data_->device);
#line 77 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 77 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp4_) {
#line 77 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp2_ = "input";
#line 794 "PulseAudioManager.c"
	} else {
#line 77 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp2_ = "output";
#line 798 "PulseAudioManager.c"
	}
#line 77 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:77: \t%s", _data_->_tmp2_);
#line 83 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp6_ = sound_device_get_input (_data_->device);
#line 83 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 83 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp7_) {
#line 83 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp8_ = _data_->self->priv->_default_output;
#line 83 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp5_ = _data_->_tmp8_;
#line 812 "PulseAudioManager.c"
	} else {
#line 83 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp9_ = _data_->self->priv->_default_input;
#line 83 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp5_ = _data_->_tmp9_;
#line 818 "PulseAudioManager.c"
	}
#line 83 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
#line 83 "../src/Services/PulseAudioManager.vala"
	_data_->other_device = _data_->_tmp10_;
#line 85 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp11_ = _data_->other_device;
#line 85 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp12_ = sound_device_get_matching_profile (_data_->device, _data_->_tmp11_);
#line 85 "../src/Services/PulseAudioManager.vala"
	_data_->profile_name = _data_->_tmp12_;
#line 87 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp13_ = _data_->profile_name;
#line 87 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp13_ == NULL) {
#line 88 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp14_ = sound_device_get_profiles (_data_->device);
#line 88 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 88 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp15_, 0);
#line 88 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data_->profile_name);
#line 88 "../src/Services/PulseAudioManager.vala"
		_data_->profile_name = (gchar*) _data_->_tmp16_;
#line 844 "PulseAudioManager.c"
	}
#line 91 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp17_ = _data_->profile_name;
#line 91 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp18_ = sound_device_get_card_active_profile_name (_data_->device);
#line 91 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 91 "../src/Services/PulseAudioManager.vala"
	if (g_strcmp0 (_data_->_tmp17_, _data_->_tmp19_) != 0) {
#line 92 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp20_ = sound_device_get_card_active_profile_name (_data_->device);
#line 92 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 92 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp22_ = _data_->profile_name;
#line 92 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:92: set card profile: %s > %s", _data_->_tmp21_, _data_->_tmp22_);
#line 94 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp23_ = sound_device_get_card_index (_data_->device);
#line 94 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 94 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp25_ = _data_->profile_name;
#line 94 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 1;
#line 94 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index (_data_->self, _data_->_tmp24_, _data_->_tmp25_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 94 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 874 "PulseAudioManager.c"
		_state_1:
#line 94 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index_finish (_data_->self, _data_->_res_);
#line 96 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:96: wait for card sink / source");
#line 97 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp27_ = sound_device_get_input (_data_->device);
#line 97 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 97 "../src/Services/PulseAudioManager.vala"
		if (_data_->_tmp28_) {
#line 97 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp26_ = "card-source-name";
#line 888 "PulseAudioManager.c"
		} else {
#line 97 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp26_ = "card-sink-name";
#line 892 "PulseAudioManager.c"
		}
#line 97 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 2;
#line 97 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp26_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 97 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 900 "PulseAudioManager.c"
		_state_2:
#line 97 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
#line 904 "PulseAudioManager.c"
	}
#line 102 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp30_ = sound_device_get_input (_data_->device);
#line 102 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp31_ = _data_->_tmp30_;
#line 102 "../src/Services/PulseAudioManager.vala"
	if (!_data_->_tmp31_) {
#line 102 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp32_ = sound_device_get_port_name (_data_->device);
#line 102 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 102 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp34_ = sound_device_get_card_sink_port_name (_data_->device);
#line 102 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 102 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp29_ = g_strcmp0 (_data_->_tmp33_, _data_->_tmp35_) != 0;
#line 922 "PulseAudioManager.c"
	} else {
#line 102 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp29_ = FALSE;
#line 926 "PulseAudioManager.c"
	}
#line 102 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp29_) {
#line 103 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp36_ = sound_device_get_card_sink_port_name (_data_->device);
#line 103 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp37_ = _data_->_tmp36_;
#line 103 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp38_ = sound_device_get_port_name (_data_->device);
#line 103 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 103 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:103: set sink port: %s > %s", _data_->_tmp37_, _data_->_tmp39_);
#line 105 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp40_ = sound_device_get_card_sink_name (_data_->device);
#line 105 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 105 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp42_ = sound_device_get_port_name (_data_->device);
#line 105 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp43_ = _data_->_tmp42_;
#line 105 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 3;
#line 105 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name (_data_->self, _data_->_tmp41_, _data_->_tmp43_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 105 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 954 "PulseAudioManager.c"
		_state_3:
#line 105 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name_finish (_data_->self, _data_->_res_);
#line 958 "PulseAudioManager.c"
	}
#line 108 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp45_ = sound_device_get_input (_data_->device);
#line 108 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 108 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp46_) {
#line 108 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp47_ = sound_device_get_port_name (_data_->device);
#line 108 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 108 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp49_ = sound_device_get_card_source_port_name (_data_->device);
#line 108 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 108 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp44_ = g_strcmp0 (_data_->_tmp48_, _data_->_tmp50_) != 0;
#line 976 "PulseAudioManager.c"
	} else {
#line 108 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp44_ = FALSE;
#line 980 "PulseAudioManager.c"
	}
#line 108 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp44_) {
#line 109 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp51_ = sound_device_get_card_source_port_name (_data_->device);
#line 109 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 109 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp53_ = sound_device_get_port_name (_data_->device);
#line 109 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 109 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:109: set source port: %s > %s", _data_->_tmp52_, _data_->_tmp54_);
#line 110 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp55_ = sound_device_get_card_source_name (_data_->device);
#line 110 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp56_ = _data_->_tmp55_;
#line 110 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp57_ = sound_device_get_port_name (_data_->device);
#line 110 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp58_ = _data_->_tmp57_;
#line 110 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 4;
#line 110 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name (_data_->self, _data_->_tmp56_, _data_->_tmp58_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 110 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 1008 "PulseAudioManager.c"
		_state_4:
#line 110 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name_finish (_data_->self, _data_->_res_);
#line 1012 "PulseAudioManager.c"
	}
#line 114 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp61_ = sound_device_get_input (_data_->device);
#line 114 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp62_ = _data_->_tmp61_;
#line 114 "../src/Services/PulseAudioManager.vala"
	if (!_data_->_tmp62_) {
#line 114 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp63_ = sound_device_get_sink_name (_data_->device);
#line 114 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 114 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp60_ = _data_->_tmp64_ == NULL;
#line 1026 "PulseAudioManager.c"
	} else {
#line 114 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp60_ = FALSE;
#line 1030 "PulseAudioManager.c"
	}
#line 114 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp60_) {
#line 114 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp59_ = TRUE;
#line 1036 "PulseAudioManager.c"
	} else {
#line 115 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp66_ = sound_device_get_input (_data_->device);
#line 115 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp67_ = _data_->_tmp66_;
#line 115 "../src/Services/PulseAudioManager.vala"
		if (_data_->_tmp67_) {
#line 115 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp68_ = sound_device_get_source_name (_data_->device);
#line 115 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp69_ = _data_->_tmp68_;
#line 115 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp65_ = _data_->_tmp69_ == NULL;
#line 1050 "PulseAudioManager.c"
		} else {
#line 115 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp65_ = FALSE;
#line 1054 "PulseAudioManager.c"
		}
#line 115 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp59_ = _data_->_tmp65_;
#line 1058 "PulseAudioManager.c"
	}
#line 114 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp59_) {
#line 116 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:116: wait for sink / source");
#line 117 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp71_ = sound_device_get_input (_data_->device);
#line 117 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp72_ = _data_->_tmp71_;
#line 117 "../src/Services/PulseAudioManager.vala"
		if (_data_->_tmp72_) {
#line 117 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp70_ = "source-name";
#line 1072 "PulseAudioManager.c"
		} else {
#line 117 "../src/Services/PulseAudioManager.vala"
			_data_->_tmp70_ = "sink-name";
#line 1076 "PulseAudioManager.c"
		}
#line 117 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 5;
#line 117 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp70_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 117 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 1084 "PulseAudioManager.c"
		_state_5:
#line 117 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
#line 1088 "PulseAudioManager.c"
	}
#line 122 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp74_ = sound_device_get_input (_data_->device);
#line 122 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp75_ = _data_->_tmp74_;
#line 122 "../src/Services/PulseAudioManager.vala"
	if (!_data_->_tmp75_) {
#line 122 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp76_ = sound_device_get_sink_name (_data_->device);
#line 122 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp77_ = _data_->_tmp76_;
#line 122 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp78_ = _data_->self->priv->default_sink_name;
#line 122 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp73_ = g_strcmp0 (_data_->_tmp77_, _data_->_tmp78_) != 0;
#line 1104 "PulseAudioManager.c"
	} else {
#line 122 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp73_ = FALSE;
#line 1108 "PulseAudioManager.c"
	}
#line 122 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp73_) {
#line 123 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp79_ = _data_->self->priv->default_sink_name;
#line 123 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp80_ = sound_device_get_sink_name (_data_->device);
#line 123 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp81_ = _data_->_tmp80_;
#line 123 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:123: set sink: %s > %s", _data_->_tmp79_, _data_->_tmp81_);
#line 124 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp82_ = sound_device_get_sink_name (_data_->device);
#line 124 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp83_ = _data_->_tmp82_;
#line 124 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 6;
#line 124 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink (_data_->self, _data_->_tmp83_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 124 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 1130 "PulseAudioManager.c"
		_state_6:
#line 124 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink_finish (_data_->self, _data_->_res_);
#line 1134 "PulseAudioManager.c"
	}
#line 127 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp85_ = sound_device_get_input (_data_->device);
#line 127 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp86_ = _data_->_tmp85_;
#line 127 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp86_) {
#line 127 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp87_ = sound_device_get_source_name (_data_->device);
#line 127 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp88_ = _data_->_tmp87_;
#line 127 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp89_ = _data_->self->priv->default_source_name;
#line 127 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp84_ = g_strcmp0 (_data_->_tmp88_, _data_->_tmp89_) != 0;
#line 1150 "PulseAudioManager.c"
	} else {
#line 127 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp84_ = FALSE;
#line 1154 "PulseAudioManager.c"
	}
#line 127 "../src/Services/PulseAudioManager.vala"
	if (_data_->_tmp84_) {
#line 128 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp90_ = _data_->self->priv->default_source_name;
#line 128 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp91_ = sound_device_get_source_name (_data_->device);
#line 128 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp92_ = _data_->_tmp91_;
#line 128 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:128: set source: %s > %s", _data_->_tmp90_, _data_->_tmp92_);
#line 129 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp93_ = sound_device_get_source_name (_data_->device);
#line 129 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp94_ = _data_->_tmp93_;
#line 129 "../src/Services/PulseAudioManager.vala"
		_data_->_state_ = 7;
#line 129 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source (_data_->self, _data_->_tmp94_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 129 "../src/Services/PulseAudioManager.vala"
		return FALSE;
#line 1176 "PulseAudioManager.c"
		_state_7:
#line 129 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source_finish (_data_->self, _data_->_res_);
#line 1180 "PulseAudioManager.c"
	}
#line 74 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->profile_name);
#line 74 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->other_device);
#line 74 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 74 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 74 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 74 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1194 "PulseAudioManager.c"
		}
	}
#line 74 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 74 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1201 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetCardProfileByIndexData, _data_);
#line 1213 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                     guint32 card_index,
                                                     const gchar* profile_name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (profile_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetCardProfileByIndexData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_card_profile_by_index_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->card_index = card_index;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = g_strdup (profile_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->profile_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->profile_name = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_card_profile_by_index_co (_data_);
#line 1250 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                            GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1260 "PulseAudioManager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 133 "../src/Services/PulseAudioManager.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 133 "../src/Services/PulseAudioManager.vala"
	return _data5_;
#line 1270 "PulseAudioManager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 133 "../src/Services/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1280 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 133 "../src/Services/PulseAudioManager.vala"
		self = _data5_->self;
#line 133 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data5_->profile_name);
#line 133 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 133 "../src/Services/PulseAudioManager.vala"
		g_slice_free (Block5Data, _data5_);
#line 1290 "PulseAudioManager.c"
	}
}

static void
__lambda46_ (Block5Data* _data5_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 134 "../src/Services/PulseAudioManager.vala"
	self = _data5_->self;
#line 134 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 135 "../src/Services/PulseAudioManager.vala"
	if (success == 1) {
#line 136 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index_co (_data5_->_async_data_);
#line 1308 "PulseAudioManager.c"
	} else {
#line 138 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:138: setting card %u profile to %s failed", (guint) _data5_->card_index, _data5_->profile_name);
#line 1312 "PulseAudioManager.c"
	}
}

static void
___lambda46__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 134 "../src/Services/PulseAudioManager.vala"
	__lambda46_ (self, c, success);
#line 1323 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_)
{
#line 133 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 133 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 1333 "PulseAudioManager.c"
		goto _state_0;
#line 133 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 1337 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 133 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1342 "PulseAudioManager.c"
	}
	_state_0:
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_->card_index = _data_->card_index;
#line 133 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data5_->profile_name);
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_->profile_name = _data_->profile_name;
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 134 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->context;
#line 134 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_card_profile_by_index (_data_->_tmp0_, _data_->_data5_->card_index, _data_->_data5_->profile_name, ___lambda46__pa_context_success_cb_t, _data_->_data5_);
#line 134 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 134 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 142 "../src/Services/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 142 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1371 "PulseAudioManager.c"
	_state_1:
	;
#line 133 "../src/Services/PulseAudioManager.vala"
	block5_data_unref (_data_->_data5_);
#line 133 "../src/Services/PulseAudioManager.vala"
	_data_->_data5_ = NULL;
#line 133 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 133 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 133 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 133 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1386 "PulseAudioManager.c"
		}
	}
#line 133 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 133 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1393 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerWaitForUpdateData, _data_);
#line 1405 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                           SoundDevice* device,
                                           const gchar* prop_name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (prop_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerWaitForUpdateData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_wait_for_update_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->device = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = g_strdup (prop_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->prop_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->prop_name = _tmp2_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_wait_for_update_co (_data_);
#line 1449 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                  GAsyncResult* _res_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1459 "PulseAudioManager.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 146 "../src/Services/PulseAudioManager.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 146 "../src/Services/PulseAudioManager.vala"
	return _data6_;
#line 1469 "PulseAudioManager.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 146 "../src/Services/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1479 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 146 "../src/Services/PulseAudioManager.vala"
		self = _data6_->self;
#line 146 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (_data6_->device);
#line 146 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data6_->prop_name);
#line 146 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 146 "../src/Services/PulseAudioManager.vala"
		g_slice_free (Block6Data, _data6_);
#line 1491 "PulseAudioManager.c"
	}
}

static void
__lambda47_ (Block6Data* _data6_,
             GObject* s,
             GParamSpec* p)
{
	SoundPulseAudioManager* self;
	gchar* prop_value = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 149 "../src/Services/PulseAudioManager.vala"
	self = _data6_->self;
#line 149 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (s != NULL);
#line 149 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (p != NULL);
#line 151 "../src/Services/PulseAudioManager.vala"
	g_object_get ((GObject*) _data6_->device, _data6_->prop_name, &_tmp0_, NULL);
#line 151 "../src/Services/PulseAudioManager.vala"
	_g_free0 (prop_value);
#line 151 "../src/Services/PulseAudioManager.vala"
	prop_value = _tmp0_;
#line 152 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = prop_value;
#line 152 "../src/Services/PulseAudioManager.vala"
	if (_tmp1_ != NULL) {
#line 153 "../src/Services/PulseAudioManager.vala"
		g_signal_handler_disconnect ((GObject*) _data6_->device, _data6_->handler_id);
#line 154 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_co (_data6_->_async_data_);
#line 1524 "PulseAudioManager.c"
	}
#line 149 "../src/Services/PulseAudioManager.vala"
	_g_free0 (prop_value);
#line 1528 "PulseAudioManager.c"
}

static void
___lambda47__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 149 "../src/Services/PulseAudioManager.vala"
	__lambda47_ (self, _sender, pspec);
#line 1538 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_)
{
#line 146 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 146 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 1548 "PulseAudioManager.c"
		goto _state_0;
#line 146 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 1552 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 146 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1557 "PulseAudioManager.c"
	}
	_state_0:
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 146 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->_data6_->device);
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->device = _data_->device;
#line 146 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data6_->prop_name);
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->prop_name = _data_->prop_name;
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 147 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = sound_device_get_id (_data_->_data6_->device);
#line 147 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 147 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:147: wait_for_update: %s:%s", _data_->_tmp1_, _data_->_data6_->prop_name);
#line 148 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->handler_id = (gulong) 0;
#line 149 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = g_strconcat ("notify::", _data_->_data6_->prop_name, NULL);
#line 149 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp3_ = g_signal_connect_data ((GObject*) _data_->_data6_->device, _data_->_tmp2_, (GCallback) ___lambda47__g_object_notify, block6_data_ref (_data_->_data6_), (GClosureNotify) block6_data_unref, 0);
#line 149 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_->handler_id = _data_->_tmp3_;
#line 149 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_tmp2_);
#line 158 "../src/Services/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 158 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1596 "PulseAudioManager.c"
	_state_1:
	;
#line 146 "../src/Services/PulseAudioManager.vala"
	block6_data_unref (_data_->_data6_);
#line 146 "../src/Services/PulseAudioManager.vala"
	_data_->_data6_ = NULL;
#line 146 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 146 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 146 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 146 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1611 "PulseAudioManager.c"
		}
	}
#line 146 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 146 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1618 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetSinkPortByNameData, _data_);
#line 1630 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 const gchar* port_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (sink_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (port_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSinkPortByNameData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_sink_port_by_name_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = g_strdup (sink_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->sink_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->sink_name = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = g_strdup (port_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->port_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->port_name = _tmp2_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_sink_port_by_name_co (_data_);
#line 1674 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1684 "PulseAudioManager.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 161 "../src/Services/PulseAudioManager.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 161 "../src/Services/PulseAudioManager.vala"
	return _data7_;
#line 1694 "PulseAudioManager.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 161 "../src/Services/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1704 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 161 "../src/Services/PulseAudioManager.vala"
		self = _data7_->self;
#line 161 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data7_->sink_name);
#line 161 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data7_->port_name);
#line 161 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 161 "../src/Services/PulseAudioManager.vala"
		g_slice_free (Block7Data, _data7_);
#line 1716 "PulseAudioManager.c"
	}
}

static void
__lambda48_ (Block7Data* _data7_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 162 "../src/Services/PulseAudioManager.vala"
	self = _data7_->self;
#line 162 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 163 "../src/Services/PulseAudioManager.vala"
	if (success == 1) {
#line 164 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name_co (_data7_->_async_data_);
#line 1734 "PulseAudioManager.c"
	} else {
#line 166 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:166: setting sink %s port to %s failed", _data7_->sink_name, _data7_->port_name);
#line 1738 "PulseAudioManager.c"
	}
}

static void
___lambda48__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 162 "../src/Services/PulseAudioManager.vala"
	__lambda48_ (self, c, success);
#line 1749 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_)
{
#line 161 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 161 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 1759 "PulseAudioManager.c"
		goto _state_0;
#line 161 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 1763 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 161 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1768 "PulseAudioManager.c"
	}
	_state_0:
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_ = g_slice_new0 (Block7Data);
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_->_ref_count_ = 1;
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_->self = g_object_ref (_data_->self);
#line 161 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data7_->sink_name);
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_->sink_name = _data_->sink_name;
#line 161 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data7_->port_name);
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_->port_name = _data_->port_name;
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_->_async_data_ = _data_;
#line 162 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->context;
#line 162 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_sink_port_by_name (_data_->_tmp0_, _data_->_data7_->sink_name, _data_->_data7_->port_name, ___lambda48__pa_context_success_cb_t, _data_->_data7_);
#line 162 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 162 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 170 "../src/Services/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 170 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1799 "PulseAudioManager.c"
	_state_1:
	;
#line 161 "../src/Services/PulseAudioManager.vala"
	block7_data_unref (_data_->_data7_);
#line 161 "../src/Services/PulseAudioManager.vala"
	_data_->_data7_ = NULL;
#line 161 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 161 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 161 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 161 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1814 "PulseAudioManager.c"
		}
	}
#line 161 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 161 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 1821 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetSourcePortByNameData, _data_);
#line 1833 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   const gchar* port_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (source_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (port_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSourcePortByNameData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_source_port_by_name_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = g_strdup (source_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->source_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->source_name = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = g_strdup (port_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->port_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->port_name = _tmp2_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_source_port_by_name_co (_data_);
#line 1877 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1887 "PulseAudioManager.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 173 "../src/Services/PulseAudioManager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 173 "../src/Services/PulseAudioManager.vala"
	return _data8_;
#line 1897 "PulseAudioManager.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 173 "../src/Services/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1907 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 173 "../src/Services/PulseAudioManager.vala"
		self = _data8_->self;
#line 173 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data8_->source_name);
#line 173 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data8_->port_name);
#line 173 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 173 "../src/Services/PulseAudioManager.vala"
		g_slice_free (Block8Data, _data8_);
#line 1919 "PulseAudioManager.c"
	}
}

static void
__lambda49_ (Block8Data* _data8_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 174 "../src/Services/PulseAudioManager.vala"
	self = _data8_->self;
#line 174 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 175 "../src/Services/PulseAudioManager.vala"
	if (success == 1) {
#line 176 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name_co (_data8_->_async_data_);
#line 1937 "PulseAudioManager.c"
	} else {
#line 178 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:178: setting source %s port to %s failed", _data8_->source_name, _data8_->port_name);
#line 1941 "PulseAudioManager.c"
	}
}

static void
___lambda49__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 174 "../src/Services/PulseAudioManager.vala"
	__lambda49_ (self, c, success);
#line 1952 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_)
{
#line 173 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 173 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 1962 "PulseAudioManager.c"
		goto _state_0;
#line 173 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 1966 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 173 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1971 "PulseAudioManager.c"
	}
	_state_0:
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_ = g_slice_new0 (Block8Data);
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_->_ref_count_ = 1;
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_->self = g_object_ref (_data_->self);
#line 173 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data8_->source_name);
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_->source_name = _data_->source_name;
#line 173 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data8_->port_name);
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_->port_name = _data_->port_name;
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_->_async_data_ = _data_;
#line 174 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->context;
#line 174 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_source_port_by_name (_data_->_tmp0_, _data_->_data8_->source_name, _data_->_data8_->port_name, ___lambda49__pa_context_success_cb_t, _data_->_data8_);
#line 174 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 174 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 182 "../src/Services/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 182 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2002 "PulseAudioManager.c"
	_state_1:
	;
#line 173 "../src/Services/PulseAudioManager.vala"
	block8_data_unref (_data_->_data8_);
#line 173 "../src/Services/PulseAudioManager.vala"
	_data_->_data8_ = NULL;
#line 173 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 173 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 173 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 173 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2017 "PulseAudioManager.c"
		}
	}
#line 173 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 173 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2024 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultSinkData, _data_);
#line 2036 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                            const gchar* sink_name,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (sink_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSinkData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_sink_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = g_strdup (sink_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->sink_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->sink_name = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_sink_co (_data_);
#line 2070 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                   GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2080 "PulseAudioManager.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 185 "../src/Services/PulseAudioManager.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 185 "../src/Services/PulseAudioManager.vala"
	return _data9_;
#line 2090 "PulseAudioManager.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 185 "../src/Services/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2100 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 185 "../src/Services/PulseAudioManager.vala"
		self = _data9_->self;
#line 185 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data9_->sink_name);
#line 185 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 185 "../src/Services/PulseAudioManager.vala"
		g_slice_free (Block9Data, _data9_);
#line 2110 "PulseAudioManager.c"
	}
}

static void
__lambda50_ (Block9Data* _data9_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 186 "../src/Services/PulseAudioManager.vala"
	self = _data9_->self;
#line 186 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 187 "../src/Services/PulseAudioManager.vala"
	if (success == 1) {
#line 188 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink_co (_data9_->_async_data_);
#line 2128 "PulseAudioManager.c"
	} else {
#line 190 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:190: setting default sink to %s failed", _data9_->sink_name);
#line 2132 "PulseAudioManager.c"
	}
}

static void
___lambda50__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 186 "../src/Services/PulseAudioManager.vala"
	__lambda50_ (self, c, success);
#line 2143 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_)
{
#line 185 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 185 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 2153 "PulseAudioManager.c"
		goto _state_0;
#line 185 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 2157 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 185 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2162 "PulseAudioManager.c"
	}
	_state_0:
#line 185 "../src/Services/PulseAudioManager.vala"
	_data_->_data9_ = g_slice_new0 (Block9Data);
#line 185 "../src/Services/PulseAudioManager.vala"
	_data_->_data9_->_ref_count_ = 1;
#line 185 "../src/Services/PulseAudioManager.vala"
	_data_->_data9_->self = g_object_ref (_data_->self);
#line 185 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data9_->sink_name);
#line 185 "../src/Services/PulseAudioManager.vala"
	_data_->_data9_->sink_name = _data_->sink_name;
#line 185 "../src/Services/PulseAudioManager.vala"
	_data_->_data9_->_async_data_ = _data_;
#line 186 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->context;
#line 186 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_default_sink (_data_->_tmp0_, _data_->_data9_->sink_name, ___lambda50__pa_context_success_cb_t, _data_->_data9_);
#line 186 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 186 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 194 "../src/Services/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 194 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2189 "PulseAudioManager.c"
	_state_1:
	;
#line 185 "../src/Services/PulseAudioManager.vala"
	block9_data_unref (_data_->_data9_);
#line 185 "../src/Services/PulseAudioManager.vala"
	_data_->_data9_ = NULL;
#line 185 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 185 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 185 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 185 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2204 "PulseAudioManager.c"
		}
	}
#line 185 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 185 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2211 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultSourceData, _data_);
#line 2223 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                              const gchar* source_name,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (source_name != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSourceData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_source_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = g_strdup (source_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->source_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->source_name = _tmp1_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_source_co (_data_);
#line 2257 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2267 "PulseAudioManager.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 197 "../src/Services/PulseAudioManager.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 197 "../src/Services/PulseAudioManager.vala"
	return _data10_;
#line 2277 "PulseAudioManager.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 197 "../src/Services/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2287 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 197 "../src/Services/PulseAudioManager.vala"
		self = _data10_->self;
#line 197 "../src/Services/PulseAudioManager.vala"
		_g_free0 (_data10_->source_name);
#line 197 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 197 "../src/Services/PulseAudioManager.vala"
		g_slice_free (Block10Data, _data10_);
#line 2297 "PulseAudioManager.c"
	}
}

static void
__lambda51_ (Block10Data* _data10_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 198 "../src/Services/PulseAudioManager.vala"
	self = _data10_->self;
#line 198 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 199 "../src/Services/PulseAudioManager.vala"
	if (success == 1) {
#line 200 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source_co (_data10_->_async_data_);
#line 2315 "PulseAudioManager.c"
	} else {
#line 202 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:202: setting default source to %s failed", _data10_->source_name);
#line 2319 "PulseAudioManager.c"
	}
}

static void
___lambda51__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 198 "../src/Services/PulseAudioManager.vala"
	__lambda51_ (self, c, success);
#line 2330 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_)
{
#line 197 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 197 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 2340 "PulseAudioManager.c"
		goto _state_0;
#line 197 "../src/Services/PulseAudioManager.vala"
		case 1:
#line 2344 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 197 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2349 "PulseAudioManager.c"
	}
	_state_0:
#line 197 "../src/Services/PulseAudioManager.vala"
	_data_->_data10_ = g_slice_new0 (Block10Data);
#line 197 "../src/Services/PulseAudioManager.vala"
	_data_->_data10_->_ref_count_ = 1;
#line 197 "../src/Services/PulseAudioManager.vala"
	_data_->_data10_->self = g_object_ref (_data_->self);
#line 197 "../src/Services/PulseAudioManager.vala"
	_g_free0 (_data_->_data10_->source_name);
#line 197 "../src/Services/PulseAudioManager.vala"
	_data_->_data10_->source_name = _data_->source_name;
#line 197 "../src/Services/PulseAudioManager.vala"
	_data_->_data10_->_async_data_ = _data_;
#line 198 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->context;
#line 198 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_default_source (_data_->_tmp0_, _data_->_data10_->source_name, ___lambda51__pa_context_success_cb_t, _data_->_data10_);
#line 198 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 198 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 206 "../src/Services/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 206 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2376 "PulseAudioManager.c"
	_state_1:
	;
#line 197 "../src/Services/PulseAudioManager.vala"
	block10_data_unref (_data_->_data10_);
#line 197 "../src/Services/PulseAudioManager.vala"
	_data_->_data10_ = NULL;
#line 197 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 197 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 197 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 197 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2391 "PulseAudioManager.c"
		}
	}
#line 197 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 197 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2398 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result;
#line 213 "../src/Services/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 214 "../src/Services/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 215 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 216 "../src/Services/PulseAudioManager.vala"
	result = FALSE;
#line 216 "../src/Services/PulseAudioManager.vala"
	return result;
#line 2415 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
#line 29 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
#line 2427 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
#line 29 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
#line 2451 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
#line 29 "../src/Services/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2461 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
#line 229 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
#line 2470 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
#line 219 "../src/Services/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 219 "../src/Services/PulseAudioManager.vala"
		case 0:
#line 2480 "PulseAudioManager.c"
		goto _state_0;
		default:
#line 219 "../src/Services/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2485 "PulseAudioManager.c"
	}
	_state_0:
#line 220 "../src/Services/PulseAudioManager.vala"
	if (_data_->self->priv->is_ready) {
#line 221 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp0_ = _data_->self->priv->context;
#line 221 "../src/Services/PulseAudioManager.vala"
		pa_context_disconnect (_data_->_tmp0_);
#line 222 "../src/Services/PulseAudioManager.vala"
		_pa_context_unref0 (_data_->self->priv->context);
#line 222 "../src/Services/PulseAudioManager.vala"
		_data_->self->priv->context = NULL;
#line 223 "../src/Services/PulseAudioManager.vala"
		_data_->self->priv->is_ready = FALSE;
#line 2500 "PulseAudioManager.c"
	}
#line 226 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_proplist_new ();
#line 226 "../src/Services/PulseAudioManager.vala"
	_data_->props = _data_->_tmp1_;
#line 227 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->props;
#line 227 "../src/Services/PulseAudioManager.vala"
	pa_proplist_sets (_data_->_tmp2_, PA_PROP_APPLICATION_ID, "org.wingpanel.indicator.sound");
#line 228 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp3_ = _data_->self->priv->loop;
#line 228 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp4_ = pa_glib_mainloop_get_api (_data_->_tmp3_);
#line 228 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp5_ = _data_->props;
#line 228 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp6_ = pa_context_new_with_proplist (_data_->_tmp4_, NULL, _data_->_tmp5_);
#line 228 "../src/Services/PulseAudioManager.vala"
	_pa_context_unref0 (_data_->self->priv->context);
#line 228 "../src/Services/PulseAudioManager.vala"
	_data_->self->priv->context = _data_->_tmp6_;
#line 229 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp7_ = _data_->self->priv->context;
#line 229 "../src/Services/PulseAudioManager.vala"
	pa_context_set_state_callback (_data_->_tmp7_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
#line 231 "../src/Services/PulseAudioManager.vala"
	_data_->_tmp8_ = _data_->self->priv->context;
#line 231 "../src/Services/PulseAudioManager.vala"
	if (pa_context_connect (_data_->_tmp8_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
#line 232 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp9_ = _data_->self->priv->context;
#line 232 "../src/Services/PulseAudioManager.vala"
		_data_->_tmp10_ = pa_strerror (pa_context_errno (_data_->_tmp9_));
#line 232 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:232: pa_context_connect () failed: %s\n", _data_->_tmp10_);
#line 2536 "PulseAudioManager.c"
	}
#line 219 "../src/Services/PulseAudioManager.vala"
	_pa_proplist_free0 (_data_->props);
#line 219 "../src/Services/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 219 "../src/Services/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 219 "../src/Services/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 219 "../src/Services/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2548 "PulseAudioManager.c"
		}
	}
#line 219 "../src/Services/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 219 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 2555 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
#line 239 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
#line 2566 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
#line 246 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
#line 2576 "PulseAudioManager.c"
}

static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
#line 253 "../src/Services/PulseAudioManager.vala"
	return result;
#line 2586 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
#line 236 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 237 "../src/Services/PulseAudioManager.vala"
	switch (pa_context_get_state (c)) {
#line 237 "../src/Services/PulseAudioManager.vala"
		case PA_CONTEXT_READY:
#line 2601 "PulseAudioManager.c"
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
#line 239 "../src/Services/PulseAudioManager.vala"
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
#line 240 "../src/Services/PulseAudioManager.vala"
			_tmp0_ = pa_context_subscribe (c, ((((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT) | PA_SUBSCRIPTION_MASK_CARD, NULL, NULL);
#line 240 "../src/Services/PulseAudioManager.vala"
			_tmp1_ = _tmp0_;
#line 240 "../src/Services/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp1_);
#line 246 "../src/Services/PulseAudioManager.vala"
			_tmp2_ = self->priv->context;
#line 246 "../src/Services/PulseAudioManager.vala"
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 246 "../src/Services/PulseAudioManager.vala"
			_tmp4_ = _tmp3_;
#line 246 "../src/Services/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp4_);
#line 247 "../src/Services/PulseAudioManager.vala"
			self->priv->is_ready = TRUE;
#line 248 "../src/Services/PulseAudioManager.vala"
			break;
#line 2628 "PulseAudioManager.c"
		}
#line 237 "../src/Services/PulseAudioManager.vala"
		case PA_CONTEXT_FAILED:
#line 237 "../src/Services/PulseAudioManager.vala"
		case PA_CONTEXT_TERMINATED:
#line 2634 "PulseAudioManager.c"
		{
#line 252 "../src/Services/PulseAudioManager.vala"
			if (self->priv->reconnect_timer_id == 0U) {
#line 253 "../src/Services/PulseAudioManager.vala"
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 2640 "PulseAudioManager.c"
			}
#line 256 "../src/Services/PulseAudioManager.vala"
			break;
#line 2644 "PulseAudioManager.c"
		}
		default:
		{
#line 259 "../src/Services/PulseAudioManager.vala"
			self->priv->is_ready = FALSE;
#line 260 "../src/Services/PulseAudioManager.vala"
			break;
#line 2652 "PulseAudioManager.c"
		}
	}
}

static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 276 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 2665 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                 pa_card_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 316 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_card_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 2676 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
#line 336 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 2687 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
#line 268 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 269 "../src/Services/PulseAudioManager.vala"
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
#line 270 "../src/Services/PulseAudioManager.vala"
	switch (source_type) {
#line 270 "../src/Services/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK:
#line 270 "../src/Services/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
#line 2709 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
#line 273 "../src/Services/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 274 "../src/Services/PulseAudioManager.vala"
			switch (event_type) {
#line 274 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 2718 "PulseAudioManager.c"
				{
					pa_operation* _tmp0_;
					pa_operation* _tmp1_;
#line 276 "../src/Services/PulseAudioManager.vala"
					_tmp0_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 276 "../src/Services/PulseAudioManager.vala"
					_tmp1_ = _tmp0_;
#line 276 "../src/Services/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp1_);
#line 277 "../src/Services/PulseAudioManager.vala"
					break;
#line 2730 "PulseAudioManager.c"
				}
#line 274 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 2734 "PulseAudioManager.c"
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
#line 280 "../src/Services/PulseAudioManager.vala"
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 280 "../src/Services/PulseAudioManager.vala"
					_tmp3_ = _tmp2_;
#line 280 "../src/Services/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp3_);
#line 281 "../src/Services/PulseAudioManager.vala"
					break;
#line 2746 "PulseAudioManager.c"
				}
#line 274 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 2750 "PulseAudioManager.c"
				{
#line 284 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:284: subscribe_callback:SINK:REMOVE");
#line 2754 "PulseAudioManager.c"
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp4_;
						GeeCollection* _tmp5_;
						GeeCollection* _tmp6_;
						GeeCollection* _tmp7_;
						GeeIterator* _tmp8_;
						GeeIterator* _tmp9_;
#line 285 "../src/Services/PulseAudioManager.vala"
						_tmp4_ = self->priv->output_devices;
#line 285 "../src/Services/PulseAudioManager.vala"
						_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
#line 285 "../src/Services/PulseAudioManager.vala"
						_tmp6_ = _tmp5_;
#line 285 "../src/Services/PulseAudioManager.vala"
						_tmp7_ = _tmp6_;
#line 285 "../src/Services/PulseAudioManager.vala"
						_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 285 "../src/Services/PulseAudioManager.vala"
						_tmp9_ = _tmp8_;
#line 285 "../src/Services/PulseAudioManager.vala"
						_g_object_unref0 (_tmp7_);
#line 285 "../src/Services/PulseAudioManager.vala"
						_device_it = _tmp9_;
#line 285 "../src/Services/PulseAudioManager.vala"
						while (TRUE) {
#line 2781 "PulseAudioManager.c"
							GeeIterator* _tmp10_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp11_;
							gpointer _tmp12_;
							SoundDevice* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SoundDevice* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
#line 285 "../src/Services/PulseAudioManager.vala"
							_tmp10_ = _device_it;
#line 285 "../src/Services/PulseAudioManager.vala"
							if (!gee_iterator_next (_tmp10_)) {
#line 285 "../src/Services/PulseAudioManager.vala"
								break;
#line 2798 "PulseAudioManager.c"
							}
#line 285 "../src/Services/PulseAudioManager.vala"
							_tmp11_ = _device_it;
#line 285 "../src/Services/PulseAudioManager.vala"
							_tmp12_ = gee_iterator_get (_tmp11_);
#line 285 "../src/Services/PulseAudioManager.vala"
							device = (SoundDevice*) _tmp12_;
#line 286 "../src/Services/PulseAudioManager.vala"
							_tmp13_ = device;
#line 286 "../src/Services/PulseAudioManager.vala"
							_tmp14_ = sound_device_get_sink_index (_tmp13_);
#line 286 "../src/Services/PulseAudioManager.vala"
							_tmp15_ = _tmp14_;
#line 286 "../src/Services/PulseAudioManager.vala"
							if (((guint32) _tmp15_) == index) {
#line 2814 "PulseAudioManager.c"
								SoundDevice* _tmp16_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
								SoundDevice* _tmp19_;
								SoundDevice* _tmp20_;
								SoundDevice* _tmp21_;
								SoundDevice* _tmp22_;
								const gchar* _tmp23_;
								const gchar* _tmp24_;
#line 287 "../src/Services/PulseAudioManager.vala"
								_tmp16_ = device;
#line 287 "../src/Services/PulseAudioManager.vala"
								_tmp17_ = sound_device_get_id (_tmp16_);
#line 287 "../src/Services/PulseAudioManager.vala"
								_tmp18_ = _tmp17_;
#line 287 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:287: \tupdating device: %s", _tmp18_);
#line 288 "../src/Services/PulseAudioManager.vala"
								_tmp19_ = device;
#line 288 "../src/Services/PulseAudioManager.vala"
								sound_device_set_sink_name (_tmp19_, NULL);
#line 289 "../src/Services/PulseAudioManager.vala"
								_tmp20_ = device;
#line 289 "../src/Services/PulseAudioManager.vala"
								sound_device_set_sink_index (_tmp20_, -1);
#line 290 "../src/Services/PulseAudioManager.vala"
								_tmp21_ = device;
#line 290 "../src/Services/PulseAudioManager.vala"
								sound_device_set_is_default (_tmp21_, FALSE);
#line 291 "../src/Services/PulseAudioManager.vala"
								_tmp22_ = device;
#line 291 "../src/Services/PulseAudioManager.vala"
								_tmp23_ = sound_device_get_sink_name (_tmp22_);
#line 291 "../src/Services/PulseAudioManager.vala"
								_tmp24_ = _tmp23_;
#line 291 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:291: \t\tdevice.sink_name: %s", _tmp24_);
#line 2852 "PulseAudioManager.c"
							}
#line 294 "../src/Services/PulseAudioManager.vala"
							_tmp25_ = device;
#line 294 "../src/Services/PulseAudioManager.vala"
							_tmp26_ = sound_device_get_card_sink_index (_tmp25_);
#line 294 "../src/Services/PulseAudioManager.vala"
							_tmp27_ = _tmp26_;
#line 294 "../src/Services/PulseAudioManager.vala"
							if (((guint32) _tmp27_) == index) {
#line 2862 "PulseAudioManager.c"
								SoundDevice* _tmp28_;
								const gchar* _tmp29_;
								const gchar* _tmp30_;
								SoundDevice* _tmp31_;
								SoundDevice* _tmp32_;
								SoundDevice* _tmp33_;
								SoundDevice* _tmp34_;
								const gchar* _tmp35_;
								const gchar* _tmp36_;
#line 295 "../src/Services/PulseAudioManager.vala"
								_tmp28_ = device;
#line 295 "../src/Services/PulseAudioManager.vala"
								_tmp29_ = sound_device_get_id (_tmp28_);
#line 295 "../src/Services/PulseAudioManager.vala"
								_tmp30_ = _tmp29_;
#line 295 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:295: \tupdating device: %s", _tmp30_);
#line 296 "../src/Services/PulseAudioManager.vala"
								_tmp31_ = device;
#line 296 "../src/Services/PulseAudioManager.vala"
								sound_device_set_card_sink_name (_tmp31_, NULL);
#line 297 "../src/Services/PulseAudioManager.vala"
								_tmp32_ = device;
#line 297 "../src/Services/PulseAudioManager.vala"
								sound_device_set_card_sink_index (_tmp32_, -1);
#line 298 "../src/Services/PulseAudioManager.vala"
								_tmp33_ = device;
#line 298 "../src/Services/PulseAudioManager.vala"
								sound_device_set_card_sink_port_name (_tmp33_, NULL);
#line 299 "../src/Services/PulseAudioManager.vala"
								_tmp34_ = device;
#line 299 "../src/Services/PulseAudioManager.vala"
								_tmp35_ = sound_device_get_card_sink_name (_tmp34_);
#line 299 "../src/Services/PulseAudioManager.vala"
								_tmp36_ = _tmp35_;
#line 299 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:299: \t\tdevice.card_sink_name: %s", _tmp36_);
#line 2900 "PulseAudioManager.c"
							}
#line 285 "../src/Services/PulseAudioManager.vala"
							_g_object_unref0 (device);
#line 2904 "PulseAudioManager.c"
						}
#line 285 "../src/Services/PulseAudioManager.vala"
						_g_object_unref0 (_device_it);
#line 2908 "PulseAudioManager.c"
					}
#line 303 "../src/Services/PulseAudioManager.vala"
					break;
#line 2912 "PulseAudioManager.c"
				}
				default:
#line 274 "../src/Services/PulseAudioManager.vala"
				break;
#line 2917 "PulseAudioManager.c"
			}
#line 306 "../src/Services/PulseAudioManager.vala"
			break;
#line 2921 "PulseAudioManager.c"
		}
#line 270 "../src/Services/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SERVER:
#line 2925 "PulseAudioManager.c"
		{
			pa_context* _tmp37_;
			pa_operation* _tmp38_;
			pa_operation* _tmp39_;
#line 309 "../src/Services/PulseAudioManager.vala"
			_tmp37_ = self->priv->context;
#line 309 "../src/Services/PulseAudioManager.vala"
			_tmp38_ = pa_context_get_server_info (_tmp37_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 309 "../src/Services/PulseAudioManager.vala"
			_tmp39_ = _tmp38_;
#line 309 "../src/Services/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp39_);
#line 310 "../src/Services/PulseAudioManager.vala"
			break;
#line 2940 "PulseAudioManager.c"
		}
#line 270 "../src/Services/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_CARD:
#line 2944 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
#line 313 "../src/Services/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 314 "../src/Services/PulseAudioManager.vala"
			switch (event_type) {
#line 314 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 2953 "PulseAudioManager.c"
				{
					pa_operation* _tmp40_;
					pa_operation* _tmp41_;
#line 316 "../src/Services/PulseAudioManager.vala"
					_tmp40_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 316 "../src/Services/PulseAudioManager.vala"
					_tmp41_ = _tmp40_;
#line 316 "../src/Services/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp41_);
#line 317 "../src/Services/PulseAudioManager.vala"
					break;
#line 2965 "PulseAudioManager.c"
				}
#line 314 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 2969 "PulseAudioManager.c"
				{
					pa_operation* _tmp42_;
					pa_operation* _tmp43_;
#line 320 "../src/Services/PulseAudioManager.vala"
					_tmp42_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 320 "../src/Services/PulseAudioManager.vala"
					_tmp43_ = _tmp42_;
#line 320 "../src/Services/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp43_);
#line 321 "../src/Services/PulseAudioManager.vala"
					break;
#line 2981 "PulseAudioManager.c"
				}
#line 314 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 2985 "PulseAudioManager.c"
				{
					GeeHashMap* _tmp44_;
					GeeHashMap* _tmp45_;
#line 324 "../src/Services/PulseAudioManager.vala"
					_tmp44_ = self->priv->output_devices;
#line 324 "../src/Services/PulseAudioManager.vala"
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp44_, index);
#line 325 "../src/Services/PulseAudioManager.vala"
					_tmp45_ = self->priv->input_devices;
#line 325 "../src/Services/PulseAudioManager.vala"
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp45_, index);
#line 326 "../src/Services/PulseAudioManager.vala"
					break;
#line 2999 "PulseAudioManager.c"
				}
				default:
#line 314 "../src/Services/PulseAudioManager.vala"
				break;
#line 3004 "PulseAudioManager.c"
			}
#line 329 "../src/Services/PulseAudioManager.vala"
			break;
#line 3008 "PulseAudioManager.c"
		}
#line 270 "../src/Services/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE:
#line 270 "../src/Services/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
#line 3014 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
#line 333 "../src/Services/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 334 "../src/Services/PulseAudioManager.vala"
			switch (event_type) {
#line 334 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3023 "PulseAudioManager.c"
				{
					pa_operation* _tmp46_;
					pa_operation* _tmp47_;
#line 336 "../src/Services/PulseAudioManager.vala"
					_tmp46_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 336 "../src/Services/PulseAudioManager.vala"
					_tmp47_ = _tmp46_;
#line 336 "../src/Services/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp47_);
#line 337 "../src/Services/PulseAudioManager.vala"
					break;
#line 3035 "PulseAudioManager.c"
				}
#line 334 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3039 "PulseAudioManager.c"
				{
					pa_operation* _tmp48_;
					pa_operation* _tmp49_;
#line 340 "../src/Services/PulseAudioManager.vala"
					_tmp48_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 340 "../src/Services/PulseAudioManager.vala"
					_tmp49_ = _tmp48_;
#line 340 "../src/Services/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp49_);
#line 341 "../src/Services/PulseAudioManager.vala"
					break;
#line 3051 "PulseAudioManager.c"
				}
#line 334 "../src/Services/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3055 "PulseAudioManager.c"
				{
#line 344 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:344: subscribe_callback:SOURCE:REMOVE");
#line 3059 "PulseAudioManager.c"
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp50_;
						GeeCollection* _tmp51_;
						GeeCollection* _tmp52_;
						GeeCollection* _tmp53_;
						GeeIterator* _tmp54_;
						GeeIterator* _tmp55_;
#line 345 "../src/Services/PulseAudioManager.vala"
						_tmp50_ = self->priv->input_devices;
#line 345 "../src/Services/PulseAudioManager.vala"
						_tmp51_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp50_);
#line 345 "../src/Services/PulseAudioManager.vala"
						_tmp52_ = _tmp51_;
#line 345 "../src/Services/PulseAudioManager.vala"
						_tmp53_ = _tmp52_;
#line 345 "../src/Services/PulseAudioManager.vala"
						_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 345 "../src/Services/PulseAudioManager.vala"
						_tmp55_ = _tmp54_;
#line 345 "../src/Services/PulseAudioManager.vala"
						_g_object_unref0 (_tmp53_);
#line 345 "../src/Services/PulseAudioManager.vala"
						_device_it = _tmp55_;
#line 345 "../src/Services/PulseAudioManager.vala"
						while (TRUE) {
#line 3086 "PulseAudioManager.c"
							GeeIterator* _tmp56_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp57_;
							gpointer _tmp58_;
							SoundDevice* _tmp59_;
							gint _tmp60_;
							gint _tmp61_;
							SoundDevice* _tmp71_;
							gint _tmp72_;
							gint _tmp73_;
#line 345 "../src/Services/PulseAudioManager.vala"
							_tmp56_ = _device_it;
#line 345 "../src/Services/PulseAudioManager.vala"
							if (!gee_iterator_next (_tmp56_)) {
#line 345 "../src/Services/PulseAudioManager.vala"
								break;
#line 3103 "PulseAudioManager.c"
							}
#line 345 "../src/Services/PulseAudioManager.vala"
							_tmp57_ = _device_it;
#line 345 "../src/Services/PulseAudioManager.vala"
							_tmp58_ = gee_iterator_get (_tmp57_);
#line 345 "../src/Services/PulseAudioManager.vala"
							device = (SoundDevice*) _tmp58_;
#line 346 "../src/Services/PulseAudioManager.vala"
							_tmp59_ = device;
#line 346 "../src/Services/PulseAudioManager.vala"
							_tmp60_ = sound_device_get_source_index (_tmp59_);
#line 346 "../src/Services/PulseAudioManager.vala"
							_tmp61_ = _tmp60_;
#line 346 "../src/Services/PulseAudioManager.vala"
							if (((guint32) _tmp61_) == index) {
#line 3119 "PulseAudioManager.c"
								SoundDevice* _tmp62_;
								const gchar* _tmp63_;
								const gchar* _tmp64_;
								SoundDevice* _tmp65_;
								SoundDevice* _tmp66_;
								SoundDevice* _tmp67_;
								SoundDevice* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
#line 347 "../src/Services/PulseAudioManager.vala"
								_tmp62_ = device;
#line 347 "../src/Services/PulseAudioManager.vala"
								_tmp63_ = sound_device_get_id (_tmp62_);
#line 347 "../src/Services/PulseAudioManager.vala"
								_tmp64_ = _tmp63_;
#line 347 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:347: \tupdating device: %s", _tmp64_);
#line 348 "../src/Services/PulseAudioManager.vala"
								_tmp65_ = device;
#line 348 "../src/Services/PulseAudioManager.vala"
								sound_device_set_source_name (_tmp65_, NULL);
#line 349 "../src/Services/PulseAudioManager.vala"
								_tmp66_ = device;
#line 349 "../src/Services/PulseAudioManager.vala"
								sound_device_set_source_index (_tmp66_, -1);
#line 350 "../src/Services/PulseAudioManager.vala"
								_tmp67_ = device;
#line 350 "../src/Services/PulseAudioManager.vala"
								sound_device_set_is_default (_tmp67_, FALSE);
#line 351 "../src/Services/PulseAudioManager.vala"
								_tmp68_ = device;
#line 351 "../src/Services/PulseAudioManager.vala"
								_tmp69_ = sound_device_get_source_name (_tmp68_);
#line 351 "../src/Services/PulseAudioManager.vala"
								_tmp70_ = _tmp69_;
#line 351 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:351: \t\tdevice.source_name: %s", _tmp70_);
#line 3157 "PulseAudioManager.c"
							}
#line 354 "../src/Services/PulseAudioManager.vala"
							_tmp71_ = device;
#line 354 "../src/Services/PulseAudioManager.vala"
							_tmp72_ = sound_device_get_card_source_index (_tmp71_);
#line 354 "../src/Services/PulseAudioManager.vala"
							_tmp73_ = _tmp72_;
#line 354 "../src/Services/PulseAudioManager.vala"
							if (((guint32) _tmp73_) == index) {
#line 3167 "PulseAudioManager.c"
								SoundDevice* _tmp74_;
								const gchar* _tmp75_;
								const gchar* _tmp76_;
								SoundDevice* _tmp77_;
								SoundDevice* _tmp78_;
								SoundDevice* _tmp79_;
								SoundDevice* _tmp80_;
								const gchar* _tmp81_;
								const gchar* _tmp82_;
#line 355 "../src/Services/PulseAudioManager.vala"
								_tmp74_ = device;
#line 355 "../src/Services/PulseAudioManager.vala"
								_tmp75_ = sound_device_get_id (_tmp74_);
#line 355 "../src/Services/PulseAudioManager.vala"
								_tmp76_ = _tmp75_;
#line 355 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:355: \tupdating device: %s", _tmp76_);
#line 356 "../src/Services/PulseAudioManager.vala"
								_tmp77_ = device;
#line 356 "../src/Services/PulseAudioManager.vala"
								sound_device_set_card_source_name (_tmp77_, NULL);
#line 357 "../src/Services/PulseAudioManager.vala"
								_tmp78_ = device;
#line 357 "../src/Services/PulseAudioManager.vala"
								sound_device_set_card_source_index (_tmp78_, -1);
#line 358 "../src/Services/PulseAudioManager.vala"
								_tmp79_ = device;
#line 358 "../src/Services/PulseAudioManager.vala"
								sound_device_set_card_source_port_name (_tmp79_, NULL);
#line 359 "../src/Services/PulseAudioManager.vala"
								_tmp80_ = device;
#line 359 "../src/Services/PulseAudioManager.vala"
								_tmp81_ = sound_device_get_card_source_name (_tmp80_);
#line 359 "../src/Services/PulseAudioManager.vala"
								_tmp82_ = _tmp81_;
#line 359 "../src/Services/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:359: \t\tdevice.card_source_name: %s", _tmp82_);
#line 3205 "PulseAudioManager.c"
							}
#line 345 "../src/Services/PulseAudioManager.vala"
							_g_object_unref0 (device);
#line 3209 "PulseAudioManager.c"
						}
#line 345 "../src/Services/PulseAudioManager.vala"
						_g_object_unref0 (_device_it);
#line 3213 "PulseAudioManager.c"
					}
#line 363 "../src/Services/PulseAudioManager.vala"
					break;
#line 3217 "PulseAudioManager.c"
				}
				default:
#line 334 "../src/Services/PulseAudioManager.vala"
				break;
#line 3222 "PulseAudioManager.c"
			}
#line 366 "../src/Services/PulseAudioManager.vala"
			break;
#line 3226 "PulseAudioManager.c"
		}
		default:
#line 270 "../src/Services/PulseAudioManager.vala"
		break;
#line 3231 "PulseAudioManager.c"
	}
}

static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* source,
                                                gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_source_port_info* _tmp8_;
#line 374 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 374 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 375 "../src/Services/PulseAudioManager.vala"
	if (source == NULL) {
#line 376 "../src/Services/PulseAudioManager.vala"
		return;
#line 3253 "PulseAudioManager.c"
	}
#line 380 "../src/Services/PulseAudioManager.vala"
	if ((*source).monitor_of_sink != PA_INVALID_INDEX) {
#line 381 "../src/Services/PulseAudioManager.vala"
		return;
#line 3259 "PulseAudioManager.c"
	}
#line 384 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:384: source info update");
#line 385 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = (*source).description;
#line 385 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = (*source).name;
#line 385 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:385: \tsource: %s (%s)", _tmp0_, _tmp1_);
#line 386 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:386: \t\tcard: %u", (guint) (*source).card);
#line 388 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = (*source).name;
#line 388 "../src/Services/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
#line 389 "../src/Services/PulseAudioManager.vala"
		return;
#line 3277 "PulseAudioManager.c"
	}
#line 392 "../src/Services/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_debug_enabled) {
#line 3281 "PulseAudioManager.c"
		pa_source_port_info** _tmp3_;
		gint _tmp3__length1;
#line 393 "../src/Services/PulseAudioManager.vala"
		_tmp3_ = (*source).ports;
#line 393 "../src/Services/PulseAudioManager.vala"
		_tmp3__length1 = (*source).n_ports;
#line 3288 "PulseAudioManager.c"
		{
			pa_source_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 393 "../src/Services/PulseAudioManager.vala"
			port_collection = _tmp3_;
#line 393 "../src/Services/PulseAudioManager.vala"
			port_collection_length1 = _tmp3__length1;
#line 393 "../src/Services/PulseAudioManager.vala"
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 3300 "PulseAudioManager.c"
				pa_source_port_info* port = NULL;
#line 393 "../src/Services/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 3304 "PulseAudioManager.c"
				{
					pa_source_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_source_port_info* _tmp6_;
					const gchar* _tmp7_;
#line 394 "../src/Services/PulseAudioManager.vala"
					_tmp4_ = port;
#line 394 "../src/Services/PulseAudioManager.vala"
					_tmp5_ = (*_tmp4_).description;
#line 394 "../src/Services/PulseAudioManager.vala"
					_tmp6_ = port;
#line 394 "../src/Services/PulseAudioManager.vala"
					_tmp7_ = (*_tmp6_).name;
#line 394 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:394: \t\tport: %s (%s)", _tmp5_, _tmp7_);
#line 3320 "PulseAudioManager.c"
				}
			}
		}
	}
#line 398 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = (*source).active_port;
#line 398 "../src/Services/PulseAudioManager.vala"
	if (_tmp8_ != NULL) {
#line 3329 "PulseAudioManager.c"
		pa_source_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_source_port_info* _tmp11_;
		const gchar* _tmp12_;
#line 399 "../src/Services/PulseAudioManager.vala"
		_tmp9_ = (*source).active_port;
#line 399 "../src/Services/PulseAudioManager.vala"
		_tmp10_ = (*_tmp9_).description;
#line 399 "../src/Services/PulseAudioManager.vala"
		_tmp11_ = (*source).active_port;
#line 399 "../src/Services/PulseAudioManager.vala"
		_tmp12_ = (*_tmp11_).name;
#line 399 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:399: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
#line 3344 "PulseAudioManager.c"
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
#line 402 "../src/Services/PulseAudioManager.vala"
		_tmp13_ = self->priv->input_devices;
#line 402 "../src/Services/PulseAudioManager.vala"
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
#line 402 "../src/Services/PulseAudioManager.vala"
		_tmp15_ = _tmp14_;
#line 402 "../src/Services/PulseAudioManager.vala"
		_tmp16_ = _tmp15_;
#line 402 "../src/Services/PulseAudioManager.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 402 "../src/Services/PulseAudioManager.vala"
		_tmp18_ = _tmp17_;
#line 402 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (_tmp16_);
#line 402 "../src/Services/PulseAudioManager.vala"
		_device_it = _tmp18_;
#line 402 "../src/Services/PulseAudioManager.vala"
		while (TRUE) {
#line 3372 "PulseAudioManager.c"
			GeeIterator* _tmp19_;
			SoundDevice* device = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
#line 402 "../src/Services/PulseAudioManager.vala"
			_tmp19_ = _device_it;
#line 402 "../src/Services/PulseAudioManager.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 402 "../src/Services/PulseAudioManager.vala"
				break;
#line 3386 "PulseAudioManager.c"
			}
#line 402 "../src/Services/PulseAudioManager.vala"
			_tmp20_ = _device_it;
#line 402 "../src/Services/PulseAudioManager.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 402 "../src/Services/PulseAudioManager.vala"
			device = (SoundDevice*) _tmp21_;
#line 403 "../src/Services/PulseAudioManager.vala"
			_tmp22_ = device;
#line 403 "../src/Services/PulseAudioManager.vala"
			_tmp23_ = sound_device_get_card_index (_tmp22_);
#line 403 "../src/Services/PulseAudioManager.vala"
			_tmp24_ = _tmp23_;
#line 403 "../src/Services/PulseAudioManager.vala"
			if (_tmp24_ == (*source).card) {
#line 3402 "PulseAudioManager.c"
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_source_port_info* _tmp35_;
#line 404 "../src/Services/PulseAudioManager.vala"
				_tmp25_ = device;
#line 404 "../src/Services/PulseAudioManager.vala"
				_tmp26_ = sound_device_get_id (_tmp25_);
#line 404 "../src/Services/PulseAudioManager.vala"
				_tmp27_ = _tmp26_;
#line 404 "../src/Services/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:404: \t\tupdating device: %s", _tmp27_);
#line 405 "../src/Services/PulseAudioManager.vala"
				_tmp28_ = device;
#line 405 "../src/Services/PulseAudioManager.vala"
				sound_device_set_card_source_index (_tmp28_, (gint) (*source).index);
#line 406 "../src/Services/PulseAudioManager.vala"
				_tmp29_ = device;
#line 406 "../src/Services/PulseAudioManager.vala"
				_tmp30_ = (*source).name;
#line 406 "../src/Services/PulseAudioManager.vala"
				sound_device_set_card_source_name (_tmp29_, _tmp30_);
#line 407 "../src/Services/PulseAudioManager.vala"
				_tmp31_ = device;
#line 407 "../src/Services/PulseAudioManager.vala"
				_tmp32_ = sound_device_get_card_source_name (_tmp31_);
#line 407 "../src/Services/PulseAudioManager.vala"
				_tmp33_ = _tmp32_;
#line 407 "../src/Services/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:407: \t\t\tdevice.card_source_name: %s", _tmp33_);
#line 408 "../src/Services/PulseAudioManager.vala"
				_tmp35_ = (*source).active_port;
#line 408 "../src/Services/PulseAudioManager.vala"
				if (_tmp35_ != NULL) {
#line 3444 "PulseAudioManager.c"
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_source_port_info* _tmp39_;
					const gchar* _tmp40_;
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp36_ = device;
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp37_ = sound_device_get_port_name (_tmp36_);
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp38_ = _tmp37_;
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp39_ = (*source).active_port;
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp40_ = (*_tmp39_).name;
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
#line 3462 "PulseAudioManager.c"
				} else {
#line 408 "../src/Services/PulseAudioManager.vala"
					_tmp34_ = FALSE;
#line 3466 "PulseAudioManager.c"
				}
#line 408 "../src/Services/PulseAudioManager.vala"
				if (_tmp34_) {
#line 3470 "PulseAudioManager.c"
					SoundDevice* _tmp41_;
					pa_source_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					gboolean _tmp58_;
					gboolean _tmp59_;
#line 409 "../src/Services/PulseAudioManager.vala"
					_tmp41_ = device;
#line 409 "../src/Services/PulseAudioManager.vala"
					_tmp42_ = (*source).active_port;
#line 409 "../src/Services/PulseAudioManager.vala"
					_tmp43_ = (*_tmp42_).name;
#line 409 "../src/Services/PulseAudioManager.vala"
					sound_device_set_card_source_port_name (_tmp41_, _tmp43_);
#line 410 "../src/Services/PulseAudioManager.vala"
					_tmp44_ = device;
#line 410 "../src/Services/PulseAudioManager.vala"
					_tmp45_ = (*source).name;
#line 410 "../src/Services/PulseAudioManager.vala"
					sound_device_set_source_name (_tmp44_, _tmp45_);
#line 411 "../src/Services/PulseAudioManager.vala"
					_tmp46_ = device;
#line 411 "../src/Services/PulseAudioManager.vala"
					_tmp47_ = sound_device_get_card_source_name (_tmp46_);
#line 411 "../src/Services/PulseAudioManager.vala"
					_tmp48_ = _tmp47_;
#line 411 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:411: \t\t\tdevice.source_name: %s", _tmp48_);
#line 412 "../src/Services/PulseAudioManager.vala"
					_tmp49_ = device;
#line 412 "../src/Services/PulseAudioManager.vala"
					sound_device_set_source_index (_tmp49_, (gint) (*source).index);
#line 413 "../src/Services/PulseAudioManager.vala"
					_tmp50_ = device;
#line 413 "../src/Services/PulseAudioManager.vala"
					_tmp51_ = (*source).name;
#line 413 "../src/Services/PulseAudioManager.vala"
					_tmp52_ = self->priv->default_source_name;
#line 413 "../src/Services/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
#line 414 "../src/Services/PulseAudioManager.vala"
					_tmp54_ = device;
#line 414 "../src/Services/PulseAudioManager.vala"
					_tmp55_ = sound_device_get_is_default (_tmp54_);
#line 414 "../src/Services/PulseAudioManager.vala"
					_tmp56_ = _tmp55_;
#line 414 "../src/Services/PulseAudioManager.vala"
					if (_tmp56_) {
#line 414 "../src/Services/PulseAudioManager.vala"
						_tmp53_ = "true";
#line 3534 "PulseAudioManager.c"
					} else {
#line 414 "../src/Services/PulseAudioManager.vala"
						_tmp53_ = "false";
#line 3538 "PulseAudioManager.c"
					}
#line 414 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:414: \t\t\tis_default: %s", _tmp53_);
#line 416 "../src/Services/PulseAudioManager.vala"
					_tmp57_ = device;
#line 416 "../src/Services/PulseAudioManager.vala"
					_tmp58_ = sound_device_get_is_default (_tmp57_);
#line 416 "../src/Services/PulseAudioManager.vala"
					_tmp59_ = _tmp58_;
#line 416 "../src/Services/PulseAudioManager.vala"
					if (_tmp59_) {
#line 3550 "PulseAudioManager.c"
						SoundDevice* _tmp60_;
#line 417 "../src/Services/PulseAudioManager.vala"
						_tmp60_ = device;
#line 417 "../src/Services/PulseAudioManager.vala"
						sound_pulse_audio_manager_set_default_input (self, _tmp60_);
#line 3556 "PulseAudioManager.c"
					}
				} else {
					SoundDevice* _tmp61_;
					SoundDevice* _tmp62_;
					SoundDevice* _tmp63_;
#line 421 "../src/Services/PulseAudioManager.vala"
					_tmp61_ = device;
#line 421 "../src/Services/PulseAudioManager.vala"
					sound_device_set_source_name (_tmp61_, NULL);
#line 422 "../src/Services/PulseAudioManager.vala"
					_tmp62_ = device;
#line 422 "../src/Services/PulseAudioManager.vala"
					sound_device_set_source_index (_tmp62_, -1);
#line 423 "../src/Services/PulseAudioManager.vala"
					_tmp63_ = device;
#line 423 "../src/Services/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp63_, FALSE);
#line 3574 "PulseAudioManager.c"
				}
			}
#line 402 "../src/Services/PulseAudioManager.vala"
			_g_object_unref0 (device);
#line 3579 "PulseAudioManager.c"
		}
#line 402 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (_device_it);
#line 3583 "PulseAudioManager.c"
	}
}

static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* sink,
                                              gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_sink_port_info* _tmp8_;
#line 429 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 430 "../src/Services/PulseAudioManager.vala"
	if (sink == NULL) {
#line 431 "../src/Services/PulseAudioManager.vala"
		return;
#line 3605 "PulseAudioManager.c"
	}
#line 434 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:434: sink info update");
#line 435 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = (*sink).description;
#line 435 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = (*sink).name;
#line 435 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:435: \tsink: %s (%s)", _tmp0_, _tmp1_);
#line 437 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = (*sink).name;
#line 437 "../src/Services/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
#line 438 "../src/Services/PulseAudioManager.vala"
		return;
#line 3621 "PulseAudioManager.c"
	}
#line 441 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:441: \t\tcard: %u", (guint) (*sink).card);
#line 442 "../src/Services/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_debug_enabled) {
#line 3627 "PulseAudioManager.c"
		pa_sink_port_info** _tmp3_;
		gint _tmp3__length1;
#line 444 "../src/Services/PulseAudioManager.vala"
		_tmp3_ = (*sink).ports;
#line 444 "../src/Services/PulseAudioManager.vala"
		_tmp3__length1 = (*sink).n_ports;
#line 3634 "PulseAudioManager.c"
		{
			pa_sink_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 444 "../src/Services/PulseAudioManager.vala"
			port_collection = _tmp3_;
#line 444 "../src/Services/PulseAudioManager.vala"
			port_collection_length1 = _tmp3__length1;
#line 444 "../src/Services/PulseAudioManager.vala"
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 3646 "PulseAudioManager.c"
				pa_sink_port_info* port = NULL;
#line 444 "../src/Services/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 3650 "PulseAudioManager.c"
				{
					pa_sink_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_sink_port_info* _tmp6_;
					const gchar* _tmp7_;
#line 445 "../src/Services/PulseAudioManager.vala"
					_tmp4_ = port;
#line 445 "../src/Services/PulseAudioManager.vala"
					_tmp5_ = (*_tmp4_).description;
#line 445 "../src/Services/PulseAudioManager.vala"
					_tmp6_ = port;
#line 445 "../src/Services/PulseAudioManager.vala"
					_tmp7_ = (*_tmp6_).name;
#line 445 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:445: \t\tport: %s (%s)", _tmp5_, _tmp7_);
#line 3666 "PulseAudioManager.c"
				}
			}
		}
	}
#line 450 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = (*sink).active_port;
#line 450 "../src/Services/PulseAudioManager.vala"
	if (_tmp8_ != NULL) {
#line 3675 "PulseAudioManager.c"
		pa_sink_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_sink_port_info* _tmp11_;
		const gchar* _tmp12_;
#line 451 "../src/Services/PulseAudioManager.vala"
		_tmp9_ = (*sink).active_port;
#line 451 "../src/Services/PulseAudioManager.vala"
		_tmp10_ = (*_tmp9_).description;
#line 451 "../src/Services/PulseAudioManager.vala"
		_tmp11_ = (*sink).active_port;
#line 451 "../src/Services/PulseAudioManager.vala"
		_tmp12_ = (*_tmp11_).name;
#line 451 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:451: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
#line 3690 "PulseAudioManager.c"
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
#line 454 "../src/Services/PulseAudioManager.vala"
		_tmp13_ = self->priv->output_devices;
#line 454 "../src/Services/PulseAudioManager.vala"
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
#line 454 "../src/Services/PulseAudioManager.vala"
		_tmp15_ = _tmp14_;
#line 454 "../src/Services/PulseAudioManager.vala"
		_tmp16_ = _tmp15_;
#line 454 "../src/Services/PulseAudioManager.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 454 "../src/Services/PulseAudioManager.vala"
		_tmp18_ = _tmp17_;
#line 454 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (_tmp16_);
#line 454 "../src/Services/PulseAudioManager.vala"
		_device_it = _tmp18_;
#line 454 "../src/Services/PulseAudioManager.vala"
		while (TRUE) {
#line 3718 "PulseAudioManager.c"
			GeeIterator* _tmp19_;
			SoundDevice* device = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
#line 454 "../src/Services/PulseAudioManager.vala"
			_tmp19_ = _device_it;
#line 454 "../src/Services/PulseAudioManager.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 454 "../src/Services/PulseAudioManager.vala"
				break;
#line 3732 "PulseAudioManager.c"
			}
#line 454 "../src/Services/PulseAudioManager.vala"
			_tmp20_ = _device_it;
#line 454 "../src/Services/PulseAudioManager.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 454 "../src/Services/PulseAudioManager.vala"
			device = (SoundDevice*) _tmp21_;
#line 455 "../src/Services/PulseAudioManager.vala"
			_tmp22_ = device;
#line 455 "../src/Services/PulseAudioManager.vala"
			_tmp23_ = sound_device_get_card_index (_tmp22_);
#line 455 "../src/Services/PulseAudioManager.vala"
			_tmp24_ = _tmp23_;
#line 455 "../src/Services/PulseAudioManager.vala"
			if (_tmp24_ == (*sink).card) {
#line 3748 "PulseAudioManager.c"
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_sink_port_info* _tmp35_;
#line 456 "../src/Services/PulseAudioManager.vala"
				_tmp25_ = device;
#line 456 "../src/Services/PulseAudioManager.vala"
				_tmp26_ = sound_device_get_id (_tmp25_);
#line 456 "../src/Services/PulseAudioManager.vala"
				_tmp27_ = _tmp26_;
#line 456 "../src/Services/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:456: \t\tupdating device: %s", _tmp27_);
#line 457 "../src/Services/PulseAudioManager.vala"
				_tmp28_ = device;
#line 457 "../src/Services/PulseAudioManager.vala"
				sound_device_set_card_sink_index (_tmp28_, (gint) (*sink).index);
#line 458 "../src/Services/PulseAudioManager.vala"
				_tmp29_ = device;
#line 458 "../src/Services/PulseAudioManager.vala"
				_tmp30_ = (*sink).name;
#line 458 "../src/Services/PulseAudioManager.vala"
				sound_device_set_card_sink_name (_tmp29_, _tmp30_);
#line 459 "../src/Services/PulseAudioManager.vala"
				_tmp31_ = device;
#line 459 "../src/Services/PulseAudioManager.vala"
				_tmp32_ = sound_device_get_card_sink_name (_tmp31_);
#line 459 "../src/Services/PulseAudioManager.vala"
				_tmp33_ = _tmp32_;
#line 459 "../src/Services/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:459: \t\t\tdevice.card_sink_name: %s", _tmp33_);
#line 461 "../src/Services/PulseAudioManager.vala"
				_tmp35_ = (*sink).active_port;
#line 461 "../src/Services/PulseAudioManager.vala"
				if (_tmp35_ != NULL) {
#line 3790 "PulseAudioManager.c"
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_sink_port_info* _tmp39_;
					const gchar* _tmp40_;
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp36_ = device;
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp37_ = sound_device_get_port_name (_tmp36_);
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp38_ = _tmp37_;
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp39_ = (*sink).active_port;
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp40_ = (*_tmp39_).name;
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
#line 3808 "PulseAudioManager.c"
				} else {
#line 461 "../src/Services/PulseAudioManager.vala"
					_tmp34_ = FALSE;
#line 3812 "PulseAudioManager.c"
				}
#line 461 "../src/Services/PulseAudioManager.vala"
				if (_tmp34_) {
#line 3816 "PulseAudioManager.c"
					SoundDevice* _tmp41_;
					pa_sink_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					gboolean _tmp58_;
					gboolean _tmp59_;
#line 462 "../src/Services/PulseAudioManager.vala"
					_tmp41_ = device;
#line 462 "../src/Services/PulseAudioManager.vala"
					_tmp42_ = (*sink).active_port;
#line 462 "../src/Services/PulseAudioManager.vala"
					_tmp43_ = (*_tmp42_).name;
#line 462 "../src/Services/PulseAudioManager.vala"
					sound_device_set_card_sink_port_name (_tmp41_, _tmp43_);
#line 463 "../src/Services/PulseAudioManager.vala"
					_tmp44_ = device;
#line 463 "../src/Services/PulseAudioManager.vala"
					_tmp45_ = (*sink).name;
#line 463 "../src/Services/PulseAudioManager.vala"
					sound_device_set_sink_name (_tmp44_, _tmp45_);
#line 464 "../src/Services/PulseAudioManager.vala"
					_tmp46_ = device;
#line 464 "../src/Services/PulseAudioManager.vala"
					_tmp47_ = sound_device_get_card_sink_name (_tmp46_);
#line 464 "../src/Services/PulseAudioManager.vala"
					_tmp48_ = _tmp47_;
#line 464 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:464: \t\t\tdevice.sink_name: %s", _tmp48_);
#line 465 "../src/Services/PulseAudioManager.vala"
					_tmp49_ = device;
#line 465 "../src/Services/PulseAudioManager.vala"
					sound_device_set_sink_index (_tmp49_, (gint) (*sink).index);
#line 466 "../src/Services/PulseAudioManager.vala"
					_tmp50_ = device;
#line 466 "../src/Services/PulseAudioManager.vala"
					_tmp51_ = (*sink).name;
#line 466 "../src/Services/PulseAudioManager.vala"
					_tmp52_ = self->priv->default_sink_name;
#line 466 "../src/Services/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
#line 467 "../src/Services/PulseAudioManager.vala"
					_tmp54_ = device;
#line 467 "../src/Services/PulseAudioManager.vala"
					_tmp55_ = sound_device_get_is_default (_tmp54_);
#line 467 "../src/Services/PulseAudioManager.vala"
					_tmp56_ = _tmp55_;
#line 467 "../src/Services/PulseAudioManager.vala"
					if (_tmp56_) {
#line 467 "../src/Services/PulseAudioManager.vala"
						_tmp53_ = "true";
#line 3880 "PulseAudioManager.c"
					} else {
#line 467 "../src/Services/PulseAudioManager.vala"
						_tmp53_ = "false";
#line 3884 "PulseAudioManager.c"
					}
#line 467 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:467: \t\t\tis_default: %s", _tmp53_);
#line 469 "../src/Services/PulseAudioManager.vala"
					_tmp57_ = device;
#line 469 "../src/Services/PulseAudioManager.vala"
					_tmp58_ = sound_device_get_is_default (_tmp57_);
#line 469 "../src/Services/PulseAudioManager.vala"
					_tmp59_ = _tmp58_;
#line 469 "../src/Services/PulseAudioManager.vala"
					if (_tmp59_) {
#line 3896 "PulseAudioManager.c"
						SoundDevice* _tmp60_;
#line 470 "../src/Services/PulseAudioManager.vala"
						_tmp60_ = device;
#line 470 "../src/Services/PulseAudioManager.vala"
						sound_pulse_audio_manager_set_default_output (self, _tmp60_);
#line 3902 "PulseAudioManager.c"
					}
				} else {
					SoundDevice* _tmp61_;
					SoundDevice* _tmp62_;
					SoundDevice* _tmp63_;
#line 474 "../src/Services/PulseAudioManager.vala"
					_tmp61_ = device;
#line 474 "../src/Services/PulseAudioManager.vala"
					sound_device_set_sink_name (_tmp61_, NULL);
#line 475 "../src/Services/PulseAudioManager.vala"
					_tmp62_ = device;
#line 475 "../src/Services/PulseAudioManager.vala"
					sound_device_set_sink_index (_tmp62_, -1);
#line 476 "../src/Services/PulseAudioManager.vala"
					_tmp63_ = device;
#line 476 "../src/Services/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp63_, FALSE);
#line 3920 "PulseAudioManager.c"
				}
			}
#line 454 "../src/Services/PulseAudioManager.vala"
			_g_object_unref0 (device);
#line 3925 "PulseAudioManager.c"
		}
#line 454 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (_device_it);
#line 3929 "PulseAudioManager.c"
	}
}

static void
_vala_array_add1 (pa_card_port_info** * array,
                  gint* length,
                  gint* size,
                  pa_card_port_info* value)
{
#line 512 "../src/Services/PulseAudioManager.vala"
	if ((*length) == (*size)) {
#line 512 "../src/Services/PulseAudioManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 512 "../src/Services/PulseAudioManager.vala"
		*array = g_renew (pa_card_port_info*, *array, *size);
#line 3945 "PulseAudioManager.c"
	}
#line 512 "../src/Services/PulseAudioManager.vala"
	(*array)[(*length)++] = value;
#line 3949 "PulseAudioManager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 3962 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_card_info* card,
                                              gint eol)
{
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_card_profile_info2* _tmp3_;
	const gchar* _tmp4_;
	pa_proplist* _tmp5_;
	const gchar* _tmp6_;
	pa_proplist* _tmp7_;
	const gchar* _tmp8_;
	gchar* card_active_profile_name = NULL;
	pa_card_profile_info2* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	pa_card_port_info** relevant_ports = NULL;
	pa_card_port_info** _tmp12_;
	gint relevant_ports_length1;
	gint _relevant_ports_size_;
	guint32 highest_output_priority = 0U;
	guint32 highest_input_priority = 0U;
	pa_card_port_info** _tmp13_;
	gint _tmp13__length1;
	GVariant* preferred_devices = NULL;
	GSettings* _tmp23_;
	GVariant* _tmp24_;
	GeeHashMap* preferred_device_map = NULL;
	GeeHashMap* _tmp25_;
	gint32 preferred_expiry = 0;
	pa_card_port_info** _tmp43_;
	gint _tmp43__length1;
	GeeHashMap* _tmp171_;
	pa_card_port_info** _tmp172_;
	gint _tmp172__length1;
	pa_card_info _tmp173_;
	GeeHashMap* _tmp174_;
	pa_card_port_info** _tmp175_;
	gint _tmp175__length1;
	pa_card_info _tmp176_;
#line 482 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 483 "../src/Services/PulseAudioManager.vala"
	if (card == NULL) {
#line 484 "../src/Services/PulseAudioManager.vala"
		return;
#line 4016 "PulseAudioManager.c"
	}
#line 487 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:487: card info update");
#line 488 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = (*card).proplist;
#line 488 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_DEVICE_DESCRIPTION);
#line 488 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = (*card).name;
#line 488 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:488: \tcard: %u %s (%s)", (guint) (*card).index, _tmp1_, _tmp2_);
#line 490 "../src/Services/PulseAudioManager.vala"
	_tmp3_ = (*card).active_profile2;
#line 490 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = (*_tmp3_).name;
#line 490 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:490: \t\tactive profile: %s", _tmp4_);
#line 492 "../src/Services/PulseAudioManager.vala"
	_tmp5_ = (*card).proplist;
#line 492 "../src/Services/PulseAudioManager.vala"
	_tmp6_ = pa_proplist_gets (_tmp5_, PA_PROP_DEVICE_FORM_FACTOR);
#line 492 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:492: \t\tcard form factor: %s", _tmp6_);
#line 493 "../src/Services/PulseAudioManager.vala"
	_tmp7_ = (*card).proplist;
#line 493 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = pa_proplist_gets (_tmp7_, PA_PROP_MEDIA_ICON_NAME);
#line 493 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:493: \t\tcard icon name: %s", _tmp8_);
#line 495 "../src/Services/PulseAudioManager.vala"
	_tmp9_ = (*card).active_profile2;
#line 495 "../src/Services/PulseAudioManager.vala"
	_tmp10_ = (*_tmp9_).name;
#line 495 "../src/Services/PulseAudioManager.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 495 "../src/Services/PulseAudioManager.vala"
	card_active_profile_name = _tmp11_;
#line 498 "../src/Services/PulseAudioManager.vala"
	_tmp12_ = g_new0 (pa_card_port_info*, 0);
#line 498 "../src/Services/PulseAudioManager.vala"
	relevant_ports = _tmp12_;
#line 498 "../src/Services/PulseAudioManager.vala"
	relevant_ports_length1 = 0;
#line 498 "../src/Services/PulseAudioManager.vala"
	_relevant_ports_size_ = relevant_ports_length1;
#line 499 "../src/Services/PulseAudioManager.vala"
	highest_output_priority = (guint32) 0;
#line 500 "../src/Services/PulseAudioManager.vala"
	highest_input_priority = (guint32) 0;
#line 501 "../src/Services/PulseAudioManager.vala"
	_tmp13_ = (*card).ports;
#line 501 "../src/Services/PulseAudioManager.vala"
	_tmp13__length1 = (*card).n_ports;
#line 4070 "PulseAudioManager.c"
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
#line 501 "../src/Services/PulseAudioManager.vala"
		port_collection = _tmp13_;
#line 501 "../src/Services/PulseAudioManager.vala"
		port_collection_length1 = _tmp13__length1;
#line 501 "../src/Services/PulseAudioManager.vala"
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 4082 "PulseAudioManager.c"
			pa_card_port_info* port = NULL;
#line 501 "../src/Services/PulseAudioManager.vala"
			port = port_collection[port_it];
#line 4086 "PulseAudioManager.c"
			{
				pa_card_port_info* _tmp14_;
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp15_;
				gboolean _tmp16_ = FALSE;
				gboolean _tmp19_ = FALSE;
				pa_card_port_info* _tmp22_;
#line 502 "../src/Services/PulseAudioManager.vala"
				_tmp14_ = port;
#line 502 "../src/Services/PulseAudioManager.vala"
				if ((*_tmp14_).available == PA_PORT_AVAILABLE_NO) {
#line 503 "../src/Services/PulseAudioManager.vala"
					continue;
#line 4100 "PulseAudioManager.c"
				}
#line 505 "../src/Services/PulseAudioManager.vala"
				_tmp15_ = port;
#line 505 "../src/Services/PulseAudioManager.vala"
				is_input = ((*_tmp15_).direction & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
#line 506 "../src/Services/PulseAudioManager.vala"
				if (is_input) {
#line 4108 "PulseAudioManager.c"
					pa_card_port_info* _tmp17_;
#line 506 "../src/Services/PulseAudioManager.vala"
					_tmp17_ = port;
#line 506 "../src/Services/PulseAudioManager.vala"
					_tmp16_ = (*_tmp17_).priority > highest_input_priority;
#line 4114 "PulseAudioManager.c"
				} else {
#line 506 "../src/Services/PulseAudioManager.vala"
					_tmp16_ = FALSE;
#line 4118 "PulseAudioManager.c"
				}
#line 506 "../src/Services/PulseAudioManager.vala"
				if (_tmp16_) {
#line 4122 "PulseAudioManager.c"
					pa_card_port_info* _tmp18_;
#line 507 "../src/Services/PulseAudioManager.vala"
					_tmp18_ = port;
#line 507 "../src/Services/PulseAudioManager.vala"
					highest_input_priority = (*_tmp18_).priority;
#line 4128 "PulseAudioManager.c"
				}
#line 509 "../src/Services/PulseAudioManager.vala"
				if (!is_input) {
#line 4132 "PulseAudioManager.c"
					pa_card_port_info* _tmp20_;
#line 509 "../src/Services/PulseAudioManager.vala"
					_tmp20_ = port;
#line 509 "../src/Services/PulseAudioManager.vala"
					_tmp19_ = (*_tmp20_).priority > highest_output_priority;
#line 4138 "PulseAudioManager.c"
				} else {
#line 509 "../src/Services/PulseAudioManager.vala"
					_tmp19_ = FALSE;
#line 4142 "PulseAudioManager.c"
				}
#line 509 "../src/Services/PulseAudioManager.vala"
				if (_tmp19_) {
#line 4146 "PulseAudioManager.c"
					pa_card_port_info* _tmp21_;
#line 510 "../src/Services/PulseAudioManager.vala"
					_tmp21_ = port;
#line 510 "../src/Services/PulseAudioManager.vala"
					highest_output_priority = (*_tmp21_).priority;
#line 4152 "PulseAudioManager.c"
				}
#line 512 "../src/Services/PulseAudioManager.vala"
				_tmp22_ = port;
#line 512 "../src/Services/PulseAudioManager.vala"
				_vala_array_add1 (&relevant_ports, &relevant_ports_length1, &_relevant_ports_size_, _tmp22_);
#line 4158 "PulseAudioManager.c"
			}
		}
	}
#line 516 "../src/Services/PulseAudioManager.vala"
	_tmp23_ = sound_indicator_settings;
#line 516 "../src/Services/PulseAudioManager.vala"
	_tmp24_ = g_settings_get_value (_tmp23_, "preferred-devices");
#line 516 "../src/Services/PulseAudioManager.vala"
	preferred_devices = _tmp24_;
#line 517 "../src/Services/PulseAudioManager.vala"
	_tmp25_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 517 "../src/Services/PulseAudioManager.vala"
	preferred_device_map = _tmp25_;
#line 518 "../src/Services/PulseAudioManager.vala"
	preferred_expiry = ((gint32) (g_get_real_time () / 1000000)) - (86400 * 7);
#line 4174 "PulseAudioManager.c"
	{
		GVariantIter* _dev_it = NULL;
		GVariant* _tmp26_;
		GVariantIter* _tmp27_;
		GVariant* dev = NULL;
#line 519 "../src/Services/PulseAudioManager.vala"
		_tmp26_ = preferred_devices;
#line 519 "../src/Services/PulseAudioManager.vala"
		_tmp27_ = g_variant_iter_new (_tmp26_);
#line 519 "../src/Services/PulseAudioManager.vala"
		_dev_it = _tmp27_;
#line 519 "../src/Services/PulseAudioManager.vala"
		while (TRUE) {
#line 4188 "PulseAudioManager.c"
			GVariantIter* _tmp28_;
			GVariant* _tmp29_;
			GVariant* _tmp30_;
			gchar* name = NULL;
			GVariant* _tmp31_;
			GVariant* _tmp32_;
			GVariant* _tmp33_;
			const gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gint32 last_used = 0;
			GVariant* _tmp37_;
			GVariant* _tmp38_;
			GVariant* _tmp39_;
			gint32 _tmp40_;
			GeeHashMap* _tmp41_;
			const gchar* _tmp42_;
#line 519 "../src/Services/PulseAudioManager.vala"
			_tmp28_ = _dev_it;
#line 519 "../src/Services/PulseAudioManager.vala"
			_tmp29_ = g_variant_iter_next_value (_tmp28_);
#line 519 "../src/Services/PulseAudioManager.vala"
			_g_variant_unref0 (dev);
#line 519 "../src/Services/PulseAudioManager.vala"
			dev = _tmp29_;
#line 519 "../src/Services/PulseAudioManager.vala"
			_tmp30_ = dev;
#line 519 "../src/Services/PulseAudioManager.vala"
			if (!(_tmp30_ != NULL)) {
#line 519 "../src/Services/PulseAudioManager.vala"
				break;
#line 4220 "PulseAudioManager.c"
			}
#line 520 "../src/Services/PulseAudioManager.vala"
			_tmp31_ = dev;
#line 520 "../src/Services/PulseAudioManager.vala"
			_tmp32_ = g_variant_get_child_value (_tmp31_, (gsize) 0);
#line 520 "../src/Services/PulseAudioManager.vala"
			_tmp33_ = _tmp32_;
#line 520 "../src/Services/PulseAudioManager.vala"
			_tmp34_ = g_variant_get_string (_tmp33_, NULL);
#line 520 "../src/Services/PulseAudioManager.vala"
			_tmp35_ = g_strdup (_tmp34_);
#line 520 "../src/Services/PulseAudioManager.vala"
			_tmp36_ = _tmp35_;
#line 520 "../src/Services/PulseAudioManager.vala"
			_g_variant_unref0 (_tmp33_);
#line 520 "../src/Services/PulseAudioManager.vala"
			name = _tmp36_;
#line 521 "../src/Services/PulseAudioManager.vala"
			_tmp37_ = dev;
#line 521 "../src/Services/PulseAudioManager.vala"
			_tmp38_ = g_variant_get_child_value (_tmp37_, (gsize) 1);
#line 521 "../src/Services/PulseAudioManager.vala"
			_tmp39_ = _tmp38_;
#line 521 "../src/Services/PulseAudioManager.vala"
			_tmp40_ = g_variant_get_int32 (_tmp39_);
#line 521 "../src/Services/PulseAudioManager.vala"
			_g_variant_unref0 (_tmp39_);
#line 521 "../src/Services/PulseAudioManager.vala"
			last_used = _tmp40_;
#line 522 "../src/Services/PulseAudioManager.vala"
			_tmp41_ = preferred_device_map;
#line 522 "../src/Services/PulseAudioManager.vala"
			_tmp42_ = name;
#line 522 "../src/Services/PulseAudioManager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, _tmp42_, (gpointer) ((gintptr) last_used));
#line 519 "../src/Services/PulseAudioManager.vala"
			_g_free0 (name);
#line 4258 "PulseAudioManager.c"
		}
#line 519 "../src/Services/PulseAudioManager.vala"
		_g_variant_unref0 (dev);
#line 519 "../src/Services/PulseAudioManager.vala"
		_g_variant_iter_free0 (_dev_it);
#line 4264 "PulseAudioManager.c"
	}
#line 526 "../src/Services/PulseAudioManager.vala"
	_tmp43_ = relevant_ports;
#line 526 "../src/Services/PulseAudioManager.vala"
	_tmp43__length1 = relevant_ports_length1;
#line 4270 "PulseAudioManager.c"
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
#line 526 "../src/Services/PulseAudioManager.vala"
		port_collection = _tmp43_;
#line 526 "../src/Services/PulseAudioManager.vala"
		port_collection_length1 = _tmp43__length1;
#line 526 "../src/Services/PulseAudioManager.vala"
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 4282 "PulseAudioManager.c"
			pa_card_port_info* port = NULL;
#line 526 "../src/Services/PulseAudioManager.vala"
			port = port_collection[port_it];
#line 4286 "PulseAudioManager.c"
			{
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp44_;
				const gchar* _tmp45_ = NULL;
				pa_card_port_info* _tmp46_;
				const gchar* _tmp47_;
				pa_card_port_info* _tmp48_;
				const gchar* _tmp49_;
				GeeHashMap* _tmp50_ = NULL;
				GeeHashMap* devices = NULL;
				GeeHashMap* _tmp53_;
				SoundDevice* device = NULL;
				gchar* id = NULL;
				pa_card_port_info* _tmp54_;
				pa_card_info _tmp55_;
				gchar* _tmp56_;
				gboolean is_new = FALSE;
				GeeHashMap* _tmp57_;
				const gchar* _tmp58_;
				SoundDevice* _tmp68_;
				const gchar* _tmp69_;
				SoundDevice* _tmp70_;
				guint32 _tmp71_ = 0U;
				SoundDevice* _tmp72_;
				pa_card_port_info* _tmp73_;
				gboolean _tmp74_ = FALSE;
				GeeHashMap* _tmp75_;
				GeeSet* _tmp76_;
				GeeSet* _tmp77_;
				GeeSet* _tmp78_;
				const gchar* _tmp79_;
				gboolean _tmp80_;
				gchar* card_description = NULL;
				pa_proplist* _tmp85_;
				const gchar* _tmp86_;
				gchar* _tmp87_;
				SoundDevice* _tmp88_;
				const gchar* _tmp89_;
				const gchar* _tmp90_;
				pa_card_port_info* _tmp91_;
				const gchar* _tmp92_;
				const gchar* _tmp93_;
				gchar* _tmp94_;
				gchar* _tmp95_;
				SoundDevice* _tmp96_;
				pa_card_port_info* _tmp97_;
				pa_proplist* _tmp98_;
				const gchar* _tmp99_;
				SoundDevice* _tmp100_;
				const gchar* _tmp101_;
				const gchar* _tmp102_;
				SoundDevice* _tmp106_;
				const gchar* _tmp107_;
				const gchar* _tmp108_;
				SoundDevice* _tmp109_;
				pa_card_port_info* _tmp110_;
				pa_proplist* _tmp111_;
				const gchar* _tmp112_;
				SoundDevice* _tmp113_;
				const gchar* _tmp114_;
				const gchar* _tmp115_;
				gboolean _tmp119_ = FALSE;
				SoundDevice* _tmp120_;
				const gchar* _tmp121_;
				const gchar* _tmp122_;
				SoundDevice* _tmp142_;
				const gchar* _tmp143_;
				const gchar* _tmp144_;
				gboolean _tmp147_ = FALSE;
				SoundDevice* _tmp152_;
				pa_card_port_info* _tmp153_;
				GeeArrayList* _tmp154_;
				GeeArrayList* _tmp155_;
#line 527 "../src/Services/PulseAudioManager.vala"
				_tmp44_ = port;
#line 527 "../src/Services/PulseAudioManager.vala"
				is_input = ((*_tmp44_).direction & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
#line 528 "../src/Services/PulseAudioManager.vala"
				if (is_input) {
#line 528 "../src/Services/PulseAudioManager.vala"
					_tmp45_ = "input";
#line 4368 "PulseAudioManager.c"
				} else {
#line 528 "../src/Services/PulseAudioManager.vala"
					_tmp45_ = "output";
#line 4372 "PulseAudioManager.c"
				}
#line 528 "../src/Services/PulseAudioManager.vala"
				_tmp46_ = port;
#line 528 "../src/Services/PulseAudioManager.vala"
				_tmp47_ = (*_tmp46_).description;
#line 528 "../src/Services/PulseAudioManager.vala"
				_tmp48_ = port;
#line 528 "../src/Services/PulseAudioManager.vala"
				_tmp49_ = (*_tmp48_).name;
#line 528 "../src/Services/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:528: \t\t%s port: %s (%s)", _tmp45_, _tmp47_, _tmp49_);
#line 529 "../src/Services/PulseAudioManager.vala"
				if (is_input) {
#line 4386 "PulseAudioManager.c"
					GeeHashMap* _tmp51_;
#line 529 "../src/Services/PulseAudioManager.vala"
					_tmp51_ = self->priv->input_devices;
#line 529 "../src/Services/PulseAudioManager.vala"
					_tmp50_ = _tmp51_;
#line 4392 "PulseAudioManager.c"
				} else {
					GeeHashMap* _tmp52_;
#line 529 "../src/Services/PulseAudioManager.vala"
					_tmp52_ = self->priv->output_devices;
#line 529 "../src/Services/PulseAudioManager.vala"
					_tmp50_ = _tmp52_;
#line 4399 "PulseAudioManager.c"
				}
#line 529 "../src/Services/PulseAudioManager.vala"
				_tmp53_ = _g_object_ref0 (_tmp50_);
#line 529 "../src/Services/PulseAudioManager.vala"
				devices = _tmp53_;
#line 530 "../src/Services/PulseAudioManager.vala"
				device = NULL;
#line 531 "../src/Services/PulseAudioManager.vala"
				_tmp54_ = port;
#line 531 "../src/Services/PulseAudioManager.vala"
				_tmp55_ = *card;
#line 531 "../src/Services/PulseAudioManager.vala"
				_tmp56_ = sound_pulse_audio_manager_get_device_id (&_tmp55_, _tmp54_);
#line 531 "../src/Services/PulseAudioManager.vala"
				id = _tmp56_;
#line 532 "../src/Services/PulseAudioManager.vala"
				_tmp57_ = devices;
#line 532 "../src/Services/PulseAudioManager.vala"
				_tmp58_ = id;
#line 532 "../src/Services/PulseAudioManager.vala"
				is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp57_, _tmp58_);
#line 533 "../src/Services/PulseAudioManager.vala"
				if (is_new) {
#line 4423 "PulseAudioManager.c"
					const gchar* _tmp59_;
					const gchar* _tmp60_;
					pa_card_port_info* _tmp61_;
					const gchar* _tmp62_;
					SoundDevice* _tmp63_;
#line 534 "../src/Services/PulseAudioManager.vala"
					_tmp59_ = id;
#line 534 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:534: \t\t\tnew device: %s", _tmp59_);
#line 535 "../src/Services/PulseAudioManager.vala"
					_tmp60_ = id;
#line 535 "../src/Services/PulseAudioManager.vala"
					_tmp61_ = port;
#line 535 "../src/Services/PulseAudioManager.vala"
					_tmp62_ = (*_tmp61_).name;
#line 535 "../src/Services/PulseAudioManager.vala"
					_tmp63_ = sound_device_new (_tmp60_, (*card).index, _tmp62_);
#line 535 "../src/Services/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 535 "../src/Services/PulseAudioManager.vala"
					device = _tmp63_;
#line 4445 "PulseAudioManager.c"
				} else {
					const gchar* _tmp64_;
					GeeHashMap* _tmp65_;
					const gchar* _tmp66_;
					gpointer _tmp67_;
#line 537 "../src/Services/PulseAudioManager.vala"
					_tmp64_ = id;
#line 537 "../src/Services/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:537: \t\t\tupdating device: %s", _tmp64_);
#line 538 "../src/Services/PulseAudioManager.vala"
					_tmp65_ = devices;
#line 538 "../src/Services/PulseAudioManager.vala"
					_tmp66_ = id;
#line 538 "../src/Services/PulseAudioManager.vala"
					_tmp67_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp65_, _tmp66_);
#line 538 "../src/Services/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 538 "../src/Services/PulseAudioManager.vala"
					device = (SoundDevice*) _tmp67_;
#line 4465 "PulseAudioManager.c"
				}
#line 541 "../src/Services/PulseAudioManager.vala"
				_tmp68_ = device;
#line 541 "../src/Services/PulseAudioManager.vala"
				_tmp69_ = card_active_profile_name;
#line 541 "../src/Services/PulseAudioManager.vala"
				sound_device_set_card_active_profile_name (_tmp68_, _tmp69_);
#line 542 "../src/Services/PulseAudioManager.vala"
				_tmp70_ = device;
#line 542 "../src/Services/PulseAudioManager.vala"
				sound_device_set_input (_tmp70_, is_input);
#line 543 "../src/Services/PulseAudioManager.vala"
				if (is_input) {
#line 543 "../src/Services/PulseAudioManager.vala"
					_tmp71_ = highest_input_priority;
#line 4481 "PulseAudioManager.c"
				} else {
#line 543 "../src/Services/PulseAudioManager.vala"
					_tmp71_ = highest_output_priority;
#line 4485 "PulseAudioManager.c"
				}
#line 543 "../src/Services/PulseAudioManager.vala"
				_tmp72_ = device;
#line 543 "../src/Services/PulseAudioManager.vala"
				_tmp73_ = port;
#line 543 "../src/Services/PulseAudioManager.vala"
				sound_device_set_is_priority (_tmp72_, (*_tmp73_).priority == _tmp71_);
#line 545 "../src/Services/PulseAudioManager.vala"
				_tmp75_ = preferred_device_map;
#line 545 "../src/Services/PulseAudioManager.vala"
				_tmp76_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp75_);
#line 545 "../src/Services/PulseAudioManager.vala"
				_tmp77_ = _tmp76_;
#line 545 "../src/Services/PulseAudioManager.vala"
				_tmp78_ = _tmp77_;
#line 545 "../src/Services/PulseAudioManager.vala"
				_tmp79_ = id;
#line 545 "../src/Services/PulseAudioManager.vala"
				_tmp80_ = gee_collection_contains ((GeeCollection*) _tmp78_, _tmp79_);
#line 545 "../src/Services/PulseAudioManager.vala"
				_g_object_unref0 (_tmp78_);
#line 545 "../src/Services/PulseAudioManager.vala"
				if (_tmp80_) {
#line 4509 "PulseAudioManager.c"
					GeeHashMap* _tmp81_;
					const gchar* _tmp82_;
					gpointer _tmp83_;
#line 545 "../src/Services/PulseAudioManager.vala"
					_tmp81_ = preferred_device_map;
#line 545 "../src/Services/PulseAudioManager.vala"
					_tmp82_ = id;
#line 545 "../src/Services/PulseAudioManager.vala"
					_tmp83_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp81_, _tmp82_);
#line 545 "../src/Services/PulseAudioManager.vala"
					_tmp74_ = ((gint32) ((gintptr) _tmp83_)) > preferred_expiry;
#line 4521 "PulseAudioManager.c"
				} else {
#line 545 "../src/Services/PulseAudioManager.vala"
					_tmp74_ = FALSE;
#line 4525 "PulseAudioManager.c"
				}
#line 545 "../src/Services/PulseAudioManager.vala"
				if (_tmp74_) {
#line 4529 "PulseAudioManager.c"
					SoundDevice* _tmp84_;
#line 546 "../src/Services/PulseAudioManager.vala"
					_tmp84_ = device;
#line 546 "../src/Services/PulseAudioManager.vala"
					sound_device_set_is_priority (_tmp84_, TRUE);
#line 4535 "PulseAudioManager.c"
				}
#line 548 "../src/Services/PulseAudioManager.vala"
				_tmp85_ = (*card).proplist;
#line 548 "../src/Services/PulseAudioManager.vala"
				_tmp86_ = pa_proplist_gets (_tmp85_, PA_PROP_DEVICE_DESCRIPTION);
#line 548 "../src/Services/PulseAudioManager.vala"
				_tmp87_ = g_strdup (_tmp86_);
#line 548 "../src/Services/PulseAudioManager.vala"
				card_description = _tmp87_;
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp88_ = device;
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp89_ = card_description;
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp90_ = string_to_string (_tmp89_);
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp91_ = port;
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp92_ = (*_tmp91_).description;
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp93_ = string_to_string (_tmp92_);
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp94_ = g_strconcat (_tmp90_, ": ", _tmp93_, NULL);
#line 549 "../src/Services/PulseAudioManager.vala"
				_tmp95_ = _tmp94_;
#line 549 "../src/Services/PulseAudioManager.vala"
				sound_device_set_display_name (_tmp88_, _tmp95_);
#line 549 "../src/Services/PulseAudioManager.vala"
				_g_free0 (_tmp95_);
#line 550 "../src/Services/PulseAudioManager.vala"
				_tmp96_ = device;
#line 550 "../src/Services/PulseAudioManager.vala"
				_tmp97_ = port;
#line 550 "../src/Services/PulseAudioManager.vala"
				_tmp98_ = (*_tmp97_).proplist;
#line 550 "../src/Services/PulseAudioManager.vala"
				_tmp99_ = pa_proplist_gets (_tmp98_, PA_PROP_DEVICE_FORM_FACTOR);
#line 550 "../src/Services/PulseAudioManager.vala"
				sound_device_set_form_factor (_tmp96_, _tmp99_);
#line 551 "../src/Services/PulseAudioManager.vala"
				_tmp100_ = device;
#line 551 "../src/Services/PulseAudioManager.vala"
				_tmp101_ = sound_device_get_form_factor (_tmp100_);
#line 551 "../src/Services/PulseAudioManager.vala"
				_tmp102_ = _tmp101_;
#line 551 "../src/Services/PulseAudioManager.vala"
				if (_tmp102_ == NULL) {
#line 4583 "PulseAudioManager.c"
					SoundDevice* _tmp103_;
					pa_proplist* _tmp104_;
					const gchar* _tmp105_;
#line 552 "../src/Services/PulseAudioManager.vala"
					_tmp103_ = device;
#line 552 "../src/Services/PulseAudioManager.vala"
					_tmp104_ = (*card).proplist;
#line 552 "../src/Services/PulseAudioManager.vala"
					_tmp105_ = pa_proplist_gets (_tmp104_, PA_PROP_DEVICE_FORM_FACTOR);
#line 552 "../src/Services/PulseAudioManager.vala"
					sound_device_set_form_factor (_tmp103_, _tmp105_);
#line 4595 "PulseAudioManager.c"
				}
#line 554 "../src/Services/PulseAudioManager.vala"
				_tmp106_ = device;
#line 554 "../src/Services/PulseAudioManager.vala"
				_tmp107_ = sound_device_get_form_factor (_tmp106_);
#line 554 "../src/Services/PulseAudioManager.vala"
				_tmp108_ = _tmp107_;
#line 554 "../src/Services/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:554: \t\t\tform factor: %s", _tmp108_);
#line 556 "../src/Services/PulseAudioManager.vala"
				_tmp109_ = device;
#line 556 "../src/Services/PulseAudioManager.vala"
				_tmp110_ = port;
#line 556 "../src/Services/PulseAudioManager.vala"
				_tmp111_ = (*_tmp110_).proplist;
#line 556 "../src/Services/PulseAudioManager.vala"
				_tmp112_ = pa_proplist_gets (_tmp111_, PA_PROP_DEVICE_ICON_NAME);
#line 556 "../src/Services/PulseAudioManager.vala"
				sound_device_set_icon_name (_tmp109_, _tmp112_);
#line 557 "../src/Services/PulseAudioManager.vala"
				_tmp113_ = device;
#line 557 "../src/Services/PulseAudioManager.vala"
				_tmp114_ = sound_device_get_icon_name (_tmp113_);
#line 557 "../src/Services/PulseAudioManager.vala"
				_tmp115_ = _tmp114_;
#line 557 "../src/Services/PulseAudioManager.vala"
				if (_tmp115_ == NULL) {
#line 4623 "PulseAudioManager.c"
					SoundDevice* _tmp116_;
					pa_proplist* _tmp117_;
					const gchar* _tmp118_;
#line 558 "../src/Services/PulseAudioManager.vala"
					_tmp116_ = device;
#line 558 "../src/Services/PulseAudioManager.vala"
					_tmp117_ = (*card).proplist;
#line 558 "../src/Services/PulseAudioManager.vala"
					_tmp118_ = pa_proplist_gets (_tmp117_, PA_PROP_DEVICE_ICON_NAME);
#line 558 "../src/Services/PulseAudioManager.vala"
					sound_device_set_icon_name (_tmp116_, _tmp118_);
#line 4635 "PulseAudioManager.c"
				}
#line 562 "../src/Services/PulseAudioManager.vala"
				_tmp120_ = device;
#line 562 "../src/Services/PulseAudioManager.vala"
				_tmp121_ = sound_device_get_icon_name (_tmp120_);
#line 562 "../src/Services/PulseAudioManager.vala"
				_tmp122_ = _tmp121_;
#line 562 "../src/Services/PulseAudioManager.vala"
				if (_tmp122_ == NULL) {
#line 4645 "PulseAudioManager.c"
					SoundDevice* _tmp123_;
					const gchar* _tmp124_;
					const gchar* _tmp125_;
#line 562 "../src/Services/PulseAudioManager.vala"
					_tmp123_ = device;
#line 562 "../src/Services/PulseAudioManager.vala"
					_tmp124_ = sound_device_get_form_factor (_tmp123_);
#line 562 "../src/Services/PulseAudioManager.vala"
					_tmp125_ = _tmp124_;
#line 562 "../src/Services/PulseAudioManager.vala"
					_tmp119_ = _tmp125_ != NULL;
#line 4657 "PulseAudioManager.c"
				} else {
#line 562 "../src/Services/PulseAudioManager.vala"
					_tmp119_ = FALSE;
#line 4661 "PulseAudioManager.c"
				}
#line 562 "../src/Services/PulseAudioManager.vala"
				if (_tmp119_) {
#line 4665 "PulseAudioManager.c"
					SoundDevice* _tmp126_;
					const gchar* _tmp127_;
					const gchar* _tmp128_;
					const gchar* _tmp129_;
					GQuark _tmp131_ = 0U;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label0 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label1 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label2 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label3 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label4 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label5 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label6 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label7 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label8 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label9 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label10 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label11 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					static GQuark _tmp130_label12 = 0;
#line 563 "../src/Services/PulseAudioManager.vala"
					_tmp126_ = device;
#line 563 "../src/Services/PulseAudioManager.vala"
					_tmp127_ = sound_device_get_form_factor (_tmp126_);
#line 563 "../src/Services/PulseAudioManager.vala"
					_tmp128_ = _tmp127_;
#line 563 "../src/Services/PulseAudioManager.vala"
					_tmp129_ = _tmp128_;
#line 563 "../src/Services/PulseAudioManager.vala"
					_tmp131_ = (NULL == _tmp129_) ? 0 : g_quark_from_string (_tmp129_);
#line 563 "../src/Services/PulseAudioManager.vala"
					if (_tmp131_ == ((0 != _tmp130_label0) ? _tmp130_label0 : (_tmp130_label0 = g_quark_from_static_string ("car")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4711 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp132_;
#line 565 "../src/Services/PulseAudioManager.vala"
								_tmp132_ = device;
#line 565 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp132_, "audio-car");
#line 566 "../src/Services/PulseAudioManager.vala"
								break;
#line 4721 "PulseAudioManager.c"
							}
						}
					} else if ((_tmp131_ == ((0 != _tmp130_label1) ? _tmp130_label1 : (_tmp130_label1 = g_quark_from_static_string ("computer")))) || (_tmp131_ == ((0 != _tmp130_label2) ? _tmp130_label2 : (_tmp130_label2 = g_quark_from_static_string ("internal"))))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4727 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp133_;
#line 569 "../src/Services/PulseAudioManager.vala"
								_tmp133_ = device;
#line 569 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp133_, "computer");
#line 570 "../src/Services/PulseAudioManager.vala"
								break;
#line 4737 "PulseAudioManager.c"
							}
						}
					} else if (_tmp131_ == ((0 != _tmp130_label3) ? _tmp130_label3 : (_tmp130_label3 = g_quark_from_static_string ("handset")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4743 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp134_;
#line 572 "../src/Services/PulseAudioManager.vala"
								_tmp134_ = device;
#line 572 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp134_, "phone");
#line 573 "../src/Services/PulseAudioManager.vala"
								break;
#line 4753 "PulseAudioManager.c"
							}
						}
					} else if (_tmp131_ == ((0 != _tmp130_label4) ? _tmp130_label4 : (_tmp130_label4 = g_quark_from_static_string ("headphone")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4759 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp135_;
#line 575 "../src/Services/PulseAudioManager.vala"
								_tmp135_ = device;
#line 575 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp135_, "audio-headphones");
#line 576 "../src/Services/PulseAudioManager.vala"
								break;
#line 4769 "PulseAudioManager.c"
							}
						}
					} else if ((_tmp131_ == ((0 != _tmp130_label5) ? _tmp130_label5 : (_tmp130_label5 = g_quark_from_static_string ("hands-free")))) || (_tmp131_ == ((0 != _tmp130_label6) ? _tmp130_label6 : (_tmp130_label6 = g_quark_from_static_string ("headset"))))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4775 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp136_;
#line 579 "../src/Services/PulseAudioManager.vala"
								_tmp136_ = device;
#line 579 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp136_, "audio-headset");
#line 580 "../src/Services/PulseAudioManager.vala"
								break;
#line 4785 "PulseAudioManager.c"
							}
						}
					} else if (_tmp131_ == ((0 != _tmp130_label7) ? _tmp130_label7 : (_tmp130_label7 = g_quark_from_static_string ("hifi")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4791 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp137_;
#line 582 "../src/Services/PulseAudioManager.vala"
								_tmp137_ = device;
#line 582 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp137_, "audio-subwoofer");
#line 583 "../src/Services/PulseAudioManager.vala"
								break;
#line 4801 "PulseAudioManager.c"
							}
						}
					} else if (_tmp131_ == ((0 != _tmp130_label8) ? _tmp130_label8 : (_tmp130_label8 = g_quark_from_static_string ("microphone")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4807 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp138_;
#line 585 "../src/Services/PulseAudioManager.vala"
								_tmp138_ = device;
#line 585 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp138_, "audio-input-microphone");
#line 586 "../src/Services/PulseAudioManager.vala"
								break;
#line 4817 "PulseAudioManager.c"
							}
						}
					} else if ((_tmp131_ == ((0 != _tmp130_label9) ? _tmp130_label9 : (_tmp130_label9 = g_quark_from_static_string ("portable")))) || (_tmp131_ == ((0 != _tmp130_label10) ? _tmp130_label10 : (_tmp130_label10 = g_quark_from_static_string ("speaker"))))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4823 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp139_;
#line 589 "../src/Services/PulseAudioManager.vala"
								_tmp139_ = device;
#line 589 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp139_, "bluetooth");
#line 590 "../src/Services/PulseAudioManager.vala"
								break;
#line 4833 "PulseAudioManager.c"
							}
						}
					} else if (_tmp131_ == ((0 != _tmp130_label11) ? _tmp130_label11 : (_tmp130_label11 = g_quark_from_static_string ("tv")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4839 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp140_;
#line 592 "../src/Services/PulseAudioManager.vala"
								_tmp140_ = device;
#line 592 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp140_, "video-display-tv");
#line 593 "../src/Services/PulseAudioManager.vala"
								break;
#line 4849 "PulseAudioManager.c"
							}
						}
					} else if (_tmp131_ == ((0 != _tmp130_label12) ? _tmp130_label12 : (_tmp130_label12 = g_quark_from_static_string ("webcam")))) {
#line 563 "../src/Services/PulseAudioManager.vala"
						switch (0) {
#line 4855 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp141_;
#line 595 "../src/Services/PulseAudioManager.vala"
								_tmp141_ = device;
#line 595 "../src/Services/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp141_, "camera-web");
#line 596 "../src/Services/PulseAudioManager.vala"
								break;
#line 4865 "PulseAudioManager.c"
							}
						}
					}
				}
#line 601 "../src/Services/PulseAudioManager.vala"
				_tmp142_ = device;
#line 601 "../src/Services/PulseAudioManager.vala"
				_tmp143_ = sound_device_get_icon_name (_tmp142_);
#line 601 "../src/Services/PulseAudioManager.vala"
				_tmp144_ = _tmp143_;
#line 601 "../src/Services/PulseAudioManager.vala"
				if (_tmp144_ == NULL) {
#line 4878 "PulseAudioManager.c"
					const gchar* _tmp145_ = NULL;
					SoundDevice* _tmp146_;
#line 602 "../src/Services/PulseAudioManager.vala"
					if (is_input) {
#line 602 "../src/Services/PulseAudioManager.vala"
						_tmp145_ = "audio-input-microphone";
#line 4885 "PulseAudioManager.c"
					} else {
#line 602 "../src/Services/PulseAudioManager.vala"
						_tmp145_ = "audio-card";
#line 4889 "PulseAudioManager.c"
					}
#line 602 "../src/Services/PulseAudioManager.vala"
					_tmp146_ = device;
#line 602 "../src/Services/PulseAudioManager.vala"
					sound_device_set_icon_name (_tmp146_, _tmp145_);
#line 4895 "PulseAudioManager.c"
				}
#line 606 "../src/Services/PulseAudioManager.vala"
				if (is_input) {
#line 4899 "PulseAudioManager.c"
					SoundDevice* _tmp148_;
					const gchar* _tmp149_;
					const gchar* _tmp150_;
#line 606 "../src/Services/PulseAudioManager.vala"
					_tmp148_ = device;
#line 606 "../src/Services/PulseAudioManager.vala"
					_tmp149_ = sound_device_get_icon_name (_tmp148_);
#line 606 "../src/Services/PulseAudioManager.vala"
					_tmp150_ = _tmp149_;
#line 606 "../src/Services/PulseAudioManager.vala"
					_tmp147_ = g_str_has_prefix (_tmp150_, "audio-card");
#line 4911 "PulseAudioManager.c"
				} else {
#line 606 "../src/Services/PulseAudioManager.vala"
					_tmp147_ = FALSE;
#line 4915 "PulseAudioManager.c"
				}
#line 606 "../src/Services/PulseAudioManager.vala"
				if (_tmp147_) {
#line 4919 "PulseAudioManager.c"
					SoundDevice* _tmp151_;
#line 607 "../src/Services/PulseAudioManager.vala"
					_tmp151_ = device;
#line 607 "../src/Services/PulseAudioManager.vala"
					sound_device_set_icon_name (_tmp151_, "audio-input-microphone");
#line 4925 "PulseAudioManager.c"
				}
#line 610 "../src/Services/PulseAudioManager.vala"
				_tmp152_ = device;
#line 610 "../src/Services/PulseAudioManager.vala"
				_tmp153_ = port;
#line 610 "../src/Services/PulseAudioManager.vala"
				_tmp154_ = sound_pulse_audio_manager_get_relevant_card_port_profiles (self, _tmp153_);
#line 610 "../src/Services/PulseAudioManager.vala"
				_tmp155_ = _tmp154_;
#line 610 "../src/Services/PulseAudioManager.vala"
				sound_device_set_profiles (_tmp152_, _tmp155_);
#line 610 "../src/Services/PulseAudioManager.vala"
				_g_object_unref0 (_tmp155_);
#line 611 "../src/Services/PulseAudioManager.vala"
				if (sound_pulse_audio_manager_debug_enabled) {
#line 4941 "PulseAudioManager.c"
					{
						GeeArrayList* _profile_list = NULL;
						SoundDevice* _tmp156_;
						GeeArrayList* _tmp157_;
						GeeArrayList* _tmp158_;
						gint _profile_size = 0;
						GeeArrayList* _tmp159_;
						gint _tmp160_;
						gint _tmp161_;
						gint _profile_index = 0;
#line 612 "../src/Services/PulseAudioManager.vala"
						_tmp156_ = device;
#line 612 "../src/Services/PulseAudioManager.vala"
						_tmp157_ = sound_device_get_profiles (_tmp156_);
#line 612 "../src/Services/PulseAudioManager.vala"
						_tmp158_ = _tmp157_;
#line 612 "../src/Services/PulseAudioManager.vala"
						_profile_list = _tmp158_;
#line 612 "../src/Services/PulseAudioManager.vala"
						_tmp159_ = _profile_list;
#line 612 "../src/Services/PulseAudioManager.vala"
						_tmp160_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp159_);
#line 612 "../src/Services/PulseAudioManager.vala"
						_tmp161_ = _tmp160_;
#line 612 "../src/Services/PulseAudioManager.vala"
						_profile_size = _tmp161_;
#line 612 "../src/Services/PulseAudioManager.vala"
						_profile_index = -1;
#line 612 "../src/Services/PulseAudioManager.vala"
						while (TRUE) {
#line 4972 "PulseAudioManager.c"
							gint _tmp162_;
							gint _tmp163_;
							gchar* profile = NULL;
							GeeArrayList* _tmp164_;
							gpointer _tmp165_;
							const gchar* _tmp166_;
#line 612 "../src/Services/PulseAudioManager.vala"
							_profile_index = _profile_index + 1;
#line 612 "../src/Services/PulseAudioManager.vala"
							_tmp162_ = _profile_index;
#line 612 "../src/Services/PulseAudioManager.vala"
							_tmp163_ = _profile_size;
#line 612 "../src/Services/PulseAudioManager.vala"
							if (!(_tmp162_ < _tmp163_)) {
#line 612 "../src/Services/PulseAudioManager.vala"
								break;
#line 4989 "PulseAudioManager.c"
							}
#line 612 "../src/Services/PulseAudioManager.vala"
							_tmp164_ = _profile_list;
#line 612 "../src/Services/PulseAudioManager.vala"
							_tmp165_ = gee_abstract_list_get ((GeeAbstractList*) _tmp164_, _profile_index);
#line 612 "../src/Services/PulseAudioManager.vala"
							profile = (gchar*) _tmp165_;
#line 613 "../src/Services/PulseAudioManager.vala"
							_tmp166_ = profile;
#line 613 "../src/Services/PulseAudioManager.vala"
							g_debug ("PulseAudioManager.vala:613: \t\t\tprofile: %s", _tmp166_);
#line 612 "../src/Services/PulseAudioManager.vala"
							_g_free0 (profile);
#line 5003 "PulseAudioManager.c"
						}
					}
				}
#line 617 "../src/Services/PulseAudioManager.vala"
				if (is_new) {
#line 5009 "PulseAudioManager.c"
					GeeHashMap* _tmp167_;
					const gchar* _tmp168_;
					SoundDevice* _tmp169_;
					SoundDevice* _tmp170_;
#line 618 "../src/Services/PulseAudioManager.vala"
					_tmp167_ = devices;
#line 618 "../src/Services/PulseAudioManager.vala"
					_tmp168_ = id;
#line 618 "../src/Services/PulseAudioManager.vala"
					_tmp169_ = device;
#line 618 "../src/Services/PulseAudioManager.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp167_, _tmp168_, _tmp169_);
#line 619 "../src/Services/PulseAudioManager.vala"
					_tmp170_ = device;
#line 619 "../src/Services/PulseAudioManager.vala"
					g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp170_);
#line 5026 "PulseAudioManager.c"
				}
#line 526 "../src/Services/PulseAudioManager.vala"
				_g_free0 (card_description);
#line 526 "../src/Services/PulseAudioManager.vala"
				_g_free0 (id);
#line 526 "../src/Services/PulseAudioManager.vala"
				_g_object_unref0 (device);
#line 526 "../src/Services/PulseAudioManager.vala"
				_g_object_unref0 (devices);
#line 5036 "PulseAudioManager.c"
			}
		}
	}
#line 623 "../src/Services/PulseAudioManager.vala"
	_tmp171_ = self->priv->output_devices;
#line 623 "../src/Services/PulseAudioManager.vala"
	_tmp172_ = relevant_ports;
#line 623 "../src/Services/PulseAudioManager.vala"
	_tmp172__length1 = relevant_ports_length1;
#line 623 "../src/Services/PulseAudioManager.vala"
	_tmp173_ = *card;
#line 623 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_cleanup_devices (self, _tmp171_, &_tmp173_, _tmp172_, (gint) _tmp172__length1);
#line 624 "../src/Services/PulseAudioManager.vala"
	_tmp174_ = self->priv->input_devices;
#line 624 "../src/Services/PulseAudioManager.vala"
	_tmp175_ = relevant_ports;
#line 624 "../src/Services/PulseAudioManager.vala"
	_tmp175__length1 = relevant_ports_length1;
#line 624 "../src/Services/PulseAudioManager.vala"
	_tmp176_ = *card;
#line 624 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_cleanup_devices (self, _tmp174_, &_tmp176_, _tmp175_, (gint) _tmp175__length1);
#line 482 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (preferred_device_map);
#line 482 "../src/Services/PulseAudioManager.vala"
	_g_variant_unref0 (preferred_devices);
#line 482 "../src/Services/PulseAudioManager.vala"
	relevant_ports = (g_free (relevant_ports), NULL);
#line 482 "../src/Services/PulseAudioManager.vala"
	_g_free0 (card_active_profile_name);
#line 5068 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                           GeeHashMap* devices,
                                           pa_card_info* card,
                                           pa_card_port_info** relevant_ports,
                                           gint relevant_ports_length1)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
#line 628 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 628 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (devices != NULL);
#line 628 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (card != NULL);
#line 631 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
#line 631 "../src/Services/PulseAudioManager.vala"
	iter = _tmp0_;
#line 632 "../src/Services/PulseAudioManager.vala"
	while (TRUE) {
#line 5092 "PulseAudioManager.c"
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		pa_card_info _tmp7_;
		gboolean found = FALSE;
#line 632 "../src/Services/PulseAudioManager.vala"
		_tmp1_ = iter;
#line 632 "../src/Services/PulseAudioManager.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 632 "../src/Services/PulseAudioManager.vala"
			break;
#line 5108 "PulseAudioManager.c"
		}
#line 633 "../src/Services/PulseAudioManager.vala"
		_tmp2_ = iter;
#line 633 "../src/Services/PulseAudioManager.vala"
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
#line 633 "../src/Services/PulseAudioManager.vala"
		device = (SoundDevice*) _tmp3_;
#line 634 "../src/Services/PulseAudioManager.vala"
		_tmp4_ = device;
#line 634 "../src/Services/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_card_index (_tmp4_);
#line 634 "../src/Services/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 634 "../src/Services/PulseAudioManager.vala"
		_tmp7_ = *card;
#line 634 "../src/Services/PulseAudioManager.vala"
		if (_tmp6_ != _tmp7_.index) {
#line 635 "../src/Services/PulseAudioManager.vala"
			_g_object_unref0 (device);
#line 635 "../src/Services/PulseAudioManager.vala"
			continue;
#line 5130 "PulseAudioManager.c"
		}
#line 639 "../src/Services/PulseAudioManager.vala"
		found = FALSE;
#line 5134 "PulseAudioManager.c"
		{
			pa_card_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 640 "../src/Services/PulseAudioManager.vala"
			port_collection = relevant_ports;
#line 640 "../src/Services/PulseAudioManager.vala"
			port_collection_length1 = relevant_ports_length1;
#line 640 "../src/Services/PulseAudioManager.vala"
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 5146 "PulseAudioManager.c"
				pa_card_port_info* port = NULL;
#line 640 "../src/Services/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 5150 "PulseAudioManager.c"
				{
					SoundDevice* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					pa_card_info _tmp11_;
					pa_card_port_info* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp8_ = device;
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp9_ = sound_device_get_id (_tmp8_);
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp10_ = _tmp9_;
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp11_ = *card;
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp12_ = port;
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp13_ = sound_pulse_audio_manager_get_device_id (&_tmp11_, _tmp12_);
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp14_ = _tmp13_;
#line 641 "../src/Services/PulseAudioManager.vala"
					_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
#line 641 "../src/Services/PulseAudioManager.vala"
					_g_free0 (_tmp14_);
#line 641 "../src/Services/PulseAudioManager.vala"
					if (_tmp15_) {
#line 642 "../src/Services/PulseAudioManager.vala"
						found = TRUE;
#line 643 "../src/Services/PulseAudioManager.vala"
						break;
#line 5184 "PulseAudioManager.c"
					}
				}
			}
		}
#line 647 "../src/Services/PulseAudioManager.vala"
		if (!found) {
#line 5191 "PulseAudioManager.c"
			SoundDevice* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			SoundDevice* _tmp19_;
			GeeMapIterator* _tmp20_;
#line 648 "../src/Services/PulseAudioManager.vala"
			_tmp16_ = device;
#line 648 "../src/Services/PulseAudioManager.vala"
			_tmp17_ = sound_device_get_id (_tmp16_);
#line 648 "../src/Services/PulseAudioManager.vala"
			_tmp18_ = _tmp17_;
#line 648 "../src/Services/PulseAudioManager.vala"
			g_debug ("PulseAudioManager.vala:648: \t\tremoving device: %s", _tmp18_);
#line 649 "../src/Services/PulseAudioManager.vala"
			_tmp19_ = device;
#line 649 "../src/Services/PulseAudioManager.vala"
			g_signal_emit_by_name (_tmp19_, "removed");
#line 650 "../src/Services/PulseAudioManager.vala"
			_tmp20_ = iter;
#line 650 "../src/Services/PulseAudioManager.vala"
			gee_map_iterator_unset (_tmp20_);
#line 5213 "PulseAudioManager.c"
		}
#line 632 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (device);
#line 5217 "PulseAudioManager.c"
	}
#line 628 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (iter);
#line 5221 "PulseAudioManager.c"
}

static gchar*
sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                         pa_card_port_info* port)
{
	pa_card_info _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 655 "../src/Services/PulseAudioManager.vala"
	g_return_val_if_fail (card != NULL, NULL);
#line 656 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = *card;
#line 656 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = _tmp0_.name;
#line 656 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 656 "../src/Services/PulseAudioManager.vala"
	_tmp3_ = (*port).name;
#line 656 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 656 "../src/Services/PulseAudioManager.vala"
	_tmp5_ = g_strconcat (_tmp2_, ":", _tmp4_, NULL);
#line 656 "../src/Services/PulseAudioManager.vala"
	result = _tmp5_;
#line 656 "../src/Services/PulseAudioManager.vala"
	return result;
#line 5253 "PulseAudioManager.c"
}

static pa_card_profile_info2**
_vala_array_dup1 (pa_card_profile_info2** self,
                  gssize length)
{
#line 660 "../src/Services/PulseAudioManager.vala"
	if (length > 0) {
#line 660 "../src/Services/PulseAudioManager.vala"
		return _vala_memdup2 (self, length * sizeof (pa_card_profile_info2*));
#line 5264 "PulseAudioManager.c"
	}
#line 660 "../src/Services/PulseAudioManager.vala"
	return NULL;
#line 5268 "PulseAudioManager.c"
}

static gint
__lambda45_ (SoundPulseAudioManager* self,
             pa_card_profile_info2* a,
             pa_card_profile_info2* b)
{
	gint result;
#line 664 "../src/Services/PulseAudioManager.vala"
	if ((*a).priority > (*b).priority) {
#line 665 "../src/Services/PulseAudioManager.vala"
		result = -1;
#line 665 "../src/Services/PulseAudioManager.vala"
		return result;
#line 5283 "PulseAudioManager.c"
	}
#line 668 "../src/Services/PulseAudioManager.vala"
	if ((*a).priority < (*b).priority) {
#line 669 "../src/Services/PulseAudioManager.vala"
		result = 1;
#line 669 "../src/Services/PulseAudioManager.vala"
		return result;
#line 5291 "PulseAudioManager.c"
	}
#line 672 "../src/Services/PulseAudioManager.vala"
	result = 0;
#line 672 "../src/Services/PulseAudioManager.vala"
	return result;
#line 5297 "PulseAudioManager.c"
}

static gint
___lambda45__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda45_ ((SoundPulseAudioManager*) self, a, b);
#line 663 "../src/Services/PulseAudioManager.vala"
	return result;
#line 5309 "PulseAudioManager.c"
}

static GeeArrayList*
sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                           pa_card_port_info* port)
{
	GeeArrayList* profiles_list = NULL;
	pa_card_profile_info2** _tmp0_;
	gint _tmp0__length1;
	pa_card_profile_info2** _tmp1_;
	gint _tmp1__length1;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* profiles = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* result;
#line 659 "../src/Services/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 660 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = (*port).profiles2;
#line 660 "../src/Services/PulseAudioManager.vala"
	_tmp0__length1 = (*port).n_profiles;
#line 660 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 660 "../src/Services/PulseAudioManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 660 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = gee_array_list_new_wrap (G_TYPE_POINTER, NULL, NULL, _tmp1_, _tmp1__length1, NULL, NULL, NULL);
#line 660 "../src/Services/PulseAudioManager.vala"
	profiles_list = _tmp2_;
#line 663 "../src/Services/PulseAudioManager.vala"
	_tmp3_ = profiles_list;
#line 663 "../src/Services/PulseAudioManager.vala"
	gee_list_sort ((GeeList*) _tmp3_, ___lambda45__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 676 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 676 "../src/Services/PulseAudioManager.vala"
	profiles = _tmp4_;
#line 5348 "PulseAudioManager.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp5_;
		gint _item_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _item_index = 0;
#line 677 "../src/Services/PulseAudioManager.vala"
		_tmp5_ = profiles_list;
#line 677 "../src/Services/PulseAudioManager.vala"
		_item_list = _tmp5_;
#line 677 "../src/Services/PulseAudioManager.vala"
		_tmp6_ = _item_list;
#line 677 "../src/Services/PulseAudioManager.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 677 "../src/Services/PulseAudioManager.vala"
		_tmp8_ = _tmp7_;
#line 677 "../src/Services/PulseAudioManager.vala"
		_item_size = _tmp8_;
#line 677 "../src/Services/PulseAudioManager.vala"
		_item_index = -1;
#line 677 "../src/Services/PulseAudioManager.vala"
		while (TRUE) {
#line 5373 "PulseAudioManager.c"
			gint _tmp9_;
			gint _tmp10_;
			pa_card_profile_info2* item = NULL;
			GeeArrayList* _tmp11_;
			gpointer _tmp12_;
			GeeArrayList* _tmp13_;
			pa_card_profile_info2* _tmp14_;
			const gchar* _tmp15_;
#line 677 "../src/Services/PulseAudioManager.vala"
			_item_index = _item_index + 1;
#line 677 "../src/Services/PulseAudioManager.vala"
			_tmp9_ = _item_index;
#line 677 "../src/Services/PulseAudioManager.vala"
			_tmp10_ = _item_size;
#line 677 "../src/Services/PulseAudioManager.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 677 "../src/Services/PulseAudioManager.vala"
				break;
#line 5392 "PulseAudioManager.c"
			}
#line 677 "../src/Services/PulseAudioManager.vala"
			_tmp11_ = _item_list;
#line 677 "../src/Services/PulseAudioManager.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _item_index);
#line 677 "../src/Services/PulseAudioManager.vala"
			item = _tmp12_;
#line 678 "../src/Services/PulseAudioManager.vala"
			_tmp13_ = profiles;
#line 678 "../src/Services/PulseAudioManager.vala"
			_tmp14_ = item;
#line 678 "../src/Services/PulseAudioManager.vala"
			_tmp15_ = (*_tmp14_).name;
#line 678 "../src/Services/PulseAudioManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp15_);
#line 5408 "PulseAudioManager.c"
		}
	}
#line 681 "../src/Services/PulseAudioManager.vala"
	result = profiles;
#line 681 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (profiles_list);
#line 681 "../src/Services/PulseAudioManager.vala"
	return result;
#line 5417 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                  GeeHashMap* devices,
                                                  guint32 card_index)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
#line 684 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 684 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (devices != NULL);
#line 685 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
#line 685 "../src/Services/PulseAudioManager.vala"
	iter = _tmp0_;
#line 686 "../src/Services/PulseAudioManager.vala"
	while (TRUE) {
#line 5437 "PulseAudioManager.c"
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
#line 686 "../src/Services/PulseAudioManager.vala"
		_tmp1_ = iter;
#line 686 "../src/Services/PulseAudioManager.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 686 "../src/Services/PulseAudioManager.vala"
			break;
#line 5451 "PulseAudioManager.c"
		}
#line 687 "../src/Services/PulseAudioManager.vala"
		_tmp2_ = iter;
#line 687 "../src/Services/PulseAudioManager.vala"
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
#line 687 "../src/Services/PulseAudioManager.vala"
		device = (SoundDevice*) _tmp3_;
#line 688 "../src/Services/PulseAudioManager.vala"
		_tmp4_ = device;
#line 688 "../src/Services/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_card_index (_tmp4_);
#line 688 "../src/Services/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 688 "../src/Services/PulseAudioManager.vala"
		if (_tmp6_ == card_index) {
#line 5467 "PulseAudioManager.c"
			SoundDevice* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			SoundDevice* _tmp10_;
			GeeMapIterator* _tmp11_;
#line 689 "../src/Services/PulseAudioManager.vala"
			_tmp7_ = device;
#line 689 "../src/Services/PulseAudioManager.vala"
			_tmp8_ = sound_device_get_id (_tmp7_);
#line 689 "../src/Services/PulseAudioManager.vala"
			_tmp9_ = _tmp8_;
#line 689 "../src/Services/PulseAudioManager.vala"
			g_debug ("PulseAudioManager.vala:689: removing device: %s", _tmp9_);
#line 690 "../src/Services/PulseAudioManager.vala"
			_tmp10_ = device;
#line 690 "../src/Services/PulseAudioManager.vala"
			g_signal_emit_by_name (_tmp10_, "removed");
#line 691 "../src/Services/PulseAudioManager.vala"
			_tmp11_ = iter;
#line 691 "../src/Services/PulseAudioManager.vala"
			gee_map_iterator_unset (_tmp11_);
#line 5489 "PulseAudioManager.c"
		}
#line 686 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (device);
#line 5493 "PulseAudioManager.c"
	}
#line 684 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (iter);
#line 5497 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
#line 710 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 5508 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
#line 721 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 5519 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* context,
                                                pa_server_info* server)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp12_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	pa_operation* _tmp24_;
	pa_operation* _tmp25_;
	pa_operation* _tmp26_;
	pa_operation* _tmp27_;
	pa_operation* _tmp28_;
	pa_operation* _tmp29_;
#line 696 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (context != NULL);
#line 697 "../src/Services/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:697: server info update");
#line 698 "../src/Services/PulseAudioManager.vala"
	if (server == NULL) {
#line 699 "../src/Services/PulseAudioManager.vala"
		return;
#line 5549 "PulseAudioManager.c"
	}
#line 702 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = self->priv->default_sink_name;
#line 702 "../src/Services/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 5555 "PulseAudioManager.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 703 "../src/Services/PulseAudioManager.vala"
		_tmp1_ = (*server).default_sink_name;
#line 703 "../src/Services/PulseAudioManager.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 703 "../src/Services/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 703 "../src/Services/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp2_;
#line 704 "../src/Services/PulseAudioManager.vala"
		_tmp3_ = self->priv->default_sink_name;
#line 704 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:704: \tdefault_sink_name: %s", _tmp3_);
#line 5571 "PulseAudioManager.c"
	}
#line 707 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = self->priv->default_sink_name;
#line 707 "../src/Services/PulseAudioManager.vala"
	_tmp5_ = (*server).default_sink_name;
#line 707 "../src/Services/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
#line 5579 "PulseAudioManager.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
#line 708 "../src/Services/PulseAudioManager.vala"
		_tmp6_ = self->priv->default_sink_name;
#line 708 "../src/Services/PulseAudioManager.vala"
		_tmp7_ = (*server).default_sink_name;
#line 708 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:708: \tdefault_sink_name: %s > %s", _tmp6_, _tmp7_);
#line 709 "../src/Services/PulseAudioManager.vala"
		_tmp8_ = (*server).default_sink_name;
#line 709 "../src/Services/PulseAudioManager.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 709 "../src/Services/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 709 "../src/Services/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp9_;
#line 710 "../src/Services/PulseAudioManager.vala"
		_tmp10_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 710 "../src/Services/PulseAudioManager.vala"
		_tmp11_ = _tmp10_;
#line 710 "../src/Services/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp11_);
#line 5606 "PulseAudioManager.c"
	}
#line 713 "../src/Services/PulseAudioManager.vala"
	_tmp12_ = self->priv->default_source_name;
#line 713 "../src/Services/PulseAudioManager.vala"
	if (_tmp12_ == NULL) {
#line 5612 "PulseAudioManager.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 714 "../src/Services/PulseAudioManager.vala"
		_tmp13_ = (*server).default_source_name;
#line 714 "../src/Services/PulseAudioManager.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 714 "../src/Services/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 714 "../src/Services/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp14_;
#line 715 "../src/Services/PulseAudioManager.vala"
		_tmp15_ = self->priv->default_source_name;
#line 715 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:715: \tdefault_source_name: %s", _tmp15_);
#line 5628 "PulseAudioManager.c"
	}
#line 718 "../src/Services/PulseAudioManager.vala"
	_tmp16_ = self->priv->default_source_name;
#line 718 "../src/Services/PulseAudioManager.vala"
	_tmp17_ = (*server).default_source_name;
#line 718 "../src/Services/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
#line 5636 "PulseAudioManager.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		pa_operation* _tmp22_;
		pa_operation* _tmp23_;
#line 719 "../src/Services/PulseAudioManager.vala"
		_tmp18_ = self->priv->default_source_name;
#line 719 "../src/Services/PulseAudioManager.vala"
		_tmp19_ = (*server).default_source_name;
#line 719 "../src/Services/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:719: \tdefault_source_name: %s > %s", _tmp18_, _tmp19_);
#line 720 "../src/Services/PulseAudioManager.vala"
		_tmp20_ = (*server).default_source_name;
#line 720 "../src/Services/PulseAudioManager.vala"
		_tmp21_ = g_strdup (_tmp20_);
#line 720 "../src/Services/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 720 "../src/Services/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp21_;
#line 721 "../src/Services/PulseAudioManager.vala"
		_tmp22_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 721 "../src/Services/PulseAudioManager.vala"
		_tmp23_ = _tmp22_;
#line 721 "../src/Services/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp23_);
#line 5663 "PulseAudioManager.c"
	}
#line 726 "../src/Services/PulseAudioManager.vala"
	_tmp24_ = pa_context_get_card_info_list (context, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 726 "../src/Services/PulseAudioManager.vala"
	_tmp25_ = _tmp24_;
#line 726 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp25_);
#line 727 "../src/Services/PulseAudioManager.vala"
	_tmp26_ = pa_context_get_source_info_list (context, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 727 "../src/Services/PulseAudioManager.vala"
	_tmp27_ = _tmp26_;
#line 727 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp27_);
#line 728 "../src/Services/PulseAudioManager.vala"
	_tmp28_ = pa_context_get_sink_info_list (context, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 728 "../src/Services/PulseAudioManager.vala"
	_tmp29_ = _tmp28_;
#line 728 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp29_);
#line 5683 "PulseAudioManager.c"
}

static void
__lambda44_ (SoundPulseAudioManager* self,
             pa_context* c,
             gint success)
{
#line 749 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 750 "../src/Services/PulseAudioManager.vala"
	if (success != 1) {
#line 751 "../src/Services/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:751: Updating source failed");
#line 5697 "PulseAudioManager.c"
	}
}

static void
___lambda44__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 749 "../src/Services/PulseAudioManager.vala"
	__lambda44_ ((SoundPulseAudioManager*) self, c, success);
#line 5708 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
#line 735 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 735 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 738 "../src/Services/PulseAudioManager.vala"
	if (eol != 0) {
#line 738 "../src/Services/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 5737 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 738 "../src/Services/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 738 "../src/Services/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
#line 5744 "PulseAudioManager.c"
	}
#line 738 "../src/Services/PulseAudioManager.vala"
	if (_tmp0_) {
#line 739 "../src/Services/PulseAudioManager.vala"
		return;
#line 5750 "PulseAudioManager.c"
	}
#line 743 "../src/Services/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 744 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 744 "../src/Services/PulseAudioManager.vala"
	new_info.name = _tmp2_;
#line 745 "../src/Services/PulseAudioManager.vala"
	_tmp3_ = (*info).channel_map;
#line 745 "../src/Services/PulseAudioManager.vala"
	new_info.channel_map = _tmp3_;
#line 746 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = (*info).volume;
#line 746 "../src/Services/PulseAudioManager.vala"
	new_info.volume = _tmp4_;
#line 747 "../src/Services/PulseAudioManager.vala"
	new_info.mute = (*info).mute;
#line 748 "../src/Services/PulseAudioManager.vala"
	_tmp5_ = self->priv->default_sink_name;
#line 748 "../src/Services/PulseAudioManager.vala"
	new_info.device = _tmp5_;
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp6_ = new_info;
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp7_[0] = _tmp6_;
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = _tmp7_;
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp8__length1 = 1;
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, ___lambda44__pa_context_success_cb_t, self);
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp10_ = _tmp9_;
#line 749 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp10_);
#line 749 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 5790 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
#line 756 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 756 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 759 "../src/Services/PulseAudioManager.vala"
	if (eol != 0) {
#line 759 "../src/Services/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 5819 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 759 "../src/Services/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 759 "../src/Services/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
#line 5826 "PulseAudioManager.c"
	}
#line 759 "../src/Services/PulseAudioManager.vala"
	if (_tmp0_) {
#line 760 "../src/Services/PulseAudioManager.vala"
		return;
#line 5832 "PulseAudioManager.c"
	}
#line 764 "../src/Services/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 765 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 765 "../src/Services/PulseAudioManager.vala"
	new_info.name = _tmp2_;
#line 766 "../src/Services/PulseAudioManager.vala"
	_tmp3_ = (*info).channel_map;
#line 766 "../src/Services/PulseAudioManager.vala"
	new_info.channel_map = _tmp3_;
#line 767 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = (*info).volume;
#line 767 "../src/Services/PulseAudioManager.vala"
	new_info.volume = _tmp4_;
#line 768 "../src/Services/PulseAudioManager.vala"
	new_info.mute = (*info).mute;
#line 769 "../src/Services/PulseAudioManager.vala"
	_tmp5_ = self->priv->default_source_name;
#line 769 "../src/Services/PulseAudioManager.vala"
	new_info.device = _tmp5_;
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp6_ = new_info;
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp7_[0] = _tmp6_;
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = _tmp7_;
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp8__length1 = 1;
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, NULL, NULL);
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp10_ = _tmp9_;
#line 770 "../src/Services/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp10_);
#line 770 "../src/Services/PulseAudioManager.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 5872 "PulseAudioManager.c"
}

SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 49 "../src/Services/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_output;
#line 49 "../src/Services/PulseAudioManager.vala"
	result = _tmp0_;
#line 49 "../src/Services/PulseAudioManager.vala"
	return result;
#line 5888 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
	SoundDevice* old_value;
#line 49 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Services/PulseAudioManager.vala"
	old_value = sound_pulse_audio_manager_get_default_output (self);
#line 49 "../src/Services/PulseAudioManager.vala"
	if (old_value != value) {
#line 5902 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 49 "../src/Services/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_output);
#line 49 "../src/Services/PulseAudioManager.vala"
		self->priv->_default_output = _tmp0_;
#line 49 "../src/Services/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
#line 5912 "PulseAudioManager.c"
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 50 "../src/Services/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_input;
#line 50 "../src/Services/PulseAudioManager.vala"
	result = _tmp0_;
#line 50 "../src/Services/PulseAudioManager.vala"
	return result;
#line 5929 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
	SoundDevice* old_value;
#line 50 "../src/Services/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Services/PulseAudioManager.vala"
	old_value = sound_pulse_audio_manager_get_default_input (self);
#line 50 "../src/Services/PulseAudioManager.vala"
	if (old_value != value) {
#line 5943 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 50 "../src/Services/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/Services/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_input);
#line 50 "../src/Services/PulseAudioManager.vala"
		self->priv->_default_input = _tmp0_;
#line 50 "../src/Services/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
#line 5953 "PulseAudioManager.c"
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 66 "../src/Services/PulseAudioManager.vala"
	for (i = 0; i < stack_length; i++) {
#line 66 "../src/Services/PulseAudioManager.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 66 "../src/Services/PulseAudioManager.vala"
			return TRUE;
#line 5969 "PulseAudioManager.c"
		}
	}
#line 66 "../src/Services/PulseAudioManager.vala"
	return FALSE;
#line 5974 "PulseAudioManager.c"
}

static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	gchar* messages_debug_raw = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
#line 58 "../src/Services/PulseAudioManager.vala"
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
#line 58 "../src/Services/PulseAudioManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 58 "../src/Services/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 59 "../src/Services/PulseAudioManager.vala"
	_tmp0_ = pa_glib_mainloop_new (NULL);
#line 59 "../src/Services/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 59 "../src/Services/PulseAudioManager.vala"
	self->priv->loop = _tmp0_;
#line 60 "../src/Services/PulseAudioManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 60 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 60 "../src/Services/PulseAudioManager.vala"
	self->priv->input_devices = _tmp1_;
#line 61 "../src/Services/PulseAudioManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 61 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 61 "../src/Services/PulseAudioManager.vala"
	self->priv->output_devices = _tmp2_;
#line 63 "../src/Services/PulseAudioManager.vala"
	_tmp3_ = g_getenv ("G_MESSAGES_DEBUG");
#line 63 "../src/Services/PulseAudioManager.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 63 "../src/Services/PulseAudioManager.vala"
	messages_debug_raw = _tmp4_;
#line 64 "../src/Services/PulseAudioManager.vala"
	_tmp5_ = messages_debug_raw;
#line 64 "../src/Services/PulseAudioManager.vala"
	if (_tmp5_ != NULL) {
#line 6026 "PulseAudioManager.c"
		gchar** messages_debug = NULL;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint messages_debug_length1;
		gint _messages_debug_size_;
		gboolean _tmp9_ = FALSE;
		gchar** _tmp10_;
		gint _tmp10__length1;
#line 65 "../src/Services/PulseAudioManager.vala"
		_tmp6_ = messages_debug_raw;
#line 65 "../src/Services/PulseAudioManager.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, " ", 0);
#line 65 "../src/Services/PulseAudioManager.vala"
		messages_debug = _tmp8_;
#line 65 "../src/Services/PulseAudioManager.vala"
		messages_debug_length1 = _vala_array_length (_tmp7_);
#line 65 "../src/Services/PulseAudioManager.vala"
		_messages_debug_size_ = messages_debug_length1;
#line 66 "../src/Services/PulseAudioManager.vala"
		_tmp10_ = messages_debug;
#line 66 "../src/Services/PulseAudioManager.vala"
		_tmp10__length1 = messages_debug_length1;
#line 66 "../src/Services/PulseAudioManager.vala"
		if (_vala_string_array_contains (_tmp10_, _tmp10__length1, "all")) {
#line 66 "../src/Services/PulseAudioManager.vala"
			_tmp9_ = TRUE;
#line 6054 "PulseAudioManager.c"
		} else {
			gchar** _tmp11_;
			gint _tmp11__length1;
#line 66 "../src/Services/PulseAudioManager.vala"
			_tmp11_ = messages_debug;
#line 66 "../src/Services/PulseAudioManager.vala"
			_tmp11__length1 = messages_debug_length1;
#line 66 "../src/Services/PulseAudioManager.vala"
			_tmp9_ = _vala_string_array_contains (_tmp11_, _tmp11__length1, "debug");
#line 6064 "PulseAudioManager.c"
		}
#line 66 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_debug_enabled = _tmp9_;
#line 64 "../src/Services/PulseAudioManager.vala"
		messages_debug = (_vala_array_free (messages_debug, messages_debug_length1, (GDestroyNotify) g_free), NULL);
#line 6070 "PulseAudioManager.c"
	}
#line 58 "../src/Services/PulseAudioManager.vala"
	_g_free0 (messages_debug_raw);
#line 58 "../src/Services/PulseAudioManager.vala"
	return obj;
#line 6076 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass,
                                      gpointer klass_data)
{
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Services/PulseAudioManager.vala"
	g_type_class_adjust_private_offset (klass, &SoundPulseAudioManager_private_offset);
#line 29 "../src/Services/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
#line 29 "../src/Services/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
#line 29 "../src/Services/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
#line 29 "../src/Services/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
#line 29 "../src/Services/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Services/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Services/PulseAudioManager.vala"
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
#line 6101 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self,
                                         gpointer klass)
{
#line 29 "../src/Services/PulseAudioManager.vala"
	self->priv = sound_pulse_audio_manager_get_instance_private (self);
#line 45 "../src/Services/PulseAudioManager.vala"
	self->priv->is_ready = FALSE;
#line 46 "../src/Services/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 6114 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
#line 29 "../src/Services/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 43 "../src/Services/PulseAudioManager.vala"
	_pa_context_unref0 (self->priv->context);
#line 44 "../src/Services/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 47 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 48 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 49 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_output);
#line 50 "../src/Services/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_input);
#line 51 "../src/Services/PulseAudioManager.vala"
	_g_free0 (self->priv->default_source_name);
#line 52 "../src/Services/PulseAudioManager.vala"
	_g_free0 (self->priv->default_sink_name);
#line 29 "../src/Services/PulseAudioManager.vala"
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
#line 6141 "PulseAudioManager.c"
}

static GType
sound_pulse_audio_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
	GType sound_pulse_audio_manager_type_id;
	sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
	SoundPulseAudioManager_private_offset = g_type_add_instance_private (sound_pulse_audio_manager_type_id, sizeof (SoundPulseAudioManagerPrivate));
	return sound_pulse_audio_manager_type_id;
}

GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__once = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__once)) {
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = sound_pulse_audio_manager_get_type_once ();
		g_once_init_leave (&sound_pulse_audio_manager_type_id__once, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__once;
}

static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/Services/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/Services/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/Services/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
#line 29 "../src/Services/PulseAudioManager.vala"
		break;
#line 29 "../src/Services/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/Services/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
#line 29 "../src/Services/PulseAudioManager.vala"
		break;
#line 6188 "PulseAudioManager.c"
		default:
#line 29 "../src/Services/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Services/PulseAudioManager.vala"
		break;
#line 6194 "PulseAudioManager.c"
	}
}

static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/Services/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/Services/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
#line 29 "../src/Services/PulseAudioManager.vala"
		break;
#line 29 "../src/Services/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/Services/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
#line 29 "../src/Services/PulseAudioManager.vala"
		break;
#line 6220 "PulseAudioManager.c"
		default:
#line 29 "../src/Services/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Services/PulseAudioManager.vala"
		break;
#line 6226 "PulseAudioManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

