/* Volume-control.c generated by valac 0.56.13, the Vala compiler
 * generated from Volume-control.vala, do not modify */

/*
 * -*- Mode:Vala; indent-tabs-mode:t; tab-width:4; encoding:utf8 -*-
 * Copyright 2013 Canonical Ltd.
 *           2015-2017 elementary, Inc. (http://launchpad.net/wingpanel)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Alberto Ruiz <alberto.ruiz@canonical.com>
 *      Ted Gould <ted@canonical.com>
 */

#include "sound.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <pulse/volume.h>
#include <pulse/pulseaudio.h>
#include <gee.h>
#include <gio/gio.h>
#include <pulse/glib-mainloop.h>

enum  {
	SOUND_SERVICES_VOLUME_CONTROL_0_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_STREAM_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_READY_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_ACTIVE_MIC_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_HIGH_VOLUME_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_MUTE_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_MIC_MUTE_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_IS_PLAYING_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_IS_LISTENING_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_VOLUME_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_MIC_VOLUME_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_HEADPHONE_PLUGGED_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_NUM_PROPERTIES
};
static GParamSpec* sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SOUND_SERVICES_VOLUME_CONTROL_VOLUME_0_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_VOLUME_NUM_PROPERTIES
};
static GParamSpec* sound_services_volume_control_volume_properties[SOUND_SERVICES_VOLUME_CONTROL_VOLUME_NUM_PROPERTIES];
enum  {
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_0_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_STREAM_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_READY_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_HIGH_VOLUME_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_MUTE_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_MUTE_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_PLAYING_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_LISTENING_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_VOLUME_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY,
	SOUND_SERVICES_VOLUME_CONTROL_PULSE_NUM_PROPERTIES
};
static GParamSpec* sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundServicesVolumeControlPulseReconnectToPulseData SoundServicesVolumeControlPulseReconnectToPulseData;
typedef struct _SoundServicesVolumeControlPulseUpdateActiveSinkInputData SoundServicesVolumeControlPulseUpdateActiveSinkInputData;

struct _SoundServicesVolumeControlPrivate {
	SoundServicesVolumeControlVolume* _volume;
	gboolean _headphone_plugged;
};

struct _SoundServicesVolumeControlPulsePrivate {
	guint _reconnect_timer;
	pa_context* context;
	gboolean _mute;
	gboolean _mute_mic;
	gboolean _is_playing;
	gboolean _is_listening;
	SoundServicesVolumeControlVolume* _volume;
	gdouble _mic_volume;
	GeeArrayList* _sink_input_list;
	GeeHashMap* _sink_input_hash;
	gboolean _pulse_use_stream_restore;
	gint32 _active_sink_input;
	gchar** _valid_roles;
	gint _valid_roles_length1;
	gint __valid_roles_size_;
	gchar* _objp_role_multimedia;
	gchar* _objp_role_alert;
	gchar* _objp_role_alarm;
	gchar* _objp_role_phone;
	GCancellable* _mute_cancellable;
	GCancellable* _volume_cancellable;
	guint _local_volume_timer;
	gboolean _send_next_local_volume;
	gboolean _ready;
	gboolean _active_mic;
};

struct _SoundServicesVolumeControlPulseReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundServicesVolumeControlPulse* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	pa_context* _tmp2_;
	pa_proplist* props;
	pa_proplist* _tmp3_;
	pa_proplist* _tmp4_;
	pa_proplist* _tmp5_;
	pa_proplist* _tmp6_;
	pa_proplist* _tmp7_;
	pa_glib_mainloop* _tmp8_;
	pa_mainloop_api* _tmp9_;
	pa_proplist* _tmp10_;
	pa_context* _tmp11_;
	pa_context* _tmp12_;
	pa_context* _tmp13_;
	pa_context* _tmp14_;
	const gchar* _tmp15_;
};

struct _SoundServicesVolumeControlPulseUpdateActiveSinkInputData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundServicesVolumeControlPulse* self;
	gint32 index;
};

static gint SoundServicesVolumeControl_private_offset;
static gpointer sound_services_volume_control_parent_class = NULL;
static gpointer sound_services_volume_control_volume_parent_class = NULL;
static gint SoundServicesVolumeControlPulse_private_offset;
static gpointer sound_services_volume_control_pulse_parent_class = NULL;
static pa_glib_mainloop* sound_services_volume_control_pulse_loop;
static pa_glib_mainloop* sound_services_volume_control_pulse_loop = NULL;

static void sound_services_volume_control_real_set_mute (SoundServicesVolumeControl* self,
                                                  gboolean mute);
static void sound_services_volume_control_volume_finalize (GObject * obj);
static GType sound_services_volume_control_volume_get_type_once (void);
static void sound_services_volume_control_finalize (GObject * obj);
static GType sound_services_volume_control_get_type_once (void);
static void _vala_sound_services_volume_control_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_sound_services_volume_control_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static void sound_services_volume_control_pulse_stop_local_volume_timer (SoundServicesVolumeControlPulse* self);
static void sound_services_volume_control_pulse_reconnect_to_pulse (SoundServicesVolumeControlPulse* self,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
static void sound_services_volume_control_pulse_reconnect_to_pulse_finish (SoundServicesVolumeControlPulse* self,
                                                                    GAsyncResult* _res_);
static void sound_services_volume_control_pulse_context_events_cb (SoundServicesVolumeControlPulse* self,
                                                            pa_context* c,
                                                            pa_subscription_event_type_t t,
                                                            guint32 index);
static void sound_services_volume_control_pulse_update_sink (SoundServicesVolumeControlPulse* self);
static void sound_services_volume_control_pulse_handle_new_sink_input_cb (SoundServicesVolumeControlPulse* self,
                                                                   pa_context* c,
                                                                   pa_sink_input_info* i,
                                                                   gint eol);
static void _sound_services_volume_control_pulse_handle_new_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                                            pa_sink_input_info* i,
                                                                                            gint eol,
                                                                                            gpointer self);
static void sound_services_volume_control_pulse_handle_changed_sink_input_cb (SoundServicesVolumeControlPulse* self,
                                                                       pa_context* c,
                                                                       pa_sink_input_info* i,
                                                                       gint eol);
static void _sound_services_volume_control_pulse_handle_changed_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                                                pa_sink_input_info* i,
                                                                                                gint eol,
                                                                                                gpointer self);
static void sound_services_volume_control_pulse_remove_sink_input_from_list (SoundServicesVolumeControlPulse* self,
                                                                      guint32 index);
static void sound_services_volume_control_pulse_update_source (SoundServicesVolumeControlPulse* self);
static void sound_services_volume_control_pulse_source_output_info_cb (SoundServicesVolumeControlPulse* self,
                                                                pa_context* c,
                                                                pa_source_output_info* i,
                                                                gint eol);
static void _sound_services_volume_control_pulse_source_output_info_cb_pa_source_output_info_cb_t (pa_context* c,
                                                                                            pa_source_output_info* i,
                                                                                            gint eol,
                                                                                            gpointer self);
static void sound_services_volume_control_pulse_sink_info_cb_for_props (SoundServicesVolumeControlPulse* self,
                                                                 pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol);
static gdouble sound_services_volume_control_pulse_volume_to_double (pa_volume_t vol);
static void sound_services_volume_control_pulse_source_info_cb (SoundServicesVolumeControlPulse* self,
                                                         pa_context* c,
                                                         pa_source_info* i,
                                                         gint eol);
static void sound_services_volume_control_pulse_server_info_cb_for_props (SoundServicesVolumeControlPulse* self,
                                                                   pa_context* c,
                                                                   pa_server_info* i);
static void _sound_services_volume_control_pulse_sink_info_cb_for_props_pa_sink_info_cb_t (pa_context* c,
                                                                                    pa_sink_info* i,
                                                                                    gint eol,
                                                                                    gpointer self);
static void _sound_services_volume_control_pulse_server_info_cb_for_props_pa_server_info_cb_t (pa_context* c,
                                                                                        pa_server_info* i,
                                                                                        gpointer self);
static void sound_services_volume_control_pulse_update_source_get_server_info_cb (SoundServicesVolumeControlPulse* self,
                                                                           pa_context* c,
                                                                           pa_server_info* i);
static void _sound_services_volume_control_pulse_source_info_cb_pa_source_info_cb_t (pa_context* c,
                                                                              pa_source_info* i,
                                                                              gint eol,
                                                                              gpointer self);
static void _sound_services_volume_control_pulse_update_source_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                                                pa_server_info* i,
                                                                                                gpointer self);
static void sound_services_volume_control_pulse_add_sink_input_into_list (SoundServicesVolumeControlPulse* self,
                                                                   pa_sink_input_info* sink_input);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void sound_services_volume_control_pulse_update_active_sink_input (SoundServicesVolumeControlPulse* self,
                                                                   gint32 index,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
static void sound_services_volume_control_pulse_update_active_sink_input_finish (SoundServicesVolumeControlPulse* self,
                                                                          GAsyncResult* _res_);
static void sound_services_volume_control_pulse_context_state_callback (SoundServicesVolumeControlPulse* self,
                                                                 pa_context* c);
static void _sound_services_volume_control_pulse_context_events_cb_pa_context_subscribe_cb_t (pa_context* c,
                                                                                       pa_subscription_event_type_t t,
                                                                                       guint32 idx,
                                                                                       gpointer self);
static gboolean sound_services_volume_control_pulse_reconnect_timeout (SoundServicesVolumeControlPulse* self);
static gboolean _sound_services_volume_control_pulse_reconnect_timeout_gsource_func (gpointer self);
static void sound_services_volume_control_pulse_reconnect_to_pulse_data_free (gpointer _data);
static gboolean sound_services_volume_control_pulse_reconnect_to_pulse_co (SoundServicesVolumeControlPulseReconnectToPulseData* _data_);
static void _sound_services_volume_control_pulse_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                                         gpointer self);
static void sound_services_volume_control_pulse_sink_info_list_callback_set_mute (SoundServicesVolumeControlPulse* self,
                                                                           pa_context* context,
                                                                           pa_sink_info* sink,
                                                                           gint eol);
static void sound_services_volume_control_pulse_sink_info_list_callback_unset_mute (SoundServicesVolumeControlPulse* self,
                                                                             pa_context* context,
                                                                             pa_sink_info* sink,
                                                                             gint eol);
static gboolean sound_services_volume_control_pulse_set_mute_internal (SoundServicesVolumeControlPulse* self,
                                                                gboolean mute);
static void _sound_services_volume_control_pulse_sink_info_list_callback_set_mute_pa_sink_info_cb_t (pa_context* c,
                                                                                              pa_sink_info* i,
                                                                                              gint eol,
                                                                                              gpointer self);
static void _sound_services_volume_control_pulse_sink_info_list_callback_unset_mute_pa_sink_info_cb_t (pa_context* c,
                                                                                                pa_sink_info* i,
                                                                                                gint eol,
                                                                                                gpointer self);
static void sound_services_volume_control_pulse_real_set_mute (SoundServicesVolumeControl* base,
                                                        gboolean mute);
static void sound_services_volume_control_pulse_source_info_list_callback_set_mute (SoundServicesVolumeControlPulse* self,
                                                                             pa_context* context,
                                                                             pa_source_info* source,
                                                                             gint eol);
static void sound_services_volume_control_pulse_source_info_list_callback_unset_mute (SoundServicesVolumeControlPulse* self,
                                                                               pa_context* context,
                                                                               pa_source_info* source,
                                                                               gint eol);
static gboolean sound_services_volume_control_pulse_set_mic_mute_internal (SoundServicesVolumeControlPulse* self,
                                                                    gboolean m);
static void _sound_services_volume_control_pulse_source_info_list_callback_set_mute_pa_source_info_cb_t (pa_context* c,
                                                                                                  pa_source_info* i,
                                                                                                  gint eol,
                                                                                                  gpointer self);
static void _sound_services_volume_control_pulse_source_info_list_callback_unset_mute_pa_source_info_cb_t (pa_context* c,
                                                                                                    pa_source_info* i,
                                                                                                    gint eol,
                                                                                                    gpointer self);
static pa_volume_t sound_services_volume_control_pulse_double_to_volume (gdouble vol);
static void sound_services_volume_control_pulse_set_volume_success_cb (SoundServicesVolumeControlPulse* self,
                                                                pa_context* c,
                                                                gint success);
static void sound_services_volume_control_pulse_sink_info_set_volume_cb (SoundServicesVolumeControlPulse* self,
                                                                  pa_context* c,
                                                                  pa_sink_info* i,
                                                                  gint eol);
static void _sound_services_volume_control_pulse_set_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                                         gint success,
                                                                                         gpointer self);
static void sound_services_volume_control_pulse_server_info_cb_for_set_volume (SoundServicesVolumeControlPulse* self,
                                                                        pa_context* c,
                                                                        pa_server_info* i);
static void _sound_services_volume_control_pulse_sink_info_set_volume_cb_pa_sink_info_cb_t (pa_context* c,
                                                                                     pa_sink_info* i,
                                                                                     gint eol,
                                                                                     gpointer self);
static void sound_services_volume_control_pulse_set_mic_volume_success_cb (SoundServicesVolumeControlPulse* self,
                                                                    pa_context* c,
                                                                    gint success);
static void sound_services_volume_control_pulse_set_mic_volume_get_server_info_cb (SoundServicesVolumeControlPulse* self,
                                                                            pa_context* c,
                                                                            pa_server_info* i);
static void _sound_services_volume_control_pulse_set_mic_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                                             gint success,
                                                                                             gpointer self);
static void sound_services_volume_control_pulse_update_active_sink_input_data_free (gpointer _data);
static gboolean sound_services_volume_control_pulse_update_active_sink_input_co (SoundServicesVolumeControlPulseUpdateActiveSinkInputData* _data_);
static void sound_services_volume_control_pulse_start_local_volume_timer (SoundServicesVolumeControlPulse* self);
static gboolean sound_services_volume_control_pulse_local_volume_changed_timeout (SoundServicesVolumeControlPulse* self);
static gboolean _sound_services_volume_control_pulse_local_volume_changed_timeout_gsource_func (gpointer self);
static void _sound_services_volume_control_pulse_server_info_cb_for_set_volume_pa_server_info_cb_t (pa_context* c,
                                                                                             pa_server_info* i,
                                                                                             gpointer self);
static void _sound_services_volume_control_pulse_set_mic_volume_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                                                 pa_server_info* i,
                                                                                                 gpointer self);
static void sound_services_volume_control_pulse_finalize (GObject * obj);
static GType sound_services_volume_control_pulse_get_type_once (void);
static void _vala_sound_services_volume_control_pulse_get_property (GObject * object,
                                                             guint property_id,
                                                             GValue * value,
                                                             GParamSpec * pspec);
static void _vala_sound_services_volume_control_pulse_set_property (GObject * object,
                                                             guint property_id,
                                                             const GValue * value,
                                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_services_volume_control_get_instance_private (SoundServicesVolumeControl* self)
{
	return G_STRUCT_MEMBER_P (self, SoundServicesVolumeControl_private_offset);
}

static GType
sound_services_volume_control_volume_reasons_get_type_once (void)
{
	static const GEnumValue values[] = {{SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE, "SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE", "pulse-change"}, {SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_ACCOUNTS_SERVICE_SET, "SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_ACCOUNTS_SERVICE_SET", "accounts-service-set"}, {SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_DEVICE_OUTPUT_CHANGE, "SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_DEVICE_OUTPUT_CHANGE", "device-output-change"}, {SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS, "SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS", "user-keypress"}, {SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_VOLUME_STREAM_CHANGE, "SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_VOLUME_STREAM_CHANGE", "volume-stream-change"}, {0, NULL, NULL}};
	GType sound_services_volume_control_volume_reasons_type_id;
	sound_services_volume_control_volume_reasons_type_id = g_enum_register_static ("SoundServicesVolumeControlVolumeReasons", values);
	return sound_services_volume_control_volume_reasons_type_id;
}

GType
sound_services_volume_control_volume_reasons_get_type (void)
{
	static volatile gsize sound_services_volume_control_volume_reasons_type_id__once = 0;
	if (g_once_init_enter (&sound_services_volume_control_volume_reasons_type_id__once)) {
		GType sound_services_volume_control_volume_reasons_type_id;
		sound_services_volume_control_volume_reasons_type_id = sound_services_volume_control_volume_reasons_get_type_once ();
		g_once_init_leave (&sound_services_volume_control_volume_reasons_type_id__once, sound_services_volume_control_volume_reasons_type_id);
	}
	return sound_services_volume_control_volume_reasons_type_id__once;
}

static void
sound_services_volume_control_real_set_mute (SoundServicesVolumeControl* self,
                                             gboolean mute)
{
#line 50 "../src/Services/Volume-control.vala"
	g_critical ("Type `%s' does not implement abstract method `sound_services_volume_control_set_mute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 50 "../src/Services/Volume-control.vala"
	return;
#line 394 "Volume-control.c"
}

void
sound_services_volume_control_set_mute (SoundServicesVolumeControl* self,
                                        gboolean mute)
{
	SoundServicesVolumeControlClass* _klass_;
#line 50 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 50 "../src/Services/Volume-control.vala"
	if (_klass_->set_mute) {
#line 50 "../src/Services/Volume-control.vala"
		_klass_->set_mute (self, mute);
#line 410 "Volume-control.c"
	}
}

SoundServicesVolumeControl*
sound_services_volume_control_construct (GType object_type)
{
	SoundServicesVolumeControl * self = NULL;
#line 23 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControl*) g_object_new (object_type, NULL);
#line 23 "../src/Services/Volume-control.vala"
	return self;
#line 422 "Volume-control.c"
}

const gchar*
sound_services_volume_control_get_stream (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 37 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 37 "../src/Services/Volume-control.vala"
	if (_klass_->get_stream) {
#line 37 "../src/Services/Volume-control.vala"
		return _klass_->get_stream (self);
#line 437 "Volume-control.c"
	}
#line 37 "../src/Services/Volume-control.vala"
	return NULL;
#line 441 "Volume-control.c"
}

static const gchar*
sound_services_volume_control_real_get_stream (SoundServicesVolumeControl* base)
{
	const gchar* result;
	SoundServicesVolumeControl* self;
#line 37 "../src/Services/Volume-control.vala"
	self = base;
#line 37 "../src/Services/Volume-control.vala"
	result = "";
#line 37 "../src/Services/Volume-control.vala"
	return result;
#line 455 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_ready (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 38 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 38 "../src/Services/Volume-control.vala"
	if (_klass_->get_ready) {
#line 38 "../src/Services/Volume-control.vala"
		return _klass_->get_ready (self);
#line 470 "Volume-control.c"
	}
#line 38 "../src/Services/Volume-control.vala"
	return FALSE;
#line 474 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_ready (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 38 "../src/Services/Volume-control.vala"
	self = base;
#line 38 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 38 "../src/Services/Volume-control.vala"
	return result;
#line 488 "Volume-control.c"
}

void
sound_services_volume_control_set_ready (SoundServicesVolumeControl* self,
                                         gboolean value)
{
	SoundServicesVolumeControlClass* _klass_;
#line 38 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 38 "../src/Services/Volume-control.vala"
	if (_klass_->set_ready) {
#line 38 "../src/Services/Volume-control.vala"
		_klass_->set_ready (self, value);
#line 504 "Volume-control.c"
	}
}

static void
sound_services_volume_control_real_set_ready (SoundServicesVolumeControl* base,
                                              gboolean value)
{
	SoundServicesVolumeControl* self;
#line 38 "../src/Services/Volume-control.vala"
	self = base;
#line 38 "../src/Services/Volume-control.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_READY_PROPERTY]);
#line 517 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_active_mic (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 39 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 39 "../src/Services/Volume-control.vala"
	if (_klass_->get_active_mic) {
#line 39 "../src/Services/Volume-control.vala"
		return _klass_->get_active_mic (self);
#line 532 "Volume-control.c"
	}
#line 39 "../src/Services/Volume-control.vala"
	return FALSE;
#line 536 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_active_mic (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 39 "../src/Services/Volume-control.vala"
	self = base;
#line 39 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 39 "../src/Services/Volume-control.vala"
	return result;
#line 550 "Volume-control.c"
}

void
sound_services_volume_control_set_active_mic (SoundServicesVolumeControl* self,
                                              gboolean value)
{
	SoundServicesVolumeControlClass* _klass_;
#line 39 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 39 "../src/Services/Volume-control.vala"
	if (_klass_->set_active_mic) {
#line 39 "../src/Services/Volume-control.vala"
		_klass_->set_active_mic (self, value);
#line 566 "Volume-control.c"
	}
}

static void
sound_services_volume_control_real_set_active_mic (SoundServicesVolumeControl* base,
                                                   gboolean value)
{
	SoundServicesVolumeControl* self;
#line 39 "../src/Services/Volume-control.vala"
	self = base;
#line 39 "../src/Services/Volume-control.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_ACTIVE_MIC_PROPERTY]);
#line 579 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_high_volume (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 40 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 40 "../src/Services/Volume-control.vala"
	if (_klass_->get_high_volume) {
#line 40 "../src/Services/Volume-control.vala"
		return _klass_->get_high_volume (self);
#line 594 "Volume-control.c"
	}
#line 40 "../src/Services/Volume-control.vala"
	return FALSE;
#line 598 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_high_volume (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 40 "../src/Services/Volume-control.vala"
	self = base;
#line 40 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 40 "../src/Services/Volume-control.vala"
	return result;
#line 612 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_mute (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 41 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 41 "../src/Services/Volume-control.vala"
	if (_klass_->get_mute) {
#line 41 "../src/Services/Volume-control.vala"
		return _klass_->get_mute (self);
#line 627 "Volume-control.c"
	}
#line 41 "../src/Services/Volume-control.vala"
	return FALSE;
#line 631 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_mute (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 41 "../src/Services/Volume-control.vala"
	self = base;
#line 41 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 41 "../src/Services/Volume-control.vala"
	return result;
#line 645 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_mic_mute (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 42 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 42 "../src/Services/Volume-control.vala"
	if (_klass_->get_mic_mute) {
#line 42 "../src/Services/Volume-control.vala"
		return _klass_->get_mic_mute (self);
#line 660 "Volume-control.c"
	}
#line 42 "../src/Services/Volume-control.vala"
	return FALSE;
#line 664 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_mic_mute (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 42 "../src/Services/Volume-control.vala"
	self = base;
#line 42 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 42 "../src/Services/Volume-control.vala"
	return result;
#line 678 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_is_playing (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 43 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 43 "../src/Services/Volume-control.vala"
	if (_klass_->get_is_playing) {
#line 43 "../src/Services/Volume-control.vala"
		return _klass_->get_is_playing (self);
#line 693 "Volume-control.c"
	}
#line 43 "../src/Services/Volume-control.vala"
	return FALSE;
#line 697 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_is_playing (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 43 "../src/Services/Volume-control.vala"
	self = base;
#line 43 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 43 "../src/Services/Volume-control.vala"
	return result;
#line 711 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_is_listening (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 44 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 44 "../src/Services/Volume-control.vala"
	if (_klass_->get_is_listening) {
#line 44 "../src/Services/Volume-control.vala"
		return _klass_->get_is_listening (self);
#line 726 "Volume-control.c"
	}
#line 44 "../src/Services/Volume-control.vala"
	return FALSE;
#line 730 "Volume-control.c"
}

static gboolean
sound_services_volume_control_real_get_is_listening (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControl* self;
#line 44 "../src/Services/Volume-control.vala"
	self = base;
#line 44 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 44 "../src/Services/Volume-control.vala"
	return result;
#line 744 "Volume-control.c"
}

SoundServicesVolumeControlVolume*
sound_services_volume_control_get_volume (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 46 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 46 "../src/Services/Volume-control.vala"
	if (_klass_->get_volume) {
#line 46 "../src/Services/Volume-control.vala"
		return _klass_->get_volume (self);
#line 759 "Volume-control.c"
	}
#line 46 "../src/Services/Volume-control.vala"
	return NULL;
#line 763 "Volume-control.c"
}

static SoundServicesVolumeControlVolume*
sound_services_volume_control_real_get_volume (SoundServicesVolumeControl* base)
{
	SoundServicesVolumeControlVolume* result;
	SoundServicesVolumeControl* self;
	SoundServicesVolumeControlVolume* _tmp0_;
#line 46 "../src/Services/Volume-control.vala"
	self = base;
#line 46 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_volume;
#line 46 "../src/Services/Volume-control.vala"
	result = _tmp0_;
#line 46 "../src/Services/Volume-control.vala"
	return result;
#line 780 "Volume-control.c"
}

void
sound_services_volume_control_set_volume (SoundServicesVolumeControl* self,
                                          SoundServicesVolumeControlVolume* value)
{
	SoundServicesVolumeControlClass* _klass_;
#line 46 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 46 "../src/Services/Volume-control.vala"
	if (_klass_->set_volume) {
#line 46 "../src/Services/Volume-control.vala"
		_klass_->set_volume (self, value);
#line 796 "Volume-control.c"
	}
}

static void
sound_services_volume_control_real_set_volume (SoundServicesVolumeControl* base,
                                               SoundServicesVolumeControlVolume* value)
{
	SoundServicesVolumeControl* self;
#line 46 "../src/Services/Volume-control.vala"
	self = base;
#line 46 "../src/Services/Volume-control.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_VOLUME_PROPERTY]);
#line 809 "Volume-control.c"
}

gdouble
sound_services_volume_control_get_mic_volume (SoundServicesVolumeControl* self)
{
	SoundServicesVolumeControlClass* _klass_;
#line 47 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 47 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 47 "../src/Services/Volume-control.vala"
	if (_klass_->get_mic_volume) {
#line 47 "../src/Services/Volume-control.vala"
		return _klass_->get_mic_volume (self);
#line 824 "Volume-control.c"
	}
#line 47 "../src/Services/Volume-control.vala"
	return -1.0;
#line 828 "Volume-control.c"
}

static gdouble
sound_services_volume_control_real_get_mic_volume (SoundServicesVolumeControl* base)
{
	gdouble result;
	SoundServicesVolumeControl* self;
#line 47 "../src/Services/Volume-control.vala"
	self = base;
#line 47 "../src/Services/Volume-control.vala"
	result = 0.0;
#line 47 "../src/Services/Volume-control.vala"
	return result;
#line 842 "Volume-control.c"
}

void
sound_services_volume_control_set_mic_volume (SoundServicesVolumeControl* self,
                                              gdouble value)
{
	SoundServicesVolumeControlClass* _klass_;
#line 47 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Services/Volume-control.vala"
	_klass_ = SOUND_SERVICES_VOLUME_CONTROL_GET_CLASS (self);
#line 47 "../src/Services/Volume-control.vala"
	if (_klass_->set_mic_volume) {
#line 47 "../src/Services/Volume-control.vala"
		_klass_->set_mic_volume (self, value);
#line 858 "Volume-control.c"
	}
}

static void
sound_services_volume_control_real_set_mic_volume (SoundServicesVolumeControl* base,
                                                   gdouble value)
{
	SoundServicesVolumeControl* self;
#line 47 "../src/Services/Volume-control.vala"
	self = base;
#line 47 "../src/Services/Volume-control.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_MIC_VOLUME_PROPERTY]);
#line 871 "Volume-control.c"
}

gboolean
sound_services_volume_control_get_headphone_plugged (SoundServicesVolumeControl* self)
{
	gboolean result;
#line 48 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/Services/Volume-control.vala"
	result = self->priv->_headphone_plugged;
#line 48 "../src/Services/Volume-control.vala"
	return result;
#line 884 "Volume-control.c"
}

void
sound_services_volume_control_set_headphone_plugged (SoundServicesVolumeControl* self,
                                                     gboolean value)
{
	gboolean old_value;
#line 48 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Services/Volume-control.vala"
	old_value = sound_services_volume_control_get_headphone_plugged (self);
#line 48 "../src/Services/Volume-control.vala"
	if (old_value != value) {
#line 48 "../src/Services/Volume-control.vala"
		self->priv->_headphone_plugged = value;
#line 48 "../src/Services/Volume-control.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_HEADPHONE_PLUGGED_PROPERTY]);
#line 902 "Volume-control.c"
	}
}

SoundServicesVolumeControlVolume*
sound_services_volume_control_volume_construct (GType object_type)
{
	SoundServicesVolumeControlVolume * self = NULL;
#line 32 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlVolume*) g_object_new (object_type, NULL);
#line 32 "../src/Services/Volume-control.vala"
	return self;
#line 914 "Volume-control.c"
}

SoundServicesVolumeControlVolume*
sound_services_volume_control_volume_new (void)
{
#line 32 "../src/Services/Volume-control.vala"
	return sound_services_volume_control_volume_construct (SOUND_SERVICES_VOLUME_CONTROL_TYPE_VOLUME);
#line 922 "Volume-control.c"
}

static void
sound_services_volume_control_volume_class_init (SoundServicesVolumeControlVolumeClass * klass,
                                                 gpointer klass_data)
{
#line 32 "../src/Services/Volume-control.vala"
	sound_services_volume_control_volume_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_services_volume_control_volume_finalize;
#line 933 "Volume-control.c"
}

static void
sound_services_volume_control_volume_instance_init (SoundServicesVolumeControlVolume * self,
                                                    gpointer klass)
{
}

static void
sound_services_volume_control_volume_finalize (GObject * obj)
{
	SoundServicesVolumeControlVolume * self;
#line 32 "../src/Services/Volume-control.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_SERVICES_VOLUME_CONTROL_TYPE_VOLUME, SoundServicesVolumeControlVolume);
#line 32 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (sound_services_volume_control_volume_parent_class)->finalize (obj);
#line 950 "Volume-control.c"
}

static GType
sound_services_volume_control_volume_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundServicesVolumeControlVolumeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_services_volume_control_volume_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundServicesVolumeControlVolume), 0, (GInstanceInitFunc) sound_services_volume_control_volume_instance_init, NULL };
	GType sound_services_volume_control_volume_type_id;
	sound_services_volume_control_volume_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundServicesVolumeControlVolume", &g_define_type_info, 0);
	return sound_services_volume_control_volume_type_id;
}

GType
sound_services_volume_control_volume_get_type (void)
{
	static volatile gsize sound_services_volume_control_volume_type_id__once = 0;
	if (g_once_init_enter (&sound_services_volume_control_volume_type_id__once)) {
		GType sound_services_volume_control_volume_type_id;
		sound_services_volume_control_volume_type_id = sound_services_volume_control_volume_get_type_once ();
		g_once_init_leave (&sound_services_volume_control_volume_type_id__once, sound_services_volume_control_volume_type_id);
	}
	return sound_services_volume_control_volume_type_id__once;
}

static void
sound_services_volume_control_class_init (SoundServicesVolumeControlClass * klass,
                                          gpointer klass_data)
{
#line 23 "../src/Services/Volume-control.vala"
	sound_services_volume_control_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Services/Volume-control.vala"
	g_type_class_adjust_private_offset (klass, &SoundServicesVolumeControl_private_offset);
#line 23 "../src/Services/Volume-control.vala"
	((SoundServicesVolumeControlClass *) klass)->set_mute = (void (*) (SoundServicesVolumeControl*, gboolean)) sound_services_volume_control_real_set_mute;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_stream = (const gchar* (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_stream;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_ready = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_ready;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_ready = (void (*) (SoundServicesVolumeControl*, gboolean)) sound_services_volume_control_real_set_ready;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_active_mic = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_active_mic;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_active_mic = (void (*) (SoundServicesVolumeControl*, gboolean)) sound_services_volume_control_real_set_active_mic;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_high_volume = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_high_volume;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_mute = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_mute;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_mic_mute = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_mic_mute;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_is_playing = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_is_playing;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_is_listening = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_is_listening;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_volume = (SoundServicesVolumeControlVolume* (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_volume;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_volume = (void (*) (SoundServicesVolumeControl*, SoundServicesVolumeControlVolume*)) sound_services_volume_control_real_set_volume;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_mic_volume = (gdouble (*) (SoundServicesVolumeControl*)) sound_services_volume_control_real_get_mic_volume;
#line 23 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_mic_volume = (void (*) (SoundServicesVolumeControl*, gdouble)) sound_services_volume_control_real_set_mic_volume;
#line 23 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_services_volume_control_get_property;
#line 23 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_services_volume_control_set_property;
#line 23 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_services_volume_control_finalize;
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_STREAM_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_STREAM_PROPERTY] = g_param_spec_string ("stream", "stream", "stream", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_READY_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_READY_PROPERTY] = g_param_spec_boolean ("ready", "ready", "ready", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_ACTIVE_MIC_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_ACTIVE_MIC_PROPERTY] = g_param_spec_boolean ("active-mic", "active-mic", "active-mic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_HIGH_VOLUME_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_HIGH_VOLUME_PROPERTY] = g_param_spec_boolean ("high-volume", "high-volume", "high-volume", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_MUTE_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_MUTE_PROPERTY] = g_param_spec_boolean ("mute", "mute", "mute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_MIC_MUTE_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_MIC_MUTE_PROPERTY] = g_param_spec_boolean ("mic-mute", "mic-mute", "mic-mute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_IS_PLAYING_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_IS_PLAYING_PROPERTY] = g_param_spec_boolean ("is-playing", "is-playing", "is-playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_IS_LISTENING_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_IS_LISTENING_PROPERTY] = g_param_spec_boolean ("is-listening", "is-listening", "is-listening", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_VOLUME_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_VOLUME_PROPERTY] = g_param_spec_object ("volume", "volume", "volume", SOUND_SERVICES_VOLUME_CONTROL_TYPE_VOLUME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_MIC_VOLUME_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_MIC_VOLUME_PROPERTY] = g_param_spec_double ("mic-volume", "mic-volume", "mic-volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_HEADPHONE_PLUGGED_PROPERTY, sound_services_volume_control_properties[SOUND_SERVICES_VOLUME_CONTROL_HEADPHONE_PLUGGED_PROPERTY] = g_param_spec_boolean ("headphone-plugged", "headphone-plugged", "headphone-plugged", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1040 "Volume-control.c"
}

static void
sound_services_volume_control_instance_init (SoundServicesVolumeControl * self,
                                             gpointer klass)
{
#line 23 "../src/Services/Volume-control.vala"
	self->priv = sound_services_volume_control_get_instance_private (self);
#line 48 "../src/Services/Volume-control.vala"
	self->priv->_headphone_plugged = FALSE;
#line 1051 "Volume-control.c"
}

static void
sound_services_volume_control_finalize (GObject * obj)
{
	SoundServicesVolumeControl * self;
#line 23 "../src/Services/Volume-control.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_SERVICES_TYPE_VOLUME_CONTROL, SoundServicesVolumeControl);
#line 45 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_volume);
#line 23 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (sound_services_volume_control_parent_class)->finalize (obj);
#line 1064 "Volume-control.c"
}

static GType
sound_services_volume_control_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundServicesVolumeControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_services_volume_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundServicesVolumeControl), 0, (GInstanceInitFunc) sound_services_volume_control_instance_init, NULL };
	GType sound_services_volume_control_type_id;
	sound_services_volume_control_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundServicesVolumeControl", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SoundServicesVolumeControl_private_offset = g_type_add_instance_private (sound_services_volume_control_type_id, sizeof (SoundServicesVolumeControlPrivate));
	return sound_services_volume_control_type_id;
}

GType
sound_services_volume_control_get_type (void)
{
	static volatile gsize sound_services_volume_control_type_id__once = 0;
	if (g_once_init_enter (&sound_services_volume_control_type_id__once)) {
		GType sound_services_volume_control_type_id;
		sound_services_volume_control_type_id = sound_services_volume_control_get_type_once ();
		g_once_init_leave (&sound_services_volume_control_type_id__once, sound_services_volume_control_type_id);
	}
	return sound_services_volume_control_type_id__once;
}

static void
_vala_sound_services_volume_control_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	SoundServicesVolumeControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_SERVICES_TYPE_VOLUME_CONTROL, SoundServicesVolumeControl);
#line 23 "../src/Services/Volume-control.vala"
	switch (property_id) {
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_STREAM_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_string (value, sound_services_volume_control_get_stream (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_READY_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_ready (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_ACTIVE_MIC_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_active_mic (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_HIGH_VOLUME_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_high_volume (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_MUTE_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_mute (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_MIC_MUTE_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_mic_mute (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_IS_PLAYING_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_is_playing (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_IS_LISTENING_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_is_listening (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_VOLUME_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_object (value, sound_services_volume_control_get_volume (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_MIC_VOLUME_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_double (value, sound_services_volume_control_get_mic_volume (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_HEADPHONE_PLUGGED_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_headphone_plugged (self));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 1165 "Volume-control.c"
		default:
#line 23 "../src/Services/Volume-control.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 1171 "Volume-control.c"
	}
}

static void
_vala_sound_services_volume_control_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	SoundServicesVolumeControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_SERVICES_TYPE_VOLUME_CONTROL, SoundServicesVolumeControl);
#line 23 "../src/Services/Volume-control.vala"
	switch (property_id) {
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_READY_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_ready (self, g_value_get_boolean (value));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_ACTIVE_MIC_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_active_mic (self, g_value_get_boolean (value));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_VOLUME_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_volume (self, g_value_get_object (value));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_MIC_VOLUME_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_mic_volume (self, g_value_get_double (value));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 23 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_HEADPHONE_PLUGGED_PROPERTY:
#line 23 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_headphone_plugged (self, g_value_get_boolean (value));
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 1215 "Volume-control.c"
		default:
#line 23 "../src/Services/Volume-control.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Services/Volume-control.vala"
		break;
#line 1221 "Volume-control.c"
	}
}

static inline gpointer
sound_services_volume_control_pulse_get_instance_private (SoundServicesVolumeControlPulse* self)
{
	return G_STRUCT_MEMBER_P (self, SoundServicesVolumeControlPulse_private_offset);
}

SoundServicesVolumeControlPulse*
sound_services_volume_control_pulse_construct (GType object_type)
{
	SoundServicesVolumeControlPulse * self = NULL;
	SoundServicesVolumeControlVolume* _tmp0_;
	SoundServicesVolumeControlVolume* _tmp1_;
	pa_glib_mainloop* _tmp2_;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
#line 118 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) sound_services_volume_control_construct (object_type);
#line 119 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_volume;
#line 119 "../src/Services/Volume-control.vala"
	_tmp0_->volume = 0.0;
#line 120 "../src/Services/Volume-control.vala"
	_tmp1_ = self->priv->_volume;
#line 120 "../src/Services/Volume-control.vala"
	_tmp1_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
#line 122 "../src/Services/Volume-control.vala"
	_tmp2_ = sound_services_volume_control_pulse_loop;
#line 122 "../src/Services/Volume-control.vala"
	if (_tmp2_ == NULL) {
#line 1254 "Volume-control.c"
		pa_glib_mainloop* _tmp3_;
#line 123 "../src/Services/Volume-control.vala"
		_tmp3_ = pa_glib_mainloop_new (NULL);
#line 123 "../src/Services/Volume-control.vala"
		_pa_glib_mainloop_free0 (sound_services_volume_control_pulse_loop);
#line 123 "../src/Services/Volume-control.vala"
		sound_services_volume_control_pulse_loop = _tmp3_;
#line 1262 "Volume-control.c"
	}
#line 125 "../src/Services/Volume-control.vala"
	_tmp4_ = g_cancellable_new ();
#line 125 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_mute_cancellable);
#line 125 "../src/Services/Volume-control.vala"
	self->priv->_mute_cancellable = _tmp4_;
#line 126 "../src/Services/Volume-control.vala"
	_tmp5_ = g_cancellable_new ();
#line 126 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_volume_cancellable);
#line 126 "../src/Services/Volume-control.vala"
	self->priv->_volume_cancellable = _tmp5_;
#line 128 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_reconnect_to_pulse (self, NULL, NULL);
#line 118 "../src/Services/Volume-control.vala"
	return self;
#line 1280 "Volume-control.c"
}

SoundServicesVolumeControlPulse*
sound_services_volume_control_pulse_new (void)
{
#line 118 "../src/Services/Volume-control.vala"
	return sound_services_volume_control_pulse_construct (SOUND_SERVICES_TYPE_VOLUME_CONTROL_PULSE);
#line 1288 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_handle_new_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                                       pa_sink_input_info* i,
                                                                                       gint eol,
                                                                                       gpointer self)
{
#line 149 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_handle_new_sink_input_cb ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 1299 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_handle_changed_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                                           pa_sink_input_info* i,
                                                                                           gint eol,
                                                                                           gpointer self)
{
#line 153 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_handle_changed_sink_input_cb ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 1310 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_source_output_info_cb_pa_source_output_info_cb_t (pa_context* c,
                                                                                       pa_source_output_info* i,
                                                                                       gint eol,
                                                                                       gpointer self)
{
#line 172 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_source_output_info_cb ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 1321 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_context_events_cb (SoundServicesVolumeControlPulse* self,
                                                       pa_context* c,
                                                       pa_subscription_event_type_t t,
                                                       guint32 index)
{
#line 140 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 141 "../src/Services/Volume-control.vala"
	switch (t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK) {
#line 141 "../src/Services/Volume-control.vala"
		case PA_SUBSCRIPTION_EVENT_SINK:
#line 1338 "Volume-control.c"
		{
#line 143 "../src/Services/Volume-control.vala"
			sound_services_volume_control_pulse_update_sink (self);
#line 144 "../src/Services/Volume-control.vala"
			break;
#line 1344 "Volume-control.c"
		}
#line 141 "../src/Services/Volume-control.vala"
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
#line 1348 "Volume-control.c"
		{
#line 147 "../src/Services/Volume-control.vala"
			switch (t & PA_SUBSCRIPTION_EVENT_TYPE_MASK) {
#line 147 "../src/Services/Volume-control.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 1354 "Volume-control.c"
				{
					pa_operation* _tmp0_;
					pa_operation* _tmp1_;
#line 149 "../src/Services/Volume-control.vala"
					_tmp0_ = pa_context_get_sink_input_info (c, index, _sound_services_volume_control_pulse_handle_new_sink_input_cb_pa_sink_input_info_cb_t, self);
#line 149 "../src/Services/Volume-control.vala"
					_tmp1_ = _tmp0_;
#line 149 "../src/Services/Volume-control.vala"
					_pa_operation_unref0 (_tmp1_);
#line 150 "../src/Services/Volume-control.vala"
					break;
#line 1366 "Volume-control.c"
				}
#line 147 "../src/Services/Volume-control.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 1370 "Volume-control.c"
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
#line 153 "../src/Services/Volume-control.vala"
					_tmp2_ = pa_context_get_sink_input_info (c, index, _sound_services_volume_control_pulse_handle_changed_sink_input_cb_pa_sink_input_info_cb_t, self);
#line 153 "../src/Services/Volume-control.vala"
					_tmp3_ = _tmp2_;
#line 153 "../src/Services/Volume-control.vala"
					_pa_operation_unref0 (_tmp3_);
#line 154 "../src/Services/Volume-control.vala"
					break;
#line 1382 "Volume-control.c"
				}
#line 147 "../src/Services/Volume-control.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 1386 "Volume-control.c"
				{
#line 157 "../src/Services/Volume-control.vala"
					sound_services_volume_control_pulse_remove_sink_input_from_list (self, index);
#line 158 "../src/Services/Volume-control.vala"
					break;
#line 1392 "Volume-control.c"
				}
				default:
				{
#line 160 "../src/Services/Volume-control.vala"
					g_debug ("Volume-control.vala:160: Sink input event not known.");
#line 161 "../src/Services/Volume-control.vala"
					break;
#line 1400 "Volume-control.c"
				}
			}
#line 163 "../src/Services/Volume-control.vala"
			break;
#line 1405 "Volume-control.c"
		}
#line 141 "../src/Services/Volume-control.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE:
#line 1409 "Volume-control.c"
		{
#line 166 "../src/Services/Volume-control.vala"
			sound_services_volume_control_pulse_update_source (self);
#line 167 "../src/Services/Volume-control.vala"
			break;
#line 1415 "Volume-control.c"
		}
#line 141 "../src/Services/Volume-control.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
#line 1419 "Volume-control.c"
		{
#line 170 "../src/Services/Volume-control.vala"
			switch (t & PA_SUBSCRIPTION_EVENT_TYPE_MASK) {
#line 170 "../src/Services/Volume-control.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 1425 "Volume-control.c"
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
#line 172 "../src/Services/Volume-control.vala"
					_tmp4_ = pa_context_get_source_output_info (c, index, _sound_services_volume_control_pulse_source_output_info_cb_pa_source_output_info_cb_t, self);
#line 172 "../src/Services/Volume-control.vala"
					_tmp5_ = _tmp4_;
#line 172 "../src/Services/Volume-control.vala"
					_pa_operation_unref0 (_tmp5_);
#line 173 "../src/Services/Volume-control.vala"
					break;
#line 1437 "Volume-control.c"
				}
#line 170 "../src/Services/Volume-control.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 1441 "Volume-control.c"
				{
#line 176 "../src/Services/Volume-control.vala"
					sound_services_volume_control_set_active_mic ((SoundServicesVolumeControl*) self, FALSE);
#line 177 "../src/Services/Volume-control.vala"
					break;
#line 1447 "Volume-control.c"
				}
				default:
#line 170 "../src/Services/Volume-control.vala"
				break;
#line 1452 "Volume-control.c"
			}
#line 179 "../src/Services/Volume-control.vala"
			break;
#line 1456 "Volume-control.c"
		}
		default:
#line 141 "../src/Services/Volume-control.vala"
		break;
#line 1461 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_sink_info_cb_for_props (SoundServicesVolumeControlPulse* self,
                                                            pa_context* c,
                                                            pa_sink_info* i,
                                                            gint eol)
{
	gboolean playing = FALSE;
	gboolean _tmp0_ = FALSE;
	pa_sink_port_info* _tmp1_;
	gboolean _tmp14_ = FALSE;
#line 183 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 184 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 185 "../src/Services/Volume-control.vala"
		return;
#line 1483 "Volume-control.c"
	}
#line 187 "../src/Services/Volume-control.vala"
	if (self->priv->_mute != ((gboolean) (*i).mute)) {
#line 188 "../src/Services/Volume-control.vala"
		self->priv->_mute = (gboolean) (*i).mute;
#line 189 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "mute");
#line 1491 "Volume-control.c"
	}
#line 192 "../src/Services/Volume-control.vala"
	playing = (*i).state == PA_SINK_RUNNING;
#line 193 "../src/Services/Volume-control.vala"
	if (self->priv->_is_playing != playing) {
#line 194 "../src/Services/Volume-control.vala"
		self->priv->_is_playing = playing;
#line 195 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "is-playing");
#line 1501 "Volume-control.c"
	}
#line 203 "../src/Services/Volume-control.vala"
	_tmp1_ = (*i).active_port;
#line 203 "../src/Services/Volume-control.vala"
	if (_tmp1_ != NULL) {
#line 1507 "Volume-control.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		pa_sink_port_info* _tmp4_;
		const gchar* _tmp5_;
#line 204 "../src/Services/Volume-control.vala"
		_tmp4_ = (*i).active_port;
#line 204 "../src/Services/Volume-control.vala"
		_tmp5_ = (*_tmp4_).name;
#line 204 "../src/Services/Volume-control.vala"
		if (g_strcmp0 (_tmp5_, "output-wired_headset") == 0) {
#line 204 "../src/Services/Volume-control.vala"
			_tmp3_ = TRUE;
#line 1520 "Volume-control.c"
		} else {
			pa_sink_port_info* _tmp6_;
			const gchar* _tmp7_;
#line 205 "../src/Services/Volume-control.vala"
			_tmp6_ = (*i).active_port;
#line 205 "../src/Services/Volume-control.vala"
			_tmp7_ = (*_tmp6_).name;
#line 205 "../src/Services/Volume-control.vala"
			_tmp3_ = g_strcmp0 (_tmp7_, "output-wired_headphone") == 0;
#line 1530 "Volume-control.c"
		}
#line 204 "../src/Services/Volume-control.vala"
		if (_tmp3_) {
#line 204 "../src/Services/Volume-control.vala"
			_tmp2_ = TRUE;
#line 1536 "Volume-control.c"
		} else {
			pa_sink_port_info* _tmp8_;
			const gchar* _tmp9_;
#line 206 "../src/Services/Volume-control.vala"
			_tmp8_ = (*i).active_port;
#line 206 "../src/Services/Volume-control.vala"
			_tmp9_ = (*_tmp8_).name;
#line 206 "../src/Services/Volume-control.vala"
			_tmp2_ = g_strcmp0 (_tmp9_, "analog-output-headphones") == 0;
#line 1546 "Volume-control.c"
		}
#line 204 "../src/Services/Volume-control.vala"
		_tmp0_ = _tmp2_;
#line 1550 "Volume-control.c"
	} else {
#line 203 "../src/Services/Volume-control.vala"
		_tmp0_ = FALSE;
#line 1554 "Volume-control.c"
	}
#line 203 "../src/Services/Volume-control.vala"
	if (_tmp0_) {
#line 1558 "Volume-control.c"
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 207 "../src/Services/Volume-control.vala"
		_tmp10_ = sound_services_volume_control_get_headphone_plugged ((SoundServicesVolumeControl*) self);
#line 207 "../src/Services/Volume-control.vala"
		_tmp11_ = _tmp10_;
#line 207 "../src/Services/Volume-control.vala"
		if (!_tmp11_) {
#line 208 "../src/Services/Volume-control.vala"
			sound_services_volume_control_set_headphone_plugged ((SoundServicesVolumeControl*) self, TRUE);
#line 209 "../src/Services/Volume-control.vala"
			g_debug ("Volume-control.vala:209: headphone plugged in\n");
#line 1571 "Volume-control.c"
		}
	} else {
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 212 "../src/Services/Volume-control.vala"
		_tmp12_ = sound_services_volume_control_get_headphone_plugged ((SoundServicesVolumeControl*) self);
#line 212 "../src/Services/Volume-control.vala"
		_tmp13_ = _tmp12_;
#line 212 "../src/Services/Volume-control.vala"
		if (_tmp13_) {
#line 213 "../src/Services/Volume-control.vala"
			sound_services_volume_control_set_headphone_plugged ((SoundServicesVolumeControl*) self, FALSE);
#line 214 "../src/Services/Volume-control.vala"
			g_debug ("Volume-control.vala:214: no headphone plugged in\n");
#line 1586 "Volume-control.c"
		}
	}
#line 218 "../src/Services/Volume-control.vala"
	if (self->priv->_pulse_use_stream_restore == FALSE) {
#line 1591 "Volume-control.c"
		SoundServicesVolumeControlVolume* _tmp15_;
#line 219 "../src/Services/Volume-control.vala"
		_tmp15_ = self->priv->_volume;
#line 219 "../src/Services/Volume-control.vala"
		_tmp14_ = _tmp15_->volume != sound_services_volume_control_pulse_volume_to_double (pa_cvolume_max (&(*i).volume));
#line 1597 "Volume-control.c"
	} else {
#line 218 "../src/Services/Volume-control.vala"
		_tmp14_ = FALSE;
#line 1601 "Volume-control.c"
	}
#line 218 "../src/Services/Volume-control.vala"
	if (_tmp14_) {
#line 1605 "Volume-control.c"
		SoundServicesVolumeControlVolume* vol = NULL;
		SoundServicesVolumeControlVolume* _tmp16_;
		SoundServicesVolumeControlVolume* _tmp17_;
		SoundServicesVolumeControlVolume* _tmp18_;
		SoundServicesVolumeControlVolume* _tmp19_;
#line 220 "../src/Services/Volume-control.vala"
		_tmp16_ = sound_services_volume_control_volume_new ();
#line 220 "../src/Services/Volume-control.vala"
		vol = _tmp16_;
#line 221 "../src/Services/Volume-control.vala"
		_tmp17_ = vol;
#line 221 "../src/Services/Volume-control.vala"
		_tmp17_->volume = sound_services_volume_control_pulse_volume_to_double (pa_cvolume_max (&(*i).volume));
#line 222 "../src/Services/Volume-control.vala"
		_tmp18_ = vol;
#line 222 "../src/Services/Volume-control.vala"
		_tmp18_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
#line 223 "../src/Services/Volume-control.vala"
		_tmp19_ = vol;
#line 223 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) self, _tmp19_);
#line 218 "../src/Services/Volume-control.vala"
		_g_object_unref0 (vol);
#line 1629 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_source_info_cb (SoundServicesVolumeControlPulse* self,
                                                    pa_context* c,
                                                    pa_source_info* i,
                                                    gint eol)
{
	gboolean listening = FALSE;
	pa_cvolume _tmp0_;
	pa_volume_t _tmp1_;
#line 227 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 228 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 229 "../src/Services/Volume-control.vala"
		return;
#line 1650 "Volume-control.c"
	}
#line 231 "../src/Services/Volume-control.vala"
	if (self->priv->_mute_mic != ((gboolean) (*i).mute)) {
#line 232 "../src/Services/Volume-control.vala"
		self->priv->_mute_mic = (gboolean) (*i).mute;
#line 233 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "micMute");
#line 1658 "Volume-control.c"
	}
#line 236 "../src/Services/Volume-control.vala"
	listening = (*i).state == PA_SOURCE_RUNNING;
#line 237 "../src/Services/Volume-control.vala"
	if (self->priv->_is_listening != listening) {
#line 238 "../src/Services/Volume-control.vala"
		self->priv->_is_listening = listening;
#line 239 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "is-listening");
#line 1668 "Volume-control.c"
	}
#line 242 "../src/Services/Volume-control.vala"
	_tmp0_ = (*i).volume;
#line 242 "../src/Services/Volume-control.vala"
	_tmp1_ = _tmp0_.values[0];
#line 242 "../src/Services/Volume-control.vala"
	if (self->priv->_mic_volume != sound_services_volume_control_pulse_volume_to_double (_tmp1_)) {
#line 1676 "Volume-control.c"
		pa_cvolume _tmp2_;
		pa_volume_t _tmp3_;
#line 243 "../src/Services/Volume-control.vala"
		_tmp2_ = (*i).volume;
#line 243 "../src/Services/Volume-control.vala"
		_tmp3_ = _tmp2_.values[0];
#line 243 "../src/Services/Volume-control.vala"
		self->priv->_mic_volume = sound_services_volume_control_pulse_volume_to_double (_tmp3_);
#line 244 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "mic-volume");
#line 1687 "Volume-control.c"
	}
}

static void
_sound_services_volume_control_pulse_sink_info_cb_for_props_pa_sink_info_cb_t (pa_context* c,
                                                                               pa_sink_info* i,
                                                                               gint eol,
                                                                               gpointer self)
{
#line 251 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_sink_info_cb_for_props ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 1699 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_server_info_cb_for_props (SoundServicesVolumeControlPulse* self,
                                                              pa_context* c,
                                                              pa_server_info* i)
{
	pa_context* _tmp0_;
	const gchar* _tmp1_;
	pa_operation* _tmp2_;
	pa_operation* _tmp3_;
#line 248 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 249 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 250 "../src/Services/Volume-control.vala"
		return;
#line 1719 "Volume-control.c"
	}
#line 251 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 251 "../src/Services/Volume-control.vala"
	_tmp1_ = (*i).default_sink_name;
#line 251 "../src/Services/Volume-control.vala"
	_tmp2_ = pa_context_get_sink_info_by_name (_tmp0_, _tmp1_, _sound_services_volume_control_pulse_sink_info_cb_for_props_pa_sink_info_cb_t, self);
#line 251 "../src/Services/Volume-control.vala"
	_tmp3_ = _tmp2_;
#line 251 "../src/Services/Volume-control.vala"
	_pa_operation_unref0 (_tmp3_);
#line 1731 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_server_info_cb_for_props_pa_server_info_cb_t (pa_context* c,
                                                                                   pa_server_info* i,
                                                                                   gpointer self)
{
#line 255 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_server_info_cb_for_props ((SoundServicesVolumeControlPulse*) self, c, i);
#line 1741 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_update_sink (SoundServicesVolumeControlPulse* self)
{
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
#line 254 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 255 "../src/Services/Volume-control.vala"
	_tmp1_ = pa_context_get_server_info (_tmp0_, _sound_services_volume_control_pulse_server_info_cb_for_props_pa_server_info_cb_t, self);
#line 255 "../src/Services/Volume-control.vala"
	_tmp2_ = _tmp1_;
#line 255 "../src/Services/Volume-control.vala"
	_pa_operation_unref0 (_tmp2_);
#line 1760 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_source_info_cb_pa_source_info_cb_t (pa_context* c,
                                                                         pa_source_info* i,
                                                                         gint eol,
                                                                         gpointer self)
{
#line 260 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_source_info_cb ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 1771 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_update_source_get_server_info_cb (SoundServicesVolumeControlPulse* self,
                                                                      pa_context* c,
                                                                      pa_server_info* i)
{
#line 258 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 259 "../src/Services/Volume-control.vala"
	if (i != NULL) {
#line 1785 "Volume-control.c"
		pa_context* _tmp0_;
		const gchar* _tmp1_;
		pa_operation* _tmp2_;
		pa_operation* _tmp3_;
#line 260 "../src/Services/Volume-control.vala"
		_tmp0_ = self->priv->context;
#line 260 "../src/Services/Volume-control.vala"
		_tmp1_ = (*i).default_source_name;
#line 260 "../src/Services/Volume-control.vala"
		_tmp2_ = pa_context_get_source_info_by_name (_tmp0_, _tmp1_, _sound_services_volume_control_pulse_source_info_cb_pa_source_info_cb_t, self);
#line 260 "../src/Services/Volume-control.vala"
		_tmp3_ = _tmp2_;
#line 260 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp3_);
#line 1800 "Volume-control.c"
	}
}

static void
_sound_services_volume_control_pulse_update_source_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                                           pa_server_info* i,
                                                                                           gpointer self)
{
#line 264 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_update_source_get_server_info_cb ((SoundServicesVolumeControlPulse*) self, c, i);
#line 1811 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_update_source (SoundServicesVolumeControlPulse* self)
{
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
#line 263 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 264 "../src/Services/Volume-control.vala"
	_tmp1_ = pa_context_get_server_info (_tmp0_, _sound_services_volume_control_pulse_update_source_get_server_info_cb_pa_server_info_cb_t, self);
#line 264 "../src/Services/Volume-control.vala"
	_tmp2_ = _tmp1_;
#line 264 "../src/Services/Volume-control.vala"
	_pa_operation_unref0 (_tmp2_);
#line 1830 "Volume-control.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 352 "../src/Services/Volume-control.vala"
	for (i = 0; i < stack_length; i++) {
#line 352 "../src/Services/Volume-control.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 352 "../src/Services/Volume-control.vala"
			return TRUE;
#line 1845 "Volume-control.c"
		}
	}
#line 352 "../src/Services/Volume-control.vala"
	return FALSE;
#line 1850 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_add_sink_input_into_list (SoundServicesVolumeControlPulse* self,
                                                              pa_sink_input_info* sink_input)
{
	gchar* role = NULL;
	pa_sink_input_info _tmp0_;
	pa_proplist* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 348 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/Services/Volume-control.vala"
	g_return_if_fail (sink_input != NULL);
#line 350 "../src/Services/Volume-control.vala"
	_tmp0_ = *sink_input;
#line 350 "../src/Services/Volume-control.vala"
	_tmp1_ = _tmp0_.proplist;
#line 350 "../src/Services/Volume-control.vala"
	_tmp2_ = pa_proplist_gets (_tmp1_, PA_PROP_MEDIA_ROLE);
#line 350 "../src/Services/Volume-control.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 350 "../src/Services/Volume-control.vala"
	role = _tmp3_;
#line 352 "../src/Services/Volume-control.vala"
	_tmp5_ = role;
#line 352 "../src/Services/Volume-control.vala"
	if (_tmp5_ != NULL) {
#line 1882 "Volume-control.c"
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
#line 352 "../src/Services/Volume-control.vala"
		_tmp6_ = role;
#line 352 "../src/Services/Volume-control.vala"
		_tmp7_ = self->priv->_valid_roles;
#line 352 "../src/Services/Volume-control.vala"
		_tmp7__length1 = self->priv->_valid_roles_length1;
#line 352 "../src/Services/Volume-control.vala"
		_tmp4_ = _vala_string_array_contains (_tmp7_, _tmp7__length1, _tmp6_);
#line 1894 "Volume-control.c"
	} else {
#line 352 "../src/Services/Volume-control.vala"
		_tmp4_ = FALSE;
#line 1898 "Volume-control.c"
	}
#line 352 "../src/Services/Volume-control.vala"
	if (_tmp4_) {
#line 1902 "Volume-control.c"
		const gchar* _tmp8_;
#line 353 "../src/Services/Volume-control.vala"
		_tmp8_ = role;
#line 353 "../src/Services/Volume-control.vala"
		if (g_strcmp0 (_tmp8_, "phone") == 0) {
#line 1908 "Volume-control.c"
			GeeArrayList* _tmp9_;
			pa_sink_input_info _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			GQuark _tmp14_ = 0U;
#line 355 "../src/Services/Volume-control.vala"
			static GQuark _tmp13_label0 = 0;
#line 355 "../src/Services/Volume-control.vala"
			static GQuark _tmp13_label1 = 0;
#line 355 "../src/Services/Volume-control.vala"
			static GQuark _tmp13_label2 = 0;
#line 355 "../src/Services/Volume-control.vala"
			static GQuark _tmp13_label3 = 0;
#line 1922 "Volume-control.c"
			gboolean _tmp27_ = FALSE;
#line 354 "../src/Services/Volume-control.vala"
			_tmp9_ = self->priv->_sink_input_list;
#line 354 "../src/Services/Volume-control.vala"
			_tmp10_ = *sink_input;
#line 354 "../src/Services/Volume-control.vala"
			gee_abstract_list_insert ((GeeAbstractList*) _tmp9_, 0, (gpointer) ((guintptr) _tmp10_.index));
#line 355 "../src/Services/Volume-control.vala"
			_tmp11_ = role;
#line 355 "../src/Services/Volume-control.vala"
			_tmp12_ = _tmp11_;
#line 355 "../src/Services/Volume-control.vala"
			_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
#line 355 "../src/Services/Volume-control.vala"
			if (_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("multimedia")))) {
#line 355 "../src/Services/Volume-control.vala"
				switch (0) {
#line 1940 "Volume-control.c"
					default:
					{
						GeeHashMap* _tmp15_;
						pa_sink_input_info _tmp16_;
						const gchar* _tmp17_;
#line 357 "../src/Services/Volume-control.vala"
						_tmp15_ = self->priv->_sink_input_hash;
#line 357 "../src/Services/Volume-control.vala"
						_tmp16_ = *sink_input;
#line 357 "../src/Services/Volume-control.vala"
						_tmp17_ = self->priv->_objp_role_multimedia;
#line 357 "../src/Services/Volume-control.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, (gpointer) ((guintptr) _tmp16_.index), _tmp17_);
#line 358 "../src/Services/Volume-control.vala"
						break;
#line 1956 "Volume-control.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("alert")))) {
#line 355 "../src/Services/Volume-control.vala"
				switch (0) {
#line 1962 "Volume-control.c"
					default:
					{
						GeeHashMap* _tmp18_;
						pa_sink_input_info _tmp19_;
						const gchar* _tmp20_;
#line 360 "../src/Services/Volume-control.vala"
						_tmp18_ = self->priv->_sink_input_hash;
#line 360 "../src/Services/Volume-control.vala"
						_tmp19_ = *sink_input;
#line 360 "../src/Services/Volume-control.vala"
						_tmp20_ = self->priv->_objp_role_alert;
#line 360 "../src/Services/Volume-control.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, (gpointer) ((guintptr) _tmp19_.index), _tmp20_);
#line 361 "../src/Services/Volume-control.vala"
						break;
#line 1978 "Volume-control.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label2) ? _tmp13_label2 : (_tmp13_label2 = g_quark_from_static_string ("alarm")))) {
#line 355 "../src/Services/Volume-control.vala"
				switch (0) {
#line 1984 "Volume-control.c"
					default:
					{
						GeeHashMap* _tmp21_;
						pa_sink_input_info _tmp22_;
						const gchar* _tmp23_;
#line 363 "../src/Services/Volume-control.vala"
						_tmp21_ = self->priv->_sink_input_hash;
#line 363 "../src/Services/Volume-control.vala"
						_tmp22_ = *sink_input;
#line 363 "../src/Services/Volume-control.vala"
						_tmp23_ = self->priv->_objp_role_alarm;
#line 363 "../src/Services/Volume-control.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, (gpointer) ((guintptr) _tmp22_.index), _tmp23_);
#line 364 "../src/Services/Volume-control.vala"
						break;
#line 2000 "Volume-control.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label3) ? _tmp13_label3 : (_tmp13_label3 = g_quark_from_static_string ("phone")))) {
#line 355 "../src/Services/Volume-control.vala"
				switch (0) {
#line 2006 "Volume-control.c"
					default:
					{
						GeeHashMap* _tmp24_;
						pa_sink_input_info _tmp25_;
						const gchar* _tmp26_;
#line 366 "../src/Services/Volume-control.vala"
						_tmp24_ = self->priv->_sink_input_hash;
#line 366 "../src/Services/Volume-control.vala"
						_tmp25_ = *sink_input;
#line 366 "../src/Services/Volume-control.vala"
						_tmp26_ = self->priv->_objp_role_phone;
#line 366 "../src/Services/Volume-control.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, (gpointer) ((guintptr) _tmp25_.index), _tmp26_);
#line 367 "../src/Services/Volume-control.vala"
						break;
#line 2022 "Volume-control.c"
					}
				}
			}
#line 370 "../src/Services/Volume-control.vala"
			if (self->priv->_active_sink_input == ((gint32) -1)) {
#line 370 "../src/Services/Volume-control.vala"
				_tmp27_ = TRUE;
#line 2030 "Volume-control.c"
			} else {
				GeeHashMap* _tmp28_;
				gpointer _tmp29_;
				gchar* _tmp30_;
				const gchar* _tmp31_;
#line 370 "../src/Services/Volume-control.vala"
				_tmp28_ = self->priv->_sink_input_hash;
#line 370 "../src/Services/Volume-control.vala"
				_tmp29_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp28_, (gpointer) ((guintptr) self->priv->_active_sink_input));
#line 370 "../src/Services/Volume-control.vala"
				_tmp30_ = (gchar*) _tmp29_;
#line 370 "../src/Services/Volume-control.vala"
				_tmp31_ = self->priv->_objp_role_phone;
#line 370 "../src/Services/Volume-control.vala"
				_tmp27_ = g_strcmp0 (_tmp30_, _tmp31_) != 0;
#line 370 "../src/Services/Volume-control.vala"
				_g_free0 (_tmp30_);
#line 2048 "Volume-control.c"
			}
#line 370 "../src/Services/Volume-control.vala"
			if (_tmp27_) {
#line 2052 "Volume-control.c"
				pa_sink_input_info _tmp32_;
#line 371 "../src/Services/Volume-control.vala"
				_tmp32_ = *sink_input;
#line 371 "../src/Services/Volume-control.vala"
				sound_services_volume_control_pulse_update_active_sink_input (self, (gint32) _tmp32_.index, NULL, NULL);
#line 2058 "Volume-control.c"
			}
		}
	}
#line 348 "../src/Services/Volume-control.vala"
	_g_free0 (role);
#line 2064 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_remove_sink_input_from_list (SoundServicesVolumeControlPulse* self,
                                                                 guint32 index)
{
	GeeArrayList* _tmp0_;
#line 377 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_sink_input_list;
#line 378 "../src/Services/Volume-control.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) index))) {
#line 2078 "Volume-control.c"
		GeeArrayList* _tmp1_;
		GeeHashMap* _tmp2_;
#line 379 "../src/Services/Volume-control.vala"
		_tmp1_ = self->priv->_sink_input_list;
#line 379 "../src/Services/Volume-control.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, (gpointer) ((guintptr) index));
#line 380 "../src/Services/Volume-control.vala"
		_tmp2_ = self->priv->_sink_input_hash;
#line 380 "../src/Services/Volume-control.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) index), NULL);
#line 381 "../src/Services/Volume-control.vala"
		if (index == ((guint32) self->priv->_active_sink_input)) {
#line 2091 "Volume-control.c"
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 382 "../src/Services/Volume-control.vala"
			_tmp3_ = self->priv->_sink_input_list;
#line 382 "../src/Services/Volume-control.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 382 "../src/Services/Volume-control.vala"
			_tmp5_ = _tmp4_;
#line 382 "../src/Services/Volume-control.vala"
			if (_tmp5_ != 0) {
#line 2103 "Volume-control.c"
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
#line 383 "../src/Services/Volume-control.vala"
				_tmp6_ = self->priv->_sink_input_list;
#line 383 "../src/Services/Volume-control.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, 0);
#line 383 "../src/Services/Volume-control.vala"
				sound_services_volume_control_pulse_update_active_sink_input (self, (gint32) ((guint32) ((guintptr) _tmp7_)), NULL, NULL);
#line 2112 "Volume-control.c"
			} else {
#line 385 "../src/Services/Volume-control.vala"
				sound_services_volume_control_pulse_update_active_sink_input (self, (gint32) -1, NULL, NULL);
#line 2116 "Volume-control.c"
			}
		}
	}
}

static void
sound_services_volume_control_pulse_handle_new_sink_input_cb (SoundServicesVolumeControlPulse* self,
                                                              pa_context* c,
                                                              pa_sink_input_info* i,
                                                              gint eol)
{
	pa_sink_input_info _tmp0_;
#line 390 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 390 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 391 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 392 "../src/Services/Volume-control.vala"
		return;
#line 2137 "Volume-control.c"
	}
#line 394 "../src/Services/Volume-control.vala"
	_tmp0_ = *i;
#line 394 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_add_sink_input_into_list (self, &_tmp0_);
#line 2143 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_handle_changed_sink_input_cb (SoundServicesVolumeControlPulse* self,
                                                                  pa_context* c,
                                                                  pa_sink_input_info* i,
                                                                  gint eol)
{
	GeeArrayList* _tmp0_;
#line 397 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 398 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 399 "../src/Services/Volume-control.vala"
		return;
#line 2161 "Volume-control.c"
	}
#line 401 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_sink_input_list;
#line 401 "../src/Services/Volume-control.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) (*i).index))) {
#line 2167 "Volume-control.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gboolean _tmp5_;
#line 403 "../src/Services/Volume-control.vala"
		_tmp1_ = self->priv->_sink_input_hash;
#line 403 "../src/Services/Volume-control.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) (*i).index));
#line 403 "../src/Services/Volume-control.vala"
		_tmp3_ = (gchar*) _tmp2_;
#line 403 "../src/Services/Volume-control.vala"
		_tmp4_ = self->priv->_objp_role_phone;
#line 403 "../src/Services/Volume-control.vala"
		_tmp5_ = g_strcmp0 (_tmp3_, _tmp4_) != 0;
#line 403 "../src/Services/Volume-control.vala"
		_g_free0 (_tmp3_);
#line 403 "../src/Services/Volume-control.vala"
		if (_tmp5_) {
#line 404 "../src/Services/Volume-control.vala"
			sound_services_volume_control_pulse_remove_sink_input_from_list (self, (*i).index);
#line 2189 "Volume-control.c"
		}
	} else {
		pa_sink_input_info _tmp6_;
#line 407 "../src/Services/Volume-control.vala"
		_tmp6_ = *i;
#line 407 "../src/Services/Volume-control.vala"
		sound_services_volume_control_pulse_add_sink_input_into_list (self, &_tmp6_);
#line 2197 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_source_output_info_cb (SoundServicesVolumeControlPulse* self,
                                                           pa_context* c,
                                                           pa_source_output_info* i,
                                                           gint eol)
{
	gchar* role = NULL;
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 411 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 412 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 413 "../src/Services/Volume-control.vala"
		return;
#line 2221 "Volume-control.c"
	}
#line 415 "../src/Services/Volume-control.vala"
	_tmp0_ = (*i).proplist;
#line 415 "../src/Services/Volume-control.vala"
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_MEDIA_ROLE);
#line 415 "../src/Services/Volume-control.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 415 "../src/Services/Volume-control.vala"
	role = _tmp2_;
#line 416 "../src/Services/Volume-control.vala"
	_tmp4_ = role;
#line 416 "../src/Services/Volume-control.vala"
	if (g_strcmp0 (_tmp4_, "phone") == 0) {
#line 416 "../src/Services/Volume-control.vala"
		_tmp3_ = TRUE;
#line 2237 "Volume-control.c"
	} else {
		const gchar* _tmp5_;
#line 416 "../src/Services/Volume-control.vala"
		_tmp5_ = role;
#line 416 "../src/Services/Volume-control.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "production") == 0;
#line 2244 "Volume-control.c"
	}
#line 416 "../src/Services/Volume-control.vala"
	if (_tmp3_) {
#line 417 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_active_mic ((SoundServicesVolumeControl*) self, TRUE);
#line 2250 "Volume-control.c"
	}
#line 411 "../src/Services/Volume-control.vala"
	_g_free0 (role);
#line 2254 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_context_events_cb_pa_context_subscribe_cb_t (pa_context* c,
                                                                                  pa_subscription_event_type_t t,
                                                                                  guint32 idx,
                                                                                  gpointer self)
{
#line 433 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_context_events_cb ((SoundServicesVolumeControlPulse*) self, c, t, idx);
#line 2265 "Volume-control.c"
}

static gboolean
_sound_services_volume_control_pulse_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_services_volume_control_pulse_reconnect_timeout ((SoundServicesVolumeControlPulse*) self);
#line 442 "../src/Services/Volume-control.vala"
	return result;
#line 2275 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_context_state_callback (SoundServicesVolumeControlPulse* self,
                                                            pa_context* c)
{
#line 420 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 421 "../src/Services/Volume-control.vala"
	switch (pa_context_get_state (c)) {
#line 421 "../src/Services/Volume-control.vala"
		case PA_CONTEXT_READY:
#line 2290 "Volume-control.c"
		{
#line 423 "../src/Services/Volume-control.vala"
			if (self->priv->_pulse_use_stream_restore) {
#line 2294 "Volume-control.c"
				pa_operation* _tmp0_;
				pa_operation* _tmp1_;
#line 424 "../src/Services/Volume-control.vala"
				_tmp0_ = pa_context_subscribe (c, ((PA_SUBSCRIPTION_MASK_SINK | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
#line 424 "../src/Services/Volume-control.vala"
				_tmp1_ = _tmp0_;
#line 424 "../src/Services/Volume-control.vala"
				_pa_operation_unref0 (_tmp1_);
#line 2303 "Volume-control.c"
			} else {
				pa_operation* _tmp2_;
				pa_operation* _tmp3_;
#line 429 "../src/Services/Volume-control.vala"
				_tmp2_ = pa_context_subscribe (c, (PA_SUBSCRIPTION_MASK_SINK | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
#line 429 "../src/Services/Volume-control.vala"
				_tmp3_ = _tmp2_;
#line 429 "../src/Services/Volume-control.vala"
				_pa_operation_unref0 (_tmp3_);
#line 2313 "Volume-control.c"
			}
#line 433 "../src/Services/Volume-control.vala"
			pa_context_set_subscribe_callback (c, _sound_services_volume_control_pulse_context_events_cb_pa_context_subscribe_cb_t, self);
#line 434 "../src/Services/Volume-control.vala"
			sound_services_volume_control_pulse_update_sink (self);
#line 435 "../src/Services/Volume-control.vala"
			sound_services_volume_control_pulse_update_source (self);
#line 436 "../src/Services/Volume-control.vala"
			sound_services_volume_control_set_ready ((SoundServicesVolumeControl*) self, TRUE);
#line 437 "../src/Services/Volume-control.vala"
			break;
#line 2325 "Volume-control.c"
		}
#line 421 "../src/Services/Volume-control.vala"
		case PA_CONTEXT_FAILED:
#line 421 "../src/Services/Volume-control.vala"
		case PA_CONTEXT_TERMINATED:
#line 2331 "Volume-control.c"
		{
#line 441 "../src/Services/Volume-control.vala"
			if (self->priv->_reconnect_timer == ((guint) 0)) {
#line 442 "../src/Services/Volume-control.vala"
				self->priv->_reconnect_timer = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_services_volume_control_pulse_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 2337 "Volume-control.c"
			}
#line 443 "../src/Services/Volume-control.vala"
			break;
#line 2341 "Volume-control.c"
		}
		default:
		{
#line 446 "../src/Services/Volume-control.vala"
			sound_services_volume_control_set_ready ((SoundServicesVolumeControl*) self, FALSE);
#line 447 "../src/Services/Volume-control.vala"
			break;
#line 2349 "Volume-control.c"
		}
	}
}

static gboolean
sound_services_volume_control_pulse_reconnect_timeout (SoundServicesVolumeControlPulse* self)
{
	gboolean result;
#line 451 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 452 "../src/Services/Volume-control.vala"
	self->priv->_reconnect_timer = (guint) 0;
#line 453 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_reconnect_to_pulse (self, NULL, NULL);
#line 454 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 454 "../src/Services/Volume-control.vala"
	return result;
#line 2368 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundServicesVolumeControlPulseReconnectToPulseData* _data_;
	_data_ = _data;
#line 56 "../src/Services/Volume-control.vala"
	_g_object_unref0 (_data_->self);
#line 56 "../src/Services/Volume-control.vala"
	g_slice_free (SoundServicesVolumeControlPulseReconnectToPulseData, _data_);
#line 2380 "Volume-control.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../src/Services/Volume-control.vala"
	return self ? g_object_ref (self) : NULL;
#line 2388 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_reconnect_to_pulse (SoundServicesVolumeControlPulse* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	SoundServicesVolumeControlPulseReconnectToPulseData* _data_;
	SoundServicesVolumeControlPulse* _tmp0_;
#line 56 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Services/Volume-control.vala"
	_data_ = g_slice_new0 (SoundServicesVolumeControlPulseReconnectToPulseData);
#line 56 "../src/Services/Volume-control.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 56 "../src/Services/Volume-control.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_services_volume_control_pulse_reconnect_to_pulse_data_free);
#line 56 "../src/Services/Volume-control.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 56 "../src/Services/Volume-control.vala"
	_data_->self = _tmp0_;
#line 56 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_reconnect_to_pulse_co (_data_);
#line 2412 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_reconnect_to_pulse_finish (SoundServicesVolumeControlPulse* self,
                                                               GAsyncResult* _res_)
{
	SoundServicesVolumeControlPulseReconnectToPulseData* _data_;
#line 56 "../src/Services/Volume-control.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2422 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                                    gpointer self)
{
#line 473 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_context_state_callback ((SoundServicesVolumeControlPulse*) self, c);
#line 2431 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_reconnect_to_pulse_co (SoundServicesVolumeControlPulseReconnectToPulseData* _data_)
{
#line 457 "../src/Services/Volume-control.vala"
	switch (_data_->_state_) {
#line 457 "../src/Services/Volume-control.vala"
		case 0:
#line 2441 "Volume-control.c"
		goto _state_0;
		default:
#line 457 "../src/Services/Volume-control.vala"
		g_assert_not_reached ();
#line 2446 "Volume-control.c"
	}
	_state_0:
#line 458 "../src/Services/Volume-control.vala"
	_data_->_tmp0_ = sound_services_volume_control_get_ready ((SoundServicesVolumeControl*) _data_->self);
#line 458 "../src/Services/Volume-control.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 458 "../src/Services/Volume-control.vala"
	if (_data_->_tmp1_) {
#line 459 "../src/Services/Volume-control.vala"
		_data_->_tmp2_ = _data_->self->priv->context;
#line 459 "../src/Services/Volume-control.vala"
		pa_context_disconnect (_data_->_tmp2_);
#line 460 "../src/Services/Volume-control.vala"
		_pa_context_unref0 (_data_->self->priv->context);
#line 460 "../src/Services/Volume-control.vala"
		_data_->self->priv->context = NULL;
#line 461 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_ready ((SoundServicesVolumeControl*) _data_->self, FALSE);
#line 2465 "Volume-control.c"
	}
#line 464 "../src/Services/Volume-control.vala"
	_data_->_tmp3_ = pa_proplist_new ();
#line 464 "../src/Services/Volume-control.vala"
	_data_->props = _data_->_tmp3_;
#line 465 "../src/Services/Volume-control.vala"
	_data_->_tmp4_ = _data_->props;
#line 465 "../src/Services/Volume-control.vala"
	pa_proplist_sets (_data_->_tmp4_, PA_PROP_APPLICATION_NAME, "elementary OS Audio Settings");
#line 466 "../src/Services/Volume-control.vala"
	_data_->_tmp5_ = _data_->props;
#line 466 "../src/Services/Volume-control.vala"
	pa_proplist_sets (_data_->_tmp5_, PA_PROP_APPLICATION_ID, "io.elementary.desktop.wingpanel.sound");
#line 467 "../src/Services/Volume-control.vala"
	_data_->_tmp6_ = _data_->props;
#line 467 "../src/Services/Volume-control.vala"
	pa_proplist_sets (_data_->_tmp6_, PA_PROP_APPLICATION_ICON_NAME, "multimedia-volume-control");
#line 468 "../src/Services/Volume-control.vala"
	_data_->_tmp7_ = _data_->props;
#line 468 "../src/Services/Volume-control.vala"
	pa_proplist_sets (_data_->_tmp7_, PA_PROP_APPLICATION_VERSION, "0.1");
#line 472 "../src/Services/Volume-control.vala"
	_data_->_tmp8_ = sound_services_volume_control_pulse_loop;
#line 472 "../src/Services/Volume-control.vala"
	_data_->_tmp9_ = pa_glib_mainloop_get_api (_data_->_tmp8_);
#line 472 "../src/Services/Volume-control.vala"
	_data_->_tmp10_ = _data_->props;
#line 472 "../src/Services/Volume-control.vala"
	_data_->_tmp11_ = pa_context_new_with_proplist (_data_->_tmp9_, NULL, _data_->_tmp10_);
#line 472 "../src/Services/Volume-control.vala"
	_pa_context_unref0 (_data_->self->priv->context);
#line 472 "../src/Services/Volume-control.vala"
	_data_->self->priv->context = _data_->_tmp11_;
#line 473 "../src/Services/Volume-control.vala"
	_data_->_tmp12_ = _data_->self->priv->context;
#line 473 "../src/Services/Volume-control.vala"
	pa_context_set_state_callback (_data_->_tmp12_, _sound_services_volume_control_pulse_context_state_callback_pa_context_notify_cb_t, _data_->self);
#line 475 "../src/Services/Volume-control.vala"
	_data_->_tmp13_ = _data_->self->priv->context;
#line 475 "../src/Services/Volume-control.vala"
	if (pa_context_connect (_data_->_tmp13_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
#line 476 "../src/Services/Volume-control.vala"
		_data_->_tmp14_ = _data_->self->priv->context;
#line 476 "../src/Services/Volume-control.vala"
		_data_->_tmp15_ = pa_strerror (pa_context_errno (_data_->_tmp14_));
#line 476 "../src/Services/Volume-control.vala"
		g_warning ("Volume-control.vala:476: pa_context_connect() failed: %s\n", _data_->_tmp15_);
#line 2513 "Volume-control.c"
	}
#line 457 "../src/Services/Volume-control.vala"
	_pa_proplist_free0 (_data_->props);
#line 457 "../src/Services/Volume-control.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 457 "../src/Services/Volume-control.vala"
	if (_data_->_state_ != 0) {
#line 457 "../src/Services/Volume-control.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 457 "../src/Services/Volume-control.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2525 "Volume-control.c"
		}
	}
#line 457 "../src/Services/Volume-control.vala"
	g_object_unref (_data_->_async_result);
#line 457 "../src/Services/Volume-control.vala"
	return FALSE;
#line 2532 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_sink_info_list_callback_set_mute (SoundServicesVolumeControlPulse* self,
                                                                      pa_context* context,
                                                                      pa_sink_info* sink,
                                                                      gint eol)
{
#line 479 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 479 "../src/Services/Volume-control.vala"
	g_return_if_fail (context != NULL);
#line 480 "../src/Services/Volume-control.vala"
	if (sink != NULL) {
#line 2547 "Volume-control.c"
		pa_operation* _tmp0_;
		pa_operation* _tmp1_;
#line 481 "../src/Services/Volume-control.vala"
		_tmp0_ = pa_context_set_sink_mute_by_index (context, (*sink).index, TRUE, NULL, NULL);
#line 481 "../src/Services/Volume-control.vala"
		_tmp1_ = _tmp0_;
#line 481 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp1_);
#line 2556 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_sink_info_list_callback_unset_mute (SoundServicesVolumeControlPulse* self,
                                                                        pa_context* context,
                                                                        pa_sink_info* sink,
                                                                        gint eol)
{
#line 484 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 484 "../src/Services/Volume-control.vala"
	g_return_if_fail (context != NULL);
#line 485 "../src/Services/Volume-control.vala"
	if (sink != NULL) {
#line 2572 "Volume-control.c"
		pa_operation* _tmp0_;
		pa_operation* _tmp1_;
#line 486 "../src/Services/Volume-control.vala"
		_tmp0_ = pa_context_set_sink_mute_by_index (context, (*sink).index, FALSE, NULL, NULL);
#line 486 "../src/Services/Volume-control.vala"
		_tmp1_ = _tmp0_;
#line 486 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp1_);
#line 2581 "Volume-control.c"
	}
}

static void
_sound_services_volume_control_pulse_sink_info_list_callback_set_mute_pa_sink_info_cb_t (pa_context* c,
                                                                                         pa_sink_info* i,
                                                                                         gint eol,
                                                                                         gpointer self)
{
#line 495 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_sink_info_list_callback_set_mute ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 2593 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_sink_info_list_callback_unset_mute_pa_sink_info_cb_t (pa_context* c,
                                                                                           pa_sink_info* i,
                                                                                           gint eol,
                                                                                           gpointer self)
{
#line 497 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_sink_info_list_callback_unset_mute ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 2604 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_set_mute_internal (SoundServicesVolumeControlPulse* self,
                                                       gboolean mute)
{
	pa_context* _tmp0_;
	gboolean result;
#line 490 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 491 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 491 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (pa_context_get_state (_tmp0_) == PA_CONTEXT_READY, FALSE);
#line 493 "../src/Services/Volume-control.vala"
	if (self->priv->_mute != mute) {
#line 494 "../src/Services/Volume-control.vala"
		if (mute) {
#line 2623 "Volume-control.c"
			pa_context* _tmp1_;
			pa_operation* _tmp2_;
			pa_operation* _tmp3_;
#line 495 "../src/Services/Volume-control.vala"
			_tmp1_ = self->priv->context;
#line 495 "../src/Services/Volume-control.vala"
			_tmp2_ = pa_context_get_sink_info_list (_tmp1_, _sound_services_volume_control_pulse_sink_info_list_callback_set_mute_pa_sink_info_cb_t, self);
#line 495 "../src/Services/Volume-control.vala"
			_tmp3_ = _tmp2_;
#line 495 "../src/Services/Volume-control.vala"
			_pa_operation_unref0 (_tmp3_);
#line 2635 "Volume-control.c"
		} else {
			pa_context* _tmp4_;
			pa_operation* _tmp5_;
			pa_operation* _tmp6_;
#line 497 "../src/Services/Volume-control.vala"
			_tmp4_ = self->priv->context;
#line 497 "../src/Services/Volume-control.vala"
			_tmp5_ = pa_context_get_sink_info_list (_tmp4_, _sound_services_volume_control_pulse_sink_info_list_callback_unset_mute_pa_sink_info_cb_t, self);
#line 497 "../src/Services/Volume-control.vala"
			_tmp6_ = _tmp5_;
#line 497 "../src/Services/Volume-control.vala"
			_pa_operation_unref0 (_tmp6_);
#line 2648 "Volume-control.c"
		}
#line 498 "../src/Services/Volume-control.vala"
		result = TRUE;
#line 498 "../src/Services/Volume-control.vala"
		return result;
#line 2654 "Volume-control.c"
	} else {
#line 500 "../src/Services/Volume-control.vala"
		result = FALSE;
#line 500 "../src/Services/Volume-control.vala"
		return result;
#line 2660 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_real_set_mute (SoundServicesVolumeControl* base,
                                                   gboolean mute)
{
	SoundServicesVolumeControlPulse * self;
#line 504 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 505 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_set_mute_internal (self, mute);
#line 2673 "Volume-control.c"
}

void
sound_services_volume_control_pulse_toggle_mute (SoundServicesVolumeControlPulse* self)
{
#line 508 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 509 "../src/Services/Volume-control.vala"
	sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) self, !self->priv->_mute);
#line 2683 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_source_info_list_callback_set_mute (SoundServicesVolumeControlPulse* self,
                                                                        pa_context* context,
                                                                        pa_source_info* source,
                                                                        gint eol)
{
	gboolean _tmp0_ = FALSE;
#line 518 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 518 "../src/Services/Volume-control.vala"
	g_return_if_fail (context != NULL);
#line 519 "../src/Services/Volume-control.vala"
	if (source != NULL) {
#line 519 "../src/Services/Volume-control.vala"
		_tmp0_ = (*source).monitor_of_sink == ((guint32) -1);
#line 2701 "Volume-control.c"
	} else {
#line 519 "../src/Services/Volume-control.vala"
		_tmp0_ = FALSE;
#line 2705 "Volume-control.c"
	}
#line 519 "../src/Services/Volume-control.vala"
	if (_tmp0_) {
#line 2709 "Volume-control.c"
		pa_operation* _tmp1_;
		pa_operation* _tmp2_;
#line 520 "../src/Services/Volume-control.vala"
		_tmp1_ = pa_context_set_source_mute_by_index (context, (*source).index, TRUE, NULL, NULL);
#line 520 "../src/Services/Volume-control.vala"
		_tmp2_ = _tmp1_;
#line 520 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp2_);
#line 2718 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_source_info_list_callback_unset_mute (SoundServicesVolumeControlPulse* self,
                                                                          pa_context* context,
                                                                          pa_source_info* source,
                                                                          gint eol)
{
	gboolean _tmp0_ = FALSE;
#line 523 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/Services/Volume-control.vala"
	g_return_if_fail (context != NULL);
#line 524 "../src/Services/Volume-control.vala"
	if (source != NULL) {
#line 524 "../src/Services/Volume-control.vala"
		_tmp0_ = (*source).monitor_of_sink == ((guint32) -1);
#line 2737 "Volume-control.c"
	} else {
#line 524 "../src/Services/Volume-control.vala"
		_tmp0_ = FALSE;
#line 2741 "Volume-control.c"
	}
#line 524 "../src/Services/Volume-control.vala"
	if (_tmp0_) {
#line 2745 "Volume-control.c"
		pa_operation* _tmp1_;
		pa_operation* _tmp2_;
#line 525 "../src/Services/Volume-control.vala"
		_tmp1_ = pa_context_set_source_mute_by_index (context, (*source).index, FALSE, NULL, NULL);
#line 525 "../src/Services/Volume-control.vala"
		_tmp2_ = _tmp1_;
#line 525 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp2_);
#line 2754 "Volume-control.c"
	}
}

static void
_sound_services_volume_control_pulse_source_info_list_callback_set_mute_pa_source_info_cb_t (pa_context* c,
                                                                                             pa_source_info* i,
                                                                                             gint eol,
                                                                                             gpointer self)
{
#line 534 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_source_info_list_callback_set_mute ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 2766 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_source_info_list_callback_unset_mute_pa_source_info_cb_t (pa_context* c,
                                                                                               pa_source_info* i,
                                                                                               gint eol,
                                                                                               gpointer self)
{
#line 536 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_source_info_list_callback_unset_mute ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 2777 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_set_mic_mute_internal (SoundServicesVolumeControlPulse* self,
                                                           gboolean m)
{
	pa_context* _tmp0_;
	gboolean result;
#line 529 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 530 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 530 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (pa_context_get_state (_tmp0_) == PA_CONTEXT_READY, FALSE);
#line 532 "../src/Services/Volume-control.vala"
	if (self->priv->_mute_mic != m) {
#line 533 "../src/Services/Volume-control.vala"
		if (m) {
#line 2796 "Volume-control.c"
			pa_context* _tmp1_;
			pa_operation* _tmp2_;
			pa_operation* _tmp3_;
#line 534 "../src/Services/Volume-control.vala"
			_tmp1_ = self->priv->context;
#line 534 "../src/Services/Volume-control.vala"
			_tmp2_ = pa_context_get_source_info_list (_tmp1_, _sound_services_volume_control_pulse_source_info_list_callback_set_mute_pa_source_info_cb_t, self);
#line 534 "../src/Services/Volume-control.vala"
			_tmp3_ = _tmp2_;
#line 534 "../src/Services/Volume-control.vala"
			_pa_operation_unref0 (_tmp3_);
#line 2808 "Volume-control.c"
		} else {
			pa_context* _tmp4_;
			pa_operation* _tmp5_;
			pa_operation* _tmp6_;
#line 536 "../src/Services/Volume-control.vala"
			_tmp4_ = self->priv->context;
#line 536 "../src/Services/Volume-control.vala"
			_tmp5_ = pa_context_get_source_info_list (_tmp4_, _sound_services_volume_control_pulse_source_info_list_callback_unset_mute_pa_source_info_cb_t, self);
#line 536 "../src/Services/Volume-control.vala"
			_tmp6_ = _tmp5_;
#line 536 "../src/Services/Volume-control.vala"
			_pa_operation_unref0 (_tmp6_);
#line 2821 "Volume-control.c"
		}
#line 537 "../src/Services/Volume-control.vala"
		result = TRUE;
#line 537 "../src/Services/Volume-control.vala"
		return result;
#line 2827 "Volume-control.c"
	} else {
#line 539 "../src/Services/Volume-control.vala"
		result = FALSE;
#line 539 "../src/Services/Volume-control.vala"
		return result;
#line 2833 "Volume-control.c"
	}
}

void
sound_services_volume_control_pulse_set_mic_mute (SoundServicesVolumeControlPulse* self,
                                                  gboolean m)
{
#line 543 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 544 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_set_mic_mute_internal (self, m);
#line 2845 "Volume-control.c"
}

void
sound_services_volume_control_pulse_toggle_mic_mute (SoundServicesVolumeControlPulse* self)
{
#line 547 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 548 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_set_mic_mute (self, !self->priv->_mute_mic);
#line 2855 "Volume-control.c"
}

static pa_volume_t
sound_services_volume_control_pulse_double_to_volume (gdouble vol)
{
	gdouble tmp = 0.0;
	pa_volume_t result;
#line 571 "../src/Services/Volume-control.vala"
	tmp = ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol;
#line 572 "../src/Services/Volume-control.vala"
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
#line 572 "../src/Services/Volume-control.vala"
	return result;
#line 2869 "Volume-control.c"
}

static gdouble
sound_services_volume_control_pulse_volume_to_double (pa_volume_t vol)
{
	gdouble tmp = 0.0;
	gdouble result;
#line 576 "../src/Services/Volume-control.vala"
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
#line 577 "../src/Services/Volume-control.vala"
	result = tmp / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
#line 577 "../src/Services/Volume-control.vala"
	return result;
#line 2883 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_set_volume_success_cb (SoundServicesVolumeControlPulse* self,
                                                           pa_context* c,
                                                           gint success)
{
#line 580 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 580 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 581 "../src/Services/Volume-control.vala"
	if ((gboolean) success) {
#line 582 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "volume");
#line 2899 "Volume-control.c"
	}
}

static void
_sound_services_volume_control_pulse_set_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                                    gint success,
                                                                                    gpointer self)
{
#line 591 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_set_volume_success_cb ((SoundServicesVolumeControlPulse*) self, c, success);
#line 2910 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_sink_info_set_volume_cb (SoundServicesVolumeControlPulse* self,
                                                             pa_context* c,
                                                             pa_sink_info* i,
                                                             gint eol)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_;
	SoundServicesVolumeControlVolume* _tmp1_;
	pa_cvolume _tmp2_;
	pa_operation* _tmp3_;
	pa_operation* _tmp4_;
#line 585 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 585 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 586 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 587 "../src/Services/Volume-control.vala"
		return;
#line 2933 "Volume-control.c"
	}
#line 589 "../src/Services/Volume-control.vala"
	_tmp0_ = (*i).volume;
#line 589 "../src/Services/Volume-control.vala"
	cvol = _tmp0_;
#line 590 "../src/Services/Volume-control.vala"
	_tmp1_ = self->priv->_volume;
#line 590 "../src/Services/Volume-control.vala"
	pa_cvolume_scale (&cvol, sound_services_volume_control_pulse_double_to_volume (_tmp1_->volume));
#line 591 "../src/Services/Volume-control.vala"
	_tmp2_ = cvol;
#line 591 "../src/Services/Volume-control.vala"
	_tmp3_ = pa_context_set_sink_volume_by_index (c, (*i).index, &_tmp2_, _sound_services_volume_control_pulse_set_volume_success_cb_pa_context_success_cb_t, self);
#line 591 "../src/Services/Volume-control.vala"
	_tmp4_ = _tmp3_;
#line 591 "../src/Services/Volume-control.vala"
	_pa_operation_unref0 (_tmp4_);
#line 2951 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_sink_info_set_volume_cb_pa_sink_info_cb_t (pa_context* c,
                                                                                pa_sink_info* i,
                                                                                gint eol,
                                                                                gpointer self)
{
#line 600 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_sink_info_set_volume_cb ((SoundServicesVolumeControlPulse*) self, c, i, eol);
#line 2962 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_server_info_cb_for_set_volume (SoundServicesVolumeControlPulse* self,
                                                                   pa_context* c,
                                                                   pa_server_info* i)
{
	pa_context* _tmp0_;
	const gchar* _tmp1_;
	pa_operation* _tmp2_;
	pa_operation* _tmp3_;
#line 594 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 594 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 595 "../src/Services/Volume-control.vala"
	if (i == NULL) {
#line 596 "../src/Services/Volume-control.vala"
		g_warning ("Volume-control.vala:596: Could not get PulseAudio server info");
#line 597 "../src/Services/Volume-control.vala"
		return;
#line 2984 "Volume-control.c"
	}
#line 600 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 600 "../src/Services/Volume-control.vala"
	_tmp1_ = (*i).default_sink_name;
#line 600 "../src/Services/Volume-control.vala"
	_tmp2_ = pa_context_get_sink_info_by_name (_tmp0_, _tmp1_, _sound_services_volume_control_pulse_sink_info_set_volume_cb_pa_sink_info_cb_t, self);
#line 600 "../src/Services/Volume-control.vala"
	_tmp3_ = _tmp2_;
#line 600 "../src/Services/Volume-control.vala"
	_pa_operation_unref0 (_tmp3_);
#line 2996 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_set_mic_volume_success_cb (SoundServicesVolumeControlPulse* self,
                                                               pa_context* c,
                                                               gint success)
{
#line 634 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 634 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 635 "../src/Services/Volume-control.vala"
	if ((gboolean) success) {
#line 636 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "mic-volume");
#line 3012 "Volume-control.c"
	}
}

static void
_sound_services_volume_control_pulse_set_mic_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                                        gint success,
                                                                                        gpointer self)
{
#line 643 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_set_mic_volume_success_cb ((SoundServicesVolumeControlPulse*) self, c, success);
#line 3023 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_set_mic_volume_get_server_info_cb (SoundServicesVolumeControlPulse* self,
                                                                       pa_context* c,
                                                                       pa_server_info* i)
{
#line 639 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 639 "../src/Services/Volume-control.vala"
	g_return_if_fail (c != NULL);
#line 640 "../src/Services/Volume-control.vala"
	if (i != NULL) {
#line 3037 "Volume-control.c"
		pa_cvolume cvol = {0};
		pa_cvolume _tmp0_;
		const gchar* _tmp1_;
		pa_cvolume _tmp2_;
		pa_operation* _tmp3_;
		pa_operation* _tmp4_;
#line 641 "../src/Services/Volume-control.vala"
		pa_cvolume_init (&cvol);
#line 642 "../src/Services/Volume-control.vala"
		_tmp0_ = cvol;
#line 642 "../src/Services/Volume-control.vala"
		cvol = *pa_cvolume_set (&_tmp0_, (guint) 1, sound_services_volume_control_pulse_double_to_volume (self->priv->_mic_volume));
#line 643 "../src/Services/Volume-control.vala"
		_tmp1_ = (*i).default_source_name;
#line 643 "../src/Services/Volume-control.vala"
		_tmp2_ = cvol;
#line 643 "../src/Services/Volume-control.vala"
		_tmp3_ = pa_context_set_source_volume_by_name (c, _tmp1_, &_tmp2_, _sound_services_volume_control_pulse_set_mic_volume_success_cb_pa_context_success_cb_t, self);
#line 643 "../src/Services/Volume-control.vala"
		_tmp4_ = _tmp3_;
#line 643 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp4_);
#line 3060 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_update_active_sink_input_data_free (gpointer _data)
{
	SoundServicesVolumeControlPulseUpdateActiveSinkInputData* _data_;
	_data_ = _data;
#line 56 "../src/Services/Volume-control.vala"
	_g_object_unref0 (_data_->self);
#line 56 "../src/Services/Volume-control.vala"
	g_slice_free (SoundServicesVolumeControlPulseUpdateActiveSinkInputData, _data_);
#line 3073 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_update_active_sink_input (SoundServicesVolumeControlPulse* self,
                                                              gint32 index,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	SoundServicesVolumeControlPulseUpdateActiveSinkInputData* _data_;
	SoundServicesVolumeControlPulse* _tmp0_;
#line 56 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Services/Volume-control.vala"
	_data_ = g_slice_new0 (SoundServicesVolumeControlPulseUpdateActiveSinkInputData);
#line 56 "../src/Services/Volume-control.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 56 "../src/Services/Volume-control.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_services_volume_control_pulse_update_active_sink_input_data_free);
#line 56 "../src/Services/Volume-control.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 56 "../src/Services/Volume-control.vala"
	_data_->self = _tmp0_;
#line 56 "../src/Services/Volume-control.vala"
	_data_->index = index;
#line 56 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_update_active_sink_input_co (_data_);
#line 3100 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_update_active_sink_input_finish (SoundServicesVolumeControlPulse* self,
                                                                     GAsyncResult* _res_)
{
	SoundServicesVolumeControlPulseUpdateActiveSinkInputData* _data_;
#line 56 "../src/Services/Volume-control.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3110 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_update_active_sink_input_co (SoundServicesVolumeControlPulseUpdateActiveSinkInputData* _data_)
{
#line 768 "../src/Services/Volume-control.vala"
	switch (_data_->_state_) {
#line 768 "../src/Services/Volume-control.vala"
		case 0:
#line 3120 "Volume-control.c"
		goto _state_0;
		default:
#line 768 "../src/Services/Volume-control.vala"
		g_assert_not_reached ();
#line 3125 "Volume-control.c"
	}
	_state_0:
#line 768 "../src/Services/Volume-control.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 768 "../src/Services/Volume-control.vala"
	if (_data_->_state_ != 0) {
#line 768 "../src/Services/Volume-control.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 768 "../src/Services/Volume-control.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3136 "Volume-control.c"
		}
	}
#line 768 "../src/Services/Volume-control.vala"
	g_object_unref (_data_->_async_result);
#line 768 "../src/Services/Volume-control.vala"
	return FALSE;
#line 3143 "Volume-control.c"
}

static gboolean
_sound_services_volume_control_pulse_local_volume_changed_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_services_volume_control_pulse_local_volume_changed_timeout ((SoundServicesVolumeControlPulse*) self);
#line 811 "../src/Services/Volume-control.vala"
	return result;
#line 3153 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_start_local_volume_timer (SoundServicesVolumeControlPulse* self)
{
#line 809 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 810 "../src/Services/Volume-control.vala"
	if (self->priv->_local_volume_timer == ((guint) 0)) {
#line 811 "../src/Services/Volume-control.vala"
		self->priv->_local_volume_timer = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _sound_services_volume_control_pulse_local_volume_changed_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 3165 "Volume-control.c"
	} else {
#line 813 "../src/Services/Volume-control.vala"
		self->priv->_send_next_local_volume = TRUE;
#line 3169 "Volume-control.c"
	}
}

static void
sound_services_volume_control_pulse_stop_local_volume_timer (SoundServicesVolumeControlPulse* self)
{
#line 817 "../src/Services/Volume-control.vala"
	g_return_if_fail (self != NULL);
#line 818 "../src/Services/Volume-control.vala"
	if (self->priv->_local_volume_timer != ((guint) 0)) {
#line 819 "../src/Services/Volume-control.vala"
		g_source_remove (self->priv->_local_volume_timer);
#line 820 "../src/Services/Volume-control.vala"
		self->priv->_local_volume_timer = (guint) 0;
#line 3184 "Volume-control.c"
	}
}

static gboolean
sound_services_volume_control_pulse_local_volume_changed_timeout (SoundServicesVolumeControlPulse* self)
{
	gboolean result;
#line 824 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 825 "../src/Services/Volume-control.vala"
	self->priv->_local_volume_timer = (guint) 0;
#line 826 "../src/Services/Volume-control.vala"
	if (self->priv->_send_next_local_volume) {
#line 827 "../src/Services/Volume-control.vala"
		self->priv->_send_next_local_volume = FALSE;
#line 828 "../src/Services/Volume-control.vala"
		sound_services_volume_control_pulse_start_local_volume_timer (self);
#line 3202 "Volume-control.c"
	}
#line 830 "../src/Services/Volume-control.vala"
	result = FALSE;
#line 830 "../src/Services/Volume-control.vala"
	return result;
#line 3208 "Volume-control.c"
}

static const gchar*
sound_services_volume_control_pulse_real_get_stream (SoundServicesVolumeControl* base)
{
	const gchar* result;
	SoundServicesVolumeControlPulse* self;
	gchar* path = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 80 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 81 "../src/Services/Volume-control.vala"
	if (self->priv->_active_sink_input == ((gint32) -1)) {
#line 82 "../src/Services/Volume-control.vala"
		result = "alert";
#line 82 "../src/Services/Volume-control.vala"
		return result;
#line 3235 "Volume-control.c"
	}
#line 83 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_sink_input_hash;
#line 83 "../src/Services/Volume-control.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) self->priv->_active_sink_input));
#line 83 "../src/Services/Volume-control.vala"
	path = (gchar*) _tmp1_;
#line 84 "../src/Services/Volume-control.vala"
	_tmp2_ = path;
#line 84 "../src/Services/Volume-control.vala"
	_tmp3_ = self->priv->_objp_role_multimedia;
#line 84 "../src/Services/Volume-control.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 85 "../src/Services/Volume-control.vala"
		result = "multimedia";
#line 85 "../src/Services/Volume-control.vala"
		_g_free0 (path);
#line 85 "../src/Services/Volume-control.vala"
		return result;
#line 3255 "Volume-control.c"
	}
#line 86 "../src/Services/Volume-control.vala"
	_tmp4_ = path;
#line 86 "../src/Services/Volume-control.vala"
	_tmp5_ = self->priv->_objp_role_alert;
#line 86 "../src/Services/Volume-control.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 87 "../src/Services/Volume-control.vala"
		result = "alert";
#line 87 "../src/Services/Volume-control.vala"
		_g_free0 (path);
#line 87 "../src/Services/Volume-control.vala"
		return result;
#line 3269 "Volume-control.c"
	}
#line 88 "../src/Services/Volume-control.vala"
	_tmp6_ = path;
#line 88 "../src/Services/Volume-control.vala"
	_tmp7_ = self->priv->_objp_role_alarm;
#line 88 "../src/Services/Volume-control.vala"
	if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 89 "../src/Services/Volume-control.vala"
		result = "alarm";
#line 89 "../src/Services/Volume-control.vala"
		_g_free0 (path);
#line 89 "../src/Services/Volume-control.vala"
		return result;
#line 3283 "Volume-control.c"
	}
#line 90 "../src/Services/Volume-control.vala"
	_tmp8_ = path;
#line 90 "../src/Services/Volume-control.vala"
	_tmp9_ = self->priv->_objp_role_phone;
#line 90 "../src/Services/Volume-control.vala"
	if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 91 "../src/Services/Volume-control.vala"
		result = "phone";
#line 91 "../src/Services/Volume-control.vala"
		_g_free0 (path);
#line 91 "../src/Services/Volume-control.vala"
		return result;
#line 3297 "Volume-control.c"
	}
#line 92 "../src/Services/Volume-control.vala"
	result = "alert";
#line 92 "../src/Services/Volume-control.vala"
	_g_free0 (path);
#line 92 "../src/Services/Volume-control.vala"
	return result;
#line 3305 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_real_get_ready (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControlPulse* self;
#line 106 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 106 "../src/Services/Volume-control.vala"
	result = self->priv->_ready;
#line 106 "../src/Services/Volume-control.vala"
	return result;
#line 3319 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_real_set_ready (SoundServicesVolumeControl* base,
                                                    gboolean value)
{
	SoundServicesVolumeControlPulse* self;
	gboolean old_value;
#line 106 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 106 "../src/Services/Volume-control.vala"
	old_value = sound_services_volume_control_pulse_real_get_ready (base);
#line 106 "../src/Services/Volume-control.vala"
	if (old_value != value) {
#line 106 "../src/Services/Volume-control.vala"
		self->priv->_ready = value;
#line 106 "../src/Services/Volume-control.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_READY_PROPERTY]);
#line 3338 "Volume-control.c"
	}
}

static gboolean
sound_services_volume_control_pulse_real_get_active_mic (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControlPulse* self;
#line 109 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 109 "../src/Services/Volume-control.vala"
	result = self->priv->_active_mic;
#line 109 "../src/Services/Volume-control.vala"
	return result;
#line 3353 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_real_set_active_mic (SoundServicesVolumeControl* base,
                                                         gboolean value)
{
	SoundServicesVolumeControlPulse* self;
	gboolean old_value;
#line 109 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 109 "../src/Services/Volume-control.vala"
	old_value = sound_services_volume_control_pulse_real_get_active_mic (base);
#line 109 "../src/Services/Volume-control.vala"
	if (old_value != value) {
#line 109 "../src/Services/Volume-control.vala"
		self->priv->_active_mic = value;
#line 109 "../src/Services/Volume-control.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY]);
#line 3372 "Volume-control.c"
	}
}

static gboolean
sound_services_volume_control_pulse_real_get_high_volume (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControlPulse* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	SoundServicesVolumeControlVolume* _tmp2_;
#line 113 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 114 "../src/Services/Volume-control.vala"
	_tmp2_ = self->priv->_volume;
#line 114 "../src/Services/Volume-control.vala"
	if (_tmp2_->volume > 0.75) {
#line 3390 "Volume-control.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 114 "../src/Services/Volume-control.vala"
		_tmp3_ = sound_services_volume_control_get_headphone_plugged ((SoundServicesVolumeControl*) self);
#line 114 "../src/Services/Volume-control.vala"
		_tmp4_ = _tmp3_;
#line 114 "../src/Services/Volume-control.vala"
		_tmp1_ = _tmp4_;
#line 3399 "Volume-control.c"
	} else {
#line 114 "../src/Services/Volume-control.vala"
		_tmp1_ = FALSE;
#line 3403 "Volume-control.c"
	}
#line 114 "../src/Services/Volume-control.vala"
	if (_tmp1_) {
#line 3407 "Volume-control.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 114 "../src/Services/Volume-control.vala"
		_tmp5_ = sound_services_volume_control_get_stream ((SoundServicesVolumeControl*) self);
#line 114 "../src/Services/Volume-control.vala"
		_tmp6_ = _tmp5_;
#line 114 "../src/Services/Volume-control.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, "multimedia") == 0;
#line 3416 "Volume-control.c"
	} else {
#line 114 "../src/Services/Volume-control.vala"
		_tmp0_ = FALSE;
#line 3420 "Volume-control.c"
	}
#line 114 "../src/Services/Volume-control.vala"
	result = _tmp0_;
#line 114 "../src/Services/Volume-control.vala"
	return result;
#line 3426 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_real_get_mute (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControlPulse* self;
#line 513 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 514 "../src/Services/Volume-control.vala"
	result = self->priv->_mute;
#line 514 "../src/Services/Volume-control.vala"
	return result;
#line 3440 "Volume-control.c"
}

gboolean
sound_services_volume_control_pulse_get_micMute (SoundServicesVolumeControlPulse* self)
{
	gboolean result;
#line 552 "../src/Services/Volume-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 553 "../src/Services/Volume-control.vala"
	result = self->priv->_mute_mic;
#line 553 "../src/Services/Volume-control.vala"
	return result;
#line 3453 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_real_get_is_playing (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControlPulse* self;
#line 558 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 559 "../src/Services/Volume-control.vala"
	result = self->priv->_is_playing;
#line 559 "../src/Services/Volume-control.vala"
	return result;
#line 3467 "Volume-control.c"
}

static gboolean
sound_services_volume_control_pulse_real_get_is_listening (SoundServicesVolumeControl* base)
{
	gboolean result;
	SoundServicesVolumeControlPulse* self;
#line 564 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 565 "../src/Services/Volume-control.vala"
	result = self->priv->_is_listening;
#line 565 "../src/Services/Volume-control.vala"
	return result;
#line 3481 "Volume-control.c"
}

static SoundServicesVolumeControlVolume*
sound_services_volume_control_pulse_real_get_volume (SoundServicesVolumeControl* base)
{
	SoundServicesVolumeControlVolume* result;
	SoundServicesVolumeControlPulse* self;
	SoundServicesVolumeControlVolume* _tmp0_;
#line 648 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 649 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_volume;
#line 649 "../src/Services/Volume-control.vala"
	result = _tmp0_;
#line 649 "../src/Services/Volume-control.vala"
	return result;
#line 3498 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_server_info_cb_for_set_volume_pa_server_info_cb_t (pa_context* c,
                                                                                        pa_server_info* i,
                                                                                        gpointer self)
{
#line 665 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_server_info_cb_for_set_volume ((SoundServicesVolumeControlPulse*) self, c, i);
#line 3508 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_real_set_volume (SoundServicesVolumeControl* base,
                                                     SoundServicesVolumeControlVolume* value)
{
	SoundServicesVolumeControlPulse* self;
	gboolean volume_changed = FALSE;
	SoundServicesVolumeControlVolume* _tmp0_;
	gboolean old_high_volume = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SoundServicesVolumeControlVolume* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	pa_context* _tmp6_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	SoundServicesVolumeControlVolume* _tmp14_;
	SoundServicesVolumeControlVolume* _tmp15_;
#line 651 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 652 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->_volume;
#line 652 "../src/Services/Volume-control.vala"
	volume_changed = value->volume != _tmp0_->volume;
#line 653 "../src/Services/Volume-control.vala"
	g_debug ("Volume-control.vala:653: Setting volume to %f for profile %d because %" \
"d", value->volume, (gint) self->priv->_active_sink_input, (gint) value->reason);
#line 655 "../src/Services/Volume-control.vala"
	_tmp1_ = sound_services_volume_control_get_high_volume ((SoundServicesVolumeControl*) self);
#line 655 "../src/Services/Volume-control.vala"
	_tmp2_ = _tmp1_;
#line 655 "../src/Services/Volume-control.vala"
	old_high_volume = _tmp2_;
#line 656 "../src/Services/Volume-control.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 656 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_volume);
#line 656 "../src/Services/Volume-control.vala"
	self->priv->_volume = _tmp3_;
#line 659 "../src/Services/Volume-control.vala"
	_tmp6_ = self->priv->context;
#line 659 "../src/Services/Volume-control.vala"
	if (pa_context_get_state (_tmp6_) == PA_CONTEXT_READY) {
#line 3554 "Volume-control.c"
		SoundServicesVolumeControlVolume* _tmp7_;
#line 660 "../src/Services/Volume-control.vala"
		_tmp7_ = self->priv->_volume;
#line 660 "../src/Services/Volume-control.vala"
		_tmp5_ = _tmp7_->reason != SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
#line 3560 "Volume-control.c"
	} else {
#line 659 "../src/Services/Volume-control.vala"
		_tmp5_ = FALSE;
#line 3564 "Volume-control.c"
	}
#line 659 "../src/Services/Volume-control.vala"
	if (_tmp5_) {
#line 661 "../src/Services/Volume-control.vala"
		_tmp4_ = volume_changed;
#line 3570 "Volume-control.c"
	} else {
#line 659 "../src/Services/Volume-control.vala"
		_tmp4_ = FALSE;
#line 3574 "Volume-control.c"
	}
#line 659 "../src/Services/Volume-control.vala"
	if (_tmp4_) {
#line 3578 "Volume-control.c"
		pa_context* _tmp8_;
		pa_operation* _tmp9_;
		pa_operation* _tmp10_;
#line 665 "../src/Services/Volume-control.vala"
		_tmp8_ = self->priv->context;
#line 665 "../src/Services/Volume-control.vala"
		_tmp9_ = pa_context_get_server_info (_tmp8_, _sound_services_volume_control_pulse_server_info_cb_for_set_volume_pa_server_info_cb_t, self);
#line 665 "../src/Services/Volume-control.vala"
		_tmp10_ = _tmp9_;
#line 665 "../src/Services/Volume-control.vala"
		_pa_operation_unref0 (_tmp10_);
#line 3590 "Volume-control.c"
	}
#line 667 "../src/Services/Volume-control.vala"
	_tmp11_ = sound_services_volume_control_get_high_volume ((SoundServicesVolumeControl*) self);
#line 667 "../src/Services/Volume-control.vala"
	_tmp12_ = _tmp11_;
#line 667 "../src/Services/Volume-control.vala"
	if (_tmp12_ != old_high_volume) {
#line 668 "../src/Services/Volume-control.vala"
		g_object_notify ((GObject*) self, "high-volume");
#line 3600 "Volume-control.c"
	}
#line 670 "../src/Services/Volume-control.vala"
	_tmp14_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) self);
#line 670 "../src/Services/Volume-control.vala"
	_tmp15_ = _tmp14_;
#line 670 "../src/Services/Volume-control.vala"
	if (_tmp15_->reason != SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_ACCOUNTS_SERVICE_SET) {
#line 671 "../src/Services/Volume-control.vala"
		_tmp13_ = volume_changed;
#line 3610 "Volume-control.c"
	} else {
#line 670 "../src/Services/Volume-control.vala"
		_tmp13_ = FALSE;
#line 3614 "Volume-control.c"
	}
#line 670 "../src/Services/Volume-control.vala"
	if (_tmp13_) {
#line 672 "../src/Services/Volume-control.vala"
		sound_services_volume_control_pulse_start_local_volume_timer (self);
#line 3620 "Volume-control.c"
	}
#line 651 "../src/Services/Volume-control.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_VOLUME_PROPERTY]);
#line 3624 "Volume-control.c"
}

static gdouble
sound_services_volume_control_pulse_real_get_mic_volume (SoundServicesVolumeControl* base)
{
	gdouble result;
	SoundServicesVolumeControlPulse* self;
#line 678 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 679 "../src/Services/Volume-control.vala"
	result = self->priv->_mic_volume;
#line 679 "../src/Services/Volume-control.vala"
	return result;
#line 3638 "Volume-control.c"
}

static void
_sound_services_volume_control_pulse_set_mic_volume_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                                            pa_server_info* i,
                                                                                            gpointer self)
{
#line 686 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_set_mic_volume_get_server_info_cb ((SoundServicesVolumeControlPulse*) self, c, i);
#line 3648 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_real_set_mic_volume (SoundServicesVolumeControl* base,
                                                         gdouble value)
{
	SoundServicesVolumeControlPulse* self;
	pa_context* _tmp0_;
	pa_context* _tmp1_;
	pa_operation* _tmp2_;
	pa_operation* _tmp3_;
#line 681 "../src/Services/Volume-control.vala"
	self = (SoundServicesVolumeControlPulse*) base;
#line 682 "../src/Services/Volume-control.vala"
	_tmp0_ = self->priv->context;
#line 682 "../src/Services/Volume-control.vala"
	g_return_if_fail (pa_context_get_state (_tmp0_) == PA_CONTEXT_READY);
#line 684 "../src/Services/Volume-control.vala"
	self->priv->_mic_volume = value;
#line 686 "../src/Services/Volume-control.vala"
	_tmp1_ = self->priv->context;
#line 686 "../src/Services/Volume-control.vala"
	_tmp2_ = pa_context_get_server_info (_tmp1_, _sound_services_volume_control_pulse_set_mic_volume_get_server_info_cb_pa_server_info_cb_t, self);
#line 686 "../src/Services/Volume-control.vala"
	_tmp3_ = _tmp2_;
#line 686 "../src/Services/Volume-control.vala"
	_pa_operation_unref0 (_tmp3_);
#line 681 "../src/Services/Volume-control.vala"
	g_object_notify_by_pspec ((GObject *) self, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY]);
#line 3678 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_class_init (SoundServicesVolumeControlPulseClass * klass,
                                                gpointer klass_data)
{
#line 56 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_parent_class = g_type_class_peek_parent (klass);
#line 56 "../src/Services/Volume-control.vala"
	g_type_class_adjust_private_offset (klass, &SoundServicesVolumeControlPulse_private_offset);
#line 56 "../src/Services/Volume-control.vala"
	((SoundServicesVolumeControlClass *) klass)->set_mute = (void (*) (SoundServicesVolumeControl*, gboolean)) sound_services_volume_control_pulse_real_set_mute;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_stream = (const gchar* (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_stream;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_ready = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_ready;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_ready = (void (*) (SoundServicesVolumeControl*, gboolean)) sound_services_volume_control_pulse_real_set_ready;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_active_mic = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_active_mic;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_active_mic = (void (*) (SoundServicesVolumeControl*, gboolean)) sound_services_volume_control_pulse_real_set_active_mic;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_high_volume = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_high_volume;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_mute = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_mute;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_is_playing = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_is_playing;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_is_listening = (gboolean (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_is_listening;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_volume = (SoundServicesVolumeControlVolume* (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_volume;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_volume = (void (*) (SoundServicesVolumeControl*, SoundServicesVolumeControlVolume*)) sound_services_volume_control_pulse_real_set_volume;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->get_mic_volume = (gdouble (*) (SoundServicesVolumeControl*)) sound_services_volume_control_pulse_real_get_mic_volume;
#line 56 "../src/Services/Volume-control.vala"
	SOUND_SERVICES_VOLUME_CONTROL_CLASS (klass)->set_mic_volume = (void (*) (SoundServicesVolumeControl*, gdouble)) sound_services_volume_control_pulse_real_set_mic_volume;
#line 56 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_services_volume_control_pulse_get_property;
#line 56 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_services_volume_control_pulse_set_property;
#line 56 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_services_volume_control_pulse_finalize;
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_STREAM_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_STREAM_PROPERTY] = g_param_spec_string ("stream", "stream", "stream", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3725 "Volume-control.c"
	/** true when connected to the pulse server */
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_READY_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_READY_PROPERTY] = g_param_spec_boolean ("ready", "ready", "ready", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3729 "Volume-control.c"
	/** true when a microphone is active **/
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY] = g_param_spec_boolean ("active-mic", "active-mic", "active-mic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3733 "Volume-control.c"
	/** true when high volume warnings should be shown */
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_HIGH_VOLUME_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_HIGH_VOLUME_PROPERTY] = g_param_spec_boolean ("high-volume", "high-volume", "high-volume", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_MUTE_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_MUTE_PROPERTY] = g_param_spec_boolean ("mute", "mute", "mute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_MUTE_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_MUTE_PROPERTY] = g_param_spec_boolean ("micMute", "micMute", "micMute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_PLAYING_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_PLAYING_PROPERTY] = g_param_spec_boolean ("is-playing", "is-playing", "is-playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_LISTENING_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_LISTENING_PROPERTY] = g_param_spec_boolean ("is-listening", "is-listening", "is-listening", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_VOLUME_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_VOLUME_PROPERTY] = g_param_spec_object ("volume", "volume", "volume", SOUND_SERVICES_VOLUME_CONTROL_TYPE_VOLUME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 56 "../src/Services/Volume-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY, sound_services_volume_control_pulse_properties[SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY] = g_param_spec_double ("mic-volume", "mic-volume", "mic-volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3749 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_instance_init (SoundServicesVolumeControlPulse * self,
                                                   gpointer klass)
{
	SoundServicesVolumeControlVolume* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashMap* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
#line 56 "../src/Services/Volume-control.vala"
	self->priv = sound_services_volume_control_pulse_get_instance_private (self);
#line 60 "../src/Services/Volume-control.vala"
	self->priv->_reconnect_timer = (guint) 0;
#line 63 "../src/Services/Volume-control.vala"
	self->priv->_mute = TRUE;
#line 64 "../src/Services/Volume-control.vala"
	self->priv->_mute_mic = TRUE;
#line 65 "../src/Services/Volume-control.vala"
	self->priv->_is_playing = FALSE;
#line 66 "../src/Services/Volume-control.vala"
	self->priv->_is_listening = FALSE;
#line 67 "../src/Services/Volume-control.vala"
	_tmp0_ = sound_services_volume_control_volume_new ();
#line 67 "../src/Services/Volume-control.vala"
	self->priv->_volume = _tmp0_;
#line 68 "../src/Services/Volume-control.vala"
	self->priv->_mic_volume = 0.0;
#line 74 "../src/Services/Volume-control.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 74 "../src/Services/Volume-control.vala"
	self->priv->_sink_input_list = _tmp1_;
#line 75 "../src/Services/Volume-control.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 75 "../src/Services/Volume-control.vala"
	self->priv->_sink_input_hash = _tmp2_;
#line 76 "../src/Services/Volume-control.vala"
	self->priv->_pulse_use_stream_restore = FALSE;
#line 77 "../src/Services/Volume-control.vala"
	self->priv->_active_sink_input = (gint32) -1;
#line 78 "../src/Services/Volume-control.vala"
	_tmp3_ = g_strdup ("multimedia");
#line 78 "../src/Services/Volume-control.vala"
	_tmp4_ = g_strdup ("alert");
#line 78 "../src/Services/Volume-control.vala"
	_tmp5_ = g_strdup ("alarm");
#line 78 "../src/Services/Volume-control.vala"
	_tmp6_ = g_strdup ("phone");
#line 78 "../src/Services/Volume-control.vala"
	_tmp7_ = g_new0 (gchar*, 4 + 1);
#line 78 "../src/Services/Volume-control.vala"
	_tmp7_[0] = _tmp3_;
#line 78 "../src/Services/Volume-control.vala"
	_tmp7_[1] = _tmp4_;
#line 78 "../src/Services/Volume-control.vala"
	_tmp7_[2] = _tmp5_;
#line 78 "../src/Services/Volume-control.vala"
	_tmp7_[3] = _tmp6_;
#line 78 "../src/Services/Volume-control.vala"
	self->priv->_valid_roles = _tmp7_;
#line 78 "../src/Services/Volume-control.vala"
	self->priv->_valid_roles_length1 = 4;
#line 78 "../src/Services/Volume-control.vala"
	self->priv->__valid_roles_size_ = self->priv->_valid_roles_length1;
#line 95 "../src/Services/Volume-control.vala"
	self->priv->_objp_role_multimedia = NULL;
#line 96 "../src/Services/Volume-control.vala"
	self->priv->_objp_role_alert = NULL;
#line 97 "../src/Services/Volume-control.vala"
	self->priv->_objp_role_alarm = NULL;
#line 98 "../src/Services/Volume-control.vala"
	self->priv->_objp_role_phone = NULL;
#line 102 "../src/Services/Volume-control.vala"
	self->priv->_local_volume_timer = (guint) 0;
#line 103 "../src/Services/Volume-control.vala"
	self->priv->_send_next_local_volume = FALSE;
#line 109 "../src/Services/Volume-control.vala"
	self->priv->_active_mic = FALSE;
#line 3832 "Volume-control.c"
}

static void
sound_services_volume_control_pulse_finalize (GObject * obj)
{
	SoundServicesVolumeControlPulse * self;
#line 56 "../src/Services/Volume-control.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_SERVICES_TYPE_VOLUME_CONTROL_PULSE, SoundServicesVolumeControlPulse);
#line 132 "../src/Services/Volume-control.vala"
	if (self->priv->_reconnect_timer != ((guint) 0)) {
#line 133 "../src/Services/Volume-control.vala"
		g_source_remove (self->priv->_reconnect_timer);
#line 134 "../src/Services/Volume-control.vala"
		self->priv->_reconnect_timer = (guint) 0;
#line 3847 "Volume-control.c"
	}
#line 136 "../src/Services/Volume-control.vala"
	sound_services_volume_control_pulse_stop_local_volume_timer (self);
#line 62 "../src/Services/Volume-control.vala"
	_pa_context_unref0 (self->priv->context);
#line 67 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_volume);
#line 74 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_sink_input_list);
#line 75 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_sink_input_hash);
#line 78 "../src/Services/Volume-control.vala"
	self->priv->_valid_roles = (_vala_array_free (self->priv->_valid_roles, self->priv->_valid_roles_length1, (GDestroyNotify) g_free), NULL);
#line 95 "../src/Services/Volume-control.vala"
	_g_free0 (self->priv->_objp_role_multimedia);
#line 96 "../src/Services/Volume-control.vala"
	_g_free0 (self->priv->_objp_role_alert);
#line 97 "../src/Services/Volume-control.vala"
	_g_free0 (self->priv->_objp_role_alarm);
#line 98 "../src/Services/Volume-control.vala"
	_g_free0 (self->priv->_objp_role_phone);
#line 100 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_mute_cancellable);
#line 101 "../src/Services/Volume-control.vala"
	_g_object_unref0 (self->priv->_volume_cancellable);
#line 56 "../src/Services/Volume-control.vala"
	G_OBJECT_CLASS (sound_services_volume_control_pulse_parent_class)->finalize (obj);
#line 3875 "Volume-control.c"
}

static GType
sound_services_volume_control_pulse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundServicesVolumeControlPulseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_services_volume_control_pulse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundServicesVolumeControlPulse), 0, (GInstanceInitFunc) sound_services_volume_control_pulse_instance_init, NULL };
	GType sound_services_volume_control_pulse_type_id;
	sound_services_volume_control_pulse_type_id = g_type_register_static (SOUND_SERVICES_TYPE_VOLUME_CONTROL, "SoundServicesVolumeControlPulse", &g_define_type_info, 0);
	SoundServicesVolumeControlPulse_private_offset = g_type_add_instance_private (sound_services_volume_control_pulse_type_id, sizeof (SoundServicesVolumeControlPulsePrivate));
	return sound_services_volume_control_pulse_type_id;
}

GType
sound_services_volume_control_pulse_get_type (void)
{
	static volatile gsize sound_services_volume_control_pulse_type_id__once = 0;
	if (g_once_init_enter (&sound_services_volume_control_pulse_type_id__once)) {
		GType sound_services_volume_control_pulse_type_id;
		sound_services_volume_control_pulse_type_id = sound_services_volume_control_pulse_get_type_once ();
		g_once_init_leave (&sound_services_volume_control_pulse_type_id__once, sound_services_volume_control_pulse_type_id);
	}
	return sound_services_volume_control_pulse_type_id__once;
}

static void
_vala_sound_services_volume_control_pulse_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec)
{
	SoundServicesVolumeControlPulse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_SERVICES_TYPE_VOLUME_CONTROL_PULSE, SoundServicesVolumeControlPulse);
#line 56 "../src/Services/Volume-control.vala"
	switch (property_id) {
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_STREAM_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_string (value, sound_services_volume_control_get_stream ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_READY_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_ready ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_active_mic ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_HIGH_VOLUME_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_high_volume ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_MUTE_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_MUTE_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_pulse_get_micMute (self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_PLAYING_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_is_playing ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_IS_LISTENING_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_boolean (value, sound_services_volume_control_get_is_listening ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_VOLUME_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_object (value, sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		g_value_set_double (value, sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) self));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 3970 "Volume-control.c"
		default:
#line 56 "../src/Services/Volume-control.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 3976 "Volume-control.c"
	}
}

static void
_vala_sound_services_volume_control_pulse_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec)
{
	SoundServicesVolumeControlPulse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_SERVICES_TYPE_VOLUME_CONTROL_PULSE, SoundServicesVolumeControlPulse);
#line 56 "../src/Services/Volume-control.vala"
	switch (property_id) {
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_READY_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_ready ((SoundServicesVolumeControl*) self, g_value_get_boolean (value));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_active_mic ((SoundServicesVolumeControl*) self, g_value_get_boolean (value));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_VOLUME_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) self, g_value_get_object (value));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 56 "../src/Services/Volume-control.vala"
		case SOUND_SERVICES_VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY:
#line 56 "../src/Services/Volume-control.vala"
		sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) self, g_value_get_double (value));
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 4014 "Volume-control.c"
		default:
#line 56 "../src/Services/Volume-control.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 56 "../src/Services/Volume-control.vala"
		break;
#line 4020 "Volume-control.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

